<?php

defined('_JEXEC') or die('Restricted access');

class BackendControllerField extends BackendController
{
	function __construct()
	{
		parent::__construct();

		$this->registerTask('add',   'edit');
		$this->registerTask('apply', 'save');
	}

  function edit()
  {
    JRequest::setVar('view', 'field');
    JRequest::setVar('layout', 'form');
    JRequest::setVar('hidemainmenu', 1);

    parent::display();
  }

  function cancel()
  {
    $msg = JText::_('Operation Cancelled');
    $this->setRedirect('index.php?option=com_lovefactory&task=fields', $msg);
  }

  function save()
  {
    $model = $this->getModel('field');

    if ($model->store())
    {
      $msg = JText::_('Field Saved!');
    }
    else
    {
      $msg = JText::_('Error Saving Field!') . ' ' . $model->getError();
    }

    if ($this->getTask() == 'apply')
    {
      $this->setRedirect('index.php?option=com_lovefactory&controller=field&task=edit&cid[]=' . $model->saved_id, $msg);
    }
    else
    {
      $this->setRedirect('index.php?option=com_lovefactory&task=fields', $msg);
    }
  }

  function remove()
  {
    $model = $this->getModel('field');

    if (!$model->delete())
    {
      $msg = JText::_('Error: One or More Fields Could not be Deleted!') . ' ' . $model->getError();
    }
    else
    {
      $msg = JText::_('Field(s) Deleted!');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=fields', $msg);
  }

  function change()
  {
    $model = $this->getModel('field');

    if ($model->change())
    {
      $msg = JText::_('State changed!');
    }
    else
    {
      $msg = JText::_('Error Changing State!') . ' ' . $model->getError();
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=fields', $msg);
  }

  function publish()
  {
    $model = $this->getModel('field');

    if ($model->publish())
    {
      $msg = JText::_('Field(s) published!');
    }
    else
    {
      $msg = JText::_('Error Publishing Field(s)!') . ' ' . $model->getError();
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=fields', $msg);
  }

  function unpublish()
  {
    $model = $this->getModel('field');

    if ($model->unpublish())
    {
      $msg = JText::_('Field(s) unpublished!');
    }
    else
    {
      $msg = JText::_('Error Unpublishing Field(s)!') . ' ' . $model->getError();
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=fields', $msg);
  }
}