<?php

defined('_JEXEC') or die('Restricted access');

class BackendControllerGateway extends BackendController
{
	function __construct()
	{
		parent::__construct();

		$this->registerTask('apply', 'save');
	}

	function unpublish()
	{
	  $model = $this->getModel('gateway');

    if ($model->unpublish())
    {
      $msg = JText::_('Payment Gateway(s) Unpublished!');
    }
    else
    {
      $msg = JText::_('Error Unpublishing Payment Gateway(s)!');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=gateways', $msg);
	}

	function publish()
	{
	  $model = $this->getModel('gateway');

    if ($model->publish())
    {
      $msg = JText::_('Payment Gateway(s) Published!');
    }
    else
    {
      $msg = JText::_('Error Publishing Payment Gateway(s)');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=gateways', $msg);
	}

	function edit()
  {
    JRequest::setVar('view',         'gateway');
    JRequest::setVar('layout',       'form');
    JRequest::setVar('hidemainmenu', 1);

    parent::display();
  }

  function save()
  {
    $model = $this->getModel('gateway');

    if ($model->store())
    {
      $message = JText::_('Payment Gateway Saved!');
    }
    else
    {
      $message = JText::_('Error Saving Payment Gateway!');
    }

    if ($this->getTask() == 'save')
    {
      $this->setRedirect('index.php?option=com_lovefactory&task=gateways', $message);
    }
    else
    {
      $this->setRedirect('index.php?option=com_lovefactory&controller=gateway&task=edit&gateway=' . $model->title, $message);
    }
  }

  function cancel()
  {
    $this->setRedirect('index.php?option=com_lovefactory&task=gateways', JText::_('Operation Cancelled!'));
  }
}