DROP TABLE IF EXISTS `#__lovefactory_actions`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_actions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `type_id` int(11) NOT NULL,
  `sender_id` int(11) NOT NULL,
  `title` varchar(255) NOT NULL,
  `text` mediumtext NOT NULL,
  `item_id` int(11) NOT NULL,
  `link` mediumtext NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS `#__lovefactory_adsense`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_adsense` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `script` mediumtext NOT NULL,
  `rows` tinyint(4) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `#__lovefactory_blacklist`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_blacklist` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sender_id` int(11) NOT NULL,
  `receiver_id` int(11) NOT NULL,
  `date` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_sender_id` (`sender_id`),
  KEY `idx_receiver_id` (`receiver_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `#__lovefactory_comments`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `receiver_id` int(11) NOT NULL,
  `sender_id` int(11) NOT NULL,
  `date` datetime NOT NULL,
  `text` mediumtext NOT NULL,
  `reported` tinyint(1) NOT NULL,
  `deleted` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_sender_id` (`sender_id`),
  KEY `idx_receiver_id` (`receiver_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `#__lovefactory_fields`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_fields` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type_id` tinyint(3) unsigned NOT NULL,
  `system` tinyint(1) NOT NULL,
  `title` varchar(255) NOT NULL,
  `title_view` varchar(255) NOT NULL,
  `title_edit` varchar(255) NOT NULL,
  `title_search` varchar(255) NOT NULL,
  `show_title` tinyint(1) NOT NULL DEFAULT '1',
  `required` tinyint(1) NOT NULL,
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL,
  `params` mediumtext NOT NULL,
  `visibility` tinyint(4) NOT NULL,
  `user_visibility` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=27 ;


DROP TABLE IF EXISTS `#__lovefactory_friends`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_friends` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) NOT NULL DEFAULT '1',
  `sender_id` int(11) NOT NULL,
  `receiver_id` int(11) NOT NULL,
  `date` date NOT NULL,
  `message` mediumtext NOT NULL,
  `sender_status` tinyint(1) NOT NULL,
  `receiver_status` tinyint(1) NOT NULL,
  `pending` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_sender_id` (`sender_id`),
  KEY `idx_receiver_id` (`receiver_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `#__lovefactory_gateways`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_gateways` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `paysystem` varchar(50) DEFAULT NULL,
  `title` varchar(50) DEFAULT NULL,
  `enabled` int(1) DEFAULT '1',
  `params` text,
  `ordering` int(11) DEFAULT NULL,
  `isdefault` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `#__lovefactory_geo`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_geo` (
  `user_id` int(11) NOT NULL,
  `username` varchar(255) NOT NULL,
  `lat` decimal(15,12) NOT NULL,
  `lng` decimal(15,12) NOT NULL,
  PRIMARY KEY (`user_id`),
  KEY `idx_username` (`username`),
  KEY `idx_lat` (`lat`),
  KEY `idx_lng` (`lng`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__lovefactory_group_bans`;
CREATE TABLE `#__lovefactory_group_bans` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `group_id` int(11) NOT NULL,
  `description` mediumtext NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__lovefactory_group_members`;
CREATE TABLE `#__lovefactory_group_members` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `group_id` int(11) NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__lovefactory_group_posts`;
CREATE TABLE `#__lovefactory_group_posts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `group_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `text` mediumtext NOT NULL,
  `parent_id` int(11) NOT NULL,
  `reported` tinyint(4) NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__lovefactory_groups`;
CREATE TABLE `#__lovefactory_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `private` tinyint(4) NOT NULL,
  `title` varchar(255) NOT NULL,
  `description` mediumtext NOT NULL,
  `thumbnail` varchar(255) NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__lovefactory_interactions`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_interactions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sender_id` int(11) NOT NULL,
  `receiver_id` int(11) NOT NULL,
  `type_id` tinyint(4) NOT NULL,
  `date` datetime NOT NULL,
  `seen` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_sender_id` (`sender_id`),
  KEY `idx_receiver_id` (`receiver_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `#__lovefactory_ips`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_ips` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `ip` varchar(15) NOT NULL,
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  `visits` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `#__lovefactory_memberships`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_memberships` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `published` tinyint(1) NOT NULL,
  `ordering` int(11) NOT NULL,
  `default` tinyint(1) NOT NULL,
  `icon_extension` varchar(20) NOT NULL,
  `max_photos` int(11) NOT NULL,
  `max_videos` int(11) NOT NULL,
  `max_friends` int(11) NOT NULL,
  `max_messages_per_day` int(11) NOT NULL,
  `max_interactions_per_day` int(11) NOT NULL,
  `shoutbox` tinyint(1) NOT NULL,
  `chatfactory` tinyint(1) NOT NULL,
  `top_friends` int(11) NOT NULL,
  `groups_create` int(11) NOT NULL,
  `groups_join` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=7 ;



DROP TABLE IF EXISTS `#__lovefactory_memberships_sold`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_memberships_sold` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `membership_id` int(11) NOT NULL,
  `payment_id` int(11) NOT NULL,
  `start_membership` datetime NOT NULL,
  `end_membership` datetime NOT NULL,
  `end_notification` tinyint(1) NOT NULL,
  `expired` tinyint(4) NOT NULL,
  `months` int(11) NOT NULL,
  `title` varchar(255) NOT NULL,
  `default` tinyint(1) NOT NULL,
  `trial` int(11) NOT NULL,
  `max_photos` int(11) NOT NULL,
  `max_videos` int(11) NOT NULL,
  `max_friends` int(11) NOT NULL,
  `max_messages_per_day` int(11) NOT NULL,
  `max_interactions_per_day` int(11) NOT NULL,
  `shoutbox` tinyint(1) NOT NULL,
  `chatfactory` tinyint(1) NOT NULL,
  `top_friends` int(11) NOT NULL,
  `groups_create` int(11) NOT NULL,
  `groups_join` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_membership_id` (`membership_id`),
  KEY `idx_user_id` (`user_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;



DROP TABLE IF EXISTS `#__lovefactory_messages`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sender_id` int(11) NOT NULL,
  `receiver_id` int(11) NOT NULL,
  `date` datetime NOT NULL,
  `title` varchar(255) NOT NULL,
  `text` mediumtext NOT NULL,
  `unread` tinyint(1) NOT NULL,
  `reported` tinyint(1) NOT NULL,
  `deleted_by_sender` tinyint(1) NOT NULL,
  `deleted_by_receiver` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_sender_id` (`sender_id`),
  KEY `idx_receiver_id` (`receiver_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `#__lovefactory_orders`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_orders` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `user_id` int(11) NOT NULL,
  `membership_id` int(11) NOT NULL,
  `params` mediumtext NOT NULL,
  `starting_type` tinyint(4) NOT NULL,
  `amount` decimal(10,2) NOT NULL,
  `currency` varchar(20) NOT NULL,
  `months` int(11) NOT NULL,
  `gateway` varchar(255) NOT NULL,
  `status` varchar(20) NOT NULL,
  `created_at` datetime NOT NULL,
  `updated_at` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `#__lovefactory_pages`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_pages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type_id` tinyint(4) NOT NULL,
  `title` varchar(255) NOT NULL,
  `description` mediumtext NOT NULL,
  `fields` mediumtext NOT NULL,
  `titles` mediumtext NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=9 ;



DROP TABLE IF EXISTS `#__lovefactory_payments`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_payments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `received_at` datetime NOT NULL,
  `payment_date` varchar(255) NOT NULL,
  `user_id` int(11) NOT NULL,
  `amount` decimal(10,2) NOT NULL,
  `currency` varchar(10) NOT NULL,
  `order_id` int(11) NOT NULL,
  `status` varchar(255) NOT NULL,
  `gateway` varchar(255) NOT NULL,
  `log` mediumtext NOT NULL,
  `refnumber` varchar(255) NOT NULL,
  `errors` mediumtext NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;



DROP TABLE IF EXISTS `#__lovefactory_photos`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_photos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL,
  `is_main` tinyint(1) NOT NULL,
  `date_added` datetime NOT NULL,
  `status` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `#__lovefactory_photo_comments`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_photo_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `photo_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `text` mediumtext NOT NULL,
  `reported` tinyint(1) NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_photo_id` (`photo_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `#__lovefactory_pricing`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_pricing` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `published` tinyint(1) NOT NULL,
  `membership_id` tinyint(4) NOT NULL,
  `price` decimal(10,2) NOT NULL,
  `months` int(11) NOT NULL,
  `gender_prices` mediumtext NOT NULL,
  `is_trial` tinyint(1) NOT NULL,
  `available_interval` tinyint(1) NOT NULL,
  `available_from` datetime NOT NULL,
  `available_until` datetime NOT NULL,
  `new_trial` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `#__lovefactory_profiles`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_profiles` (
  `user_id` int(11) unsigned NOT NULL,
  `online` tinyint(1) NOT NULL,
  `validated` tinyint(1) NOT NULL,
  `banned` tinyint(1) NOT NULL,
  `membership_sold_id` int(11) NOT NULL,
  `date` datetime NOT NULL,
  `alerts` tinyint(1) NOT NULL,
  `rating` decimal(4,2) NOT NULL,
  `votes` int(11) NOT NULL,
  `infobar` tinyint(1) NOT NULL,
  `photos` int(11) NOT NULL,
  `friends` int(11) NOT NULL,
  `main_photo` varchar(255) NOT NULL,
  `relationship` int(11) NOT NULL,
  `trials` int(11) NOT NULL,
  `status` mediumtext NOT NULL,
  `sex` varchar(255) NOT NULL,
  `looking` varchar(255) NOT NULL,
  `field_6` varchar(8) NOT NULL,
  `field_16` varchar(255) NOT NULL,
  `field_16_visibility` tinyint(1) NOT NULL DEFAULT '1',
  `field_17` varchar(255) NOT NULL,
  `field_17_visibility` tinyint(1) NOT NULL DEFAULT '1',
  `field_18` mediumtext NOT NULL,
  `field_18_visibility` tinyint(1) NOT NULL DEFAULT '1',
  `field_19` mediumtext NOT NULL,
  `field_19_visibility` tinyint(1) NOT NULL DEFAULT '1',
  `field_20` mediumtext NOT NULL,
  `field_20_visibility` tinyint(1) NOT NULL DEFAULT '1',
  `field_21` varchar(255) NOT NULL,
  `field_21_visibility` tinyint(1) NOT NULL DEFAULT '1',
  `field_22` varchar(255) NOT NULL,
  `field_22_visibility` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`user_id`),
  KEY `idx_membership_sold_id` (`membership_sold_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `#__lovefactory_profile_visitors`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_profile_visitors` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `visitor_id` int(11) NOT NULL,
  `date` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `#__lovefactory_ratings`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_ratings` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sender_id` int(11) NOT NULL,
  `receiver_id` int(11) NOT NULL,
  `date` datetime NOT NULL,
  `rating` tinyint(4) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_sender_id` (`sender_id`),
  KEY `idx_receiver_id` (`receiver_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `#__lovefactory_reports`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_reports` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `reporting_id` int(11) NOT NULL,
  `type_id` int(11) NOT NULL,
  `date` datetime NOT NULL,
  `comment` mediumtext NOT NULL,
  `reported_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `status` tinyint(4) NOT NULL,
  `text` mediumtext NOT NULL,
  `action_message` mediumtext NOT NULL,
  `action_ban` tinyint(1) NOT NULL,
  `action_delete` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `#__lovefactory_shoutbox`;
CREATE TABLE `#__lovefactory_shoutbox` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sender_id` int(11) NOT NULL,
  `message` varchar(255) NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_sender_id` (`sender_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `#__lovefactory_statistics_per_day`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_statistics_per_day` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `date_messages` date NOT NULL,
  `messages` int(11) NOT NULL,
  `date_interactions` date NOT NULL,
  `interactions` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `#__lovefactory_videos`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_videos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `code` mediumtext NOT NULL,
  `thumbnail` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `description` varchar(255) NOT NULL,
  `status` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  `date_added` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


DROP TABLE IF EXISTS `#__lovefactory_video_comments`;
CREATE TABLE IF NOT EXISTS `#__lovefactory_video_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `video_id` int(11) NOT NULL,
  `text` mediumtext NOT NULL,
  `reported` tinyint(1) NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_video_id` (`video_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


INSERT INTO `#__lovefactory_fields` (`id`, `type_id`, `system`, `title`, `title_view`, `title_edit`, `title_search`, `show_title`, `required`, `description`, `published`, `params`, `visibility`, `user_visibility`) VALUES
(1, 8, 1, 'Membership', '', '', '', 1, 0, '', 1, '', 1, 0),
(2, 9, 1, 'Main photo', '', '', '', 0, 0, '', 1, 'link=3\ngallery=1\n', 1, 0),
(3, 12, 1, 'Username', '', '', '', 1, 1, '', 1, 'ajax_check=1\n', 1, 0),
(4, 10, 1, 'Sex', '', '', 'I am a', 1, 1, '', 1, 'values=Male*|*Female*|*Couple*|*Other\ndisplay=1\nmode=0\n', 1, 0),
(5, 11, 1, 'Looking for', '', '', '', 1, 1, '', 1, 'values=Male*|*Female*|*Couple*|*Other\ndisplay=0\nmode=4\n', 1, 0),
(6, 7, 1, 'Date of birth', 'Age', '', 'Age between', 1, 1, 'When were you born?', 1, 'minage=18\nmaxage=40\n', 1, 0),
(7, 13, 1, 'Online members', '', '', '', 0, 0, '', 1, 'values=Search only for online members', 1, 0),
(8, 14, 1, 'With pictures', '', '', '', 0, 0, '', 1, 'values=Search only for members with pictures', 1, 0),
(9, 15, 1, 'Last seen', '', '', '', 1, 0, '', 1, 'mode=0\n', 1, 0),
(10, 16, 1, 'No. of photos', '', '', '', 1, 0, 'Number of photos', 1, '', 1, 0),
(11, 17, 1, 'Online status', '', '', '', 0, 0, '', 1, 'online=online\noffline=offline\n', 1, 0),
(12, 18, 1, 'Email', '', '', '', 1, 1, '', 1, 'validation=2\nvalidation_message=Please enter a valid email address\nregexp=^([a-zA-Z0-9_.-])+@([a-zA-Z0-9_.-])+\\.([a-zA-Z])+([a-zA-Z])+\najax_check=1\n', 1, 0),
(13, 19, 1, 'Password', '', '', '', 1, 1, '', 1, '', 1, 0),
(14, 20, 1, 'Repeat password', '', '', '', 1, 1, '', 1, 'validation_message=The passwords do not match\n', 1, 0),
(15, 21, 1, 'Main photo upload', '', '', '', 1, 1, '', 1, '', 1, 0),
(16, 1, 0, 'Name', '', '', '', 1, 1, '', 1, 'maxlength=255\nvalidation=0\nvalidation_message=\nregexp=\n', 1, 1),
(17, 1, 0, 'Surname', '', '', '', 1, 0, '', 1, 'maxlength=255\nvalidation=0\nvalidation_message=\nregexp=\n', 1, 1),
(18, 2, 0, 'About me', '', '', '', 1, 0, '', 1, 'rows=10\ncols=80\nallowed_tags=embed,param,object\n', 1, 0),
(19, 3, 0, 'Relationship Status', '', '', '', 1, 0, '', 1, 'values=Single*|*In a relationship*|*Long term relationship*|*Engaged*|*Married*|*Divorced\n', 1, 0),
(20, 5, 0, 'Here for', '', '', '', 1, 0, '', 1, 'values=Friends*|*Fun*|*Dating*|*Relationship*|*Sex\ndisplay=0\nquery_operand=0\n', 1, 0),
(21, 1, 0, 'City', '', '', '', 1, 0, '', 1, 'maxlength=255\nvalidation=0\nvalidation_message=\nregexp=\n', 1, 0),
(22, 1, 0, 'Country', '', '', '', 1, 0, '', 1, 'maxlength=255\nvalidation=0\nvalidation_message=\nregexp=\n', 1, 0),
(23, 22, 1, 'No. of friends', '', '', '', 1, 0, '', 1, '', 1, 0),
(24, 23, 1, 'Google map location', '', '', '', 1, 1, '', 1, 'height=300\nwidth=500\nshow_hide_map=1\nshow_full_map=1\n', 1, 0),
(25, 24, 1, 'Distance', '', '', 'Maximum distance', 1, 0, '', 1, '', 1, 0),
(26, 25, 1,	'Relationship',	'In a relationship with',	'',	'Search only for members in a relationship',	1,	0,	'',	1,	'show_photo=0\nvalues=Relationship\n',	1,	0),
(27, 26, 1, 'ReCaptcha', '', '', '', 1, 0, '', 1, 'theme=0\n', 1, 0),
(28, 27, 1, 'Spacer', '', '', '', 0, 0, '', 1, '', 1, 0),
(29, 28, 1, 'Terms and Conditions', '', '', '', 1, 1, '', 1, '', 1, 0),
(30, 29, 1, 'Profile rating', '', '', '', 1, 0, '', 1, '', 1, 0);

INSERT INTO `#__lovefactory_memberships` (`id`, `title`, `published`, `ordering`, `default`, `icon_extension`, `max_photos`, `max_videos`, `max_friends`, `max_messages_per_day`, `max_interactions_per_day`, `top_friends`) VALUES
(1, 'Free', 1, 1, 1, '', 0, 0, 0, 0, 0, 0),
(2, 'Starter', 1, 2, 0, '', 1, 1, 1, 1, 1, 0),
(3, 'Basic', 1, 3, 0, '', 3, 3, 3, 5, 5, 1),
(4, 'Advanced', 1, 4, 0, '', 5, 5, 5, 10, 10, 3),
(5, 'Expert', 1, 5, 0, '', 10, 10, 10, 50, 50, 5),
(6, 'Unlimited', 1, 6, 0, '', -1, -1, -1, -1, -1, -1);

INSERT INTO `#__lovefactory_memberships_sold` (`id`, `user_id`, `membership_id`, `payment_id`, `start_membership`, `end_membership`, `end_notification`, `expired`, `months`, `title`, `default`, `max_photos`, `max_friends`, `max_messages_per_day`, `max_interactions_per_day`) VALUES
(1, 0, 1, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 0, 0, 'Free', 1, 0, 0, 0, 0);

INSERT INTO `#__lovefactory_pages` (`id`, `type_id`, `title`, `description`, `fields`, `titles`) VALUES
(1,	1,	'Registration',	'Registration',	'0_0_3#0_0_12#0_0_13#0_0_14#1_0_15#2_0_4#2_0_5#2_0_6#2_1_16#3_0_27#3_0_29',	'0___Account details###1___Your photo###2___Basic details###3___Terms and Security'),
(2,	2,	'Profile Edit',	'Edit profile',	'0_0_16#0_0_17#0_0_4#0_1_6#0_1_5#1_0_19#1_0_20#1_1_21#1_1_22#2_0_18',	'0___Basic details###1___More info###2___About me'),
(3,	3,	'Quick search',	'Quick search',	'0_0_4#0_0_5#0_0_6#0_1_7#0_1_8',	'0___Quick search'),
(4,	4,	'Advanced search',	'Advanced search',	'0_0_4#0_0_5#0_0_6#0_1_7#0_1_8#1_0_19#1_0_20#1_1_21#1_1_22',	'0___Basic info###1___More info'),
(5,	5,	'Profile Search',	'',	'0_0_2#0_1_11#0_1_16#0_1_6#0_2_4#0_2_5#0_3_21#0_3_22#0_3_9',	'0___'),
(6,	6,	'Profile View',	'Profile View',	'0_0_2#0_1_16#0_1_6#0_1_9#0_1_5#0_2_17#0_2_4#0_2_11#1_0_19#1_0_21#1_0_23#1_0_1#1_1_20#1_1_22#1_1_10#1_1_3#2_0_18',	'0___%%username%%###1___More info###2___About me'),
(7,	7,	'Friends list view',	'Freinds list view',	'0_0_2#0_1_11#0_1_16#0_1_6#0_2_4#0_2_5#0_3_21#0_3_22#0_3_9',	'0___'),
(8,	8,	'Profile Fillin',	'Profile Fillin',	'0_0_4#0_0_5#0_0_6#0_1_15#1_0_16#1_0_17#1_1_19#1_1_20',	'0___Basic details###1___More info'),
(9,	9,	'Map member info',	'',	'0_0_16#0_0_4#0_0_5',	'0___');
