<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelAbout extends JModel
{
  function getCurrentVersion()
  {
    static $version = null;

    if (is_null($version))
    {
      $file = JPATH_COMPONENT_ADMINISTRATOR.DS.'com_lovefactory.xml';
      $data = JApplicationHelper::parseXMLInstallFile($file);

      $version = $data['version'];
    }

    return $version;
  }

  function getInformation()
  {
    static $information = null;

    if (is_null($information))
    {
      jimport('joomla.utilities.simplexml');
      $xmldoc = new JSimpleXML();
		  @set_time_limit(60);

		  $filename     = 'http://thefactory.ro/versions/com_lovefactory.xml';
		  $fileContents = @$this->_remote_read_url($filename);

		  if (!$fileContents)
		  {
  		  return false;
		  }

		  $success = $xmldoc->loadString($fileContents);

		  if (!$success)
		  {
			 return false;
		  }

		  $information = array();
		  $fields = array(
		    'latestversion',
		    'downloadlink',
		    'newdownloadlink',
		    'newsletter',
		    'announcements',
		    'releasenotes');

		  foreach ($fields as $field)
		  {
		    $element = $xmldoc->document->getElementByPath('/' . $field . '/');

		    if ($element)
		    {
		      $information[$field] = $element->data();
		    }
		  }
    }

		return $information;
  }

  function getNewVersion()
  {
    $current   = $this->getCurrentVersion();
    $available = $this->getInformation();
    $available = $available['latestversion'];

    $current   = intval(str_replace('.', '', $current));
    $available = intval(str_replace('.', '', $available));

    return $available > $current;
  }

  function _remote_read_url($uri)
  {
    if (function_exists('curl_init'))
    {
      $handle = curl_init();

      curl_setopt ($handle, CURLOPT_URL, $uri);
      curl_setopt ($handle, CURLOPT_MAXREDIRS,5);
      curl_setopt ($handle, CURLOPT_AUTOREFERER, 1);
      curl_setopt ($handle, CURLOPT_FOLLOWLOCATION ,1);
      curl_setopt ($handle, CURLOPT_CONNECTTIMEOUT, 10);
      curl_setopt ($handle, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt ($handle, CURLOPT_TIMEOUT, 10);

      $buffer = @curl_exec($handle);

      curl_close($handle);
      return $buffer;
    }
    elseif (ini_get('allow_url_fopen'))
    {
      $fp = @fopen($uri, 'r');

      if (!$fp)
      {
        return false;
      }

      stream_set_timeout($fp, 20);
      $linea = '';
      while ($remote_read = fread($fp, 4096))
      {
        $linea .= $remote_read;
      }

      $info = stream_get_meta_data($fp);
      fclose($fp);

      if ($info['timed_out'])
      {
        return false;
      }

      return $linea;
    }
    else
    {
      return false;
    }
  }
}