<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelDashboard extends JModel
{
  function __construct()
  {
    parent::__construct();

    require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');
  }

  function getUsers()
  {
    $settings = new LovefactorySettings();
    $array = array();

    $query = ' SELECT COUNT(user_id) AS count, banned'
           . ' FROM #__lovefactory_profiles'
           . ' GROUP BY banned';
    $this->_db->setQuery($query);
    $users = $this->_db->loadObject();

    $array['total']  = $users ? $users->count : 0;
    $array['banned'] = $users ? $users->banned : 0;

    $query = ' SELECT COUNT(p.user_id) AS count, m.id'
           . ' FROM #__lovefactory_profiles p'
           . ' LEFT JOIN #__lovefactory_memberships_sold s ON s.id = p.membership_sold_id'
           . ' LEFT JOIN #__lovefactory_memberships m ON m.id = s.membership_id'
           . ' GROUP BY p.user_id';
    $this->_db->setQuery($query);
    $users = $this->_db->loadObjectList();

    $array['membership'] = array();

    foreach ($users as $user)
    {
      $array['membership'][$user->id] = $user->count;
    }

    return $array;
  }

  function getLatest()
  {
    $query = ' SELECT p.*, u.username'
           . ' FROM #__lovefactory_profiles p'
           . ' LEFT JOIN #__users u ON p.user_id = u.id'
           . ' ORDER BY date DESC'
           . ' LIMIT 0, 6';
    $this->_db->setQuery($query);
    return $this->_db->loadObjectList();
  }

  function getPayments()
  {
    $query = ' SELECT p.*, u.username'
           . ' FROM #__lovefactory_payments p'
           . ' LEFT JOIN #__users u ON p.user_id = u.id'
           . ' ORDER BY p.received_at DESC'
           . ' LIMIT 0, 5';
    $this->_db->setQuery($query);
    return $this->_db->loadObjectList();
  }

  function getReports()
  {
    $query = ' SELECT r.*, u.username'
           . ' FROM #__lovefactory_reports r'
           . ' LEFT JOIN #__users u ON r.user_id = u.id'
           . ' ORDER BY date DESC'
           . ' LIMIT 0, 5';
    $this->_db->setQuery($query);
    return $this->_db->loadObjectList();
  }

  function getMemberships()
  {
    $query = ' SELECT m.id, m.title, COUNT(p.user_id) AS users'
           . ' FROM #__lovefactory_memberships m'
           . ' LEFT JOIN #__lovefactory_memberships_sold s ON s.membership_id = m.id'
           . ' LEFT JOIN #__lovefactory_profiles p ON p.membership_sold_id = s.id'
           . ' GROUP BY m.id'
           . ' ORDER BY m.ordering ASC';
    $this->_db->setQuery($query);
    return $this->_db->loadObjectList();
  }
}