<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelPayments extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;

  function __construct()
  {
    parent::__construct();

    global $mainframe, $option;
    $limit      = $mainframe->getUserStateFromRequest('global.list.limit',            'limit',      $mainframe->getCfg('list_limit'), 'int');
    $limitstart = $mainframe->getUserStateFromRequest($option.'.payments.limitstart', 'limitstart', 0,                                'int');

    $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

    $this->setState('limit',      $limit);
    $this->setState('limitstart', $limitstart);
  }

  function getData()
  {
    if (empty($this->_data))
    {
      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
    }

    return $this->_data;
  }

  function _buildQuery()
  {
    $orderby = $this->_buildContentOrderBy();
    $where   = $this->_buildContentWhere();

    $query = ' SELECT p.*, u.username AS username, m.title, o.amount, o.currency, o.months, o.id AS order_id'
           . ' FROM #__lovefactory_payments p'
           . ' LEFT JOIN #__users u ON u.id = p.user_id'
           . ' LEFT JOIN #__lovefactory_orders o ON o.id = p.order_id'
           . ' LEFT JOIN #__lovefactory_memberships m ON m.id = o.membership_id'
           . $where
           . $orderby;

    return $query;
  }

  function _buildContentOrderBy()
  {
    global $mainframe, $option;

    $filter_order     = $mainframe->getUserStateFromRequest($option.'.payments.filter_order',     'filter_order',     'title', 'cmd');
    $filter_order_Dir = $mainframe->getUserStateFromRequest($option.'.payments.filter_order_Dir', 'filter_order_Dir', 'asc',   'word');

    $orderby = '';

    if (in_array($filter_order, array('p.id', 'p.refnumber', 'u.username', 'p.payment_date', 'm.ordering', 'o.id', 'o.amount', 'o.months', 'p.gateway', 'p.status')))
    {
      $orderby = ' ORDER BY ' . $filter_order . ' ' . $filter_order_Dir;
    }

    return $orderby;
  }

  function _buildContentWhere()
  {
    global $mainframe, $option;

    $search        = $mainframe->getUserStateFromRequest($option.'.payments.search',       'search',     '', 'cmd');
    $membership_id = $mainframe->getUserStateFromRequest($option.'.payments.membership',   'membership', -1, 'int');
    $method        = $mainframe->getUserStateFromRequest($option.'.payments.method',       'method',     '', 'string');
    $status        = $mainframe->getUserStateFromRequest($option.'.payments.status',       'status',     '', 'string');

    $where = ' WHERE 1';

    if ($search != '')
    {
      $where .= ' AND username LIKE "%' . $search . '%"';
    }

    if ($membership_id != -1)
    {
      $where .= ' AND o.membership_id = ' . $membership_id;
    }

    if ($method != '')
    {
      $where .= ' AND p.gateway = "' . $method . '"';
    }

    if ($status != '')
    {
      $where .= ' AND p.status = "' . $status . '"';
    }

    return $where;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit'));
    }

    return $this->_pagination;
  }
}