<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelReport extends JModel
{
  var $_report;

  function __construct()
  {
    parent::__construct();
  }

  function delete()
  {
    $cids   = JRequest::getVar('cid', array(0), 'post', 'array');
    $report =& $this->getTable('report');

    foreach($cids as $cid)
    {
      if (!$report->delete($cid))
      {
        $this->setError($report->getErrorMsg());
        return false;
      }
    }

    return true;
  }

  function store()
  {
    $id     = JRequest::getVar('id',     0, 'POST', 'integer');
    $status = JRequest::getVar('status', 0, 'POST', 'integer');

    $report =& $this->getTable('report');
    $report->load($id);

    if ($report->reporting_id == null)
    {
      return false;
    }

    $report->status = $status;
    $report->store();

    return true;
  }

  function resolve()
  {
    $id     =  JRequest::getVar('id', 0, 'GET', 'integer');
    $report =& $this->getTable('report');

    $report->load($id);

    if ($report->status != 1)
    {
      $report->status = 1;
      $report->store();

      return true;
    }

    return false;
  }

  function unresolve()
  {
    $id     =  JRequest::getVar('id', 0, 'GET', 'integer');
    $report =& $this->getTable('report');

    $report->load($id);

    if ($report->status == 1)
    {
      $report->status = 0;
      $report->store();

      return true;
    }

    return false;
  }

  function resolveList()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');

    $query = ' UPDATE #__lovefactory_reports'
           . ' SET status = 1'
           . ' WHERE id IN (' . implode(', ', $cids) . ')';
    $this->_db->setQuery($query);

    return $this->_db->query();
  }

  function unresolveList()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');

    $query = ' UPDATE #__lovefactory_reports'
           . ' SET status = 0'
           . ' WHERE id IN (' . implode(', ', $cids) . ')';
    $this->_db->setQuery($query);

    return $this->_db->query();
  }

  function getReport()
  {
    if (!isset($this->_report))
    {
      $id = JRequest::getVar('id', 0, 'GET', 'integer');

      $query = ' SELECT r.*, u.username AS reporting_user, u2.username AS reported_user'
             . ' FROM #__lovefactory_reports r'
             . ' LEFT JOIN #__users u ON r.reporting_id = u.id'
             . ' LEFT JOIN #__users u2 ON r.user_id = u2.id'
             . ' WHERE r.id = ' . $id;
      $this->_db->setQuery($query);

      $this->_report = $this->_db->loadObject();
    }

    return $this->_report;
  }

  function getGallery()
  {
    $query = ' SELECT *'
           . ' FROM #__lovefactory_photos'
           . ' WHERE user_id = ' .  $this->getReport()->user_id;
    $this->_db->setQuery($query);

    return $this->_db->loadObjectList();
  }

  function actionDelete()
  {
    $id     =  JRequest::getVar('id', 0, 'GET', 'integer');
    $report =& $this->getTable('report');
    $report->load($id);

    switch ($report->type_id)
    {
      // Message
      case 1:
        $message =& $this->getTable('LoveFactoryMessage');
        $message->load($report->reported_id);

        $message->delete();
      break;

      // Comment
      case 2:
        $comment =& $this->getTable('comment');
        $comment->load($report->reported_id);

        $comment->delete();
      break;

      // Gallery
      case 3:
        $photo_id = JRequest::getVar('photo', 0, 'GET', 'integer');
        $photo =& $this->getTable('photo');
        $photo->load($photo_id);

        @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$photo->user_id.DS.$photo->id.'.'.$photo->extension);
        @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$photo->user_id.DS.$photo->id.'_thumb.'.$photo->extension);

        $photo->delete();
      break;

      // Photo Comment
      case 4:
        $comment =& $this->getTable('photocomment');
        $comment->load($report->reported_id);

        $comment->delete();
      break;

      // Video Comment
      case 5:
        $comment =& $this->getTable('VideoComment');
        $comment->load($report->reported_id);

        $comment->delete();
      break;

      // Group post
      case 6:
        $post =& $this->getTable('GroupPost', 'Table');
        $post->load($report->reported_id);

        $post->delete();
      break;
    }

    $report->action_delete = 1;
    $report->store();

    return true;
  }

  function actionBan()
  {
    $id     =  JRequest::getVar('id', 0, 'GET', 'integer');
    $report =& $this->getTable('report');
    $report->load($id);

    $profile =& $this->getTable('profile');
    $profile->load($report->user_id);

    $profile->banned = 1;
    $profile->store();

    $report->action_ban = 1;
    $report->store();

    return true;
  }

  function actionMessage()
  {
    $id      =  JRequest::getVar('id', 0, 'POST', 'integer');
    $notify =  JRequest::getVar('message', '', 'POST', 'string');
    $report  =& $this->getTable('report');
    $message =& $this->getTable('LoveFactoryMessage');

    $report->load($id);
    $report->action_message = $notify;
    $report->store();

    $message->sendSystemMessage($report->user_id, JText::_('Warning Message'), $notify);

    return true;
  }
}
