<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelSettings extends JModel
{
  var $settings;
  var $file;
  var $variables;

  function __construct()
  {
    $this->file = JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php';

    //require_once($this->file);
    $this->settings = new LovefactorySettings();

    $this->variables = array(
      'photo_max_width'                => 'integer',
      'photo_max_height'               => 'integer',
      'thumbnail_max_height'           => 'integer',
      'thumbnail_max_width'            => 'integer',
      'enable_comments'                => 'integer',
      'enable_messages'                => 'integer',
      'enable_rating'                  => 'integer',
      'currency'                       => 'string',
      'enable_wallpage'                => 'integer',
      'wallpage_entries'               => 'integer',
      'my_gallery_action_links'        => 'integer',

      'enable_infobar'                 => 'integer',
      'infobar_location'               => 'integer',
      'infobar_refresh_interval'       => 'integer',
      'enable_infobar_interactions'    => 'integer',
      'infobar_interactions_itemid'    => 'integer',
      'enable_infobar_messages'        => 'integer',
      'infobar_messages_itemid'        => 'integer',
      'enable_infobar_requests'        => 'integer',
      'infobar_requests_itemid'        => 'integer',
      'enable_infobar_view_profile'    => 'integer',
      'infobar_view_profile_itemid'    => 'integer',
      'enable_infobar_update_profile'  => 'integer',
      'infobar_update_profile_itemid'  => 'integer',
      'enable_infobar_gallery'         => 'integer',
      'infobar_gallery_itemid'         => 'integer',
      'enable_infobar_friends'         => 'integer',
      'infobar_friends_itemid'         => 'integer',
      'enable_infobar_close'           => 'integer',

      'jump_to_results'                => 'integer',
      'sort_by_membership'             => 'integer',
      'results_columns'                => 'integer',
      'display_hidden'                 => 'integer',
      'gender_pricing'                 => 'integer',
      'gender_change'                  => 'integer',
      'profile_status_change'          => 'integer',
      'fields_location'                => 'integer',
      'update_fields_location'         => 'integer',
      'enable_relationships'           => 'integer',
      'invalid_membership_action'      => 'integer',
      'enable_top_friends'             => 'integer',
      'results_default_sort_order'     => 'integer',
      'results_default_sort_by'        => 'integer',

      'enable_groups'                  => 'integer',
      'groups_allow_users_create'      => 'integer',
      'groups_post_allowed_html'       => 'string',
      'groups_photo_max_width'         => 'integer',
      'groups_photo_max_height'        => 'integer',
      'groups_list_limit'              => 'integer',

      'enable_token_auth'              => 'integer',
      'delete_user_plugin'             => 'integer',

      'admin_comments_delete'           => 'integer',

      'date_format'                    => 'integer',
      'date_custom_format'             => 'string',

      'enable_shoutbox'                => 'integer',
      'shoutbox_refresh_interval'      => 'integer',
      'shoutbox_messages'              => 'integer',
      'cron_job_shoutbox_messages'     => 'integer',
      'shoutbox_log'                   => 'integer',

      'user_delete_comments'           => 'integer',
      'user_delete_photo_comments'     => 'integer',
      'user_delete_video_comments'     => 'integer',
      'user_delete_profile_visits'     => 'integer',
      'user_delete_ratings'            => 'integer',
      'user_delete_shoutbox'           => 'integer',
      'user_delete_interactions'       => 'integer',
      'user_delete_payments'           => 'integer',
      'user_delete_actions'            => 'integer',
      'user_delete_created_groups'     => 'integer',
      'user_delete_posts_in_groups'    => 'integer',

      'enable_gravatar_integration'         => 'integer',
      'enable_chatfactory_integration'      => 'integer',
      'chatfactory_integration_users_list'  => 'integer',
      'chatfactory_integration_delete_user' => 'integer',

      'enable_gmaps'                   => 'integer',
      'gmaps_api_key'                  => 'string',
      'gmaps_default_x'                => 'string',
      'gmaps_default_y'                => 'string',
      'gmaps_default_z'                => 'integer',
      'location_field_city'            => 'integer',
      'location_field_state'           => 'integer',
      'location_field_country'         => 'integer',

      'videos_pagination_limit'          => 'integer',
      'videos_list_pagination_limit'     => 'integer',
      'videos_comments_pagination_limit' => 'integer',
      'videos_embed_allowed_html'        => 'string',

      'search_radius_group_users'      => 'integer',
      'search_radius_group_zoom'       => 'integer',

      'recaptcha_public_key'  => 'string',
      'recaptcha_private_key' => 'string',
      'enable_recaptcha'      => 'integer',

      'enable_profile_friends' => 'integer',
      'profile_friends_number' => 'integer',
      'profile_friends_sort'   => 'integer',
      'profile_friends_top'    => 'integer',

      'limit_search_results'            => 'integer',
      'distances_unit'                  => 'integer',
      'max_search_radius'               => 'integer',
      'enable_search_radius'            => 'integer',
      'enable_search_radius_sex_filter' => 'integer',
      'allow_guest_search_radius'       => 'integer',
      'enable_members_map'              => 'integer',
      'allow_guest_members_map'         => 'integer',
      'members_map_group_users'         => 'integer',
      'members_map_group_zoom'          => 'integer',

      'enable_status'                  => 'integer',
      'status_max_length'              => 'integer',
      'registration_mode'              => 'integer',

      'hide_banned_profiles'           => 'integer',
      'hide_ignored_profiles'          => 'integer',
      'default_photo_extension'        => 'string',
      'enable_user_email_notify'       => 'integer',
      'enable_smarty'                  => 'integer',
      'number_search_results_per_page' => 'integer',
      'allow_guests_view_profile'      => 'integer',
      'end_membership_notification'    => 'integer',
      'cron_password'                  => 'string',
      'end_membership_notify_interval' => 'string',
      'enable_interactions'            => 'integer',
      'enable_interaction_kiss'        => 'integer',
      'enable_interaction_wink'        => 'integer',
      'enable_interaction_hug'         => 'integer',

      'wallpage_add_status'        => 'integer',
      'wallpage_add_photo'         => 'integer',
      'wallpage_add_rating'        => 'integer',
      'wallpage_add_comment'       => 'integer',
      'wallpage_add_photo_comment' => 'integer',
      'html_notifications'         => 'integer',

      'notification_warning_message'        => 'notification',

      'notification_end_membership_subject' => 'notification',
      'notification_end_membership_message' => 'notification',

      'notification_new_comment_enabled' => 'integer',
      'notification_new_comment_subject' => 'string',
      'notification_new_comment_message' => 'notification',

      'notification_new_photo_comment_enabled' => 'integer',
      'notification_new_photo_comment_subject' => 'string',
      'notification_new_photo_comment_message' => 'notification',

      'notification_change_membership_enabled'   => 'integer',
      'notification_change_membership_subject'   => 'string',
      'notification_change_membership_message'   => 'notification',
      'notification_change_membership_receivers' => 'array',

      'notification_new_interaction_enabled' => 'integer',
      'notification_new_interaction_subject' => 'string',
      'notification_new_interaction_message' => 'notification',

      'notification_new_message_enabled' => 'integer',
      'notification_new_message_subject' => 'string',
      'notification_new_message_message' => 'notification',

      'notification_new_rating_enabled' => 'integer',
      'notification_new_rating_subject' => 'string',
      'notification_new_rating_message' => 'notification',

      'cron_job_wallpage_entries_interval' => 'integer',

      'default_membership_access' => 'array',
    );

    parent::__construct();
  }

  function store()
  {
    $this->updateSettings();

    $this->writeSettings();

    return true;
  }

  function updateSettings()
  {
    $post =& JRequest::get('post');

    $this->_prepareData($post);

    foreach ($this->variables as $setting => $type)
    {
      if (!isset($post[$setting]))
      {
        continue;
      }

      switch ($type)
      {
        case 'string':
        case 'integer':
          $this->settings->$setting = addslashes(JRequest::getVar($setting, $this->settings->$setting, 'POST', $type));
        break;

        case 'notification':
          $this->settings->$setting = addslashes(JRequest::getVar($setting, $this->settings->$setting, 'POST', 'string', 4));
        break;

        case 'array':
          $this->settings->$setting = JRequest::getVar($setting, array(), 'POST', $type);
        break;
      }
    }

    $this->settings->currency = strtoupper($this->settings->currency);
  }

  function writeSettings()
  {
    $handle = fopen($this->file, 'w');
    fwrite($handle, $this->templateSettings());
    fclose($handle);
  }

  function templateSettings()
  {
    $max_length = 0;
    foreach ($this->variables as $setting => $type)
    {
      $max_length = (strlen($setting) > $max_length) ? strlen($setting) : $max_length;
    }

    $template = '<?php

defined(\'_JEXEC\') or die(\'Restricted access\');

class LovefactorySettings
{';

    foreach ($this->variables as $setting => $type)
    {
      $template .= "\n";
      $template .=
'  var $' . $setting . str_repeat(' ', $max_length - strlen($setting)) . ' = ';

      switch ($type)
      {
        case 'string':
        case 'notification':
          $template .= '"' . $this->settings->$setting . '"';
        break;

        case 'integer':
          $template .= $this->settings->$setting;
        break;

        case 'array':
          if (count($this->settings->$setting))
          {
            $template .= 'array(\'' . implode('\',\'', $this->settings->$setting) . '\')';
          }
          else
          {
            $template .= 'array()';
          }
        break;
      }

      $template .= ';';
    }
    $template .= "\n";
    $template .=
'}';

    return $template;
  }

  function restoreBackup($backup_settings)
  {
    foreach ($this->variables as $setting => $type)
    {
      if (isset($backup_settings->$setting))
      {
        $this->settings->$setting = $backup_settings->$setting;
      }
    }

    if (isset($backup_settings->terms_and_conditions))
    {
      $this->settings->terms_and_conditions = $backup_settings->terms_and_conditions;
    }

    $this->writeSettings();

    return true;
  }

  function getAdmins()
  {
    $query = ' SELECT u.id, u.username'
           . ' FROM #__users u'
           . ' WHERE u.gid IN (24, 25)'
           . ' ORDER BY u.username ASC';
    $this->_db->setQuery($query);

    return $this->_db->loadObjectList();
  }

  function getAccess()
  {
    $array = array(
      'advancedsearch' => 'Advanced search',
      'blacklist'      => 'Ignore list',
      'comment'        => 'Comment (add, delete, report)',
      //'edit'           => 'Profile edit',
      'friend'         => 'Friendship (request, accept, remove, cancel, reject)',
      'friends'        => 'Friends list',
      'friendspending' => 'Pending friendships requests list',
      'gallery'        => 'Gallery',
      'inbox'          => 'Inbox',
      'interaction'    => 'Interaction (send, respond)',
      'interactions'   => 'Interactions list',
      'mailbox'        => 'Mailbox (empty inbox, empty outbox)',
      'membersmap'     => 'Members map',
      'message'        => 'Message (send, delete, report)',
      'messageread'    => 'Read message',
      'messagewrite'   => 'Write message',
      'myfriends'      => 'My friends list',
      'mygallery'      => 'My gallery',
      'online'         => 'Online users list',
      'outbox'         => 'Outbox',
      'otherprofiles'  => 'Other profiles',
      'rating'         => 'Rating (add)',
      'radiussearch'   => 'Radius search',
      'quicksearch'    => 'Quick search',
      'status'         => 'Status',
      'wallpage'       => 'Detailed wallpage',
    );

    return $array;
  }

  function getShoutboxLogSize()
  {
    $log = JPATH_COMPONENT_ADMINISTRATOR.DS.'shoutbox_log.txt';

    return number_format(filesize($log) / 1024, 2) . ' MB';
  }

  function getSettingsFileIsWritable()
  {
    return is_writable(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');
  }

  function getChatFactory()
  {
    $query = ' SELECT c.id'
           . ' FROM #__components c'
           . ' WHERE link = "option=com_chatfactory"'
           . ' LIMIT 0,1';
    $this->_db->setQuery($query);

    return (bool)$this->_db->loadResult();
  }

  function _prepareData($post)
  {
    // Default access membership
    if (!isset($post['default_membership_access']))
    {
      return false;
    }

    $array = JRequest::getVar('default_membership_access', array(), 'POST', 'array');
    JRequest::setVar('default_membership_access', array_keys($array), 'POST');
  }

  function getLocationFields()
  {
    $dbo =& JFactory::getDbo();

    $query = ' SELECT f.id AS value, f.title AS text'
           . ' FROM #__lovefactory_fields f'
           . ' WHERE f.type_id = 1'
           . ' AND f.published = 1';
    $dbo->setQuery($query);
    $fields = $dbo->loadObjectList();

    array_unshift($fields, JHTML::_('select.option', '', ''));

    return $fields;
  }
}