<?php

defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'plugins'.DS.'factoryPaymentPlugin.class.php');

class Sagepay extends factoryPaymentPlugin
{
  // Required
  function configure()
  {
    parent::configure();

    $this->description = 'Sagepay Payment';
    $this->params      = array('vendor_name',
                               'encryption_password',
                               'referrer_id',
                               'confirmation_email',
                               'send_email',
                               'email_message',
                               'allow_gift_aid',
                               'apply_avscv2',
                               'apply_3dsecure',
                               'mode');

    switch ($this->_params->get('mode', 0))
    {
      case 2: // Simulator
        $this->action = 'https://test.sagepay.com/Simulator/VSPFormGateway.asp';
      break;

      case 1: // Test
        $this->action = 'https://test.sagepay.com/gateway/service/vspform-register.vsp';
      break;

      default: // Live
        $this->action = 'https://live.sagepay.com/gateway/service/vspform-register.vsp';
      break;
    }
  }

  function showAdminConfig()
  {
    ?>

    <table width="100%" class="admintable">
      <tr>
        <td class="key" align="right"><label for="email"><?php echo JText::_('Email'); ?>:</label></td>
        <td><input size="40" name="email" id="email" class="inputbox" value="<?php echo $this->_params->get('email', 'test@sagepay.com'); ?>"></td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="vendor_name"><?php echo JText::_('Sage Pay Vendor Login Name'); ?>:</label></td>
        <td><input size="40" name="vendor_name" class="inputbox" value="<?php echo $this->_params->get('vendor_name', ''); ?>"></td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="encryption_password"><?php echo JText::_('Sage Pay Encryption password'); ?>:</label></td>
        <td><input size="40" name="encryption_password" class="inputbox" value="<?php echo $this->_params->get('encryption_password', ''); ?>"></td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="referrer_id"><?php echo JText::_('Sage Pay Referrer ID'); ?>:</label></td>
        <td><input size="40" name="referrer_id" class="referrer_id" value="<?php echo $this->_params->get('referrer_id', ''); ?>"></td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="confirmation_email"><?php echo JText::_('Confirmation email address'); ?>:</label></td>
        <td><input size="40" name="confirmation_email" class="confirmation_email" value="<?php echo $this->_params->get('confirmation_email', ''); ?>"></td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="send_email"><?php echo JText::_('Send confirmation email'); ?>:</label></td>
        <td>
          <select name="send_email">
            <option value="0" <?php echo 0 == $this->_params->get('send_email', 1) ? 'selected' : ''; ?>><?php echo JText::_('Do not send either customer or vendor e-mails'); ?></option>
            <option value="1" <?php echo 1 == $this->_params->get('send_email', 1) ? 'selected' : ''; ?>><?php echo JText::_('Send customer and vendor e-mails (default)'); ?></option>
            <option value="2" <?php echo 2 == $this->_params->get('send_email', 1) ? 'selected' : ''; ?>><?php echo JText::_('Send vendor e-mail but NOT the customer e-mail'); ?></option>
          </select>
        </td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="email_message"><?php echo JText::_('Email message'); ?>:</label></td>
        <td><textarea cols="40" rows="10" name="email_message" class="email_message"><?php echo $this->_params->get('email_message', ''); ?></textarea></td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="allow_gift_aid"><?php echo JText::_('Enable Gift Aid'); ?>:</label></td>
        <td>
          <select name="allow_gift_aid">
            <option value="0" <?php echo 0 == $this->_params->get('allow_gift_aid', 0) ? 'selected' : ''; ?>><?php echo JText::_('No (default)'); ?></option>
            <option value="1" <?php echo 1 == $this->_params->get('allow_gift_aid', 0) ? 'selected' : ''; ?>><?php echo JText::_('Yes'); ?></option>
          </select>
        </td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="apply_avscv2"><?php echo JText::_('AVS/CV2 checks'); ?>:</label></td>
        <td>
          <select name="apply_avscv2">
            <option value="0" <?php echo 0 == $this->_params->get('apply_avscv2', 0) ? 'selected' : ''; ?>><?php echo JText::_('If AVS/CV2 enabled then check them. If rules apply, use rules (default)'); ?></option>
            <option value="1" <?php echo 1 == $this->_params->get('apply_avscv2', 0) ? 'selected' : ''; ?>><?php echo JText::_('Force AVS/CV2 checks even if not enabled for the account. If rules apply, use rules'); ?></option>
            <option value="2" <?php echo 2 == $this->_params->get('apply_avscv2', 0) ? 'selected' : ''; ?>><?php echo JText::_('Force NO AVS/CV2 checks even if enabled on account'); ?></option>
            <option value="3" <?php echo 3 == $this->_params->get('apply_avscv2', 0) ? 'selected' : ''; ?>><?php echo JText::_('Force AVS/CV2 checks even if not enabled for the account but DON’T apply any rules'); ?></option>
          </select>
        </td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="apply_3dsecure"><?php echo JText::_('3D-Secure checks'); ?>:</label></td>
        <td>
          <select name="apply_3dsecure">
            <option value="0" <?php echo 0 == $this->_params->get('apply_3dsecure', 0) ? 'selected' : ''; ?>><?php echo JText::_('If 3D-Secure checks are possible and rules allow, perform the checks and apply the authorisation rules (default)'); ?></option>
            <option value="1" <?php echo 1 == $this->_params->get('apply_3dsecure', 0) ? 'selected' : ''; ?>><?php echo JText::_('Force 3D-Secure checks if possible and apply rules for authorisation'); ?></option>
            <option value="2" <?php echo 2 == $this->_params->get('apply_3dsecure', 0) ? 'selected' : ''; ?>><?php echo JText::_('Do not perform 3D-Secure checks and always authorise'); ?></option>
            <option value="3" <?php echo 3 == $this->_params->get('apply_3dsecure', 0) ? 'selected' : ''; ?>><?php echo JText::_('Force 3D-Secure checks if possible but ALWAYS obtain an auth code, irrespective of rule base'); ?></option>
          </select>
        </td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="enable"><?php echo JText::_('Enable'); ?>:</label></td>
        <td><?php echo JHTML::_('select.booleanlist', 'enable', 'class="inputbox"', $this->enabled); ?></td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="mode"><?php echo JText::_('Mode'); ?>:</label></td>
        <td>
          <select name="mode">
            <option value="0" <?php echo 0 == $this->_params->get('mode', 0) ? 'selected' : ''; ?>><?php echo JText::_('Live System'); ?></option>
            <option value="1" <?php echo 1 == $this->_params->get('mode', 0) ? 'selected' : ''; ?>><?php echo JText::_('Test System'); ?></option>
            <option value="2" <?php echo 2 == $this->_params->get('mode', 0) ? 'selected' : ''; ?>><?php echo JText::_('Simulator'); ?></option>
          </select>
        </td>
      </tr>

    </table>

    <?php
  }

  function step1()
  {
    global $Itemid;
    $vars = 'GET' == $_SERVER['REQUEST_METHOD'] ? $_SESSION['sagepay_vars'] : array();
    ?>

    <script>

    <?php $this->writeJavascriptCountries(); ?>

    function getCountryOptionsListHtml(strSelectedValue)
    {
      var strCountryOptionsList = '';
      for (var i = 0; i < countries.length; i++)
      {
        strCountryOptionsList += '<option value="' + countries[i].code + '"'
        if (strSelectedValue == countries[i].code) {
            strCountryOptionsList += " SELECTED"
        }
        strCountryOptionsList += ">" + countries[i].name + "</option>\n";
      }

      return strCountryOptionsList;
    }

    function validation()
      {
        name    = document.getElementById("BillingFirstnames").value;
        surname = document.getElementById("BillingSurname").value;
        address = document.getElementById("BillingAddress1").value;
        city    = document.getElementById("BillingCity").value;
        code    = document.getElementById("BillingPostCode").value;
        country = document.getElementById("BillingCountry").selectedIndex;

        error = '';

        if ('' == name)
        {
          error += "<?php echo addslashes(JText::_('Please enter the First Name!')); ?>" + "\n";
        }

        if ('' == surname)
        {
          error += "<?php echo addslashes(JText::_('Please enter the Surname!')); ?>" + "\n";
        }

        if ('' == address)
        {
          error += "<?php echo addslashes(JText::_('Please enter the Address!')); ?>" + "\n";
        }

        if ('' == city)
        {
          error += "<?php echo addslashes(JText::_('Please enter the City!')); ?>" + "\n";
        }

        if ('' == code)
        {
          error += "<?php echo addslashes(JText::_('Please enter the Post/Zip Code!')); ?>" + "\n";
        }

        if (0 == country)
        {
          error += "<?php echo addslashes(JText::_('Please select the Country!')); ?>" + "\n";
        }

        if ('' != error)
        {
          alert(error);
          return false;
        }

        return true;
      }
    </script>

    <form action="index.php" method="POST" onsubmit="return validation();">

    <h1><?php echo JText::_('Sage Pay details:'); ?></h1>

    <table>

      <!-- Billing details -->
      <tr>
        <th colspan="2"><?php echo JText::_('Please enter your Billing details below'); ?></th>
      </tr>

      <tr>
        <td><label for="BillingFirstnames"><span class="warning">*</span><?php echo JText::_('First Name(s)'); ?>:</label></td>
        <td><input id="BillingFirstnames" name="BillingFirstnames" type="text" maxlength="20" value="<?php echo @$vars['BillingFirstnames']; ?>" /></td>
      </tr>

      <tr>
        <td><label for="BillingSurname"><span class="warning">*</span><?php echo JText::_('Surname'); ?>:</label></td>
        <td><input id="BillingSurname" name="BillingSurname" type="text" maxlength="20" value="<?php echo @$vars['BillingSurname']; ?>" /></td>
      </tr>

      <tr>
        <td><label for="BillingAddress1"><span class="warning">*</span><?php echo JText::_('Address Line 1'); ?>:</label></td>
        <td><input id="BillingAddress1" name="BillingAddress1" type="text" maxlength="100" value="<?php echo @$vars['BillingAddress1']; ?>" /></td>
      </tr>

      <tr>
        <td><label for="BillingAddress2"><?php echo JText::_('Address Line 2'); ?>:</label></td>
        <td><input id="BillingAddress2" name="BillingAddress2" type="text" maxlength="100" value="<?php echo @$vars['BillingAddress2']; ?>" /></td>
      </tr>

      <tr>
        <td><label for="BillingCity"><span class="warning">*</span><?php echo JText::_('City'); ?>:</label></td>
        <td><input id="BillingCity" name="BillingCity" type="text" maxlength="40" value="<?php echo @$vars['BillingCity']; ?>" /></td>
      </tr>

      <tr>
        <td><label for="BillingPostCode"><span class="warning">*</span><?php echo JText::_('Post/Zip Code'); ?>:</label></td>
        <td><input id="BillingPostCode" name="BillingPostCode" type="text" maxlength="10" value="<?php echo @$vars['BillingPostCode']; ?>" /></td>
      </tr>

      <tr>
        <td><label for="BillingCountry"><span class="warning">*</span><?php echo JText::_('Country'); ?>:</label></td>
        <td>
          <select id="BillingCountry" name="BillingCountry" style="width: 200px;" >
            <option value=""><?php echo JText::_('Please select...'); ?></option>
            <script type="text/javascript" language="javascript">
				      document.write(getCountryOptionsListHtml("<?php echo @$vars['BillingCountry']; ?>"));
				    </script>
          </select>
        </td>
      </tr>

      <tr>
        <td><label for="BillingState"><?php echo JText::_('State Code (U.S. only)'); ?>:</label></td>
        <td><input id="BillingState" name="BillingState" type="text" maxlength="2" value="<?php echo @$vars['BillingState']; ?>" /></td>
      </tr>

      <tr>
        <td><label for="BillingPhone"><?php echo JText::_('Phone'); ?>:</label></td>
        <td><input id="BillingPhone" name="BillingPhone" type="text" maxlength="20" value="<?php echo @$vars['BillingPhone']; ?>" /></td>
      </tr>
    </table>

      <input type="submit" value="<?php echo JText::_('Next step'); ?>" />

      <input type="hidden" name="step" value="2" />

      <input type="hidden" name="option"     value="com_lovefactory" />
      <input type="hidden" name="controller" value="gateway" />
      <input type="hidden" name="task"       value="process" />
      <input type="hidden" name="method"     value="<?php echo $this->title; ?>" />
      <input type="hidden" name="price"      value="<?php echo $this->price; ?>" />
      <input type="hidden" name="Itemid"     value="<?php echo $Itemid; ?>" />
    </form>
    <?php
  }

  function step2()
  {
    // Get the values
    $vars = array();

    $IsDeliverySame = 'YES';

    $vars['BillingFirstnames'] = $this->cleanInput(JRequest::getVar('BillingFirstnames', '', 'POST', 'string'), 'Text');
    $vars['BillingSurname']    = $this->cleaninput(JRequest::getVar('BillingSurname',    '', 'POST', 'string'), 'Text');
    $vars['BillingAddress1']   = $this->cleaninput(JRequest::getVar('BillingAddress1',   '', 'POST', 'string'), 'Text');
    $vars['BillingAddress2']   = $this->cleaninput(JRequest::getVar('BillingAddress2',   '', 'POST', 'string'), 'Text');
    $vars['BillingCity']       = $this->cleaninput(JRequest::getVar('BillingCity',       '', 'POST', 'string'), 'Text');
    $vars['BillingPostCode']   = $this->cleaninput(JRequest::getVar('BillingPostCode',   '', 'POST', 'string'), 'Text');
    $vars['BillingCountry']    = $this->cleaninput(JRequest::getVar('BillingCountry',    '', 'POST', 'string'), 'Text');
    $vars['BillingState']      = $this->cleaninput(JRequest::getVar('BillingState',      '', 'POST', 'string'), 'Text');
    $vars['BillingPhone']      = $this->cleaninput(JRequest::getVar('BillingPhone',      '', 'POST', 'string'), 'Text');

    $vars['DeliveryFirstnames'] = $vars['BillingFirstnames'];
    $vars['DeliverySurname']    = $vars['BillingSurname'];
    $vars['DeliveryAddress1']   = $vars['BillingAddress1'];
    $vars['DeliveryAddress2']   = $vars['BillingAddress2'];
    $vars['DeliveryCity']       = $vars['BillingCity'];
    $vars['DeliveryPostCode']   = $vars['BillingPostCode'];
    $vars['DeliveryCountry']    = $vars['BillingCountry'];
    $vars['DeliveryState']      = $vars['BillingState'];
    $vars['DeliveryPhone']      = $vars['BillingPhone'];

    // Check for errors
    $error = $this->validateSagePay($vars);

    // If errors were found, show the form again
    if ($error != '')
    {
      // Store the values in session, so we can fill in the fields
      $_SESSION['sagepay_vars'] = $vars;

      // Show the error
      $this->showError($error);

      // Redirect to step 1
      $this->redirectToStep(1);
    }

    // No errors found, create a new order
    $order = $this->createOrder();

    // Create the crypt
    $crypt = $this->createCrypt($order, $vars);

    // Show the confirmation form
    ?>
    <script>

      <?php $this->writeJavascriptCountries(); ?>
      function getCountryName(strCountryCode)
      {
        for (var i = 0; i < countries.length; i++)
        {
          if (strCountryCode == countries[i].code)
          {
            return countries[i].name;
          }
        }

        return "";
      }
    </script>

    <h1><?php echo JText::_('Confirm'); ?></h1>
    <p><?php echo JText::_('Are you sure you want to buy'); ?> <b><?php echo $order->title; ?></b> <?php echo JText::_('using Sagepay?'); ?></p>

    <table>
      <!-- Billing details -->
      <tr>
        <th colspan="2"><?php echo JText::_('Billing details'); ?></th>
      </tr>

      <tr>
        <td><?php echo JText::_('First Name(s)'); ?>:</td>
        <td><?php echo $vars['BillingFirstnames']; ?></td>
      </tr>

      <tr>
        <td><?php echo JText::_('Surname'); ?>:</td>
        <td><?php echo $vars['BillingSurname']; ?></td>
      </tr>

      <tr>
        <td><?php echo JText::_('Address Line 1'); ?>:</td>
        <td><?php echo $vars['BillingAddress1']; ?></td>
      </tr>

      <tr>
        <td><?php echo JText::_('Address Line 2'); ?>:</td>
        <td><?php echo $vars['BillingAddress2']; ?></td>
      </tr>

      <tr>
        <td><?php echo JText::_('City'); ?>:</td>
        <td><?php echo $vars['BillingCity']; ?></td>
      </tr>

      <tr>
        <td><?php echo JText::_('Post/Zip Code'); ?>:</td>
        <td><?php echo $vars['BillingPostCode']; ?></td>
      </tr>

      <tr>
        <td><?php echo JText::_('Country'); ?>:</td>
        <td>
          <script type="text/javascript" language="javascript">
				    document.write(getCountryName("<?php echo $vars['BillingCountry']; ?>"));
					</script>
        </td>
      </tr>

      <tr>
        <td><?php echo JText::_('State Code (U.S. only)'); ?>:</td>
        <td><?php echo $vars['BillingState']; ?></td>
      </tr>

      <tr>
        <td><?php echo JText::_('Phone'); ?>:</td>
        <td><?php echo $vars['BillingPhone']; ?></td>
      </tr>
    </table>

    <form action="<?php echo $this->action; ?>" method="POST" id="SagePayForm" name="SagePayForm">
      <input type="hidden" name="navigate" value="" />
	    <input type="hidden" name="VPSProtocol" value="2.23">
	    <input type="hidden" name="TxType" value="PAYMENT">
	    <input type="hidden" name="Vendor" value="<?php echo $this->_params->get('vendor_name', ''); ?>">
	    <input type="hidden" name="Crypt" value="<?php echo $crypt; ?>">

	    <input type="submit" value="<?php echo JText::_('Confirm'); ?>" />
    </form>

    <?php
  }

  function processIpn()
  {
    $crypt     = @$_GET['crypt'];
    $decrypted =  $this->simpleXor($this->base64Decode($crypt), $this->_params->get('encryption_password', ''));
    $exploded  =  explode('&', $decrypted);

    $vars = array();
    foreach ($exploded as $field)
    {
      $field = explode('=', $field);
      $vars[$field[0]] = $field[1];
    }

    $payment = $this->getNewPayment();

	  $payment->payment_date = $payment->received_at;
	  $payment->refnumber    = $vars['VendorTxCode'];

    $order = $this->getOrder($vars['VendorTxCode']);
    $this->errors = array();

    if ($order)
    {
      // We found the order
      $payment->user_id  = $order->user_id;
	    $payment->amount   = $order->amount;
	    $payment->currency = $order->currency;
	    $payment->order_id = $order->id;

      if ('pending' != $order->status)
      {
        // Seems the order has been already processed
        $payment->status = 'manual-check';
        $this->errors[] = JText::_('Order already processed!');
      }
      else
      {
        switch ($vars['Status'])
        {
          case 'OK':
            $payment->status = 'ok';
          break;

          default:
            $payment->status = 'error';
            $this->errors[] = JText::_('Payment status:') . ' ' . $vars['Status'];
          break;
        }
      }
    }
    else
    {
      // No order found
      $payment->status = 'error';
      $this->errors[] = JText::_('No order found!');
    }

    $this->savePayment($payment);

    // Show the response
    switch ($payment->status)
    {
      case 'ok':
        ?>
          <h1><?php echo JText::_('Payment processed'); ?></h1>
          <p><?php echo JText::_('Payment processed'); ?></p>
        <?php
      break;

      default:
        if ('OK' == $vars['Status'])
        {
          ?>
          <h1><?php echo JText::_('Payment pending'); ?></h1>
          <p><?php echo JText::_("Payment needs to be reviewd by the site's administrator"); ?></p>
          <?php
        }
        else
        {
          ?>
          <h1><?php echo JText::_('Payment failed'); ?></h1>
          <p><?php echo JText::_('Status'); ?>: <?php echo $vars['Status']; ?> (<?php echo $vars['StatusDetail']; ?>)</p>
          <?php
        }
      break;
    }
  }

  // Helpers
  function cleanInput($strRawText,$strType)
  {
    if ($strType=="Number") {
      $strClean="0123456789.";
      $bolHighOrder=false;
    }
    else if ($strType=="VendorTxCode") {
      $strClean="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.";
      $bolHighOrder=false;
    }
    else {
      $strClean=" ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,'/{}@():?-_&�$=%~<>*+\"";
      $bolHighOrder=true;
    }

    $strCleanedText="";
    $iCharPos = 0;

    do
    {
      // Only include valid characters
      $chrThisChar=substr($strRawText,$iCharPos,1);

      if (strspn($chrThisChar,$strClean,0,strlen($strClean))>0) {
        $strCleanedText=$strCleanedText . $chrThisChar;
      }
      else if ($bolHighOrder==true) {
        // Fix to allow accented characters and most high order bit chars which are harmless
        if (bin2hex($chrThisChar)>=191) {
          $strCleanedText=$strCleanedText . $chrThisChar;
        }
      }

      $iCharPos=$iCharPos+1;
    }
    while ($iCharPos<strlen($strRawText));

    $cleanInput = ltrim($strCleanedText);
    return $cleanInput;

  }

  function validateSagePay($sagepay_vars)
  {
    $bIsDeliverySame =& JRequest::getVar('IsDeliverySame', '', 'POST', 'string');
    $bIsDeliverySame =  ($bIsDeliverySame == 'YES') ? true : false;

    // Validate the compulsory fields
    $error = '';
    if (strlen($sagepay_vars['BillingFirstnames'])==0)
      $error="Please enter your Billing First Name(s) where requested below.";
    else if (strlen($sagepay_vars['BillingSurname'])==0)
      $error="Please enter your Billing Surname where requested below.";
    else if (strlen($sagepay_vars['BillingAddress1'])==0)
      $error="Please enter your Billing Address Line 1 where requested below.";
    else if (strlen($sagepay_vars['BillingCity'])==0)
      $error="Please enter your Billing City where requested below.";
    else if (strlen($sagepay_vars['BillingPostCode'])==0)
      $error="Please enter your Billing Post Code where requested below.";
    else if (strlen($sagepay_vars['BillingCountry'])==0)
      $error="Please select your Billing Country where requested below.";
    else if ((strlen($sagepay_vars['BillingState'])==0) and ($sagepay_vars['BillingCountry'] == "US"))
      $error="Please enter your State code as you have selected United States for billing country.";
    else if (($bIsDeliverySame==false) and strlen($sagepay_vars['DeliveryFirstnames'])==0)
      $error="Please enter your Delivery First Names(s) where requested below.";
    else if (($bIsDeliverySame==false) and strlen($sagepay_vars['DeliverySurname'])==0)
      $error="Please enter your Delivery Surname where requested below.";
    else if (($bIsDeliverySame==false) and strlen($sagepay_vars['DeliveryAddress1'])==0)
      $error="Please enter your Delivery Address Line 1 where requested below.";
    else if (($bIsDeliverySame==false) and strlen($sagepay_vars['DeliveryCity'])==0)
      $error="Please enter your Delivery City where requested below.";
    else if (($bIsDeliverySame==false) and strlen($sagepay_vars['DeliveryPostCode'])==0)
      $error="Please enter your Delivery Post Code where requested below.";
    else if (($bIsDeliverySame==false) and strlen($sagepay_vars['DeliveryCountry'])==0)
      $error="Please select your Delivery Country where requested below.";
    else if (($bIsDeliverySame==false) and (strlen($sagepay_vars['DeliveryState'])==0) and ($sagepay_vars['DeliveryCountry'] == "US"))
      $error="Please enter your State code as you have selected United States for delivery country.";

    $error = JText::_($error);

    return $error;
  }

  function createCrypt($order, $vars)
  {
    $strPost = 'VendorTxCode=' . $order->id;

    $strPost .= '&ReferrerID='  . $this->_params->get('referer_id', '');
    $strPost .= '&Amount='      . $order->amount;
    $strPost .= '&Currency='    . $order->currency;
    $strPost .= '&Description=' . $order->title;

    $strPost .= '&SuccessURL=' . $this->notify_url;
    $strPost .= '&FailureURL=' . $this->notify_url;

    $strPost .= '&CustomerName='  . $vars['BillingFirstnames'] . ' ' . $vars['BillingSurname'];
    $strPost .= '&CustomerEMail=' . $this->user->email;
    $strPost .= '&VendorEMail='   . $this->_params->get('confirmation_email', '');
    $strPost .= '&SendEMail='     . $this->_params->get('send_email', '');
    $strPost .= '&eMailMessage='  . $this->_params->get('email_message', '');

    // Billing Details:
    $strPost .= '&BillingFirstnames=' . $vars['BillingFirstnames'];
    $strPost .= '&BillingSurname='    . $vars['BillingSurname'];
    $strPost .= '&BillingAddress1='   . $vars['BillingAddress1'];

    if (strlen($vars['BillingAddress2']) > 0)
    {
      $strPost .= '&BillingAddress2=' . $vars['BillingAddress2'];
    }

    $strPost .= '&BillingCity='     . $vars['BillingCity'];
    $strPost .= '&BillingPostCode=' . $vars['BillingPostCode'];
    $strPost .= '&BillingCountry='  . $vars['BillingCountry'];

    if (strlen($vars['BillingState']) > 0)
    {
      $strPost .= '&BillingState=' . $vars['BillingState'];
    }

    if (strlen($vars['BillingPhone']) > 0)
    {
      $strPost .= '&BillingPhone=' . $vars['BillingPhone'];
    }

    // Delivery Details:
    $strPost .= '&DeliveryFirstnames=' . $vars['DeliveryFirstnames'];
    $strPost .= '&DeliverySurname='    . $vars['DeliverySurname'];
    $strPost .= '&DeliveryAddress1='   . $vars['DeliveryAddress1'];

    if (strlen($vars['DeliveryAddress2']) > 0)
    {
      $strPost .= '&DeliveryAddress2=' . $vars['DeliveryAddress2'];
    }

    $strPost .= '&DeliveryCity='     . $vars['DeliveryCity'];
    $strPost .= '&DeliveryPostCode=' . $vars['DeliveryPostCode'];
    $strPost .= '&DeliveryCountry='  . $vars['DeliveryCountry'];

    if (strlen($vars['DeliveryState']) > 0)
    {
      $strPost .= '&DeliveryState=' . $vars['DeliveryState'];
    }

    if (strlen($vars['DeliveryPhone']) > 0)
    {
      $strPost .= '&DeliveryPhone=' . $vars['DeliveryPhone'];
    }

    // Basket
    $strPost .= '&Basket=' . '1:' . $order->title . ':1:' . $order->amount . ':0:' . $order->amount . ':' . $order->amount;

    $strPost .= '&AllowGiftAid='  . $this->_params->get('allow_gift_aid', '');
    $strPost .= '&ApplyAVSCV2='   . $this->_params->get('apply_avscv2', '');
    $strPost .= '&Apply3DSecure=' . $this->_params->get('apply_3dsecure', '');

    $strCrypt = $this->base64Encode($this->SimpleXor($strPost, $this->_params->get('encryption_password', '')));

    return $strCrypt;
  }

  function base64Encode($plain)
  {
    // Initialise output variable
    $output = "";

    // Do encoding
    $output = base64_encode($plain);

    // Return the result
    return $output;
  }

  function base64Decode($scrambled)
  {
    // Initialise output variable
    $output = "";

    // Fix plus to space conversion issue
    $scrambled = str_replace(" ","+",$scrambled);

    // Do encoding
    $output = base64_decode($scrambled);

    // Return the result
    return $output;
  }

  function simpleXor($InString, $Key)
  {
    // Initialise key array
    $KeyList = array();
    // Initialise out variable
    $output = "";

    // Convert $Key into array of ASCII values
    for($i = 0; $i < strlen($Key); $i++){
      $KeyList[$i] = ord(substr($Key, $i, 1));
    }

    // Step through string a character at a time
    for($i = 0; $i < strlen($InString); $i++) {
      // Get ASCII code from string, get ASCII code from key (loop through with MOD), XOR the two, get the character from the result
      // % is MOD (modulus), ^ is XOR
      $output.= chr(ord(substr($InString, $i, 1)) ^ ($KeyList[$i % strlen($Key)]));
    }

    // Return the result
    return $output;
  }

  function writeJavascriptCountries()
  {
    ?>
    // ISO 3166-1 country names and codes from http://opencountrycodes.appspot.com/javascript
countries = [
    {code: "GB", name: "United Kingdom"},
    {code: "AF", name: "Afghanistan"},
    {code: "AX", name: "Aland Islands"},
    {code: "AL", name: "Albania"},
    {code: "DZ", name: "Algeria"},
    {code: "AS", name: "American Samoa"},
    {code: "AD", name: "Andorra"},
    {code: "AO", name: "Angola"},
    {code: "AI", name: "Anguilla"},
    {code: "AQ", name: "Antarctica"},
    {code: "AG", name: "Antigua and Barbuda"},
    {code: "AR", name: "Argentina"},
    {code: "AM", name: "Armenia"},
    {code: "AW", name: "Aruba"},
    {code: "AU", name: "Australia"},
    {code: "AT", name: "Austria"},
    {code: "AZ", name: "Azerbaijan"},
    {code: "BS", name: "Bahamas"},
    {code: "BH", name: "Bahrain"},
    {code: "BD", name: "Bangladesh"},
    {code: "BB", name: "Barbados"},
    {code: "BY", name: "Belarus"},
    {code: "BE", name: "Belgium"},
    {code: "BZ", name: "Belize"},
    {code: "BJ", name: "Benin"},
    {code: "BM", name: "Bermuda"},
    {code: "BT", name: "Bhutan"},
    {code: "BO", name: "Bolivia"},
    {code: "BA", name: "Bosnia and Herzegovina"},
    {code: "BW", name: "Botswana"},
    {code: "BV", name: "Bouvet Island"},
    {code: "BR", name: "Brazil"},
    {code: "IO", name: "British Indian Ocean Territory"},
    {code: "BN", name: "Brunei Darussalam"},
    {code: "BG", name: "Bulgaria"},
    {code: "BF", name: "Burkina Faso"},
    {code: "BI", name: "Burundi"},
    {code: "KH", name: "Cambodia"},
    {code: "CM", name: "Cameroon"},
    {code: "CA", name: "Canada"},
    {code: "CV", name: "Cape Verde"},
    {code: "KY", name: "Cayman Islands"},
    {code: "CF", name: "Central African Republic"},
    {code: "TD", name: "Chad"},
    {code: "CL", name: "Chile"},
    {code: "CN", name: "China"},
    {code: "CX", name: "Christmas Island"},
    {code: "CC", name: "Cocos (Keeling) Islands"},
    {code: "CO", name: "Colombia"},
    {code: "KM", name: "Comoros"},
    {code: "CG", name: "Congo"},
    {code: "CD", name: "Congo, The Democratic Republic of the"},
    {code: "CK", name: "Cook Islands"},
    {code: "CR", name: "Costa Rica"},
    {code: "CI", name: "Côte d'Ivoire"},
    {code: "HR", name: "Croatia"},
    {code: "CU", name: "Cuba"},
    {code: "CY", name: "Cyprus"},
    {code: "CZ", name: "Czech Republic"},
    {code: "DK", name: "Denmark"},
    {code: "DJ", name: "Djibouti"},
    {code: "DM", name: "Dominica"},
    {code: "DO", name: "Dominican Republic"},
    {code: "EC", name: "Ecuador"},
    {code: "EG", name: "Egypt"},
    {code: "SV", name: "El Salvador"},
    {code: "GQ", name: "Equatorial Guinea"},
    {code: "ER", name: "Eritrea"},
    {code: "EE", name: "Estonia"},
    {code: "ET", name: "Ethiopia"},
    {code: "FK", name: "Falkland Islands (Malvinas)"},
    {code: "FO", name: "Faroe Islands"},
    {code: "FJ", name: "Fiji"},
    {code: "FI", name: "Finland"},
    {code: "FR", name: "France"},
    {code: "GF", name: "French Guiana"},
    {code: "PF", name: "French Polynesia"},
    {code: "TF", name: "French Southern Territories"},
    {code: "GA", name: "Gabon"},
    {code: "GM", name: "Gambia"},
    {code: "GE", name: "Georgia"},
    {code: "DE", name: "Germany"},
    {code: "GH", name: "Ghana"},
    {code: "GI", name: "Gibraltar"},
    {code: "GR", name: "Greece"},
    {code: "GL", name: "Greenland"},
    {code: "GD", name: "Grenada"},
    {code: "GP", name: "Guadeloupe"},
    {code: "GU", name: "Guam"},
    {code: "GT", name: "Guatemala"},
    {code: "GG", name: "Guernsey"},
    {code: "GN", name: "Guinea"},
    {code: "GW", name: "Guinea-Bissau"},
    {code: "GY", name: "Guyana"},
    {code: "HT", name: "Haiti"},
    {code: "HM", name: "Heard Island and McDonald Islands"},
    {code: "VA", name: "Holy See (Vatican City State)"},
    {code: "HN", name: "Honduras"},
    {code: "HK", name: "Hong Kong"},
    {code: "HU", name: "Hungary"},
    {code: "IS", name: "Iceland"},
    {code: "IN", name: "India"},
    {code: "ID", name: "Indonesia"},
    {code: "IR", name: "Iran, Islamic Republic of"},
    {code: "IQ", name: "Iraq"},
    {code: "IE", name: "Ireland"},
    {code: "IM", name: "Isle of Man"},
    {code: "IL", name: "Israel"},
    {code: "IT", name: "Italy"},
    {code: "JM", name: "Jamaica"},
    {code: "JP", name: "Japan"},
    {code: "JE", name: "Jersey"},
    {code: "JO", name: "Jordan"},
    {code: "KZ", name: "Kazakhstan"},
    {code: "KE", name: "Kenya"},
    {code: "KI", name: "Kiribati"},
    {code: "KP", name: "Korea, Democratic People's Republic of"},
    {code: "KR", name: "Korea, Republic of"},
    {code: "KW", name: "Kuwait"},
    {code: "KG", name: "Kyrgyzstan"},
    {code: "LA", name: "Lao People's Democratic Republic"},
    {code: "LV", name: "Latvia"},
    {code: "LB", name: "Lebanon"},
    {code: "LS", name: "Lesotho"},
    {code: "LR", name: "Liberia"},
    {code: "LY", name: "Libyan Arab Jamahiriya"},
    {code: "LI", name: "Liechtenstein"},
    {code: "LT", name: "Lithuania"},
    {code: "LU", name: "Luxembourg"},
    {code: "MO", name: "Macao"},
    {code: "MK", name: "Macedonia, The Former Yugoslav Republic of"},
    {code: "MG", name: "Madagascar"},
    {code: "MW", name: "Malawi"},
    {code: "MY", name: "Malaysia"},
    {code: "MV", name: "Maldives"},
    {code: "ML", name: "Mali"},
    {code: "MT", name: "Malta"},
    {code: "MH", name: "Marshall Islands"},
    {code: "MQ", name: "Martinique"},
    {code: "MR", name: "Mauritania"},
    {code: "MU", name: "Mauritius"},
    {code: "YT", name: "Mayotte"},
    {code: "MX", name: "Mexico"},
    {code: "FM", name: "Micronesia, Federated States of"},
    {code: "MD", name: "Moldova"},
    {code: "MC", name: "Monaco"},
    {code: "MN", name: "Mongolia"},
    {code: "ME", name: "Montenegro"},
    {code: "MS", name: "Montserrat"},
    {code: "MA", name: "Morocco"},
    {code: "MZ", name: "Mozambique"},
    {code: "MM", name: "Myanmar"},
    {code: "NA", name: "Namibia"},
    {code: "NR", name: "Nauru"},
    {code: "NP", name: "Nepal"},
    {code: "NL", name: "Netherlands"},
    {code: "AN", name: "Netherlands Antilles"},
    {code: "NC", name: "New Caledonia"},
    {code: "NZ", name: "New Zealand"},
    {code: "NI", name: "Nicaragua"},
    {code: "NE", name: "Niger"},
    {code: "NG", name: "Nigeria"},
    {code: "NU", name: "Niue"},
    {code: "NF", name: "Norfolk Island"},
    {code: "MP", name: "Northern Mariana Islands"},
    {code: "NO", name: "Norway"},
    {code: "OM", name: "Oman"},
    {code: "PK", name: "Pakistan"},
    {code: "PW", name: "Palau"},
    {code: "PS", name: "Palestinian Territory, Occupied"},
    {code: "PA", name: "Panama"},
    {code: "PG", name: "Papua New Guinea"},
    {code: "PY", name: "Paraguay"},
    {code: "PE", name: "Peru"},
    {code: "PH", name: "Philippines"},
    {code: "PN", name: "Pitcairn"},
    {code: "PL", name: "Poland"},
    {code: "PT", name: "Portugal"},
    {code: "PR", name: "Puerto Rico"},
    {code: "QA", name: "Qatar"},
    {code: "RE", name: "Réunion"},
    {code: "RO", name: "Romania"},
    {code: "RU", name: "Russian Federation"},
    {code: "RW", name: "Rwanda"},
    {code: "BL", name: "Saint Barthélemy"},
    {code: "SH", name: "Saint Helena"},
    {code: "KN", name: "Saint Kitts and Nevis"},
    {code: "LC", name: "Saint Lucia"},
    {code: "MF", name: "Saint Martin"},
    {code: "PM", name: "Saint Pierre and Miquelon"},
    {code: "VC", name: "Saint Vincent and the Grenadines"},
    {code: "WS", name: "Samoa"},
    {code: "SM", name: "San Marino"},
    {code: "ST", name: "Sao Tome and Principe"},
    {code: "SA", name: "Saudi Arabia"},
    {code: "SN", name: "Senegal"},
    {code: "RS", name: "Serbia"},
    {code: "SC", name: "Seychelles"},
    {code: "SL", name: "Sierra Leone"},
    {code: "SG", name: "Singapore"},
    {code: "SK", name: "Slovakia"},
    {code: "SI", name: "Slovenia"},
    {code: "SB", name: "Solomon Islands"},
    {code: "SO", name: "Somalia"},
    {code: "ZA", name: "South Africa"},
    {code: "GS", name: "South Georgia and the South Sandwich Islands"},
    {code: "ES", name: "Spain"},
    {code: "LK", name: "Sri Lanka"},
    {code: "SD", name: "Sudan"},
    {code: "SR", name: "Suriname"},
    {code: "SJ", name: "Svalbard and Jan Mayen"},
    {code: "SZ", name: "Swaziland"},
    {code: "SE", name: "Sweden"},
    {code: "CH", name: "Switzerland"},
    {code: "SY", name: "Syrian Arab Republic"},
    {code: "TW", name: "Taiwan, Province of China"},
    {code: "TJ", name: "Tajikistan"},
    {code: "TZ", name: "Tanzania, United Republic of"},
    {code: "TH", name: "Thailand"},
    {code: "TL", name: "Timor-Leste"},
    {code: "TG", name: "Togo"},
    {code: "TK", name: "Tokelau"},
    {code: "TO", name: "Tonga"},
    {code: "TT", name: "Trinidad and Tobago"},
    {code: "TN", name: "Tunisia"},
    {code: "TR", name: "Turkey"},
    {code: "TM", name: "Turkmenistan"},
    {code: "TC", name: "Turks and Caicos Islands"},
    {code: "TV", name: "Tuvalu"},
    {code: "UG", name: "Uganda"},
    {code: "UA", name: "Ukraine"},
    {code: "AE", name: "United Arab Emirates"},
    {code: "GB", name: "United Kingdom"},
    {code: "US", name: "United States"},
    {code: "UM", name: "United States Minor Outlying Islands"},
    {code: "UY", name: "Uruguay"},
    {code: "UZ", name: "Uzbekistan"},
    {code: "VU", name: "Vanuatu"},
    {code: "VE", name: "Venezuela"},
    {code: "VN", name: "Viet Nam"},
    {code: "VG", name: "Virgin Islands, British"},
    {code: "VI", name: "Virgin Islands, U.S."},
    {code: "WF", name: "Wallis and Futuna"},
    {code: "EH", name: "Western Sahara"},
    {code: "YE", name: "Yemen"},
    {code: "ZM", name: "Zambia"},
    {code: "ZW", name: "Zimbabwe"}
];
    <?php
  }
}