<?php

defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'plugins'.DS.'factoryPaymentPlugin.class.php');

class TargetPay extends factoryPaymentPlugin
{
  function configure()
  {
    parent::configure();

    $this->description = 'Target Pay Ideal';
    $this->params      = array('layoutcode');
  }

  function showAdminConfig()
  {
    ?>

    <table width="100%" class="admintable">
      <tr>
        <td class="key" align="right"><label for="email"><?php echo JText::_('Layoutcode'); ?>:</label></td>
        <td><input size="40" name="layoutcode" id="layoutcode" class="inputbox" value="<?php echo $this->_params->get('layoutcode', ''); ?>"></td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="enable"><?php echo JText::_('Enable'); ?>:</label></td>
        <td><?php echo JHTML::_('select.booleanlist', 'enable', 'class="inputbox"', $this->enabled); ?></td>
      </tr>
    </table>

    <?php
  }

  function step1()
  {
    global $Itemid;

    // Create banks list
    $banks = $this->createBanksList();

    ?>

    <h1><?php echo JText::_('Choose bank'); ?></h1>
    <p><?php echo JText::_('Chose the bank that you want to use'); ?>:</p>

    <br />

    <form action="index.php" method="post">
      <label for="bank"><?php echo JText::_('Bank'); ?>:</label>
      <?php echo JHTML::_('select.genericlist', $banks, 'bank'); ?>

      <br />

      <input type="submit" value="<?php echo JText::_('Confirm'); ?>" />

      <input type="hidden" name="step" value="2" />

      <input type="hidden" name="option"     value="com_lovefactory" />
      <input type="hidden" name="controller" value="gateway" />
      <input type="hidden" name="task"       value="process" />
      <input type="hidden" name="price"      value="<?php echo $this->price; ?>" />
      <input type="hidden" name="method"     value="<?php echo $this->title; ?>" />
      <input type="hidden" name="Itemid"     value="<?php echo $Itemid; ?>" />
    </form>

    <?php
  }

  function step2()
  {
    // Create order
    $order = $this->createOrder();

    $url = 'https://www.targetpay.com/ideal/start';

    // Create params
    $params = array(
      'rtlo'        => $this->_params->get('layoutcode', ''),
      'bank'        => JRequest::getInt('bank', 0, 'POST'),
      'description' => $order->title,
      'currency'    => $order->currency,
      'amount'      => $order->amount,
      'returnurl'   => $this->return_url,
      'reporturl'   => $this->notify_url,
    );

    // Generate GET string
    $string = '';
    foreach ($params as $name => $value)
    {
      $string .= urlencode($name) . '=' . urlencode($value) . '&';
    }
    $string = trim($string, '&');

    // Get response
    $response = file_get_contents($url . '?' . $string);
    $aResponse = explode('|', $response);

    // Check if response is valid
    if (!isset($aResponse[1]))
    {
      ?>
        <h1><?php echo JText::_('Error'); ?></h1>
        <p><?php echo $aResponse[0]; ?></p>
      <?php

      return false;
    }

    $iTrxID  = explode(' ', $aResponse[0]);

    $iTrxID  = $iTrxID[1];
    $bankUrl = $aResponse[1];

    // Create payment
    $date    =& JFactory::getDate();
    $payment =& JTable::getInstance('payment', 'Table');

	  $payment->payment_date = $date->toFormat();
	  $payment->user_id      = $order->user_id;
	  $payment->amount       = $order->amount;
	  $payment->currency     = $order->currency;
	  $payment->order_id     = $order->id;
	  $payment->refnumber    = $iTrxID;
	  $payment->status       = 'processing';

	  $payment->store();

    header('Location: ' . $bankUrl);
  }

  function createBanksList()
  {
    $options = array();
    $xml     = new JSimpleXML();

    $xml->loadString(file_get_contents('https://www.targetpay.com/ideal/getissuers.php?format=xml'));

    foreach ($xml->document->issuer as $issuer)
    {
      $options[] = array('value' => $issuer->attributes('id'), 'text' => $issuer->data());
    }

    return $options;
  }


  function processIpn()
  {
    // Get values from request
    $this->trxid  =& JRequest::getVar('trxid',  '', 'REQUEST', 'string');
    $this->rtlo   =& JRequest::getVar('rtlo',   '', 'REQUEST', 'string');
    $this->status =& JRequest::getVar('status', '', 'REQUEST', 'string');

    // Get the payment
    $dbo =& JFactory::getDBO();
    $query = ' SELECT p.*'
           . ' FROM #__lovefactory_payments p'
           . ' WHERE p.refnumber = "' . $dbo->getEscaped($this->trxid) . '"';
    $dbo->setQuery($query);
    $result = $dbo->loadObject();

    if (!$result)
    {
      return false;
    }

    $payment =& JTable::getInstance('Payment', 'Table');
    $payment->bind($result);

    $this->errors = array();

    // Get the order
    $order = $this->getOrder($payment->order_id);

    // Check if order has been processed
    if ($order->status != 'pending')
    {
      $this->errors[] = JText::_('Order already processed');
    }

    // Check response status
    if (preg_match('/000000 OK/i', $this->status))
    {
      $status = 'Completed';
    }
    else
    {
      $status = 'Failed';

      $this->errors[] = $this->status;
    }

    switch ($status)
	  {
      case 'Completed':
        $payment->status = count($this->errors) ? 'error' : 'ok';
      break;

      default:
      case 'Failed':
        $payment->status = 'error';
      break;
    }

    $this->savePayment($payment);
  }
}