<?php

defined('_JEXEC') or die('Restricted access');

class TableAction extends JTable
{
	var $id         = null;
	var $user_id    = null;
	var $type_id    = null;
	var $sender_id  = null;
	var $title      = null;
	var $text       = null;
	var $link       = null;
	var $item_id    = null;
	var $created_at = null;

	function TableAction(&$db)
	{
		parent::__construct('#__lovefactory_actions', 'id', $db);
	}


	function addStatus($status)
	{
	  if (!$this->checkIfEnabled('status'))
	  {
	    return false;
	  }

	  $user =& JFactory::getUser();

	  $this->user_id = $user->id;
	  $this->type_id = 1;
	  $this->title   = JText::_('WALLPAGE_ENTRY_CHANGED_STATUS');
	  $this->text    = $status;

	  $this->store();
	}

	function addPhoto($user)
	{
	  if (!$this->checkIfEnabled('photo'))
	  {
	    return false;
	  }

	  $this->user_id = $user->id;
	  $this->type_id = 2;
	  $this->title   = JText::_('WALLPAGE_ENTRY_NEW_PHOTO');

	  $this->store();
	}

	function addComment($text, $receiver_id, $sender_id)
	{
	  if (!$this->checkIfEnabled('comment'))
	  {
	    return false;
	  }

	  global $Itemid;
	  $sender =& JFactory::getUser($sender_id);

	  $this->user_id   = $receiver_id;
	  $this->type_id   = 3;
	  $this->sender_id = $sender_id;
	  $this->title     = JText::sprintf('WALLPAGE_ENTRY_NEW_COMMENT', '<a href="%%link%%">' . $sender->username . '</a>');
	  $this->text      = $text;
	  $this->link      = 'index.php?option=com_lovefactory&view=profile&id=' . $sender_id . '&Itemid=' . $Itemid;

	  $this->store();
	}

	function addPhotoComment($comment)
	{
	  if (!$this->checkIfEnabled('photo_comment'))
	  {
	    return false;
	  }

	  global $Itemid;
	  $sender =& JFactory::getUser($comment->user_id);

	  $this->user_id   = $comment->_user_id;
	  $this->type_id   = 5;
	  $this->sender_id = $comment->user_id;
	  $this->title     = JText::sprintf('WALLPAGE_ENTRY_NEW_PHOTO_COMMENT', '<a href="%%link%%">' . $sender->username . '</a>', '%%link2%%');
	  $this->text      = $comment->text;

	  $links = array(
	    'index.php?option=com_lovefactory&view=profile&id=' . $comment->user_id . '&Itemid=%%Itemid%%',
	    'index.php?option=com_lovefactory&view=photo&id=' . $comment->photo_id . '&Itemid=%%Itemid%%',
	  );

	  $this->link = implode("\n", $links);

	  $this->store();
	}

	function addRating($rating, $receiver_id, $sender_id)
	{
	  if (!$this->checkIfEnabled('rating'))
	  {
	    return false;
	  }

	  global $Itemid;
	  $sender =& JFactory::getUser($sender_id);

	  $this->user_id   = $receiver_id;
	  $this->type_id   = 4;
	  $this->sender_id = $sender_id;
	  $this->title     = JText::sprintf('WALLPAGE_ENTRY_NEW_RATING', '<span class="lovefactory-button lovefactory-bullet-star-2">' . $rating . '</span>', '<a href="%%link%%">' . $sender->username . '</a>');
	  $this->link      = 'index.php?option=com_lovefactory&view=profile&id=' . $sender_id . '&Itemid=' . $Itemid;

	  $this->store();
	}

	function checkIfEnabled($action)
	{
	  $settings = new LovefactorySettings();

	  return $settings->{'wallpage_add_' . $action};
	}


	function store($updateNulls = false)
	{
	  $settings = new LovefactorySettings();
		if (!$settings->enable_wallpage)
		{
		  return false;
		}

	  $date =& JFactory::getDate();

	  $this->created_at = $date->toMySql();
	  $this->text = 160 < strlen($this->text) ? substr($this->text, 0, 160) . '...' : $this->text;

	  parent::store($updateNulls);
	}
}
