<?php

defined('_JEXEC') or die('Restricted access');

class TableGroup extends JTable
{
	var $id          = null;
	var $user_id     = null;
	var $private     = null;
	var $title       = null;
	var $description = null;
	var $thumbnail   = null;
	var $created_at  = null;

	function __construct(&$db)
	{
		parent::__construct('#__lovefactory_groups', 'id', $db);
	}

	function getLink()
	{
	  global $Itemid;

	  return JRoute::_('index.php?option=com_lovefactory&view=group&group_id=' . $this->id . '&Itemid=' . $Itemid);
	}

	function getOwnerLink()
	{
	  global $Itemid;

	  return JRoute::_('index.php?option=com_lovefactory&view=profile&id=' . $this->user_id . '&Itemid=' . $Itemid);
	}

	function getThumbnail($size = 'large')
	{
	  $filename = 'group' . ('large' == $size ? '' : '_thumb') . '_' . $this->thumbnail;
	  $filepath = JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id.DS.$filename;
	  $base     = JURI::root().'components/com_lovefactory/';

	  if (file_exists($filepath))
	  {
	    return $base .'storage/photos/'.$this->user_id.'/'.$filename;
	  }

	  return $base.'assets/images/love.png';
	}

	function isMyGroup()
	{
	  $user =& JFactory::getUser();

	  return $user->id == $this->user_id;
	}

	function store($updateNulls = false)
	{
	  if (is_null($this->id) || empty($this->id))
	  {
	    $user =& JFactory::getUser();
	    $date =& JFactory::getDate();

	    $this->created_at = $date->toMySql();
	    $this->user_id    = $user->id;
	  }

	  return parent::store($updateNulls);
	}

	function delete($oid = null)
	{
	  // Delete thumbnail
	  @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id.DS.'group_'.$this->thumbnail);
    @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id.DS.'group_thumb_'.$this->thumbnail);

	  // Delete posts
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_group_posts'
	         . ' WHERE group_id = ' . $this->id;
	  $this->_db->setQuery($query);
	  $this->_db->query();

	  // Delete members
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_group_members'
	         . ' WHERE group_id = ' . $this->id;
	  $this->_db->setQuery($query);
	  $this->_db->query();

	  // Delete bans
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_group_bans'
	         . ' WHERE group_id = ' . $this->id;
	  $this->_db->setQuery($query);
	  $this->_db->query();

	  return parent::delete($oid);
	}
}
