<?php

defined('_JEXEC') or die('Restricted access');

class TableLoveFactoryMessage extends JTable
{
	var $id                  = null;
	var $receiver_id         = null;
	var $sender_id           = null;
	var $date                = null;
	var $title               = null;
	var $text                = null;
	var $unread              = null;
	var $reported            = null;
	var $deleted_by_sender   = null;
	var $deleted_by_receiver = null;

	function __construct(&$db)
	{
		parent::__construct('#__lovefactory_messages', 'id', $db);
	}

	function send($to, $from, $title, $text)
	{
	  $date =& JFactory::getDate();

	  $this->sender_id   = $from;
	  $this->receiver_id = $to;
	  $this->title       = $title;
	  $this->text        = $text;
	  $this->unread      = 1;
	  $this->date        = $date->toMySql();

	  $this->store();
	}

	function sendSystemMessage($to, $title, $text)
	{
	  $this->deleted_by_sender = 1;
	  $this->send($to, 0, $title, $text);
	}

	function markAsRead()
	{
	  $this->unread = 0;

	  $this->store();
	}

	function getReceiverName()
	{
	  $query = ' SELECT username'
	         . ' FROM #__users'
	         . ' WHERE id = ' . $this->receiver_id;
	  $this->_db->setQuery($query);
	  $username = $this->_db->loadResult();

	  return ($username == '') ? JText::_('user deleted') : $username;
	}

	function getSenderName()
	{
	  if ($this->isSystemMessage())
	  {
	    return JText::_('System');
	  }

	  $query = ' SELECT username'
	         . ' FROM #__users'
	         . ' WHERE id = ' . $this->sender_id;
	  $this->_db->setQuery($query);
	  $username = $this->_db->loadResult();

	  return ($username == '') ? JText::_('user deleted') : $username;
	}

	function isSystemMessage()
	{
	  return ($this->sender_id == 0);
	}

	function isSent()
	{
	  $user =& JFactory::getUser();

	  return ($this->sender_id == $user->id);
	}

	function isReceived()
	{
	  return !$this->isSent();
	}

	function softDelete()
	{
	  if ($this->isReceived())
	  {
	    $this->deleted_by_receiver = 1;
	  }

	  if ($this->isSent())
	  {
	    $this->deleted_by_sender = 1;
	  }

	  $this->store();
	}


	function deleteByReceiver()
	{
	  if ($this->deleted_by_sender || 0 == $this->sender_id)
	  {
	    $this->delete();
	  }
	  else
	  {
	    $this->deleted_by_receiver = 1;
	    $this->store();
	  }

	  return true;
	}

	function delete()
	{
	  $user =& JFactory::getUser();

	  if ($user->id == $this->sender_id)
	  {
	    // Message was sent by the user
	    if ($this->deleted_by_receiver || $user->id == $this->receiver_id)
	    {
	      parent::delete();
	    }
	    else
	    {
	      $this->deleted_by_sender = 1;
	      $this->store();
	    }
	  }
	  else
	  {
	    // Message was received by the user
	    if ($this->deleted_by_sender || $user->id == $this->sender_id)
	    {
	      parent::delete();
	    }
	    else
	    {
	      $this->deleted_by_receiver = 1;
	      $this->store();
	    }
	  }
	}
}
