<?php

defined('_JEXEC') or die('Restricted access');

class TablePhoto extends JTable
{
	var $id         = null;
	var $user_id    = null;
	var $filename   = null;
	var $ordering   = null;
	var $is_main    = null;
	var $date_added = null;
	var $status     = null;

	function TablePhoto(&$db)
	{
		parent::__construct('#__lovefactory_photos', 'id', $db);
	}

	function delete()
	{
	  // Delete files
	  $filename = JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id.DS.$this->filename;
	  $thumb    = JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id.DS.'thumb_'.$this->filename;

	  if (file_exists($filename))
	  {
	    @unlink($filename);
	  }

	  if (file_exists($thumb))
	  {
	    @unlink($thumb);
	  }

	  // Update profile
	  if (0 == $this->status)
	  {
	    $profile =& JTable::getInstance('profile', 'Table');
	    $profile->load($this->user_id);
	    $profile->removePhoto($this->filename);
	  }

	  // If needed, set a new main photo
//	  if ($this->filename == $profile->main_photo)
//	  {
//	    $query = ' SELECT p.filename'
//	           . ' FROM #__lovefactory_photos p'
//	           . ' WHERE p.user_id = ' . $profile->user_id
//	           . ' AND p.filename <> "' . $this->filename . '"'
//	           . ' ORDER BY RAND()';
//	    $this->_db->setQuery($query);
//	    $filename = $this->_db->loadResult();
//
//	    $profile->main_photo = is_null($filename) ? '' : $filename;
//	    $profile->store();
//	  }

	  // Delete photo comments
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_photo_comments'
	         . ' WHERE photo_id = ' . $this->id;
	  $this->_db->setQuery($query);
	  $this->_db->query();

	  parent::delete();
	}

	function store($updateNulls = false)
	{
	  $is_new = is_null($this->id);

	  if (!parent::store($updateNulls))
	  {
	    return false;
	  }

	  if ($is_new && 0 === $this->status)
	  {
	    $profile =& JTable::getInstance('profile', 'Table');
	    $profile->load($this->user_id);

	    $profile->addPhoto();
	  }

	  return true;
	}

	function getSource($thumbnail = false)
	{
	  $settings = new LoveFactorySettings();

	  if ('gravatar' == $this->filename)
	  {
	    if ($settings->enable_gravatar_integration)
	    {
	      if (!isset($this->_email))
	      {
	        $user =& JFactory::getUser($this->user_id);
	        $email = md5(strtolower(trim($user->email)));
	      }
	      else
	      {
	        $email = md5(strtolower(trim($this->_email)));
	      }

	      $size = $thumbnail ? max(array($settings->thumbnail_max_width, $settings->thumbnail_max_height)) : 512;

	      return 'http://www.gravatar.com/avatar/'.$email.'?s='.$size.'.jpg';
	    }
	    else
	    {
	      $path = JURI::root().'components/com_lovefactory/';

	      return $path.'assets/images/love.png';
	    }
	  }

	  $thumb = $thumbnail ? 'thumb_' : '';

	  return JURI::root().'components/com_lovefactory/storage/photos/'.$this->user_id.'/'.$thumb.$this->filename;
	}

	function getThumbnailSource()
	{
	  echo '<pre>';
	  var_dump(debug_print_backtrace());
	  echo '</pre>';
	  die('-');
	  return JURI::root().'components/com_lovefactory/storage/photos/'.$this->user_id.'/'.$this->filename;
	}

	function setAsMain()
	{
	  $profile =& JTable::getInstance('profile', 'Table');
	  $profile->load($this->user_id);

	  $profile->main_photo = $this->filename;
	  $profile->store();

	  $this->is_main = 1;

	  return parent::store();
	}
}
