<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class BackendViewMemberships extends JView
{
  function display($tpl = null)
  {
    JToolBarHelper::title(JText::_('Memberships'), 'generic.png');

    JToolBarHelper::custom('pricing', 'creditcard_paypal', '', 'Pricing', false);
    JToolBarHelper::divider();
    JToolBarHelper::makeDefault('setdefault');
    JToolBarHelper::divider();
    JToolBarHelper::publishList();
    JToolBarHelper::unpublishList();
    JToolBarHelper::divider();
    JToolBarHelper::addNew();
    JToolBarHelper::editListX();
    JToolBarHelper::custom('options', 'config', 'config', 'Options', false);
    JToolBarHelper::deleteList(JText::_('Deleting these memberships also deletes the associated prices! Are you sure you want to delete these memberships?'));

    $settings    =  new LovefactorySettings();
    $memberships =& $this->get('Data');
    $pagination  =& $this->get('Pagination');
    $lists		   =& $this->_getViewLists();
    $ordering    =  ($lists['order'] == 'm.ordering');
    $shoutbox    =& $this->get('Shoutbox');

    $this->assignRef('memberships', $memberships);
    $this->assignRef('pagination',  $pagination);
    $this->assignRef('lists',       $lists);
    $this->assignRef('ordering',    $ordering);
    $this->assignRef('shoutbox',    $shoutbox);
    $this->assignRef('settings',    $settings);

    if ($this->_layout == 'options')
    {
      $access = $this->get('Access');
      $this->assignRef('access', $access);
    }
    JHTML::_('behavior.modal');

    parent::display($tpl);
  }

  function moveForm($tpl = null)
	{
	  $this->_layout = 'move';
	  JToolBarHelper::title(JText::_('Membership users'). ': <small><small>[ '. JText::_( 'Move' ) .' ]</small></small>', 'generic.png');

	  JToolBarHelper::customX('doMoveUsers', 'move.png', 'move_f2.png', JText::_('Move Users'), false);
	  JToolBarHelper::cancel();

	  $price             =& JModel::getInstance('Price', 'BackendModel');
    $memberships       =& $price->getMemberships(0);
    $membership_select =  JHTML::_('select.genericlist', $memberships, 'membership_id', 'class="inputbox" size="1"', 'id', 'title');

		$memberships =& $this->get('MembershipsToMove');

	  $this->assignRef('memberships',       $memberships);
	  $this->assignRef('membership_select', $membership_select);

	  parent::display($tpl);
	}

  function &_getViewLists()
	{
		global $mainframe, $option;

		$filter_order     = $mainframe->getUserStateFromRequest($option.'.memberships.filter_order',     'filter_order',     'title', 'cmd');
    $filter_order_Dir = $mainframe->getUserStateFromRequest($option.'.memberships.filter_order_Dir', 'filter_order_Dir', 'asc',   'word');
    $filter_state		  = $mainframe->getUserStateFromRequest($option.'.memberships.filter_state',		 'filter_state',		 '',			'word');

		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		  = $filter_order;

		// state
		$lists['state'] = $filter_state;

		return $lists;
	}
}