<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class BackendViewPayments extends JView
{
  function display($tpl = null)
  {
    require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');

    JToolBarHelper::title(JText::_('Payments'), 'generic.png');

    JToolBarHelper::custom('gateways', 'creditcard_paypal', '', 'Payment Gateways', false);
    JToolBarHelper::divider();
    JToolBarHelper::custom('log', 'table_48', '', 'View full log', false);
    JToolBarHelper::divider();
    JToolBarHelper::publishList('validate', JText::_('Validate'));
    JToolBarHelper::unpublishList('invalidate', JText::_('Invalidate'));
    JToolBarHelper::divider();
    JToolBarHelper::editListX();
    JToolBarHelper::deleteList(JText::_('Are you sure you want to delete these payments?'));

    $payments   =& $this->get('Data');
    $pagination =& $this->get('Pagination');
    $lists		  =& $this->_getViewLists();
    $settings   =  new LovefactorySettings();

    $this->assignRef('payments',   $payments);
    $this->assignRef('pagination', $pagination);
    $this->assignRef('lists',      $lists);
    $this->assignRef('settings',   $settings);

    parent::display($tpl);
  }

	function &_getViewLists()
	{
		global $mainframe, $option;

		$filter_order     = $mainframe->getUserStateFromRequest($option . '.payments.filter_order',     'filter_order',     'title', 'cmd');
    $filter_order_Dir = $mainframe->getUserStateFromRequest($option . '.payments.filter_order_Dir', 'filter_order_Dir', 'asc',   'word');
    $membership		    = $mainframe->getUserStateFromRequest($option . '.payments.membership',		   'membership',		   '',			'int');
    $method		        = $mainframe->getUserStateFromRequest($option . '.payments.method',		       'method',		       '',			'string');
    $status		        = $mainframe->getUserStateFromRequest($option . '.payments.status',		       'status',		       '',			'string');
    $search				    = $mainframe->getUserStateFromRequest($option . '.payments.search',			     'search',			     '',			'string');
		$search				    = JString::strtolower($search);

		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		  = $filter_order;

		// search
		$lists['search'] = $search;

		// membership
		$lists['membership'] = $membership;

	  // method
		$lists['method'] = $method;

		// status
		$lists['status'] = $status;

		// memberships
		$lists['memberships'] = array();
		$lists['memberships'][] = JHTML::_('select.option', '-1', JText::_('- Select Membership -'));

		$model =& JModel::getInstance('Price', 'BackendModel');
		$memberships = $model->getMemberships(0);

		foreach ($memberships as $membership)
		{
		  $lists['memberships'][] = JHTML::_('select.option',  $membership->id, $membership->title);
		}

		// methods
		$lists['methods'] = array();
		$lists['methods'][] = JHTML::_('select.option', '',                 JText::_('- Select Method -'));
		$lists['methods'][] = JHTML::_('select.option', 'pay_paypal',       JText::_('Paypal'));
		$lists['methods'][] = JHTML::_('select.option', 'pay_moneybookers', JText::_('Moneybookers'));
		$lists['methods'][] = JHTML::_('select.option', 'Sage Pay',         JText::_('Sage Pay'));

		// statuses
		$lists['statuses'] = array();
		$lists['statuses'][] = JHTML::_('select.option', '',             JText::_('- Select Status -'));
		$lists['statuses'][] = JHTML::_('select.option', 'ok',           JText::_('Ok'));
		$lists['statuses'][] = JHTML::_('select.option', 'error',        JText::_('Error'));
		$lists['statuses'][] = JHTML::_('select.option', 'manual-check', JText::_('Manual Check'));

		return $lists;
	}
}
