<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class BackendViewReports extends JView
{
  function display($tpl = null)
  {
    JToolBarHelper::title(JText::_('Reports'), 'generic.png');
    JToolBarHelper::unpublishList('unresolveList', JText::_('Unresolve'));
    JToolBarHelper::publishList('resolveList', JText::_('Resolve'));
    JToolBarHelper::deleteList(JText::_('Are you sure you want to delete these reports?'));

    $reports    =& $this->get('Data');
    $pagination =& $this->get('Pagination');
    $lists		  =& $this->_getViewLists();

    $this->assignRef('reports',    $reports);
    $this->assignRef('pagination', $pagination);
    $this->assignRef('lists',      $lists);
    $this->assignRef('settings',   $settings);

    $types = array(1 => JText::_('Message'),
                   2 => JText::_('Comment'),
                   3 => JText::_('Gallery'),
                   4 => JText::_('Photo Comment'),
                   5 => JText::_('Video Comment'),
                   6 => JText::_('Group Post'));
    $this->assignRef('types', $types);

    $status = array();
    $status[] = JHTML::_('select.option', 0, JText::_('- select status -'));
    $status[] = JHTML::_('select.option', 1, JText::_('Not resolved'));
    $status[] = JHTML::_('select.option', 2, JText::_('Resolved'));

    $this->assignRef('status', $status);

    #JHTML::_('stylesheet', 'main.css', 'components/com_lovefactory/assets/css/');

    parent::display($tpl);
  }

  function &_getViewLists()
	{
		global $mainframe, $option;

		$filter_order     = $mainframe->getUserStateFromRequest($option . '.filter_order',     'filter_order',     'title', 'cmd');
    $filter_order_Dir = $mainframe->getUserStateFromRequest($option . '.filter_order_Dir', 'filter_order_Dir', 'asc',   'word');
    $filter_state		  = $mainframe->getUserStateFromRequest($option . '.filter_state',		 'filter_state',		 '',			'word');
    $type		          = $mainframe->getUserStateFromRequest($option . '.type',		         'type',		         '',			'int');
    $status		        = $mainframe->getUserStateFromRequest($option . '.status',		       'status',		       '',			'int');
    $search				    = $mainframe->getUserStateFromRequest($option . '.search',			     'search',			     '',			'string');
		$search				    = JString::strtolower($search);

		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		  = $filter_order;

		// search
		$lists['search'] = $search;

		// types
		$lists['types'] = array();
		$lists['types'][] = JHTML::_('select.option', '0', JText::_('- select type -'));
		$lists['types'][] = JHTML::_('select.option', '1', JText::_('Messages'));
		$lists['types'][] = JHTML::_('select.option', '2', JText::_('Comments'));
		$lists['types'][] = JHTML::_('select.option', '3', JText::_('Galleries'));
		$lists['types'][] = JHTML::_('select.option', '4', JText::_('Photo Comments'));
		$lists['types'][] = JHTML::_('select.option', '5', JText::_('Video Comments'));
		$lists['types'][] = JHTML::_('select.option', '6', JText::_('Group Posts'));

		// type
		$lists['type'] = $type;

		// status
		$lists['status'] = $status;

		return $lists;
	}
}