jQueryFactory.fn.extend({
  update: function (link) {
    var $this  = jQueryFactory(this);
    var tbody  = jQueryFactory('tbody', $this);
    var tfoot  = jQueryFactory('tfoot', $this);
    var height = tbody.outerHeight();

    tbody.html('<tr class="loading"><td colspan="20" style="height: ' + height + 'px;"></td></tr>');

    jQueryFactory.get(link, function (response) {
      tfoot.remove();
      tbody.remove();
      $this.append(response);
    });
  }
});

jQueryFactory(document).ready(function ($) {
  // No caching for ajax calls
  $.ajaxSetup({ cache: false });

  // Pagination
  $('td.lf-pagination a').live('click', function (event) {
    event.preventDefault();

    $('.lf-table').update(this.href);
  });

  // Sort by change
  $('#sort_groups').change(function () {
    $.cookie('lf-groupmembers-sortby', this.value);

    $('.lf-table').update('index.php?option=com_lovefactory&view=groupmembers&format=raw&group_id=' + lf_group_id);
  });

  // Sort order change
  $('#sort_order').live('click', function (event) {
    event.preventDefault();

    var value = 'asc' == this.title ? 1 : 0;

    $.cookie('lf-groupmembers-sortorder', value);

    if (value) {
      this.title     = 'desc';
      this.innerHTML = txt_desc;
      $(this).removeClass('lovefactory-asc').addClass('lovefactory-desc');
    }
    else {
      this.title     = 'asc';
      this.innerHTML = txt_asc;
      $(this).removeClass('lovefactory-desc').addClass('lovefactory-asc');
    }

    $('.lf-table').update('index.php?option=com_lovefactory&view=groupmembers&format=raw&group_id=' + lf_group_id);
  });
});