jQueryFactory.fn.extend({
  update: function (link) {
    var $this  = jQueryFactory(this);
    var tbody  = jQueryFactory('tbody', $this);
    var tfoot  = jQueryFactory('tfoot', $this);
    var height = tbody.outerHeight();

    tbody.html('<tr class="loading"><td colspan="20" style="height: ' + height + 'px;"></td></tr>');

    jQueryFactory.get(link, function (response) {
      tfoot.remove();
      tbody.remove();
      $this.append(response);

      jQueryFactory('a', '.lf-group-actions').ajaxAction();

      // Text expandable
      jQueryFactory('.expandable').expander({
        expandPrefix: '… ',
        expandText: '<small>read more</small>',
        userCollapse: false,
        slicePoint: 65,
      });
    });
  }
});

jQueryFactory(document).ready(function ($) {
  // No caching for ajax calls
  $.ajaxSetup({ cache: false });

  $('a', '.lf-group-actions').ajaxAction();

  // Pagination
  $('td.lf-pagination a').live('click', function (event) {
    event.preventDefault();

    $('.lf-table').update(this.href);
  });

  // Filter change
  $('#filter_groups').change(function () {
    $.cookie('lf-groups-filter-groups', this.value);

    $('.lf-table').update('index.php?option=com_lovefactory&view=groups&format=raw');
  });

  // Sort by change
  $('#sort_groups').change(function () {
    $.cookie('lf-groups-sortby-groups', this.value);

    $('.lf-table').update('index.php?option=com_lovefactory&view=groups&format=raw');
  });

  // Sort order change
  $('#sort_order').live('click', function (event) {
    event.preventDefault();

    var value = 'asc' == this.title ? 1 : 0;

    $.cookie('lf-groups-sortorder-groups', value);

    if (value) {
      this.title     = 'desc';
      this.innerHTML = txt_desc;
      $(this).removeClass('lovefactory-asc').addClass('lovefactory-desc');
    }
    else {
      this.title     = 'asc';
      this.innerHTML = txt_asc;
      $(this).removeClass('lovefactory-desc').addClass('lovefactory-asc');
    }

    $('.lf-table').update('index.php?option=com_lovefactory&view=groups&format=raw');
  });

  // Text expandable
  $('.expandable').expander({
    expandPrefix: '… ',
    expandText: '<small>read more</small>',
    userCollapse: false,
    slicePoint: 65,
  });

  function update(link)
  {
    var table  = $('.lf-table');
    var tbody  = $('tbody', table);
    var tfoot  = $('tfoot', table);
    var height = tbody.outerHeight();

    tbody.html('<tr class="loading"><td colspan="20" style="height: ' + height + 'px;"></td></tr>');

    $.get(link, function (response) {
      tfoot.remove();
      tbody.remove();
      table.append(response);
    });
  }
});