<?php

defined('_JEXEC') or die('Restricted access');

class FrontendControllerFriend extends FrontendController
{
	function request()
	{
	  $model    = $this->getModel('friend');
	  $response = array();

	  if ($model->request())
	  {
	    $response['success'] = true;
	    $response['message'] = JText::_('FRIENDS_TASK_REQUEST_SUCCESS');
	    $response['link']    = JRoute::_('index.php?option=com_lovefactory&view=requests', false);
	    $response['text']    = JText::_('FRIENDS_TASK_REQUEST_SUCCESS_TEXT');
	    $response['ajax']    = false;

	    $response['removeClass'] = 'lovefactory-user-add lovefactory-ajax-action';
	    $response['addClass']    = 'lovefactory-user-go';

	    $response['status']     = 1;
	    $response['request_id'] = $model->_request_id;
	    $response['code']       = 0;
	  }
	  else
	  {
	    $response['success'] = false;
	    $response['message'] = '<b>'.JText::_('FRIENDS_TASK_REQUEST_FAILURE') . '</b>';

	    $response['status'] = 0;
	    $response['error']  = $model->getError();
	    $response['code']   = isset($model->_code) ? $model->_code : 0;
	  }

	  $settings = new LovefactorySettings();
	  if (2 == $response['code'] && !$settings->invalid_membership_action)
	  {
	    $response['code'] = 0;
	  }

	  $this->renderJson($response);
	}

	function cancel()
	{
	  $model = $this->getModel('friend');
	  $response = array();

    if ($model->cancel())
    {
      $response['status']  = 1;
      $response['message'] = JText::_('FRIENDS_TASK_CANCEL_SUCCESS');
      $response['error']   = '';
      $response['text']    = JText::_('FREINDS_TASK_CANCEL_SUCCESS_TEXT');
    }
    else
    {
      $response['status']  = 0;
      $response['message'] = JText::_('FRIENDS_TASK_CANCEL_FAILURE');
      $response['error']   = $model->getError();
      $response['text']    = '';
    }

    if ($this->isAjaxRequest())
    {
      $this->renderJson($response);
    }

    global $Itemid;
    if ($model->getError())
    {
      JError::raiseWarning(0, $model->getError());
    }

    $this->setRedirect(JRoute::_('index.php?option=com_lovefactory&view=requests&Itemid=' . $Itemid, false), $message);

	}

	function remove()
	{
	  $model    = $this->getModel('friend');
	  $response = array();

    if ($model->remove())
    {
      $response['success'] = true;
	    $response['message'] = JText::_('FRIENDS_TASK_REMOVE_SUCCESS');
	    $response['link']    = JRoute::_('index.php?option=com_lovefactory&controller=friend&task=request&id='.$model->_user_id, false);
	    $response['text']    = JText::_('FRIENDS_TASK_REMOVE_SUCCESS_TEXT');
	    $response['ajax']    = false;

	    $response['removeClass'] = 'lovefactory-user-delete';
	    $response['addClass']    = 'lovefactory-user-add';

	    $response['status'] = 1;
    }
    else
    {
      $response['succes']  = false;
      $response['message'] = '<b>'.JText::_('FRIENDS_TASK_REMOVE_FAILURE').'</b>';

      $response['status'] = 0;
      $response['error']  = $model->getError();
    }

    if ($this->isAjaxRequest())
    {
      $this->renderJson($response);
    }

    global $Itemid;
    if ($model->getError())
    {
      JError::raiseWarning('ERROR', $model->getError());
    }

    $this->setRedirect(JRoute::_('index.php?option=com_lovefactory&view=myfriends&Itemid=' . $Itemid, false), $message);
	}


  function accept()
	{
	  $model = $this->getModel('friend');

	  if ($model->accept())
	  {
	    $msg = JText::_('FRIENDS_TASK_ACCEPT_SUCCESS');
	  }
	  else
	  {
	    $msg = JText::_('FRIENDS_TASK_ACCEPT_FAILURE');
	  }

    global $Itemid;

    $settings = new LovefactorySettings();
    if (isset($model->_code) && 2 == $model->_code && $settings->invalid_membership_action)
    {
      global $mainframe;

      $mainframe->redirect(JRoute::_('index.php?option=com_lovefactory&controller=membership&task=redirectnomembership&code=4&Itemid=' . $Itemid, true));
    }

    $this->setRedirect(JRoute::_('index.php?option=com_lovefactory&view=requests&Itemid=' . $Itemid, false), $msg);
	}

	function reject()
	{
	  $model = $this->getModel('friend');

    if ($model->reject())
    {
      $msg = JText::_('FRIENDS_TASK_REJECT_SUCCESS');
    }
    else
    {
      $msg = JText::_('FRIENDS_TASK_REJECT_FAILURE');
    }

    global $Itemid;

    $this->setRedirect(JRoute::_('index.php?option=com_lovefactory&view=requests&Itemid=' . $Itemid, false), $msg);
	}

	// Top Friend
	function addTopFriend()
	{
	  $model    = $this->getModel('friend');
	  $response = array();

	  if ($model->addTopFriend())
	  {
	    $response['success'] = true;
	    $response['message'] = JText::_('FRIENDS_TASK_ADDTOPFRIEND_SUCCESS');
	    $response['link']    = JRoute::_('index.php?option=com_lovefactory&controller=friend&task=removetopfriend&friendship=' . $model->friendship_id, false);
	    $response['text']    = JText::_('FRIENDS_TASK_ADDTOPFRIEND_SUCCESS_TEXT');

	    $response['removeClass'] = 'lovefactory-star-add';
	    $response['addClass']    = 'lovefactory-star-delete';
	  }
	  else
	  {
	    $response['success'] = false;
	    $response['message'] = '<b>'.JText::_('FRIENDS_TASK_ADDTOPFRIEND_FAILURE') . '</b><br />' . $model->getError();

	    $settings = new LovefactorySettings();
	    if (isset($model->_redirectInvalidAction) && $model->_redirectInvalidAction && $settings->invalid_membership_action)
	    {
	      global $Itemid;
	      $response['redirect'] = JRoute::_('index.php?option=com_lovefactory&controller=membership&task=redirectnomembership&code=5&Itemid=' . $Itemid, true);
	    }
	  }

	  $this->renderJson($response);
	}

	function removeTopFriend()
	{
	  $model    = $this->getModel('friend');
	  $response = array();

	  if ($model->removeTopFriend())
	  {
	    $response['success'] = true;
	    $response['message'] = JText::_('FRIENDS_TASK_REMOVETOPFRIEND_SUCCESS');
	    $response['link']    = JRoute::_('index.php?option=com_lovefactory&controller=friend&task=addtopfriend&friendship=' . $model->friendship_id, false);
	    $response['text']    = JText::_('FRIENDS_TASK_REMOVETOPFRIEND_SUCCESS_TEXT');

	    $response['removeClass'] = 'lovefactory-star-delete';
	    $response['addClass']    = 'lovefactory-star-add';
	  }
	  else
	  {
	    $response['success'] = false;
	    $response['message'] = '<b>'.JText::_('FRIENDS_TASK_REMOVETOPFRIEND_FAILURE') . '</b><br />' . $model->getError();
	  }

	  $this->renderJson($response);
	}
}