<?php

defined('_JEXEC') or die('Restricted access');

class FrontendControllerRelationship extends FrontendController
{
	function request()
	{
	  $model = $this->getModel('relationship');
	  $response = array();

	  if ($model->request())
	  {
	    $response['status']     = 1;
	    $response['message']    = JText::_('MY_RELATIONSHIP_TASK_REQUEST_SUCCESS');
	    $response['error']      = '';
	    $response['request_id'] = $model->_request_id;
	    $response['text']       = JText::_('MY_RELATIONSHIP_TASK_REQUEST_SUCCESS_TEXT');
	  }
	  else
	  {
	    $response['status']     = 0;
	    $response['message']    = JText::_('MY_RELATIONSHIP_TASK_REQUEST_FAILURE');
	    $response['error']      = $model->getError();
	    $response['request_id'] = 0;
	    $response['text']       = '';
	  }

	  $this->renderJson($response);
	}

	function cancel()
	{
	  $model = $this->getModel('relationship');
	  $response = array();

    if ($model->cancel())
    {
      $response['status']  = 1;
      $response['message'] = JText::_('MY_RELATIONSHIP_TASK_CANCEL_SUCCESS');
      $response['error']   = '';
      $response['text']    = JText::_('MY_RELATIONSHIP_TASK_CANCEL_SUCCESS_TEXT');
    }
    else
    {
      $response['status']  = 0;
      $response['message'] = JText::_('MY_RELATIONSHIP_TASK_CANCEL_FAILURE');
      $response['error']   = $model->getError();
      $response['text']    = '';
    }

    if ($this->isAjaxRequest())
    {
      $this->renderJson($response);
    }

    global $Itemid;
    if ($model->getError())
    {
      JError::raiseWarning(0, $model->getError());
    }

    $this->setRedirect(JRoute::_('index.php?option=com_lovefactory&view=requests&Itemid=' . $Itemid, false), $message);

	}

	function remove()
	{
	  $model = $this->getModel('relationship');
	  $response = array();

    if ($model->remove())
    {
      $response['status']  = 1;
      $response['message'] = JText::_('MY_RELATIONSHIP_TASK_REMOVE_SUCCESS');
      $response['error']   = 0;
      $response['text']    = JText::_('MY_RELATIONSHIP_TASK_REMOVE_SUCCESS_TEXT');
    }
    else
    {
      $response['status']  = 0;
      $response['message'] = JText::_('MY_RELATIONSHIP_TASK_REMOVE_FAILURE');
      $response['error']   = $model->getError();
      $response['text']    = '';
    }

    if ($this->isAjaxRequest())
    {
      $this->renderJson($response);
    }

    global $Itemid;
    if ($model->getError())
    {
      JError::raiseWarning(0, $model->getError());
    }

    $this->setRedirect(JRoute::_('index.php?option=com_lovefactory&view=myrelationship&Itemid=' . $Itemid, false), $message);
	}


  function accept()
	{
	  $model = $this->getModel('relationship');

	  if ($model->accept())
	  {
	    $msg  = JText::_('MY_RELATIONSHIP_TASK_ACCEPT_SUCCESS');
	    $view = 'myrelationship';
	  }
	  else
	  {
	    $msg  = JText::_('MY_RELATIONSHIP_TASK_ACCEPT_FAILURE');
	    $view = 'requests';
	  }

    global $Itemid;
    $this->setRedirect(JRoute::_('index.php?option=com_lovefactory&view=' . $view . '&Itemid=' . $Itemid, false), $msg);
	}

	function reject()
	{
	  $model = $this->getModel('relationship');

    if ($model->reject())
    {
      $msg = JText::_('MY_RELATIONSHIP_TASK_REJECT_SUCCESS');
    }
    else
    {
      $msg = JText::_('MY_RELATIONSHIP_TASK_REJECT_FAILURE');
    }

    global $Itemid;

    $this->setRedirect(JRoute::_('index.php?option=com_lovefactory&view=requests&Itemid=' . $Itemid, false), $msg);
	}
}