<?php

defined('_JEXEC') or die('Restricted access');

class FrontendControllerVideo extends FrontendController
{
	function commentsList()
	{
	  $view  =& $this->getView('Video', 'raw');
	  $model =& $this->getModel('VideoComments', 'FrontendModel');

	  $view->assignRef('comments',   $model->getData());
	  $view->assignRef('comments_pagination', $model->getPagination());
	  $view->assignRef('my_video',   $model->getIsMyVideo());

	  $view->display('comments');
	}

	function videosList()
	{
	  $view  =& $this->getView('Video', 'raw');
	  $model =& $this->getModel('Video', 'FrontendModel');

	  $view->assignRef('videos',     $model->getData());
	  $view->assignRef('pagination', $model->getPagination());

	  $view->display('list');
	}

	function submitComment()
	{
	  $model =& $this->getModel('VideoComments', 'FrontendModel');
	  $response = array();

	  if ($model->add())
	  {
	    $response['status'] = 1;
	    $response['message'] = JText::_('VIDEOS_COMMENTS_ADD_SUCCESS');
	  }
	  else
	  {
	    $response['status'] = 0;
	  }

	  $this->renderJson($response);
	}

	function removeComment()
	{
	  $model =& $this->getModel('VideoComments', 'FrontendModel');
	  $response = array();

	  if ($model->remove())
	  {
	    $response['status']  = 1;
	    $response['message'] = JText::_('VIDEOS_COMMENTS_REMOVE_SUCCESS');
	  }
	  else
	  {
	    $response['status']  = 0;
	    $response['message'] = $model->getError();
	  }

	  $this->renderJson($response);
	}

	function reportComment()
	{
	  $model =& $this->getModel('VideoComments', 'FrontendModel');
	  $response = array();

	  if ($model->report())
	  {
	    $response['status']  = 1;
	    $response['message'] = JText::_('VIDEOS_COMMENTS_COMMENT_REPORTED');
	  }
	  else
	  {
	    $response['status']  = 0;
	    $response['message'] = $model->getError();
	  }

	  $this->renderJson($response);
	}

	function loadVideo()
	{
	  $view     =& $this->getView('Video', 'raw');
	  $comments =& $this->getModel('VideoComments', 'FrontendModel');
	  $model    =& $this->getModel('Video', 'FrontendModel');
	  $video    =  $model->getVideo();

	  $view->assignRef('video',      $video);
	  $view->assignRef('comments',   $comments->getData());
	  $view->assignRef('comments_pagination', $comments->getPagination());
	  $view->assignRef('my_video',   $video->isMyVideo());

	  $view->display('load_video');
	}
}