<?php

class TheFactoryHelper
{
  function format_date($date, $mode = 'date', $format = 'Y-m-d H:i:s')
  {
    $date = strtotime($date) ? strtotime($date) : $date;

    switch ($mode)
    {
      case 'ago':
        $joomla_date =& JFactory::getDate();
        $difference  =  $joomla_date->_date - $date;

        if ($difference < 3600)
        {
          $difference = floor($difference / 60);
          if (0 == $difference)
          {
            $output = JText::_('LESS_THAN_A_MINUTE_AGO');
          }
          else
          {
            $output = $difference . ' ' . (1 == $difference ? JText::_('MINUTE_AGO') : JText::_('MINUTES_AGO'));
          }
        }
        elseif ($difference < 3600 * 24)
        {
          $difference = floor($difference / 3600);
          $output = $difference . ' ' . (1 == $difference ? JText::_('HOUR_AGO') : JText::_('HOURS_AGO'));
        }
        else
        {
          $difference = floor($difference / 3600 / 24);
          $output = $difference . ' ' . (1 == $difference ? JText::_('DAY_AGO') : JText::_('DAYS_AGO'));
        }
      break;

      case 'date':
        $output = date($format, $date);
      break;
    }

    return $output;
  }

  function strip_text($text, $max_length = 100)
  {
    $length = strlen($text);

    if ($length <= $max_length)
    {
      return $text;
    }

    return substr($text, 0, $max_length) . '...';
  }

  function date($timestamp)
  {
    $settings  = new LovefactorySettings();
    $timestamp = strtotime($timestamp) ? strtotime($timestamp) : $timestamp;

    switch ($settings->date_format)
    {
      case 1: // xx days/minutes ago
      default:
        $date = TheFactoryHelper::format_date($timestamp, 'ago');
      break;

      case 2: // Custom format
        $date = date($settings->date_custom_format, $timestamp);
      break;
    }

    return $date;
  }

  function isAdmin($user)
  {
    return in_array($user->gid, array(24, 25));
  }

  function adminCommentsDelete($user)
  {
    $settings = new LovefactorySettings();

    if (!$settings->admin_comments_delete)
    {
      return false;
    }

    return TheFactoryHelper::isAdmin($user);
  }
}