<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelComments extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;
  var $_limit;
  var $_limitstart;

  function __construct()
  {
    parent::__construct();

    global $mainframe;
    $this->_limit      = JRequest::getVar('limit',      10, 'REQUEST', 'integer');
    $this->_limitstart = JRequest::getVar('limitstart', 0,  'GET', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
  }

  function getData()
  {
    if (empty($this->_data))
    {
      $user =& JFactory::getUser();

      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);

      foreach ($this->_data as $i => $comment)
      {
        $profile =& $this->getTable('profile', 'Table');
        $profile->user_id    = $comment->sender_id;
        $profile->main_photo = $comment->main_photo;
        $profile->sex        = $comment->sex;

        $this->_data[$i]->_profile   = $profile;
        $this->_data[$i]->username   = is_null($comment->username) ? JText::_('USER_DELETED') : $comment->username;
        $this->_data[$i]->date       = TheFactoryHelper::date($comment->date);
        $this->_data[$i]->my_profile = $comment->receiver_id == $user->id || TheFactoryHelper::adminCommentsDelete($user);
      }
    }

    $this->getPagination();

    return $this->_data;
  }

  function _buildQuery()
  {
    $user =& JFactory::getUser();
    $id   =& JRequest::getVar('id', 0, 'REQUEST', 'integer');

    $id = $id == 0 ? $user->id : $id;

    $query = ' SELECT c.*, u.username, p.main_photo, p.sex'
           . ' FROM #__lovefactory_comments c'
           . ' LEFT JOIN #__users u ON u.id = c.sender_id'
           . ' LEFT JOIN #__lovefactory_profiles p ON p.user_id = c.sender_id'
           . ' WHERE c.receiver_id = ' . $id
           . ' AND deleted = 0'
           . ' ORDER BY c.date DESC';

    return $query;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }
}