<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelGateway extends JModel
{
  // Task
  function process()
  {
    $step     =& JRequest::getVar('step',    0, 'REQUEST', 'integer');
    $method   =& JRequest::getVar('method', '', 'REQUEST', 'cmd');
    $price    =& JRequest::getVar('price',   0, 'REQUEST', 'integer');
    $settings =  new LoveFactorySettings();

    // Check if price is available for user gender
    $user    =& JFactory::getUser();
    $profile =& $this->getTable('profile', 'Table');
    $table   =& $this->getTable('price', 'Table');
    $profile->load($user->id);
    $table->load($price);

    if (count($table->_errors))
    {
      JError::raiseWarning(0, JText::_('GATEWAY_PRICE_NOT_FOUND'));
      return false;
    }

    if ($settings->gender_pricing && !$table->hasGender($profile->sex))
    {
      JError::raiseWarning(0, JText::_('GATEWAY_PRICE_NOT_AVAILABLE'));
      return false;
    }

    // Check for gateway
    $gateway =& $this->getTable('gateway', 'Table');
    $gateway->findOneByTitle($method);

    if (count($gateway->_errors) || !$gateway->enabled)
    {
      JError::raiseWarning(0, JText::_('GATEWAY_NOT_FOUND'));
      return false;
    }

    JLoader::register($gateway->title, JPATH_COMPONENT_ADMINISTRATOR.DS.'plugins'.DS.'payment'.DS.$gateway->title.'.php');
    $gateway = new $gateway->title();

    $gateway->price = $price;
    $gateway->executeStep($step);
  }

  // View
  function getGateway()
  {
    $gateway =& JRequest::getVar('gateway', '', 'GET',     'cmd');
    $step    =& JRequest::getVar('step',     0, 'REQUEST', 'integer');

    JLoader::register($gateway, JPATH_COMPONENT_ADMINISTRATOR.DS.'plugins'.DS.'payment'.DS.$gateway.'.php');

    if (!class_exists($gateway))
    {
      JError::raiseWarning(0, JText::_('GATEWAY_NOT_FOUND'));
      return false;
    }
    $gateway = new $gateway();

    if (!$gateway->enabled)
    {
      JError::raiseWarning(0, JText::_('GATEWAY_NOT_FOUND'));
      return false;
    }

    if (!method_exists($gateway, 'step'.$step))
    {
      JError::raiseWarning(0, JText::_('GATEWAY_NOT_FOUND'));
      return false;
    }

    return $gateway;
  }
}