<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelGroup extends JModel
{
  function getData()
  {
    $user     =& JFactory::getUser();
    $group_id =& JRequest::getVar('group_id', 0, 'REQUEST', 'integer');
    $group    =& $this->getTable('Group', 'Table');

    $query = ' SELECT g.*, gm.id AS group_member, u.username AS creator_username'
           . ' FROM #__lovefactory_groups g'
           . ' LEFT JOIN #__lovefactory_group_members gm ON gm.group_id = g.id AND gm.user_id = ' . $user->id
           . ' LEFT JOIN #__users u ON u.id = g.user_id'
           . ' WHERE g.id = ' . $group_id;
    $this->_db->setQuery($query);
    $result = $this->_db->loadObject();

    $group->bind($result);
    $group->group_member     = $result->group_member;
    $group->creator_username = $result->creator_username;
    $group->created_at       = TheFactoryHelper::format_date($result->created_at, 'ago');
    $group->info             = JText::sprintf('GROUP_INFO', '<a href="' . $group->getOwnerLink() . '" class="lovefactory-button lovefactory-user">' . $group->creator_username . '</a>', $group->created_at);

    $this->_group = $group;

    return $group;
  }

  function getPosts()
  {
    $this->_limit      =& JRequest::getVar('limit',      2, 'REQUEST', 'integer');
    $this->_limitstart =& JRequest::getVar('limitstart', 0,  'GET',     'integer');
    $this->_limitstart =  ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);

    $user     =& JFactory::getUser();
    $group_id =& JRequest::getVar('group_id', 0, 'GET', 'integer');

    // Check if user can delete posts
    $canDelete = false;
    if (in_array($user->gid, array(24, 25)) || $this->_group->user_id == $user->id)
    {
      $canDelete = true;
    }

    $orderby = ' ORDER BY g.created_at DESC';

    // Get posts
    $mainQuery = ' SELECT g.*, p.main_photo, IF(f.id IS NULL, 0, 1) AS is_friend, u.username,'
               . '   gb.id AS excluded, IF(g.user_id = ' . $user->id . ', 1, 0) AS my_post'
               . ' FROM #__lovefactory_group_posts g'
               . ' LEFT JOIN #__lovefactory_profiles p ON p.user_id = g.user_id'
               . ' LEFT JOIN #__users u ON u.id = p.user_id'
               . ' LEFT JOIN #__lovefactory_friends f ON (((f.sender_id = g.user_id AND f.receiver_id = '.$user->id.') OR (f.receiver_id = g.user_id AND f.sender_id = '.$user->id.')) AND f.pending = 0)'
               . ' LEFT JOIN #__lovefactory_group_bans gb ON gb.group_id = g.group_id AND gb.user_id = g.user_id'
               . ' WHERE g.group_id = ' . $group_id;

    $query = $mainQuery . ' AND g.parent_id = 0' . $orderby;
    $this->_db->setQuery($query, $this->_limitstart, $this->_limit);
    $posts = $this->_db->loadObjectList('id');

    foreach ($posts as $i => $post)
    {
      $profile =& $this->getTable('Profile', 'Table');
      $profile->bind($post);

      $profile->_is_friend   = $post->is_friend;
      $posts[$i]->profile    = $profile;
      $posts[$i]->replies    = array();
      $posts[$i]->created_at = TheFactoryHelper::format_date($post->created_at, 'ago');
      $posts[$i]->text       = nl2br($post->text);
      $posts[$i]->canDelete  = $canDelete;
      $posts[$i]->excluded   = $post->excluded;
      $posts[$i]->my_post    = $post->my_post;
    }

    // Get replies
    if ($posts)
    {
      $query = $mainQuery . ' AND g.parent_id IN (' . implode(',', array_keys($posts)) . ')' . $orderby;
      $this->_db->setQuery($query);
      $replies = $this->_db->loadObjectList();

      foreach ($replies as $reply)
      {
        $profile =& $this->getTable('Profile', 'Table');
        $profile->bind($reply);

        $profile->_is_friend = $reply->is_friend;
        $reply->profile      = $profile;
        $reply->text         = nl2br($reply->text);
        $reply->created_at   = TheFactoryHelper::format_date($reply->created_at, 'ago');
        $reply->canDelete    = $canDelete;
        $reply->excluded     = $reply->excluded;
        $reply->my_post      = $reply->my_post;

        $posts[$reply->parent_id]->replies[] = $reply;
      }
    }

    return $posts;
  }

  function getPagination($ajax = true)
  {
    if (empty($this->_pagination))
    {
      if ($ajax)
      {
        $app    =& JFactory::getApplication();
        $router =& $app->getRouter();

        $router->setVar('format', 'raw');
      }

      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $group_id =& JRequest::getVar('group_id', 0, 'GET', 'integer');

      $query = ' SELECT COUNT(1)'
             . ' FROM #__lovefactory_group_posts g'
             . ' WHERE g.group_id = ' . $group_id
             . ' AND g.parent_id = 0';
      $this->_db->setQuery($query);
      $this->_total = $this->_db->loadResult();
    }
    return $this->_total;
  }

  function join()
  {
    $user     =& JFactory::getUser();
    $group_id =& JRequest::getVar('group_id', 0, 'GET', 'integer');
    $profile  =& $this->getTable('Profile', 'Table');
    $group    =& $this->getTable('Group', 'Table');

    // Get user profile
    $profile->loadAndMembership($user->id);

    // Check if user is allowed to join groups
    if ($profile->membershipGroupsLimitReached('join'))
    {
      $this->setError(JText::_('GROUP_TASK_JOIN_ERROR_LIMIT_REACHED'));

      $settings = new LovefactorySettings();
      if ($settings->invalid_membership_action)
      {
        $this->_code = 7;
      }

      return false;
    }

    $group->load($group_id);

    // Check if group exists
    if (is_null($group->user_id))
    {
      $this->setError(JText::_('GROUP_TASK_JOIN_ERROR_GROUP_NOT_FOUND'));
      return false;
    }

    // Check if user is the creator of the group
    if ($group->user_id == $user->id)
    {
      $this->setError(JText::_('GROUP_TASK_JOIN_ERROR_GROUP_OWNER'));
      return false;
    }

    // Check if user is already a member of the group
    $query = ' SELECT m.id'
           . ' FROM #__lovefactory_group_members m'
           . ' WHERE m.user_id = ' . $user->id
           . ' AND m.group_id = ' . $group_id;
    $this->_db->setQuery($query);
    $result = $this->_db->loadResult();

    if ($result)
    {
      $this->setError(JText::_('GROUP_TASK_JOIN_ERROR_ALREADY_MEMBER'));
      return false;
    }

    // Check if the user has been banned
    $query = ' SELECT gb.id'
           . ' FROM #__lovefactory_group_bans gb'
           . ' WHERE gb.user_id = ' . $user->id
           . ' AND gb.group_id = ' . $group_id;
    $this->_db->setQuery($query);
    $result = $this->_db->loadResult();

    if ($result)
    {
      $this->setError(JText::_('GROUP_TASK_JOIN_ERROR_BANNED'));
      return false;
    }

    // All ok, add user to the group
    $member =& $this->getTable('GroupMember', 'Table');

    $member->user_id  = $user->id;
    $member->group_id = $group_id;

    $member->store();

    $this->_group_id = $group_id;

    return true;
  }

  function leave()
  {
    $user     =& JFactory::getUser();
    $group_id =& JRequest::getVar('group_id', 0, 'GET', 'integer');
    $member   =& $this->getTable('GroupMember', 'Table');

    // Get the member id
    $query = ' SELECT m.id'
           . ' FROM #__lovefactory_group_members m'
           . ' WHERE m.user_id = ' . $user->id
           . ' AND m.group_id = ' . $group_id;
    $this->_db->setQuery($query);
    $id = $this->_db->loadResult();

    if (!$id)
    {
      $this->setError(JText::_('GROUP_TASK_LEAVE_ERROR_MEMBER_NOT_FOUND'));
      return false;
    }

    $member->delete($id);

    $this->_group_id = $group_id;

    return true;
  }

  function post()
  {
    $user     =& JFactory::getUser();
    $post_id  =& JRequest::getVar('post_id',  0,  'POST', 'integer');
    $group_id =& JRequest::getVar('group_id', 0,  'POST', 'integer');
    $message  =& JRequest::getVar('message',  '', 'POST', 'string', 2);

    // Prepare the message
    $settings = new LovefactorySettings();
    $tags    = explode(',', $settings->groups_post_allowed_html);
	  $message = strip_tags($message, '<' . implode('><', $tags) . '>');
	  $aDisabledAttributes = array('onabort', 'onactivate', 'onafterprint', 'onafterupdate', 'onbeforeactivate', 'onbeforecopy', 'onbeforecut', 'onbeforedeactivate', 'onbeforeeditfocus', 'onbeforepaste', 'onbeforeprint', 'onbeforeunload', 'onbeforeupdate', 'onblur', 'onbounce', 'oncellchange', 'onchange', 'onclick', 'oncontextmenu', 'oncontrolselect', 'oncopy', 'oncut', 'ondataavaible', 'ondatasetchanged', 'ondatasetcomplete', 'ondblclick', 'ondeactivate', 'ondrag', 'ondragdrop', 'ondragend', 'ondragenter', 'ondragleave', 'ondragover', 'ondragstart', 'ondrop', 'onerror', 'onerrorupdate', 'onfilterupdate', 'onfinish', 'onfocus', 'onfocusin', 'onfocusout', 'onhelp', 'onkeydown', 'onkeypress', 'onkeyup', 'onlayoutcomplete', 'onload', 'onlosecapture', 'onmousedown', 'onmouseenter', 'onmouseleave', 'onmousemove', 'onmoveout', 'onmouseover', 'onmouseup', 'onmousewheel', 'onmove', 'onmoveend', 'onmovestart', 'onpaste', 'onpropertychange', 'onreadystatechange', 'onreset', 'onresize', 'onresizeend', 'onresizestart', 'onrowexit', 'onrowsdelete', 'onrowsinserted', 'onscroll', 'onselect', 'onselectionchange', 'onselectstart', 'onstart', 'onstop', 'onsubmit', 'onunload');
    $message = preg_replace('/<(.*?)>/ie', "'<' . preg_replace(array('/javascript:[^\"\']*/i', '/(" . implode('|', $aDisabledAttributes) . ")[ \\t\\n]*=[ \\t\\n]*[\"\'][^\"\']*[\"\']/i', '/\s+/'), array('', '', ' '), stripslashes('\\1')) . '>'", $message);

    // Check if message is empty
    if ('' == $message)
    {
      $this->setError(JText::_('GROUP_TASK_POST_ERROR_MESSAGE_EMPTY'));
      return false;
    }

    // Check if user is allowed to post in this group
    $query = ' SELECT gm.id'
           . ' FROM #__lovefactory_group_members gm'
           . ' WHERE gm.user_id = ' . $user->id
           . ' AND gm.group_id = ' . $group_id;
    $this->_db->setQuery($query);
    $result = $this->_db->loadResult();

    if (!$result)
    {
      $this->setError(JText::_('GROUP_TASK_POST_ERROR_NOT_ALLOWED_TO_POST_IN_GROUP'));
      return false;
    }

    // If it's a reply, check that the post belongs to the group
    if ($post_id)
    {
      $groupPost =& $this->getTable('GroupPost');
      $groupPost->load($post_id);

      if ($groupPost->group_id != $group_id)
      {
        $this->setError(JText::_('GROUP_TASK_POST_ERROR_POST_NOT_FOUND'));
        return false;
      }
    }

    // Post the message
    $groupPost =& $this->getTable('GroupPost');
    $group     =& $this->getTable('Group');

    $group->load($group_id);

    $groupPost->group_id  = $group_id;
    $groupPost->parent_id = $post_id;
    $groupPost->text      = $message;
    $groupPost->user_id   = $user->id;

    // Store the post
    $groupPost->store();

    $groupPost->username   = $user->username;
    $groupPost->created_at = TheFactoryHelper::format_date($groupPost->created_at, 'ago');
    $groupPost->text       = nl2br($groupPost->text);

    $profile =& $this->getTable('profile', 'Table');
    $profile->load($user->id);
    $groupPost->profile   = $profile;
    $groupPost->canDelete = (in_array($user->gid, array(24, 25)) || $group->user_id == $user->id);
    $groupPost->replies   = array();
    $groupPost->my_post   = true;

    $this->_reply = $groupPost;
    $this->_group = $this->getData();

    return true;
  }

  function deletePost()
  {
    $user      =& JFactory::getUser();
    $post_id   =& JRequest::getVar('post_id', 0, 'GET', 'integer');
    $group     =& $this->getTable('Group', 'Table');
    $groupPost =& $this->getTable('GroupPost', 'Table');

    // Get post
    $groupPost->load($post_id);

    // Check if post exists
    if (!$groupPost)
    {
      $this->setError(JText::_('GROUP_TASK_DELETE_REPLY_ERROR_NOT_FOUND'));
      return false;
    }

    // Get group
    $group->load($groupPost->group_id);

    // Check if user is allowed to delete
    if (!in_array($user->gid, array(24, 25)) && $group->user_id != $user->id)
    {
      $this->setError(JText::_('GROUP_TASK_DELETE_REPLY_NOT_ALLOWED'));
      return false;
    }

    // Delete
    $groupPost->delete();

    return true;
  }

  function save()
  {
    jimport('joomla.filesystem.file');

    $user  =& JFactory::getUser();
    $id    =& JRequest::getVar('id', 0, 'POST', 'integer');
    $group =& $this->getTable('Group');
    $settings = new LovefactorySettings();

    $isNew = false;

    // Trying to create a new group
    if (!$id)
    {
      // Check if group creation is allowed
      if (!$settings->groups_allow_users_create)
      {
        global $mainframe;
        $mainframe->redirect(JRoute::_('index.php?option=com_lovefactory&view=notavailable&layout=notenabled'));
      }

      $profile =& $this->getTable('Profile');
      $profile->loadAndMembership($user->id);

      // Check if user is allowed to create any more groups
      if ($profile->membershipGroupsLimitReached('create'))
      {
        $this->setError(JText::_('GROUP_CREATE_TASK_SAVE_ERROR_NOT_ALLOWED'));
        return false;
      }

      $isNew = true;
      $group->user_id = $user->id;
    }
    else
    {
      $group->load($id);

      // Check if it's my group
      if ($group->user_id != $user->id)
      {
        $this->setError(JText::_('GROUP_CREATE_TASK_SAVE_ERROR_NOT_ALLOWED'));
        return false;
      }

      // Check for thumbnail delete
      $delete_thumb =& JRequest::getVar('delete_thumb', 0, 'POST', 'integer');

      if ($delete_thumb)
      {
        @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$group->user_id.DS.'group_'.$group->thumbnail);
        @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$group->user_id.DS.'group_thumb_'.$group->thumbnail);

        $group->thumbnail = '';
      }
    }

    // Upload thumbnail
    $thumbnail = JRequest::getVar('thumbnail', array(), 'FILES', 'array');

    if (count($thumbnail) && !$thumbnail['error'])
    {
      require_once(JPATH_COMPONENT_SITE.DS.'resizeIMG.php');

      // Delete old thumbnail
      @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$group->user_id.DS.'group_'.$group->thumbnail);
      @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$group->user_id.DS.'group_thumb_'.$group->thumbnail);

      // Upload new thumbnail
      $user_folder = JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$group->user_id;
      $extension   = strtolower(JFile::getExt($thumbnail['name']));
      $filename    = md5($group->user_id . time() . rand(0, 1000000)) . '.' . $extension;

      $filepath = JPath::clean($user_folder.DS.'group_'.$filename);
      $resize = new RESIZEIMAGE($thumbnail['tmp_name']);
      $resize->resize_scale($settings->groups_photo_max_width, $settings->groups_photo_max_height, $filepath, false);
      $resize->close();

      $filepath = JPath::clean($user_folder.DS.'group_thumb_'.$filename);
      $resize = new RESIZEIMAGE($thumbnail['tmp_name']);
      $resize->resize_scale(100, 63, $filepath);
      $resize->close();

      $group->thumbnail = $filename;
    }

    $group->bind(JRequest::get('post'));
    $group->user_id = $user->id;
    $group->store();

    if ($isNew)
    {
      // Create owner group member
      $member =& $this->getTable('GroupMember');

      $member->group_id = $group->id;
      $member->user_id  = $group->user_id;

      $member->store();
    }

    return true;
  }

  function delete()
  {
    $id    =& JRequest::getVar('id', 0, 'GET', 'integer');
    $group =& $this->getTable('Group');

    // Load the group
    $group->load($id);

    // Check if it my group
    if (!$group->isMyGroup())
    {
      JError::raiseWarning(0, JText::_('GROUP_DELETE_NOT_MY_GROUP'));
      return false;
    }

    return $group->delete();
  }
}