<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelInteractions extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;
  var $_limit;
  var $_limitstart;

  function __construct()
  {
    parent::__construct();

    global $mainframe;
    $this->_limit      = JRequest::getVar('limit',      $mainframe->getCfg('list_limit'), 'REQUEST', 'integer');
    $this->_limitstart = JRequest::getVar('limitstart', 0,                                'REQUEST', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);

    $this->types = array(
      1 => array(
        'text'   => JText::_('INTERACTIONS_RECEIVED_KISS'),
        'action' => JText::_('INTERACTIONS_RESPOND_KISS'),
        'img'    => 1),
      2 => array(
        'text'   => JText::_('INTERACTIONS_RESPONDEND_KISS'),
        'action' => false,
        'img'    => 1),
      3 => array(
        'text'   => JText::_('INTERACTIONS_RECEIVED_WINK'),
        'action' => JText::_('INTERACTIONS_RESPOND_WINK'),
        'img'    => 3),
      4 => array(
        'text'   => JText::_('INTERACTIONS_RESPONDED_WINK'),
        'action' => false,
        'img'    => 3),
      5 => array(
        'text'   => JText::_('INTERACTIONS_RECEIVED_HUG'),
        'action' => JText::_('INTERACTIONS_RESPOND_HUG'),
        'img'    => 5),
      6 => array(
        'text'   => JText::_('INTERACTIONS_RESPONDED_HUG'),
        'action' => false,
        'img'    => 5),
    );
  }

  // View
  function getData()
  {
    if (empty($this->_data))
    {
      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);

      $interactions = array();
      foreach ($this->_data as $i => $interaction)
      {
        $interactions[] = $interaction->id;
        $this->_data[$i]->text   = $this->types[$interaction->type_id]['text'];
        $this->_data[$i]->img    = $this->types[$interaction->type_id]['img'];
        $this->_data[$i]->action = $this->types[$interaction->type_id]['action'];

        $this->_data[$i]->username = is_null($interaction->username) ? JText::_('USER_DELETED') : $interaction->username;
        $this->_data[$i]->date = TheFactoryHelper::date($interaction->date);
      }

      $this->markAsSeen($interactions);
    }

    return $this->_data;
  }

  function _buildQuery()
  {
    $user =& JFactory::getUser();

    $query = ' SELECT i.*, u.username'
           . ' FROM #__lovefactory_interactions i'
           . ' LEFT JOIN #__users u ON u.id = i.sender_id'
           . ' WHERE i.receiver_id = ' . $user->id
           . ' ORDER BY i.date DESC';

    return $query;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }

  function getTypes()
  {
    return $this->types;
  }

  // Helpers
  function markAsSeen($interactions)
  {
    if (count($interactions))
    {
      $query = ' UPDATE #__lovefactory_interactions'
             . ' SET seen = 1'
             . ' WHERE id IN (' . implode(', ', $interactions) . ')';
      $this->_db->setQuery($query);

      $this->_db->query();
    }
  }

  function getUnseen()
  {
    $user =& JFactory::getUser();

    if ($user->guest)
    {
      return false;
    }

    $query = ' SELECT COUNT(id)'
           . ' FROM #__lovefactory_interactions i'
           . ' WHERE i.receiver_id = ' . $user->id
           . ' AND seen = 0';

    $this->_db->setQuery($query);
    return $this->_db->loadResult();
  }


  // Tasks
  function deleteAll()
  {
    $user =& JFactory::getUser();

    $query = ' DELETE'
           . ' FROM #__lovefactory_interactions'
           . ' WHERE receiver_id = ' . $user->id;
    $this->_db->setQuery($query);

    return $this->_db->query($query);
  }
}