<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelMemberships extends JModel
{
  function getPricing()
  {
    $settings = new LovefactorySettings();

    $query = ' SELECT p.*'
           . ' FROM #__lovefactory_pricing p'
           . ' WHERE p.published = 1'
           . ' AND p.is_trial = 0'
           . ' ORDER BY p.months ASC';
    $this->_db->setQuery($query);
    $prices = $this->_db->loadObjectList();
    $array = array();

    foreach ($prices as $price)
    {
      if ($price->months == 0)
      {
        $price->months = 9999;
      }

      if (!isset($array[$price->months]))
      {
        $array[$price->months] = array();
      }

      $array[$price->months][$price->membership_id] = $price;

      // Prepare prices for each gender
      if ($settings->gender_pricing)
      {
        JModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'models');
        $model =& JModel::getInstance('price', 'BackendModel');

        $genders       = $this->getAvailableGenders();
        $gender_prices = $model->_prepareGenderPrices($price->gender_prices);

        foreach ($gender_prices as $gender => $gender_price)
        {
          if (!in_array($gender, $genders))
          {
            unset($gender_prices[$gender]);
          }
        }

        $price->gender_prices = $gender_prices;
      }
    }

    ksort($array);

    return $array;
  }

  function getTrials()
  {
    $settings = new LovefactorySettings();
    $date     =& JFactory::getDate();

    $query = ' SELECT p.*'
           . ' FROM #__lovefactory_pricing p'
           . ' WHERE p.published = 1'
           . ' AND p.is_trial = 1'
           . ' AND (p.available_interval = 0 OR (UNIX_TIMESTAMP(p.available_from) <= ' . $date->toUnix(). ' AND UNIX_TIMESTAMP(p.available_until) >= ' . $date->toUnix(). '))'
           . ' ORDER BY p.months ASC';
    $this->_db->setQuery($query);
    $prices = $this->_db->loadObjectList();
    $array = array();

    foreach ($prices as $price)
    {
      if ($price->months == 0)
      {
        $price->months = 9999;
      }

      if (!isset($array[$price->months]))
      {
        $array[$price->months] = array();
      }

      $array[$price->months][$price->membership_id] = $price;

      // Prepare prices for each gender
      if ($settings->gender_pricing)
      {
        JModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'models');
        $model =& JModel::getInstance('price', 'BackendModel');

        $genders       = $this->getAvailableGenders();
        $gender_prices = $model->_prepareGenderPrices($price->gender_prices);

        foreach ($gender_prices as $gender => $gender_price)
        {
          if (!in_array($gender, $genders))
          {
            unset($gender_prices[$gender]);
          }
        }

        $price->gender_prices = $gender_prices;
      }
    }

    ksort($array);

    return $array;
  }

  function getPrices()
  {
    $query = ' SELECT p.*, m.title'
           . ' FROM #__lovefactory_pricing p'
           . ' LEFT JOIN #__lovefactory_memberships m ON m.id = p.membership_id'
           . ' WHERE p.published = 1'
           . ' AND p.is_trial = 0'
           . ' ORDER BY p.price ASC, m.ordering ASC, p.months ASC';
    $this->_db->setQuery($query);
    $prices = $this->_db->loadObjectList('id');

    $settings = new LovefactorySettings();

    if ($settings->gender_pricing)
    {
      // Get available genders
      $genders = $this->getAvailableGenders();

      // Get user gender
      $profile =& $this->getTable('profile', 'Table');
      $user    =& JFactory::getUser();

      $profile->load($user->id);
      $this->gender = $profile->sex;

      // Filter prices only for user gender
      foreach ($prices as $i => $price)
      {
        $table =& $this->getTable('price', 'Table');
        $table->bind($price);

        if (!$table->hasGender($this->gender) || !in_array($this->gender, $genders) || '0.00' == $table->getGenderPrice($this->gender))
        {
          unset($prices[$i]);
        }
        else
        {
          $prices[$i]->price = $table->getGenderPrice($this->gender);
        }
      }
    }

    return $prices;
  }

  function getPrice()
  {
    require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');
    $settings = new LovefactorySettings();

    $id =& JRequest::getVar('price', 0, 'POST', 'integer');

    $query = ' SELECT p.*, m.title'
           . ' FROM #__lovefactory_pricing p'
           . ' LEFT JOIN #__lovefactory_memberships m ON m.id = p.membership_id'
           . ' WHERE p.id = ' . $id;
    $this->_db->setQuery($query);
    $price = $this->_db->loadObject();

    // Is it published?
    if ($price->published == 0)
    {
      JError::raiseWarning(0, JText::_('MEMBERSHIPS_TASK_GETPRICE_NOT_FOUND'));
      return false;
    }

    return $price;
  }

  function getMemberships()
  {
    $query = ' SELECT m.*,'
           . '   IF (m.max_friends=-1, "'              . JText::_('MEMBERSHIPS_UNLIMITED') . '", m.max_friends)              AS max_friends,'
           . '   IF (m.max_photos=-1, "'               . JText::_('MEMBERSHIPS_UNLIMITED') . '", m.max_photos)               AS max_photos,'
           . '   IF (m.max_videos=-1, "'               . JText::_('MEMBERSHIPS_UNLIMITED') . '", m.max_videos)               AS max_videos,'
           . '   IF (m.max_messages_per_day=-1, "'     . JText::_('MEMBERSHIPS_UNLIMITED') . '", m.max_messages_per_day)     AS max_messages_per_day,'
           . '   IF (m.max_interactions_per_day=-1, "' . JText::_('MEMBERSHIPS_UNLIMITED') . '", m.max_interactions_per_day) AS max_interactions_per_day,'
           . '   IF (m.top_friends=-1, "'              . JText::_('MEMBERSHIPS_UNLIMITED') . '", m.top_friends)              AS top_friends,'
           . '   IF (m.groups_create=-1, "'            . JText::_('MEMBERSHIPS_UNLIMITED') . '", m.groups_create)            AS groups_create,'
           . '   IF (m.groups_join=-1, "'              . JText::_('MEMBERSHIPS_UNLIMITED') . '", m.groups_join)              AS groups_join'
           . ' FROM #__lovefactory_memberships m'
           . ' WHERE m.published = 1'
           . ' ORDER BY m.ordering ASC';
    $this->_db->setQuery($query);

    return $this->_db->loadObjectList();
  }

  function getGateways()
  {
    jimport('joomla.filesystem.file');
    jimport('joomla.filesystem.folder');

    $query = ' SELECT g.title'
           . ' FROM #__lovefactory_gateways g'
           . ' WHERE g.enabled = 1';
    $this->_db->setQuery($query);
    $published = $this->_db->loadObjectList('title');

    $gateways = JFolder::files(JPATH_COMPONENT_ADMINISTRATOR.DS.'plugins'.DS.'payment');
    $array    = array();

    foreach ($gateways as $gateway)
    {
      $plugin = JFile::stripExt($gateway);

      if (!array_key_exists($plugin, $published))
      {
        continue;
      }

      JLoader::register($plugin, JPATH_COMPONENT_ADMINISTRATOR.DS.'plugins'.DS.'payment'.DS.$gateway);

      $plugin = new $plugin();
      $plugin->thumbnail = $plugin->getLogo();

      if ($plugin->enabled)
      {
        $array[] = $plugin;
      }
    }

    return $array;
  }


  function getOrder()
  {
    $id   =& JRequest::getVar('order', 0, 'GET', 'integer');
    $user =& JFactory::getUser();

    $this->order =& $this->getTable('order');
    $this->order->load($id);

    if (count($this->order->_errors) || $this->order->user_id != $user->id)
    {
      $this->order = false;
    }

    return $this->order;
  }

  function getGateway()
  {
    if (!$this->order)
    {
      return false;
    }

    JLoader::register($this->order->gateway, JPATH_COMPONENT_ADMINISTRATOR.DS.'plugins'.DS.'payment'.DS.$this->order->gateway.'.php');
    $gateway = new $this->order->gateway();

    return $gateway;
  }

  function getAvailableGenders()
  {
    JModel::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'models');
    $model   =& JModel::getInstance('price', 'BackendModel');

    return $model->getGenders();
  }


  function getShoutbox()
  {
    $membership =& $this->getTable('membership');

    return $membership->getShoutboxValues();
  }


  function getSelect()
  {
    $selected =& JRequest::getVar('id', 0, 'GET', 'integer');
    $settings =  new LovefactorySettings();

    // Get the prices
    $prices = $this->getPrices();

    // Show warning if selected price was not found
    if ($selected && !isset($prices[$selected]))
    {
      JError::raiseWarning(0, JText::_('MEMBERSHIPS_TASK_GETSELECT_NOT_FOUND'));
    }

    $gender_string = $settings->gender_pricing ? $this->gender . ' ' : '';

    $options = array();
    foreach ($prices as $price)
    {
      $text = ($price->months == 0 ? JText::_('MEMBERSHIP_UNLIMITED') : $price->months . ' ' . JText::_('MEMBERSHIPS_MONTHS')) . ' '
            . $price->title . ' ' . $gender_string . '@ '
            . number_format($price->price, 2) . ' ' . $settings->currency;

      $options[] = JHTML::_('select.option', $price->id, $text);
    }

    $output = JHTML::_('select.genericlist', $options, 'price', '', 'value', 'text', $selected);

    return $output;
  }
}