<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelOrder extends JModel
{
  // Tasks
  function store()
  {
    $id     =& JRequest::getVar('price',  0, 'REQUEST', 'integer');
    $method =& JRequest::getVar('method', 0, 'POST', 'integer');
    $date   =& JFactory::getDate();
    $user   =& JFactory::getUser();

    $method = 0 == $method ? 4 : $method;

    // Check for price
    $price =& $this->getTable('price');
    $price->load($id);

    if (count($price->_errors) || $price->published === 0)
    {
      JError::raiseWarning('ERROR', JText::_('ORDER_TASK_STORE_ERROR_PRICE_NOT_FOUND'));
      return false;
    }

    // Check for gateway
    $gateway =& $this->getTable('gateway');
    $gateway->load($method);

    if (count($gateway->_errors))
    {
      JError::raiseWarning('ERROR', JText::_('ORDER_TASK_STORE_ERROR_GATEWAY_NOT_FOUND'));
      return false;
    }

    require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');
    $settings = new LovefactorySettings();

    // All it's ok, save the order
    $order =& $this->getTable();

    $order->user_id       = $user->id;
    $order->membership_id = $price->membership_id;
    $order->params        = $this->convertMembershipToParams($price->membership_id);
    $order->starting_type = 0;
    $order->amount        = $price->price;
    $order->currency      = $settings->currency;
    $order->months        = $price->months;
    $order->gateway       = $gateway->title;

    $order->store();

    $this->order_id = $order->id;

    return true;
  }

  function create($title, $price_id)
  {
    global $mainframe, $Itemid;

    // Check for gateway
    $gateway =& $this->getTable('gateway');
    $gateway->findOneByTitle($title);

    if (count($gateway->_errors))
    {
      JError::raiseWarning('ERROR', JText::_('ORDER_TASK_CREATE_ERROR_GATEWAY_NOT_FOUND'));
      $mainframe->redirect(JRoute::_('index.php?option=com_lovefactory&view=membershipbuy&Itemid=' . $Itemid, false));
    }

    // Check for price
    $price =& $this->getTable('price');
    $price->load($price_id);

    if (count($price->_errors) || $price->published === 0)
    {
      JError::raiseWarning('ERROR', JText::_('ORDER_TASK_CREATE_ERROR_PRICE_NOT_FOUND'));
      return false;
    }

    $settings =  new LovefactorySettings();
    $user     =& JFactory::getUser();
    $profile  =& $this->getTable('profile');

    $profile->load($user->id);

    // Get gender price
    if ($settings->gender_pricing)
    {
      $price->price = $price->getGenderPrice($profile->sex);
    }

    // All it's ok, create a new order
    $order =& $this->getTable();

    $order->user_id       = $user->id;
    $order->membership_id = $price->membership_id;
    $order->params        = $this->convertMembershipToParams($price->membership_id);
    $order->starting_type = 0;
    $order->amount        = $price->price;
    $order->currency      = $settings->currency;
    $order->months        = $price->months;
    $order->gateway       = $gateway->title;

    $order->store();

    return $order;
  }

  // Helpers
  function convertMembershipToParams($membership_id)
  {
    $membership =& $this->getTable('membership');
    $membership->load($membership_id);

    $params = array();

    foreach ($membership as $key => $value)
    {
      if (substr($key, 0, 1) != '_')
      {
        $params[] = $key . '=' .$value;
      }
    }

    return implode("\n", $params);
  }
}