<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelOutbox extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;
  var $_limit;
  var $_limitstart;

  function __construct()
  {
    parent::__construct();

    global $mainframe;
    $this->_limit      = JRequest::getVar('limit',      $mainframe->getCfg('list_limit'), 'REQUEST', 'integer');
    $this->_limitstart = JRequest::getVar('limitstart', 0,                                'REQUEST', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
  }

  // Pagination
  function getData()
  {
    if (empty($this->_data))
    {
      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);

      foreach ($this->_data as $i => $message)
      {
        $this->_data[$i]->date = TheFactoryHelper::date($message->date);
      }
    }

    return $this->_data;
  }

  function _buildQuery()
  {
    $where = $this->_buildContentWhere();

    $query = ' SELECT m.*, u.username, m.receiver_id AS reply_id'
           . ' FROM #__lovefactory_messages m'
           . ' LEFT JOIN #__users u ON u.id = m.receiver_id'
           . $where
           . ' ORDER BY date DESC';

    return $query;
  }

  function _buildContentWhere()
  {
    $user =& JFactory::getUser();

    $where = ' WHERE m.sender_id = ' . $user->id
           . ' AND m.deleted_by_sender = 0';

    return $where;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }

  // Tasks
  function delete()
  {
    $messages =& JRequest::getVar('lovefactory-item', array(), 'POST', 'array');

    if (!count($messages))
    {
      JError::raiseWarning('ERROR', JText::_('OUTBOX_TASK_DELETE_ERROR_NO_MESSAGES'));
      return false;
    }

    $user =& JFactory::getUser();

    foreach ($messages as $id => $value)
    {
      $message =& $this->getTable('LoveFactoryMessage', 'Table');
      $message->load($id);

      if ($user->id != $message->sender_id)
      {
        JError::raiseWarning('ERROR', JText::_('OUTBOX_TASK_DELETE_MESSAGE_NOT_FOUND'));
        return false;
      }

      $message->delete();
    }

    return true;
  }

  function deleteAll()
  {
    $user =& JFactory::getUser();

    $query = ' SELECT m.*'
           . ' FROM #__lovefactory_messages m'
           . ' WHERE m.sender_id = ' . $user->id
           . ' AND deleted_by_sender = 0';
    $this->_db->setQuery($query);
    $messages = $this->_db->loadObjectList();

    foreach ($messages as $message)
    {
      $table =& $this->getTable('LoveFactoryMessage', 'Table');
      $table->bind($message);

      $table->delete();
    }

    return true;
  }
}
