<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelPhoto extends JModel
{
  function __construct()
  {
    parent::__construct();

    global $mainframe;
    $this->_id         =& JRequest::getVar('id',         0,                                'GET',     'integer');
    $this->_limit      =& JRequest::getVar('limit',      $mainframe->getCfg('list_limit'), 'REQUEST', 'integer');
    $this->_limitstart =& JRequest::getVar('limitstart', 0,                                'REQUEST', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
  }

  // Photo
  function getData()
  {
    $query = ' SELECT p.*, pr.online, u.username, u.email AS _email'
           . ' FROM #__lovefactory_photos p'
           . ' LEFT JOIN #__lovefactory_profiles pr ON pr.user_id = p.user_id'
           . ' LEFT JOIN #__users u ON u.id = p.user_id'
           . ' WHERE p.id = ' . $this->_id;
    $this->_db->setQuery($query);
    $photo = $this->_db->loadObject();

    if ($photo)
    {
      $table =& JTable::getInstance('photo', 'Table');
      $user  =& JFactory::getUser();

      $table->bind($photo);
      $table->username = $photo->username;
      $table->_email = $photo->_email;

      // Check if user is allowed to view the photo
      if (1 == $photo->status)
      {
        $model =& JModel::getInstance('gallery', 'FrontendModel');
        if (!$model->getIsFriend($photo->user_id))
        {
          return null;
        }
      }

      if (2 == $photo->status && $user->id != $photo->user_id)
      {
        return null;
      }

      $table->my_photo = $user->id == $photo->user_id || TheFactoryHelper::adminCommentsDelete($user);

      return $table;
    }

    return $photo;
  }

  // Comments
  function getComments()
  {
    if (empty($this->_data))
    {
      $query       = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);

      $this->_prepareData();
    }

    return $this->_data;
  }

  function _buildQuery()
  {
    $user =& JFactory::getUser();

    $query = ' SELECT c.*, p.online, p.main_photo, u.email AS _email, u.username,'
           . '   (SELECT f.id FROM #__lovefactory_friends f WHERE ((f.sender_id = c.user_id AND f.receiver_id = ' . $user->id . ') OR (f.sender_id = ' . $user->id . ' AND f.receiver_id = c.user_id)) AND f.pending = 0 AND f.type = 1) AS is_friend'
           . ' FROM #__lovefactory_photo_comments c'
           . ' LEFT JOIN #__lovefactory_profiles p ON p.user_id = c.user_id'
           . ' LEFT JOIN #__users u ON u.id = c.user_id'
           . ' WHERE c.photo_id = ' . $this->_id
           . ' ORDER BY c.created_at DESC';

    return $query;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }

  function getLimitstart()
  {
    return $this->_limitstart;
  }

  function _prepareData()
  {
    $settings = new LovefactorySettings();

    // Get main photo field
    $field =& $this->getTable('field', 'Table');

    $field->getMainPhoto();

    $field->id      = 1;
    $field->type_id = 9;
    $field->params  = 'link=1';

    foreach ($this->_data as $i => $data)
    {
      // Get profile photo
      $profile =& $this->getTable('profile', 'Table');

      $profile->user_id    = $data->user_id;
      $profile->main_photo = $data->main_photo;
      $profile->is_friend  = $data->is_friend;
      $profile->_email     = $data->_email;

      switch ($field->visibility)
      {
        case 0: // Hidden
          $profile->field_1_visibility = 0;
        break;

        case 1: // For all
          switch ($data->online)
          {
            case 0: // Online
              $profile->field_1_visibility = 1;
            break;

            case 1: // Friends
              $profile->field_1_visibility = 2;
            break;

            case 2: // Offline
              $profile->field_1_visibility = 0;
            break;
          }
        break;

        case 2: // For friends
          switch ($data->online)
          {
            case 0: // Online
            case 1: // Friends
              $profile->field_1_visibility = 2;
            break;

            case 2: // Offline
              $profile->field_1_visibility = 0;
            break;
          }
        break;
      }

      // Set the main photo
      $this->_data[$i]->photo_src  = $field->showField($profile, $settings->display_hidden) ? $field->renderForView($profile, $settings->display_hidden) : '';
      $this->_data[$i]->username   = is_null($data->username) ? JText::_('USER_DELETED') : $data->username;
      $this->_data[$i]->created_at = TheFactoryHelper::date($data->created_at);
    }
  }

  // Tasks
  function deleteComment()
  {
    $id      =& JRequest::getVar('comment_id', 0, 'REQUEST', 'integer');
    $comment =& $this->getTable('photocomment');
    $user    =& JFactory::getUser();

    $comment->loadAndOwner($id);

    if ($comment->isMyComment() || TheFactoryHelper::adminCommentsDelete($user))
    {
      $comment->delete();
      return true;
    }

    $this->setError(JText::_('PHOTO_TASK_DELETECOMMENT_ERROR_NOT_FOUND'));
    return false;
  }

  function reportComment()
  {
    $id      =& JRequest::getVar('comment_id', 0, 'REQUEST', 'integer');
    $comment =& $this->getTable('photocomment');
    $comment->loadAndOwner($id);

    if ($comment->isMyComment())
    {
      $comment->report();
      return true;
    }

    $this->setError(JText::_('PHOTO_TASK_REPORTCOMMENT_ERROR_NOT_FOUND'));
    return false;
  }

  function addComment()
  {
    $user     =& JFactory::getUser();
    $photo_id =& JRequest::getVar('photo_id', 0,  'POST', 'integer');
    $text     =& JRequest::getVar('text',     '', 'POST', 'string');

    $photo =& $this->getTable('photo', 'Table');
    $photo->load($photo_id);

    // Check if photo exists
    if (count($photo->_errors))
    {
      $this->setError(JText::_('PHOTO_TASK_ADDCOMMENT_ERROR_NOT_FOUND'));
      return false;
    }

    // Check if comment is empty
    if ('' == $text)
    {
      $this->setError(JText::_('PHOTO_TASK_ADDCOMMENT_ERROR_MESSAGE_EMPTY'));
      return false;
    }

    // Check if the user is blacklisted
    $blacklist =& JModel::getInstance('blacklist', 'FrontendModel');
    $blacklisted = $blacklist->isBlacklisted($user->id, $photo->user_id);

    if ($blacklisted)
    {
      $this->setError(JText::_('PHOTO_TASK_ADDCOMMENT_ERROR_BLACKLISTED'));
      return false;
    }
    $comment =& $this->getTable('photocomment');

    $comment->photo_id   = $photo_id;
    $comment->user_id    = $user->id;
    $comment->text       = $text;
    $comment->_user_id   = $photo->user_id;

    $comment->store();

    return true;
  }
}