<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelProfile extends JModel
{
  var $_fields;
  var $_zones;

  // View
  function getProfile($overrides = array())
  {
    $user =& JFactory::getUser();

    $id =& JRequest::getVar('id', 0, 'GET', 'integer');
    $id =  $id == 0 ? $user->id : $id;

    $zones = $this->getZones();
    $extra = $this->getExtraFields($zones['types']);

	  $query = $this->getMainSelectQuery($extra, $overrides)
	         //. '   (SELECT COUNT(f.id) FROM #__lovefactory_friends f WHERE ((f.sender_id = ' . $user->id . ' AND f.receiver_id = ' . $id . ') OR (f.sender_id = ' . $id . ' AND f.receiver_id = ' . $user->id . ')) AND f.pending = 0 AND f.type = 1) AS is_friend'
	         . ' FROM #__lovefactory_profiles p'
	         . $this->getLeftJoinsQuery($extra)
	         . ' WHERE p.user_id = ' . $id
	         . ' GROUP BY p.user_id';
	  $this->_db->setQuery($query);
	  $profile = $this->_db->loadObject();

    $profile->_my_profile = $user->id == $id;
    $profile->is_friend   = $profile->_my_profile ? 1 : $profile->is_friend;

    $visitor =& $this->getTable('profilevisitor', 'Table');
    $visitor->update($id, $user->id);

    $this->_profile = $profile;

    // Latest viewed profile module
    $this->updateLatestViewedProfileModule($profile);

    return $profile;
  }

  function getFriendship()
  {
    $id   =& JRequest::getVar('id', 0, 'GET', 'integer');
    $user =& JFactory::getUser();

    $query = ' SELECT f.*'
           . ' FROM #__lovefactory_friends f'
           . ' WHERE ((f.sender_id = ' . $id . ' AND f.receiver_id = ' . $user->id . ')'
           . ' OR (f.sender_id = ' . $user->id . ' AND f.receiver_id = ' . $id . '))';
           //. ' AND f.type = 1';
    $this->_db->setQuery($query);
    $friendships = $this->_db->loadObjectList('type');

    $friendship   = isset($friendships[1]) ? $friendships[1] : null;
    $relationship = isset($friendships[2]) ? $friendships[2] : null;

    // Friendship check
    if (!is_null($friendship))
    {
      $friendship->is_friend  = 1;
      $friendship->my_request = $friendship->sender_id == $user->id;

      if ($friendship->pending)
      {
        $friendship->status = $friendship->my_request ? 1 : 2;
      }
      else
      {
        $friendship->status = 3;
      }
    }
    else
    {
      $friendship->is_friend = 0;
      $friendship->id        = 0;
      $friendship->status    = 0;
    }

    $array = array(
      0 => JText::_('FRIENDS_STATUS_ASK_FOR_FRIENDSHIP'),
      1 => JText::_('FRIENDS_STATUS_CANCEL_PENDING_REQUEST'),
      2 => JText::_('FRIENDS_STATUS_PENDING_REQUEST'),
      3 => JText::_('FRIENDS_STATUS_BREAK_FRIENDSHIP'),
    );

    $friendship->status_text = $array[$friendship->status];

    // Relationship check
    if ($this->_profile->relationship)
    {
      $relationship->status = 4;
    }
    else if (!is_null($relationship))
    {
      $relationship->my_request = $relationship->sender_id == $user->id;

      if ($relationship->pending)
      {
        $relationship->status = $relationship->my_request ? 1 : 2;
      }
      else
      {
        $relationship->status = 3;
      }
    }
    else
    {
      $relationship->status = 0;
      $relationship->id     = 0;
    }

    $array = array(
      0 => JText::_('RELATIONSHIP_STATUS_ASK_FOR_RELATIONSHIP'),
      1 => JText::_('RELATIONSHIP_STATUS_CANCEL_PENDING_REQUEST'),
      2 => JText::_('RELATIONSHIP_STATUS_PENDING_RELATIONSHIP_REQUEST'),
      3 => JText::_('RELATIONSHIP_STATUS_BREAK_RELATIONSHIP'),
      4 => JText::_('RELATIONSHIP_STATUS_ALREADY_IN_RELATIONSHIP'),
    );

    $relationship->status_text = $array[$relationship->status];

    return (object)array('friendship' => $friendship, 'relationship' => $relationship);
  }

  function getBlacklist()
  {
    $id   =& JRequest::getVar('id', 0, 'GET', 'integer');
    $user =& JFactory::getUser();

    $query = ' SELECT b.*'
           . ' FROM #__lovefactory_blacklist b'
           . ' WHERE b.sender_id = ' . $user->id
           . ' AND b.receiver_id = ' . $id;
    $this->_db->setQuery($query);
    $blacklist = $this->_db->loadObject();

    $blacklist->is_blacklisted = is_null($blacklist) ? 0 : 1;
    $blacklist->status_text    = $blacklist->is_blacklisted ? JText::_('BLACKLIST_REMOVE_USER') : JText::_('BLACKLIST_ADD_USER');

    return $blacklist;
  }

  function getFriends()
  {
    $user_id  =& JRequest::getVar('id', 0, 'REQUEST', 'integer');
    $user     =& JFactory::getUser();
    $settings =  new LovefactorySettings();

    $user_id = ($user_id) ? $user_id : $user->id;

    $order = ' ORDER BY';

    if ($settings->profile_friends_top)
    {
      //$order .= ' f.status DESC,';
    }

    switch ($settings->profile_friends_sort)
    {
      case 0: // Random
        $order .= ' RAND()';
      break;

      case 1: // Newest first
        $order .= ' f.date DESC';
      break;

      case 2: // Oldest first
        $order .= ' f.date ASC';
      break;
    }

    $query = ' SELECT'
           . '   IF (f.sender_id = ' . $user_id . ', u2.username, u1.username) AS username,'
           . '   IF (f.sender_id = ' . $user_id . ', u2.email, u1.email) AS _email,'
           . '   IF (f.sender_id = ' . $user_id . ', u2.id, u1.id) AS user_id,'
           . '   IF (f.sender_id = ' . $user_id . ', p2.main_photo, p1.main_photo) AS main_photo,'
           . '   IF (f.sender_id = ' . $user_id . ', p2.sex, p1.sex) AS sex,'
           . '   IF (f.sender_id = ' . $user_id . ','
           . '     (SELECT f.id FROM #__lovefactory_friends fr WHERE ((fr.sender_id = p2.user_id AND fr.receiver_id = ' . $user->id . ') OR (fr.receiver_id = p2.user_id AND fr.sender_id = ' . $user->id . ')) AND fr.pending = 0 AND fr.type = 1),'
           . '     (SELECT f.id FROM #__lovefactory_friends fr WHERE ((fr.sender_id = p1.user_id AND fr.receiver_id = ' . $user->id . ') OR (fr.receiver_id = p1.user_id AND fr.sender_id = ' . $user->id . ')) AND fr.pending = 0 AND fr.type = 1)) AS is_friend'
           . ' FROM #__lovefactory_friends f'
           . ' LEFT JOIN #__users u1 on u1.id = f.sender_id'
           . ' LEFT JOIN #__users u2 on u2.id = f.receiver_id'
           . ' LEFT JOIN #__lovefactory_profiles p1 on p1.user_id = f.sender_id'
           . ' LEFT JOIN #__lovefactory_profiles p2 on p2.user_id = f.receiver_id'
           . ' WHERE (f.sender_id = ' . $user_id . ' OR f.receiver_id = ' . $user_id . ')'
           . ' AND f.pending = 0'
           . ' AND f.type = 1'
           . $order
           . ' LIMIT 0,' . intval($settings->profile_friends_number);
    $this->_db->setQuery($query);
    $friends = $this->_db->loadObjectList();

    $field =& $this->getTable('field', 'Table');
    $field->getMainPhoto();

    foreach ($friends as $i => $friend)
    {
      $profile =& $this->getTable('profile', 'Table');
      $profile->bind($friend);

      $profile->username               = $friend->username;
      $profile->_main_photo_visibility = $field->visibility;
      $profile->_is_friend             = $friend->is_friend;
      $profile->_email                 = $friend->_email;

      $friends[$i] = $profile;
    }

    return $friends;
  }

  function getTotalFriends()
  {
    $user_id =  JRequest::getVar('id', 0, 'REQUEST', 'integer');
    $user    =& JFactory::getUser();

    $user_id = ($user_id) ? $user_id : $user->id;

    $query = ' SELECT COUNT(id)'
           . ' FROM #__lovefactory_friends f'
           . ' WHERE (f.sender_id = ' . $user_id . ' OR f.receiver_id = ' . $user_id . ')'
           . ' AND f.pending = 0'
           . ' AND f.type = 1';
    $this->_db->setQuery($query);

    return $this->_db->loadResult();
  }

  function getVisitor()
  {
    $user =& JFactory::getUser();
    $visitor = (object)array();

    if ($user->guest)
    {
      $uri =& JFactory::getURI();

      $visitor->status  = 0;
      $visitor->referer = base64_encode($uri->_uri);
    }
    else
    {
      $profile =& $this->getTable('profile', 'Table');
      $profile->load($user->id);

      $visitor->status = !$profile->validated ? 1 : 2;
    }

    return $visitor;
  }

  function getWallpage()
  {
    $settings = new LovefactorySettings();
    JRequest::setVar('limit', $settings->wallpage_entries, 'POST');

    $wallpage =& JModel::getInstance('wallpage', 'FrontendModel');

    return $wallpage->getData();
  }

  function getInfobar()
  {
    $user     =& JFactory::getUser();
    $settings =  new LovefactorySettings();

    // Infobar is disabled
    if (0 == $settings->enable_infobar)
    {
      return 0;
    }

    // Get user location
    $query = ' SELECT p.infobar'
           . ' FROM #__lovefactory_profiles p'
           . ' WHERE p.user_id = ' . $user->id;
    $this->_db->setQuery($query);
    $result = $this->_db->loadResult();

    // Infobar location is fixed
    if (in_array($settings->infobar_location, array(2,3)) && $result)
    {
      return $settings->infobar_location;
    }

    return $result;
  }


  // Tasks
  function update($user_id = null)
  {
    $user    =& JFactory::getUser();
    $fields  =& JModel::getInstance('fields', 'FrontendModel');
    $profile =& $this->getTable('profile', 'Table');

    $fields->getFieldsForPage('edit');

    // Set user_id
    $user_id = null == $user_id ? $user->id : $user_id;

    // Initialize fields
    $profile->initializeFields($fields->_fields);

    // Load profile
    $profile->load($user_id);

    // Check if profile has been validated
    if (!$profile->validated)
    {
      JError::raiseWarning(0, JText::_('EDIT_TASK_UPDATE_ERROR_NOT_VALID'));
      return false;
    }

    // Update profile fields and fields visibilities
    $profile->updateFromFields($fields->_fields);

    // Check for errors
    if ($profile->_has_errors)
    {
      return false;
    }

    // Update other settings
    $this->_updateOtherSettings($profile);

    // Save the profile
    return $profile->store();
  }

  function _updateOtherSettings(&$profile)
  {
    $online  =& JRequest::getVar('field_online',  0, 'POST', 'integer');
    $alerts  =& JRequest::getVar('field_alerts',  0, 'POST', 'integer');
    $infobar =& JRequest::getVar('field_infobar', 0, 'POST', 'integer');

    $profile->online = $online;
    $profile->alerts = $alerts;
    $profile->infobar = $infobar != -1 ? $infobar : $profile->infobar;
  }


  // Helpers
  function getZones()
  {
    static $zones = null;

    if (!is_null($zones))
    {
      return $zones;
    }

    $model =& JModel::getInstance('zones', 'FrontendModel');
    $zones = $model->getZonesForDisplayForPage('view');

    return $zones;
  }

  function checkOnlineStatus($user_id = null)
  {
    $visiting_user =& JFactory::getUser();
    $user_id = is_null($user_id) ? JRequest::getVar('id', 0, 'GET', 'integer') : $user_id;

    $user_id = 0 == $user_id ? $visiting_user->id : $user_id;

    // Viewing own page
    if ($user_id == $visiting_user->id)
    {
      return true;
    }

    $query = ' SELECT p.online, f.id AS is_friend'
           . ' FROM #__lovefactory_profiles p'
           . ' LEFT JOIN #__lovefactory_friends f ON ((f.sender_id = p.user_id AND f.receiver_id = ' . $visiting_user->id . ') OR (f.receiver_id = p.user_id AND f.sender_id = ' . $visiting_user->id . ')) AND f.pending = 0 AND f.type = 1'
           . ' WHERE p.user_id = ' . $user_id;
    $this->_db->setQuery($query);
    $profile = $this->_db->loadObject();

    // Profile not found
    if (is_null($profile))
    {
      global $mainframe, $Itemid;
      $mainframe->redirect(JRoute::_('index.php?option=com_lovefactory&view=notavailable&id=' . $user_id . '&layout=notfound&Itemid=' . $Itemid, false));
    }

    // Profile is online
    if (0 == $profile->online)
    {
      return true;
    }

    $settings = new LovefactorySettings();

    // Profile is offline
    if (2 == $profile->online && $settings->profile_status_change)
    {
      global $mainframe, $Itemid;
      $mainframe->redirect(JRoute::_('index.php?option=com_lovefactory&view=notavailable&id=' . $user_id . '&layout=offline&Itemid=' . $Itemid, false));
    }

    // Profile is available for friends
    if (1 == $profile->online && !$profile->is_friend && $settings->profile_status_change)
    {
      global $mainframe, $Itemid;
      $mainframe->redirect(JRoute::_('index.php?option=com_lovefactory&view=notavailable&id=' . $user_id . '&layout=onlyfriends&Itemid=' . $Itemid, false));
    }
  }

  function getExtraFields($types)
  {
    $extra = array();

    // Distance
    if (in_array(24, $types))
    {
      $extra[] = 'distance';
    }

    // Google Maps location
    if (in_array(23, $types))
    {
      $extra[] = 'gmaps_location';
    }

    // Relationship
    if (in_array(25, $types))
    {
      $extra[] = 'relationship';
    }

    return $extra;
  }

  function getMainSelectQuery($extra = array(), $overrides = array())
  {
    $date =& JFactory::getDate();
    $user =& JFactory::getUser();
    $diff =  $date->_date - time();

    $output = ' SELECT p.*, u.username, m.title, m.title AS testering, m.ordering, u.email AS _email,'
            . '   u.lastvisitDate, COUNT(se.userid) AS loggedin,'
            . '   IF (f.id IS NULL, 0, 1) AS is_friend,'
	          . '   IF (MAX(se.time) IS NULL, UNIX_TIMESTAMP(u.lastvisitDate), MAX(se.time) + ' . $diff . ') AS last_seen_on';

	  // Distance || Google Maps Location
	  if (in_array('gmaps_location', $extra) || in_array('distance', $extra))
	  {
	    $output .= ', IF (g.lat IS NOT NULL, g.lat, 0) AS lat,'
              .  '  IF (g.lng IS NOT NULL, g.lng, 0) AS lng';
	  }

	  // Relationship
	  if (in_array('relationship', $extra))
	  {
	    $output .= ', rel_user.username AS relationship_username,'
	            .  '  rel_user.id AS relationship_id,'
	            .  '  rel_profile.main_photo AS relationship_main_photo';
	  }

	  // Distance
	  if (in_array('distance', $extra))
	  {
	    $override = array_key_exists('lat', $overrides) && array_key_exists('lng', $overrides);

	    if ($user->guest && !$override)
	    {
	      $output .= ', "' . JText::_('NOT_AVAILABLE') . '" AS distance';
	    }
	    else
	    {
	      $geo =& $this->getTable('geo', 'Table');

	      if (!$override)
	      {
	        $geo->load($user->id);
	      }

	      if ((0 === $geo->lat && 0 === $geo->lng) || (is_null($geo->lat) && is_null($geo->lng)))
	      {
	        $output .= ', "' . JText::_('NOT_AVAILABLE') . '" AS distance';
	      }
	      else
	      {
	        $settings = new LovefactorySettings();
	        $unit     = !$settings->distances_unit ? 1.6 : 1;

	        // Overrides for radius search
	        $lat = array_key_exists('lat', $overrides) ? $overrides['lat'] : $geo->lat;
	        $lng = array_key_exists('lng', $overrides) ? $overrides['lng'] : $geo->lng;

	        $output .= ', IF( 0 <> g.lat AND 0 <> g.lng, '
	                .  '     ROUND((((acos(sin(('.$lat.'*pi()/180)) * sin((g.lat*pi()/180)) + cos(('.$lat.'*pi()/180)) * cos((g.lat*pi()/180)) * cos((('.$lng.' - g.lng)*pi()/180))))*180/pi())*60*1.1515) * ' . $unit . '),'
	                .  '     "' . JText::_('NOT_AVAILABLE') . '") AS distance';
	      }
	    }
	  }


	  return $output;
  }

  function getLeftJoinsQuery($extra = array(), $mode = 'search')
  {
    $user =& JFactory::getUser();

    $output = ' LEFT JOIN #__users u ON u.id = p.user_id'
	          . ' LEFT JOIN #__lovefactory_memberships_sold s ON s.id = p.membership_sold_id'
	          . ' LEFT JOIN #__lovefactory_memberships m ON m.id = s.membership_id'
	          . ' LEFT JOIN #__session se ON se.userid = p.user_id AND se.client_id = 0'
	          . ' LEFT JOIN #__lovefactory_friends f ON (((f.sender_id = p.user_id AND f.receiver_id = ' . $user->id . ') OR (f.receiver_id = p.user_id AND f.sender_id = ' . $user->id . ')) AND f.pending = 0)';

	  // Distance || Google Maps location
	  if (in_array('distance', $extra) || in_array('gmaps_location', $extra))
	  {
	    $output .= ' LEFT JOIN #__lovefactory_geo g ON g.user_id = p.user_id';
	  }

	  // Relationship
	  if (in_array('relationship', $extra))
	  {
	    switch ($mode)
	    {
	      case 'search':
	        $output .= ' LEFT JOIN #__users rel_user ON rel_user.id = p.relationship'
                  .  ' LEFT JOIN #__lovefactory_profiles rel_profile ON rel_profile.user_id = p.relationship';
	      break;

	      default:
	        $user =& JFactory::getUser();

          $id =& JRequest::getVar('id', 0, 'GET', 'integer');
          $id =  $id == 0 ? $user->id : $id;

          $output .= ' LEFT JOIN #__users rel_user ON rel_user.id = p.relationship'
                  .  ' LEFT JOIN #__lovefactory_profiles rel_profile ON rel_profile.user_id = p.relationship';
	      break;
	    }
	  }

	  return $output;
  }

  function updateLatestViewedProfileModule($profile)
  {
    if (!$profile->_my_profile)
    {
      global $Itemid;

      $date    =& JFactory::getDate();
      $session =& JFactory::getSession();

      $profiles = $session->get('lovefactory.mod_latest_viewed.members', array());

      foreach ($profiles as $i => $item)
      {
        if ($item['id'] == $profile->user_id)
        {
          array_splice($profiles, $i, 1);
        }
      }

      $array = array();

      $array['id']        = $profile->user_id;
      $array['username']  = $profile->username;
      $array['link']      = JRoute::_('index.php?option=com_lovefactory&view=profile&id='.$profile->user_id.'&Itemid='.$Itemid);
      $array['viewed_at'] = $date->toUnix();

      $profiles[] = $array;

      if (count($profiles) > 10)
      {
        array_splice($profiles, 10);
      }

      $session->set('lovefactory.mod_latest_viewed.members', $profiles);
    }
  }
}