<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelRadiusSearch extends JModel
{
  function getSearchResults()
  {
    $settings =  new LovefactorySettings();
    $lat      =& JRequest::getVar('lat',    0,  'POST', 'float');
    $lng      =& JRequest::getVar('lng',    0,  'POST', 'float');
    $radius   =& JRequest::getVar('radius', 0,  'POST', 'float');
    $sex      =& JRequest::getVar('sex',    -1, 'POST', 'integer');
    $Itemid   =& JRequest::getVar('Itemid', 0,  'POST', 'integer');

    if ($radius > $settings->max_search_radius)
    {
      $radius = $settings->max_search_radius;
    }
    $unit = $settings->distances_unit ? 1 : 1.6;

    if (-1 != $sex)
    {
      $sex_field = $this->getSexField();

      if (!$sex_field)
      {
        $sex = -1;
      }
      else
      {
        $values = explode('*|*', $sex_field->getParam('values'));
        $sex    = !array_key_exists($sex, $values) ? -1 : $values[$sex];
      }
    }

    $query = ' SELECT g.*'
           . ' FROM #__lovefactory_geo g'
           . (-1 != $sex ? ' LEFT JOIN #__lovefactory_profiles p ON p.user_id = g.user_id' : '')
           . ' WHERE (g.lat <> 0 AND g.lng <> 0)'
           . ' AND (((acos(sin(('.$lat.'*pi()/180)) * sin((g.lat*pi()/180)) + cos(('.$lat.'*pi()/180)) * cos((g.lat*pi()/180)) * cos((('.$lng.' - g.lng)*pi()/180))))*180/pi())*60*1.1515) * ' . $unit . ' <= ' . $radius
           . (-1 != $sex ? ' AND p.sex = "' . $sex . '"' : '');
    $this->_db->setQuery($query);

    $members = $this->_db->loadObjectList();

    foreach ($members as $i => $member)
    {
      $members[$i]->link = JRoute::_('index.php?option=com_lovefactory&view=profile&id=' . $member->user_id . '&Itemid=' . $Itemid, false);
    }

    return $members;
  }

  function getDefaults()
  {
    $user     =& JFactory::getUser();
    $defaults =  (object)array();
    $settings =  new LovefactorySettings();

    $defaults->x = $settings->gmaps_default_x;
    $defaults->y = $settings->gmaps_default_y;

    if (!$user->guest)
    {
      $geo =& $this->getTable('geo');
      $geo->load($user->id);

      if ($geo->lat && $geo->lng)
      {
        $defaults->x = $geo->lat;
        $defaults->y = $geo->lng;
      }
    }

    $defaults->z = $settings->gmaps_default_z;

    return $defaults;
  }

  function getSexField()
  {
    $query = ' SELECT f.*'
           . ' FROM #__lovefactory_fields f'
           . ' WHERE f.type_id = 10'
           . ' AND f.published = 1';
    $db =& JFactory::getDBO();
    $db->setQuery($query);
    $result = $db->loadObject();

    $settings = new LovefactorySettings();

    if (!$result || !$settings->enable_search_radius_sex_filter)
    {
      return false;
    }

    $field =& $this->getTable('field');
    $field->bind($result);

    $field->params .= "\n" . 'mode=0' . "\n" . 'display=1';

    return $field;
  }
}