<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelRelationship extends JModel
{
  // Tasks
  function accept()
  {

    $user =& JFactory::getUser();
    $id   =  JRequest::getVar('id', 0, 'GET', 'integer');

    $friend =& $this->getTable('friend');
    $friend->load($id);

    if (($friend->receiver_id == $user->id) &&
        ($friend->pending == 1) && ($friend->type == 2))
    {
      // Check if both users don't already have a relationship
      $sender   =& $this->getTable('profile');
      $receiver =& $this->getTable('profile');

      $sender->load($friend->sender_id);
      $receiver->load($friend->receiver_id);

      if ($sender->relationship || $receiver->relationship)
      {
        if ($sender->relationship)
        {
          JError::raiseWarning(0, JText::_('MY_RELATIONSHIP_TASK_ACCEPT_ERROR_SENDER_HAS_RELATIONSHIP'));
        }
        else
        {
          JError::raiseWarning(0, JText::_('MY_RELATIONSHIP_TASK_ACCEPT_ERROR_YOU_HAVE_RELATIONSHIP'));
        }

        return false;
      }

      // Accept relationship request
      $friend->accept();

      // Send message
      $settings = new LovefactorySettings();
      if ($settings->enable_messages)
      {
        $message =& $this->getTable('LoveFactoryMessage');
        $message->sendSystemMessage(
          $friend->sender_id,
          JText::_('MY_RELATIONSHIP_TASK_ACCEPT_MESSAGE_TITLE'),
          JText::sprintf('MY_RELATIONSHIP_TASK_ACCEPT_MESSAGE_TEXT', $user->username)
        );
      }

      return true;
    }

    JError::raiseWarning(0, JText::_('MY_RELATIONSHIP_TASK_ACCEPT_ERROR_NOT_FOUND'));
    return false;
  }

  function reject()
  {
    $user =& JFactory::getUser();
    $id   =  JRequest::getVar('id', 0, 'GET', 'integer');

    $friend =& $this->getTable('friend');
    $friend->load($id);

    if (($friend->receiver_id == $user->id) &&
        ($friend->pending == 1) && ($friend->type == 2))
    {
      $friend->delete();

      $settings = new LovefactorySettings();
      if ($settings->enable_messages)
      {
        $message =& $this->getTable('LoveFactoryMessage');
        $message->sendSystemMessage(
          $friend->sender_id,
          JText::_('MY_RELATIONSHIP_TASK_REJECT_MESSAGE_TITLE'),
          JText::sprintf('MY_RELATIONSHIP_TASK_REJECT_MESSAGE_TEXT', $user->username)
        );
      }

      return true;
    }

    JError::raiseWarning(0, JText::_('MY_RELATIONSHIP_TASK_REJECT_ERROR_NOT_FOUND'));
    return false;
  }

  function cancel()
  {
    $user =& JFactory::getUser();
    $id   =  JRequest::getVar('id', 0, 'REQUEST', 'integer');

    $friend =& $this->getTable('friend');
    $friend->load($id);

    if (($friend->sender_id == $user->id) &&
        ($friend->pending == 1) && ($friend->type == 2))
    {
      $friend->delete();

      return true;
    }

    $this->setError(JText::_('MY_RELATIONSHIP_TASK_CANCEL_ERROR_NOT_FOUND'));
    return false;
  }

  function request()
  {
    $id   =  JRequest::getVar('id', 0, 'POST', 'integer');
    $user =& JFactory::getUser();

    $query = ' SELECT id'
           . ' FROM #__lovefactory_friends'
           . ' WHERE ((sender_id = ' . $id . ' AND receiver_id = ' . $user->id . ')'
           . ' OR (sender_id = ' . $user->id . ' AND receiver_id = ' . $id . '))'
           . ' AND type = 2';
    $this->_db->setQuery($query);
    $result = $this->_db->loadResult();

    if ($result)
    {
      $this->setError(JText::_('MY_RELATIONSHIP_TASK_REQUEST_ERROR_ALREADY_SENT'));
      return false;
    }

    $message = JRequest::getVar('message', '', 'POST', 'string');

    $friend =& $this->getTable('friend');
    $friend->request($user->id, $id, $message, 2);

    $this->_request_id = $this->_db->insertid();

    return true;
  }

  function remove()
  {
    $user =& JFactory::getUser();
    $id   =&  JRequest::getVar('id', 0, 'REQUEST', 'integer');

    $friend =& $this->getTable('friend');
    $friend->load($id);

    if ((($friend->receiver_id == $user->id) ||
         ($friend->sender_id == $user->id)) &&
        ($friend->pending == 0) && $friend->type == 2)
    {
      $friend->remove();

      $settings = new LovefactorySettings();
      if ($settings->enable_messages)
      {
        $message =& $this->getTable('LoveFactoryMessage');
        $message->sendSystemMessage(
          $friend->sender_id,
          JText::_('MY_RELATIONSHIP_TASK_REMOVE_MESSAGE_TITLE'),
          JText::sprintf('MY_RELATIONSHIP_TASK_REMOVE_MESSAGE_TEXT', $user->username)
        );
      }

      return true;
    }

    $this->setError(JText::_('MY_RELATIONSHIP_TASK_REMOVE_ERROR_NOT_FOUND'));
    return false;
  }
}
