<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelShoutbox extends JModel
{
  // Tasks
  function getMessages()
  {
    $enabled = $this->getEnabled();

    if (0 == $enabled)
    {
      $this->setError(JText::_('SHOUTBOX_TASK_GET_MESSAGES_ERROR_NOT_ENABLED'));
      return false;
    }

    $access = $this->getAccess();

    if (0 == $access)
    {
      $this->setError(JText::_('SHOUTBOX_TASK_GET_MESSAGES_ERROR_NO_ACCESS'));
      return false;
    }

    global $Itemid;
    require_once(JPATH_COMPONENT_SITE.DS.'lib'.DS.'vendor'.DS.'TheFactoryHelper.class.php');

    $last =& JRequest::getVar('lovefactory_shoutbox_last', 0, 'REQUEST', 'integer');

    $settings = new LovefactorySettings();

    $query = ' SELECT s.id, s.message AS m, s.created_at AS d, u.username AS u'
	         . ' FROM #__lovefactory_shoutbox s'
	         . ' LEFT JOIN #__users u ON u.id = s.sender_id'
	         . ' WHERE s.id > ' . $last
	         . ' ORDER BY s.created_at ASC'
	         . ' LIMIT 0, ' . $settings->shoutbox_messages;
	  $this->_db->setQuery($query);
	  $messages = $this->_db->loadObjectList();

	  foreach ($messages as $i => $message)
	  {
	    $messages[$i]->l = JRoute::_('index.php?option=com_lovefactory&view=profile&id=' . $message->id . '&Itemid=' . $Itemid, false);
	    $messages[$i]->d = TheFactoryHelper::date($message->d);
	  }

	  return $messages;
  }

  function postMessage()
  {
    $enabled = $this->getEnabled();

    if (0 == $enabled)
    {
      $this->setError(JText::_('SHOUTBOX_TASK_POST_MESSAGE_ERROR_NOT_ENABLED'));
      return false;
    }

    $access = $this->getAccess();

    if (2 != $access)
    {
      $this->setError(JText::_('SHOUTBOX_TASK_POST_MESSAGE_ERROR_NO_ACCESS'));
      return false;
    }

    $user    =& JFactory::getUser();
    $message =& JRequest::getVar('message', '', 'POST', 'string');

    if ('' == $message)
    {
      $this->setError(JText::_('SHOUTBOX_TASK_POST_MESSAGE_ERROR_NO_MESSAGE'));
      return false;
    }

    $table =& $this->getTable('shoutbox');

    $table->message   = $message;
    $table->sender_id = $user->id;

    return $table->store();
  }


  // Helpers
  function getAccess()
  {
    $user    =& JFactory::getUser();
	  $profile =& JTable::getInstance('profile', 'Table');

	  $profile->loadAndMembership($user->id);

	  return intval($profile->membership_sold->shoutbox);
  }

  function getEnabled()
  {
    $settings = new LovefactorySettings();

    return $settings->enable_shoutbox;
  }
}