<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelVideos extends JModel
{
  function __construct()
  {
    parent::__construct();

    global $mainframe;

    $settings = new LovefactorySettings();

    $this->_limit      =& JRequest::getVar('limit',      $settings->videos_pagination_limit, 'REQUEST', 'integer');
    $this->_limitstart =& JRequest::getVar('limitstart', 0, 'GET', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
  }

  function getData()
  {
    if (empty($this->_data))
    {
      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);

      foreach ($this->_data as $i => $video)
      {
        $table =& $this->getTable('Video');
        $table->bind($video);

        $this->_data[$i] = $table;
      }
    }

    return $this->_data;
  }

  function _buildQuery($total = false)
  {
    $user_id   =& JRequest::getVar('user_id', 0, 'GET', 'integer');
    $gallery   =& JModel::getInstance('Gallery', 'FrontendModel');
    $is_friend =  $gallery->getIsFriend($user_id);

    $array = array(0);
    if ($is_friend)
    {
      $array[] = 1;
    }

    if ($gallery->getIsMyGallery())
    {
      $array[] = 2;
    }

    $query = ($total ? 'SELECT COUNT(1)' : ' SELECT v.*')
           . ' FROM #__lovefactory_videos v'
           . ' WHERE v.user_id = ' . $user_id
           . ' AND v.status IN (' . implode(',', $array) . ')'
           . ' GROUP BY v.id'
           . ' ORDER BY v.status ASC, ordering ASC';

    return $query;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery(true);
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }

  function getProfile()
  {
    $user_id =& JRequest::getVar('user_id', 0, 'GET', 'integer');

    $query = ' SELECT p.user_id, u.username'
           . ' FROM #__lovefactory_profiles p'
           . ' LEFT JOIN #__users u ON u.id = p.user_id'
           . ' WHERE p.user_id = ' . $user_id;
    $this->_db->setQuery($query);

    return $this->_db->loadObject();
  }
}