<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelWallpage extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;
  var $_limit;
  var $_limitstart;

  // List & pagination
  function __construct()
  {
    parent::__construct();

    global $mainframe;
    $this->_limit      = JRequest::getVar('limit',      $mainframe->getCfg('list_limit'), 'REQUEST', 'integer');
    $this->_limitstart = JRequest::getVar('limitstart', 0,                                'GET', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
  }

  function getData()
  {
    global $Itemid;

    if (empty($this->_data))
    {
      $query       = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);

      foreach ($this->_data as $i => $action)
      {
        switch ($action->type_id)
        {
          case 3:
          case 4:
            $this->_data[$i]->title = str_replace('%%link%%', JRoute::_($action->link), $this->_data[$i]->title);
          break;

          case 5:
            $links   = explode("\n", $action->link);
            $links[] = $Itemid;
            $this->_data[$i]->title = str_replace(array('%%link%%', '%%link2%%', '%%Itemid%%'), $links, $this->_data[$i]->title);
          break;
        }

        $this->_data[$i]->created_at = TheFactoryHelper::date($action->created_at);
      }
    }

    return $this->_data;
  }

  function _buildQuery()
  {
    $user_id =& JRequest::getVar('id', 0, 'GET', 'integer');
    $user    =& JFactory::getUser();

    $user_id = 0 == $user_id ? $user->id : $user_id;

    $query = ' SELECT a.*'
           . ' FROM #__lovefactory_actions a'
           . ' WHERE a.user_id = ' . $user_id
           . ' ORDER BY a.created_at DESC';

    return $query;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }

  function getIsMyWall()
  {
    $user_id =& JRequest::getVar('id', 0, 'GET', 'integer');
    $user    =& JFactory::getUser();

    return $user_id == $user->id || $user_id == 0;
  }

  function delete()
  {
    $id     =& JRequest::getVar('id', 0, 'GET', 'integer');
    $user   =& JFactory::getUser();
    $action =& $this->getTable('action', 'Table');

    $action->load($id);

    // Check if it's my action
    if ($action->user_id != $user->id)
    {
      JError::raiseWarning(0, JText::_('WALLPAGE_DELETE_ERROR_NOT_FOUND'));
      return false;
    }

    return $action->delete();
  }
}