<?php

function getRoutes()
{
  $routes = array(
    // Views
    'profile-not-available' => array(
      'view'   => 'notavailable',
      'params' => array('id', 'layout')),

    'section-not-available' => array(
      'view'   => 'notavailable',
      'params' => array('layout')),

    'view-user-profile' => array(
      'view'   => 'profile',
      'params' => array('id')),

    'view-my-profile' => array(
      'view'   => 'profile'),

    'you-have-been-banned' => array(
      'view'   => 'banned'),

    'my-membership' => array(
      'view'   => 'mymembership'),

    'my-memberships-archive' => array(
      'view'   => 'mymemberships'),

    'edit-my-gallery' => array(
      'view'   => 'mygallery'),

    'ignore-list' => array(
      'view'   => 'blacklist'),

    'edit-my-profile' => array(
      'view'   => 'edit'),

    'friends-list-for-user' => array(
      'view'   => 'friends',
      'params' => array('id')),

    'view-user-photo' => array(
      'view'   => 'photo',
      'params' => array('id')),

    'my-friends' => array(
      'view'   => 'myfriends'),

    'fillin' => array(
      'view'   => 'fillin'),

    'my-inbox' => array(
      'view'   => 'inbox'),

    'signup' => array(
      'view'   => 'signup'),

    'my-outbox' => array(
      'view'   => 'outbox'),

    'wallpage-for-user' => array(
      'view'   => 'wallpage',
      'params' => array('id')),

    'compose-message-to' => array(
      'view'   => 'messagewrite',
      'params' => array('to')),

    'reply-to-message' => array(
      'view'   => 'messagewrite',
      'params' => array('message_id')),

    'compose-message' => array(
      'view'   => 'messagewrite'),

    'read-message' => array(
      'view'   => 'messageread',
      'params' => array('id')),

    'quick-search-results' => array(
      'view'   => 'quicksearch',
      'params' => array('show')),

    'quick-search' => array(
      'view'   => 'quicksearch'),

    'advanced-search-results' => array(
      'view'   => 'advancedsearch',
      'params' => array('show')),

    'advanced-search' => array(
      'view'   => 'advancedsearch'),

    'online-users' => array(
      'view'   => 'online'),

    'interactions' => array(
      'view'   => 'interactions'),

    'terms-and-conditions' => array(
      'view'   => 'terms'),

    'pending-friendship-requests' => array(
      'view'   => 'friendspending'),

    'view-user-gallery' => array(
      'view'   => 'gallery',
      'params' => array('user_id')),

    'compare-memberships' => array(
      'view'   => 'memberships'),

    'buy-membership' => array(
      'view'   => 'membershipbuy',
      'params' => array('id')),

    'confirm-membership-order' => array(
      'view'   => 'membershipconfirm',
      'params' => array('order')),

    'finalize-payment' => array(
      'view'   => 'payment',
      'params' => array('type')),

    'members-map' => array(
      'view'   => 'membersmap'),

    'radius-search' => array(
      'view'   => 'radiussearch'),

    'my-relationship' => array(
      'view'   => 'myrelationship'),

    'pending-relationship-requests' => array(
      'view'   => 'relationshipspending'),

    'top-friends' => array(
      'view'   => 'topfriends'),

    'requests' => array(
      'view'   => 'requests'),

    'edit-my-video-gallery' => array(
      'view'   => 'mygalleryvideo'),

    'view-photo-gallery' => array(
      'view'   => 'gallery',
      'params' => array('user_id')),

    'view-video' => array(
      'view'   => 'video',
      'params' => array('user_id', 'video_id')),

    'view-video-gallery' => array(
      'view'   => 'videos',
      'params' => array('user_id')),

    'view-group' => array(
      'view'   => 'group',
      'params' => array('group_id')),

    'view-group-exclude-list' => array(
      'view'   => 'groupexclude',
      'params' => array('group_id')),

    'view-group-members' => array(
      'view'   => 'groupmembers',
      'params' => array('group_id')),

    'edit-group' => array(
      'view'   => 'groupedit',
      'params' => array('group_id')),

    'create-new-group' => array(
      'view'   => 'groupedit'),

    // Controllers
    'break-friendship' => array(
      'controller' => 'friend',
      'task'       => 'remove',
      'params' => array('id')),

    'add-to-ignore-list' => array(
      'controller' => 'blacklist',
      'task'       => 'add'),

    'remove-from-ignore-list' => array(
      'controller' => 'blacklist',
      'task'       => 'remove',
      'params'     => array('optional' => 'id')),

    'empty-inbox' => array(
      'controller' => 'inbox',
      'task'       => 'deleteall'),

    'empty-outbox' => array(
      'controller' => 'outbox',
      'task'       => 'deleteall'),

    'respond-to-interaction' => array(
      'controller' => 'interaction',
      'task'       => 'respond',
      'params'     => array('id')),

    'send-interaction' => array(
      'controller' => 'interaction',
      'task'       => 'send'),

    'send-message' => array(
      'controller' => 'message',
      'task'       => 'send'),

    'delete-message' => array(
      'controller' => 'message',
      'task'       => 'delete',
      'params'     => array('id')),

    'delete-comment' => array(
      'controller' => 'comment',
      'task'       => 'delete'),

    'report-comment' => array(
      'controller' => 'comment',
      'task'       => 'report'),

    'add-comment' => array(
      'controller' => 'comment',
      'task'       => 'add'),

    'report-message' => array(
      'controller' => 'message',
      'task'       => 'report'),

    'report-gallery' => array(
      'controller' => 'gallery',
      'task'       => 'report'),

    'accept-friendship-request' => array(
      'controller' => 'friend',
      'task'       => 'accept',
      'params'     => array('id')),

    'reject-friendship-request' => array(
      'controller' => 'friend',
      'task'       => 'reject',
      'params'     => array('id')),

    'cancel-friendship-request' => array(
      'controller' => 'friend',
      'task'       => 'cancel',
      'params'     => array('id')),

    'infobar-update' => array(
      'controller' => 'infobar',
      'task'       => 'update'),

    'empty-interactions-list' => array(
      'controller' => 'interactions',
      'task'       => 'deleteall'),

    'notify-payment' => array(
      'controller' => 'payment',
      'task'       => 'notify',
      'params'     => array('gateway', 'lang')),

    'trial-membership' => array(
      'controller' => 'membership',
      'task'       => 'trial',
      'params'     => array('id')),

    'free-membership' => array(
      'controller' => 'membership',
      'task'       => 'free',
      'params'     => array('id')),

    'accept-relationship-request' => array(
      'controller' => 'relationship',
      'task'       => 'accept',
      'params'     => array('id')),

    'reject-relationship-request' => array(
      'controller' => 'relationship',
      'task'       => 'reject',
      'params'     => array('id')),

    'cancel-relationship-request' => array(
      'controller' => 'relationship',
      'task'       => 'cancel',
      'params'     => array('id')),

    'break-relationship' => array(
      'controller' => 'relationship',
      'task'       => 'remove',
      'params' => array('id')),

    'remove-top-friend' => array(
      'controller' => 'friend',
      'task'       => 'removetopfriend',
      'params' => array('friendship')),

    'add-top-friend' => array(
      'controller' => 'friend',
      'task'       => 'addtopfriend',
      'params' => array('friendship')),

    'request-friendship' => array(
      'controller' => 'friend',
      'task'       => 'request',
      'params' => array('id')),

    'delete-wallpage-entry' => array(
      'controller' => 'wallpage',
      'task'       => 'delete',
      'params' => array('id')),

    'delete-group-post' => array(
      'controller' => 'group',
      'task'       => 'deletePost',
      'params' => array('post_id')),
  );

  return $routes;
}

function lovefactoryBuildRoute(&$query)
{
  if (!isset($query['view']) && !isset($query['controller']))
  {
    return array();
  }

  $routes   = getRoutes();
  $segments = array();

  foreach ($routes as $alias => $route)
  {
    if (isset($query['view']))
    {
      if (!isset($route['view']) || $route['view'] != $query['view'])
      {
        continue;
      }
    }
    elseif (isset($query['controller']))
    {
      if (!isset($route['controller']) || $route['controller'] != $query['controller'] || $route['task'] != $query['task'])
      {
        continue;
      }
    }

    $valid = true;
    $temp  = array();

    if (isset($route['params']))
    {
      foreach ($route['params'] as $type => $param)
      {
        if (!isset($query[$param]))
        {
          if ('optional' !== $type)
          {
            $valid = false;
            break;
          }
        }
      }
    }

    if (!$valid)
    {
      continue;
    }

    $segments[] = $alias;
    if (isset($query['view']))
    {
      unset($query['view']);
    }
    else
    {
      unset($query['controller']);
    }

    if (isset($route['controller']))
    {
      unset($query['task']);
    }

    if (isset($route['params']))
    {
      foreach ($route['params'] as $param)
      {
        if (isset($query[$param]))
        {
          $segments[] = $query[$param];
          unset($query[$param]);
        }
      }
    }

    break;
  }

  return $segments;
}

function lovefactoryParseRoute($segments)
{
  $routes = getRoutes();
  $vars   = array();

  $segments[0] = str_replace(':', '-', $segments[0]);

  if (array_key_exists($segments[0], $routes))
  {
    $route = $routes[$segments[0]];

    if (isset($route['view']))
    {
      $vars['view'] = $route['view'];
    }
    else
    {
      $vars['controller'] = $route['controller'];
      $vars['task']       = $route['task'];
    }

    if (isset($route['params']))
    {
      $i = 1;
      foreach ($route['params'] as $type => $param)
      {
        if (isset($segments[$i]))
        {
          $vars[$param] = $segments[$i];
        }

        $i++;
      }
    }
  }

  return $vars;
}