<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class FrontendViewAdvancedSearch extends JFactoryView
{
  function display($tpl = null)
  {
    global $Itemid;

    $search   =& JModel::getInstance('search',   'FrontendModel');
    $renderer =& JModel::getInstance('renderer', 'FrontendModel');
    $session  =& JFactory::getSession();
    $juri     =& JFactory::getUri();
    $settings =  new LovefactorySettings();

    $search->_type = 'advanced';

    $zones        =& $search->getZones();
    $result_zones =& $search->getResultZones();

    $results      =& $search->getData();
    $pagination   =& $search->getPagination();
    $total        =& $search->getTotal();

    $defaults     =& $search->getDefaults();
    $show         =& $search->_show;
    $show_form    =& $search->getShowForm();
    $columns      =  $settings->results_columns == 2 ? 'lovefactory-double-columns' : '';
    $iterator     =  $settings->results_columns == 2 ? 4 : 2;
    $valid        =  $settings->results_columns == 2 ? array(0, 1) : array(0);
    $adsense      =& $search->getAdsense();

    $this->assignRef('zones',        $zones);
    $this->assignRef('result_zones', $result_zones);
    $this->assignRef('renderer',     $renderer);
    $this->assignRef('defaults',     $defaults);
    $this->assignRef('results',      $results);
    $this->assignRef('show',         $show);
    $this->assignRef('show_form',    $show_form);
    $this->assignRef('pagination',   $pagination);
    $this->assignRef('sort_by',      $session->get('lovefactory.search.sortby',    $settings->results_default_sort_by));
    $this->assignRef('sort_order',   $session->get('lovefactory.search.sortorder', $settings->results_default_sort_order));
    $this->assignRef('referer',      str_replace('&', '&amp;', $juri->_uri));
    $this->assignRef('settings',     $settings);
    $this->assignRef('Itemid',       $Itemid);
    $this->assignRef('columns',      $columns);
    $this->assignRef('iterator',     $iterator);
    $this->assignRef('valid',        $valid);
    $this->assignRef('adsense',      $adsense);
    $this->assignRef('total',        $total);

    $this->assignJavascript('txt_show', JText::_('SHOW'));
    $this->assignJavascript('txt_hide', JText::_('HIDE'));
    $this->assignJavascript('root',     JURI::root());

    JHtmlFactory::jQueryScript('cookie', 'fancybox', 'ajaxaction', 'livequery');
    JHTML::script('search.js', 'components/com_lovefactory/assets/js/views/');

    JHTML::stylesheet('main.css',            'components/com_lovefactory/assets/css/');
    JHTML::stylesheet('buttons.css',         'components/com_lovefactory/assets/css/');
    JHTML::stylesheet('search.css',          'components/com_lovefactory/assets/css/views/');
    JHTML::stylesheet('jquery-fancybox.css', 'components/com_lovefactory/assets/css/');
    JHTML::stylesheet('jquery-colortip.css', 'components/com_lovefactory/assets/css/');

    JHtmlFactory::IEStylesheet('ie.css');

    parent::display($tpl);
  }
}