<h1>{jtext _='MEMBERSHIPS_TITLE'}</h1>

<table cellpadding="0" cellspacing="0" class="lovefactory-table">
  <thead>
    <tr>
      <th style="width: 130px;"></th>
      {foreach from=$memberships item=membership}
        <th style="text-align: center; width: 70px;">{$membership->title}</th>
      {/foreach}
      <th></th>
    </tr>
  </thead>
  <tbody>

    <!-- Photos -->
    <tr class="even">
      <td style="text-transform: capitalize;"><b>{jtext _='MEMBERSHIPS_PHOTOS'}</b></td>
      {foreach from=$memberships item=membership}
        <td style="text-align: center;">{$membership->max_photos}</td>
      {/foreach}
      <td></td>
    </tr>

    <!-- Videos -->
    <tr>
      <td style="text-transform: capitalize;"><b>{jtext _='MEMBERSHIPS_VIDEOS'}</b></td>
      {foreach from=$memberships item=membership}
        <td style="text-align: center;">{$membership->max_videos}</td>
      {/foreach}
      <td></td>
    </tr>

    <!-- Friends -->
    <tr class="even">
      <td style="text-transform: capitalize;"><b>{jtext _='MEMBERSHIPS_FRIENDS'}</b></td>
      {foreach from=$memberships item=membership}
        <td style="text-align: center;">{$membership->max_friends}</td>
      {/foreach}
      <td></td>
    </tr>

    <!-- Messages -->
    <tr>
      <td style="text-transform: capitalize;"><b>{jtext _='MEMBERSHIPS_MESSAGES_PER_DAY'}</b></td>
      {foreach from=$memberships item=membership}
        <td style="text-align: center;">{$membership->max_messages_per_day}</td>
      {/foreach}
      <td></td>
    </tr>

    <!-- Interactions -->
    {if $settings->enable_interactions}
      <tr class="even">
        <td style="text-transform: capitalize;"><b>{jtext _='MEMBERSHIPS_INTERACTIONS_PER_DAY'}</b></td>
        {foreach from=$memberships item=membership}
          <td style="text-align: center;">{$membership->max_interactions_per_day}</td>
        {/foreach}
        <td></td>
      </tr>
    {/if}

    <!-- Shoutbox -->
    {if $settings->enable_shoutbox}
      <tr>
        <td style="text-transform: capitalize;"><b>{jtext _='MEMBERSHIPS_SHOUTBOX_ACCESS'}</b></td>
        {foreach from=$memberships item=membership}
          {assign var='temp' value=$membership->shoutbox}
          <td style="text-align: center;">{$shoutbox.$temp}</td>
        {/foreach}
        <td></td>
      </tr>
    {/if}

    <!-- Top Friends -->
    {if $settings->enable_top_friends}
      <tr class="even">
        <td style="text-transform: capitalize;"><b>{jtext _='MEMBERSHIPS_TOP_FRIENDS'}</b></td>
        {foreach from=$memberships item=membership}
          <td style="text-align: center;">{$membership->top_friends}</td>
        {/foreach}
        <td></td>
      </tr>
    {/if}

    <!-- Groups -->
    {if $settings->enable_groups}
      <!-- Groups create -->
      {if $settings->groups_allow_users_create}
        <tr>
          <td style="text-transform: capitalize;"><b>{jtext _='MEMBERSHIPS_GROUPS_CREATE'}</b></td>
          {foreach from=$memberships item=membership}
            <td style="text-align: center;">{$membership->groups_create}</td>
          {/foreach}
          <td></td>
        </tr>
      {/if}

      <!-- Groups join -->
      <tr class='{if $settings->groups_allow_users_create}even{/if}'>
        <td style="text-transform: capitalize;"><b>{jtext _='MEMBERSHIPS_GROUPS_JOIN'}</b></td>
        {foreach from=$memberships item=membership}
          <td style="text-align: center;">{$membership->groups_join}</td>
        {/foreach}
        <td></td>
      </tr>
    {/if}

    <!-- Spacer -->
    <tr>
      <td colspan="10" style="padding-top: 10px;">&nbsp;</td>
    </tr>

    <tr>
      <th></th>
      {foreach from=$memberships item=membership}
        <th style="text-align: center; width: 70px;">{$membership->title}</th>
      {/foreach}
      <th></th>
    </tr>

    <!-- Pricing -->
    {foreach from=$pricing key=months item=prices}
      <tr class="{cycle values="odd,even"}">
      {$i}
        <td>
          <b>
            {if $months != 9999}
              {$months} {jtext _='MEMBERSHIPS_MONTHS'}
            {else}
              {jtext _='MEMBERSHIPS_UNLIMITED'}
            {/if}
          </b>
        </td>

        {foreach from=$memberships item=membership}
          {assign var='temp' value=$membership->id}
          {if $membership->default}
            <td style="text-align: center;">{jtext _='MEMBERSHIPS_DEFAULT'}</td>
          {elseif isset($prices.$temp)}
            <td style="text-align: right;">

              {if !$settings->gender_pricing}

                <a href="{jroute _='index.php?option=com_lovefactory&view=membershipbuy&id=%id%&Itemid=%Itemid%' Itemid=$Itemid id=$prices.$temp->id}">
                  {$prices.$temp->price|number_format:2}&nbsp;{$settings->currency}
                </a>

              {else}

                {foreach from=$prices.$temp->gender_prices key=gender item=price}
                  {if '-1.00' != $price}

                    {if '0.00' != $price}
                      <a href="{jroute _='index.php?option=com_lovefactory&view=membershipbuy&id=%id%&Itemid=%Itemid%' id=$prices.$temp->id Itemid=$Itemid}">
                        {$price|number_format:2}&nbsp;{$settings->currency}
                    {else}
                      <a href="{jroute _='index.php?option=com_lovefactory&controller=membership&task=free&id=%id%&Itemid=%Itemid%' id=$prices.$temp->id Itemid=$Itemid}">
                        {jtext _='MEMBERSHIP_FREE'}
                    {/if}
                      <small>[{$gender}]</small><br />
                    </a>
                  {/if}
                {/foreach}
              {/if}
            </td>
          {else}
            <td style="text-align: center;">-</td>
          {/if}
        {/foreach}
        <td></td>

      </tr>
    {/foreach}

    {if count($trials)}
      <!-- Spacer -->
      <tr>
        <td colspan="10" style="padding-top: 10px;">&nbsp;</td>
      </tr>

      <tr>
        <td colspan="10">{jtext _='MEMBERSHIPS_FREE_TRIALS'}</td>
      </tr>

      <tr>
        <th></th>
        {foreach from=$memberships item=membership}
          <th style="text-align: center; width: 70px;">{$membership->title}</th>
        {/foreach}
        <th></th>
      </tr>

      <!-- Pricing -->
      {foreach from=$trials key=months item=prices}
        <tr class="{cycle values="odd,even"}">
        {$i}
          <td>
            <b>
              {if $months != 9999}
                {$months} {jtext _='MEMBERSHIPS_HOURS'}
              {else}
                {jtext _='MEMBERSHIPS_UNLIMITED'}
              {/if}
            </b>
          </td>

          {foreach from=$memberships item=membership}
            {assign var='temp' value=$membership->id}
            {if $membership->default}
              <td style="text-align: center;">{jtext _='MEMBERSHIPS_DEFAULT'}</td>
            {elseif isset($prices.$temp)}
              <td style="text-align: center;">
                <a href="{jroute _='index.php?option=com_lovefactory&controller=membership&task=trial&id=%id%' id=$prices.$temp->id}">{jtext _='MEMBERSHIPS_FREE_TRIAL'}</a>
              </td>
            {else}
              <td style="text-align: center;">-</td>
            {/if}
          {/foreach}
          <td></td>

        </tr>
      {/foreach}
    {/if}
  </tbody>
</table>

<br />