<?php

defined('_JEXEC') or die('Restricted access');

class BackendControllerReport extends BackendController
{
	function __construct()
	{
		parent::__construct();
	}

	function remove()
  {
    $model = $this->getModel('report');

    if (!$model->delete())
    {
      $msg = JText::_('Error: One or More Reports Could not be Deleted');
    }
    else
    {
      $msg = JText::_('Report(s) Deleted');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=reports', $msg);
  }

  function resolve()
  {
    $model = $this->getModel('report');

    if (!$model->resolve())
    {
      $msg = JText::_('Error Resolving Report');
    }
    else
    {
      $msg = JText::_('Report Resolved');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=reports', $msg);
  }

  function unresolve()
  {
    $model = $this->getModel('report');

    if (!$model->unresolve())
    {
      $msg = JText::_('Error Changin Report State');
    }
    else
    {
      $msg = JText::_('Report State Changed');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=reports', $msg);
  }

  function resolveList()
  {
    $model = $this->getModel('report');

    if (!$model->resolveList())
    {
      $msg = JText::_('Error Resolving Reports!');
    }
    else
    {
      $msg = JText::_('Reports Resolved');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=reports', $msg);
  }

  function unresolveList()
  {
    $model = $this->getModel('report');

    if (!$model->unresolveList())
    {
      $msg = JText::_('Error Unresolving Reports!');
    }
    else
    {
      $msg = JText::_('Reports Unresolved');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=reports', $msg);
  }

  function view()
  {
    JRequest::setVar('view', 'report');
    JRequest::setVar('layout', 'view');
    #JRequest::setVar('hidemainmenu', 1);

    parent::display();
  }

  function cancel()
  {
    $msg = JText::_('Operation Cancelled');
    $this->setRedirect('index.php?option=com_lovefactory&task=reports', $msg);
  }

  function save()
  {
    $model = $this->getModel('report');

    if ($model->store())
    {
      $msg = JText::_('Report Saved!');
    }
    else
    {
      $msg = JText::_('Error Saving Report');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=reports', $msg);
  }

  function actionDelete()
  {
    $id     =  JRequest::getVar('id', 0, 'GET', 'integer');
    $model  =  $this->getModel('report');

    if ($model->actionDelete())
    {
      $msg = JText::_('Reported Item Deleted!');
    }
    else
    {
      $msg = JText::_('Error Deleting Reported Item!');
    }

    $this->setRedirect('index.php?option=com_lovefactory&controller=report&task=view&id=' . $id, $msg);
  }

  function actionBan()
  {
    $id     =  JRequest::getVar('id', 0, 'GET', 'integer');
    $model  =  $this->getModel('report');

    if ($model->actionBan())
    {
      $msg = JText::_('User Banned!');
    }
    else
    {
      $msg = JText::_('Error Banning User!');
    }

    $this->setRedirect('index.php?option=com_lovefactory&controller=report&task=view&id=' . $id, $msg);
  }

  function actionMessage()
  {
    $id     =  JRequest::getVar('id', 0, 'POST', 'integer');
    $model  =  $this->getModel('report');

    if ($model->actionMessage())
    {
      $msg = JText::_('Message Sent!');
    }
    else
    {
      $msg = JText::_('Error Sending Message!');
    }

    $this->setRedirect('index.php?option=com_lovefactory&controller=report&task=view&id=' . $id, $msg);
  }
}