<?php

defined('_JEXEC') or die('Restricted access');

class BackendControllerUser extends BackendController
{
	function __construct()
	{
		parent::__construct();
	}

	function remove()
  {
    $model = $this->getModel('user');

    if (!$model->delete())
    {
      $msg = JText::_('Error: One or More Users Could not be Deleted') . ' ' . $model->getError();
    }
    else
    {
      $msg = JText::_('User(s) Deleted!');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=users', $msg);
  }

  function view()
  {
    JRequest::setVar('view', 'user');
    JRequest::setVar('layout', 'view');
    #JRequest::setVar('hidemainmenu', 1);

    parent::display();
  }

  function editProfile()
  {
    JRequest::setVar('view', 'profile');

    parent::display();
  }

  function cancel()
  {
    $msg = JText::_('Operation Cancelled');
    $this->setRedirect('index.php?option=com_lovefactory&task=users', $msg);
  }

  function save()
  {
    $model = $this->getModel('user');

    if ($model->store())
    {
      $msg = JText::_('User Saved!');
    }
    else
    {
      $msg = JText::_('Error Saving User');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=users', $msg);
  }

  function apply()
  {
    $model = $this->getModel('user');

    if ($model->store())
    {
      $msg = JText::_('User Saved!');
    }
    else
    {
      $msg = JText::_('Error Saving User');
    }

    $id = JRequest::getVar('id', 0, 'POST', 'integer');
    $this->setRedirect('index.php?option=com_lovefactory&controller=user&task=view&id=' . $id, $msg);
  }

  function unban()
  {
    $model = $this->getModel('user');

    if (!$model->unban())
    {
      $msg = JText::_('Error Unbanning User!');
    }
    else
    {
      $msg = JText::_('User Unbanned');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=users', $msg);
  }

  function ban()
  {
    $model = $this->getModel('user');

    if (!$model->ban())
    {
      $msg = JText::_('Error Banning User!');
    }
    else
    {
      $msg = JText::_('User Banned');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=users', $msg);
  }

  function unbanList()
  {
    $model = $this->getModel('user');

    if (!$model->unbanList())
    {
      $msg = JText::_('Error Unbanning Users!');
    }
    else
    {
      $msg = JText::_('Users Unbanned');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=users', $msg);
  }

  function banList()
  {
    $model = $this->getModel('user');

    if (!$model->banList())
    {
      $msg = JText::_('Error Banning Users!');
    }
    else
    {
      $msg = JText::_('Users Banned');
    }

    $this->setRedirect('index.php?option=com_lovefactory&task=users', $msg);
  }

  function applyProfile()
  {
    JModel::addIncludePath(JPATH_COMPONENT_SITE.DS.'models');
    $model =& JModel::getInstance('profile', 'FrontendModel');

    $id = JRequest::getVar('id', 0, 'POST', 'integer');

    if ($model->update($id))
    {
      $msg = JText::_('User Profile Saved!');
    }
    else
    {
      $msg = JText::_('Error Saving User Profile!');
    }

    $this->setRedirect('index.php?option=com_lovefactory&controller=user&task=editprofile&id=' . $id, $msg);
  }

  function saveProfile()
  {
    JModel::addIncludePath(JPATH_COMPONENT_SITE.DS.'models');
    $model =& JModel::getInstance('profile', 'FrontendModel');

    $id = JRequest::getVar('id', 0, 'POST', 'integer');

    if ($model->update($id))
    {
      $msg = JText::_('User Profile Saved!');
    }
    else
    {
      $msg = JText::_('Error Saving User Profile!');
    }

    $this->setRedirect('index.php?option=com_lovefactory&controller=user&task=view&id=' . $id, $msg);
  }

  function cancelProfile()
  {
    $msg = JText::_('Operation Cancelled');
    $id = JRequest::getVar('id', 0, 'POST', 'integer');
    $this->setRedirect('index.php?option=com_lovefactory&controller=user&task=view&id=' . $id, $msg);
  }

  function verifyUsers()
  {
    $model = $this->getModel('user');

    $model->verifyUsers();
    $msg = JText::_('Verification finished!');

    $this->setRedirect('index.php?option=com_lovefactory&task=users', $msg);
  }
}