<?php

defined('_JEXEC') or die('Restricted access');

// Component Installer
function com_install()
{
  installModulesAndPlugins();
  installMenus();
}

// Modules and Plugins Installers
function installModulesAndPlugins()
{
  require_once(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_lovefactory'.DS.'modules'.DS.'info.php');

  // Modules
  foreach ($modules as $module => $options)
  {
    installModule($module, $options);
  }

  // Plugins
  foreach ($plugins as $plugin => $options)
  {
    installPlugin($plugin, $options);
  }
}

function installModule($module, $options)
{
  $database =& JFactory::getDBO();

  // Copy module files
  rename(
    JPATH_ADMINISTRATOR.DS.'components'.DS.'com_lovefactory'.DS.'modules'.DS.'mod_'.$module,
    JPATH_ROOT.DS.'modules'.DS.'mod_'.$module
  );

  // Copy languages
  foreach ($options['languages'] as $language)
  {
    rename(
      JPATH_ROOT.DS.'modules'.DS.'mod_'.$module.DS.$language.'.mod_'.$module.'.ini',
      JPATH_ROOT.DS.'language'.DS.$language.DS.$language.'.mod_'.$module.'.ini'
    );
  }

  // Insert into modules table
  $query = ' INSERT INTO #__modules'
         . ' VALUES ("", "' . $options['title'] . '", "", 0, "left", 0, "0000-00-00 00:00:00", ' . $options['enabled'] . ', "mod_' . $module . '", 0, ' . $options['access'] . ', 1, "", 0, 0, "")';
  $database->setQuery($query);
  $database->query();

  $id = $database->insertid();

  // Insert into modules_menu table
  $query = ' INSERT INTO #__modules_menu'
         . ' VALUES(' . $id . ', 0)';
  $database->setQuery($query);
  $database->query();
}

function installPlugin($plugin, $options)
{
  $database =& JFactory::getDBO();

  // Copy plugin files
  rename(
    JPATH_ADMINISTRATOR.DS.'components'.DS.'com_lovefactory'.DS.'modules'.DS.'plugins'.DS.$plugin.'.php',
    JPATH_ROOT.DS.'plugins'.DS.$options['type'].DS.$plugin.'.php'
  );

  rename(
    JPATH_ADMINISTRATOR.DS.'components'.DS.'com_lovefactory'.DS.'modules'.DS.'plugins'.DS.$plugin.'.xml',
    JPATH_ROOT.DS.'plugins'.DS.$options['type'].DS.$plugin.'.xml'
  );

  $query = ' INSERT'
         . ' INTO `#__plugins` (`id`, `name`, `element`, `folder`, `access`, `ordering`, `published`, `iscore`, `client_id`, `checked_out`, `checked_out_time`, `params`) VALUES'
         . ' ("", "' . $options['title'] . '", "' . $plugin . '", "' . $options['type'] . '", 0, 0, 1, 0, 0, 0, "0000-00-00 00:00:00", "")';
  $database->setQuery($query);
  $database->query();
}

// Menus Installer
function installMenus()
{
  $database =& JFactory::getDBO();

  // Love Factory Menu
  $query = ' SELECT m.id'
         . ' FROM #__menu_types m'
         . ' WHERE m.menutype = "lovefactory"';
  $database->setQuery($query);

  if (!$database->loadResult())
  {
    // 1. Create menu
    $query = ' INSERT'
           . ' INTO #__menu_types'
           . ' VALUES (NULL , "lovefactory", "Love Factory Menu", "Love Factory Menu")';
    $database->setQuery($query);
    $database->query();

    $menu_id = $database->insertid();

    // 2. Create module
    $query = ' INSERT INTO #__modules'
           . ' VALUES ("", "Love Factory Menu", "", 0, "left", 0, "0000-00-00 00:00:00", 1, "mod_mainmenu", 0, 0, 1, "menutype=lovefactory", 0, 0, "")';
    $database->setQuery($query);
    $database->query();

    $module_id = $database->insertid();

    $query = ' INSERT INTO #__modules_menu'
           . ' VALUES(' . $module_id . ', 0)';
    $database->setQuery($query);
    $database->query();

    $module_menu_id = $database->insertid();

    // Get the component id
    $query = ' SELECT id'
           . ' FROM #__components'
           . ' WHERE link="option=com_lovefactory"';
    $database->setQuery($query);
    $component_id = $database->loadResult();

    // 3. Create menu items
    // Search for a match
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactory';
    $menu_item->name        = 'Search For A Match';
    $menu_item->alias       = 'search-for-a-match';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=quicksearch';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 1;
    $menu_item->params      = '';

    $menu_item->store();

    // Online users
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactory';
    $menu_item->name        = 'Online Users';
    $menu_item->alias       = 'online-users';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=online';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 2;
    $menu_item->params      = '';

    $menu_item->store();

    // Memberships plans
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactory';
    $menu_item->name        = 'Memberships Plans';
    $menu_item->alias       = 'memberships-plans';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=memberships';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 3;
    $menu_item->params      = '';

    $menu_item->store();

    // Radius search
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactory';
    $menu_item->name        = 'Radius search';
    $menu_item->alias       = 'radius-search';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=radiussearch';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 4;
    $menu_item->params      = '';

    $menu_item->store();

    // Members map
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactory';
    $menu_item->name        = 'Members map';
    $menu_item->alias       = 'members-map';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=membersmap';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 4;
    $menu_item->params      = '';

    $menu_item->store();
  }



  // Love Factory User Menu
  $query = ' SELECT m.id'
         . ' FROM #__menu_types m'
         . ' WHERE m.menutype = "lovefactoryuser"';
  $database->setQuery($query);

  if (!$database->loadResult())
  {
    // 1. Create menu
    $query = ' INSERT'
           . ' INTO #__menu_types'
           . ' VALUES (NULL , "lovefactoryuser", "Love Factory User Menu", "Love Factory User Menu")';
    $database->setQuery($query);
    $database->query();

    $menu_id = $database->insertid();

    // 2. Create module
    $query = ' INSERT INTO #__modules'
           . ' VALUES ("", "Love Factory User Menu", "", 0, "left", 0, "0000-00-00 00:00:00", 1, "mod_mainmenu", 0, 1, 1, "menutype=lovefactoryuser", 0, 0, "")';
    $database->setQuery($query);
    $database->query();

    $module_id = $database->insertid();

    $query = ' INSERT INTO #__modules_menu'
           . ' VALUES(' . $module_id . ', 0)';
    $database->setQuery($query);
    $database->query();

    $module_menu_id = $database->insertid();

    // 3. Create menu items
    // View profile
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactoryuser';
    $menu_item->name        = 'View My Profile';
    $menu_item->alias       = 'view-my-profile';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=profile';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 1;
    $menu_item->params      = '';

    $menu_item->store();

    // Edit profile
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactoryuser';
    $menu_item->name        = 'Edit My Profile';
    $menu_item->alias       = 'edit-my-profile';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=edit';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 2;
    $menu_item->params      = '';

    $menu_item->store();

    // My gallery
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactoryuser';
    $menu_item->name        = 'My Gallery';
    $menu_item->alias       = 'my-gallery';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=mygallery';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 3;
    $menu_item->params      = '';

    $menu_item->store();

    // My inbox
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactoryuser';
    $menu_item->name        = 'Inbox';
    $menu_item->alias       = 'inbox';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=inbox';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 4;
    $menu_item->params      = '';

    $menu_item->store();

    // Friends
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactoryuser';
    $menu_item->name        = 'Friends list';
    $menu_item->alias       = 'friends-list';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=myfriends';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 5;
    $menu_item->params      = '';

    $menu_item->store();

    // Interactions
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactoryuser';
    $menu_item->name        = 'Interactions';
    $menu_item->alias       = 'interactions';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=interactions';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 6;
    $menu_item->params      = '';

    $menu_item->store();

    // Ignore list
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactoryuser';
    $menu_item->name        = 'Ignore List';
    $menu_item->alias       = 'ignore-list';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=blacklist';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 7;
    $menu_item->params      = '';

    $menu_item->store();

    // My memberships
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactoryuser';
    $menu_item->name        = 'My Membership';
    $menu_item->alias       = 'my-membership';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=mymembership';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 8;
    $menu_item->params      = '';

    $menu_item->store();

    // Groups
    $menu_item =& JTable::getInstance('menu');
    $menu_item->menutype    = 'lovefactoryuser';
    $menu_item->name        = 'Groups';
    $menu_item->alias       = 'groups';
    $menu_item->link        = 'index.php?option=com_lovefactory&view=groups';
    $menu_item->type        = 'component';
    $menu_item->published   = 1;
    $menu_item->componentid = $component_id;
    $menu_item->ordering    = 9;
    $menu_item->params      = '';

    $menu_item->store();
  }
}