<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelField extends JModel
{
  function __construct()
  {
    parent::__construct();

    $cids = JRequest::getVar('cid', 0, '', 'array');
    $this->setId((int)$cids[0]);
  }

  function setId($id)
  {
    $this->_id   = $id;
    $this->_data = null;
  }

  function &getData()
  {
    if (empty($this->_data))
    {
      $this->_data = $this->getTable();
      $this->_data->load($this->_id);
      $this->_data->_params = $this->_data->getParams();
    }

    return $this->_data;
  }

  function store()
  {
    $field =& $this->getTable('field', 'Table');
    $id    =& JRequest::getVar('id', 0, 'POST', 'integer');

    $field->load($id);
    $this->saved_id = $id;

    if (!$field->updateCommonFromRequest())
    {
      return false;
    }

    if (!$field->updateFromRequest())
    {
      return false;
    }

    $field->store();
    $this->saved_id = $field->id;

    return true;
  }

  function delete()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');
    $field =& $this->getTable();

    foreach($cids as $cid)
    {
      $field =& $this->getTable('field', 'Table');
      $field->load($cid);

      // Trying to delete a system field?
      if ($field->system)
      {
        JError::raiseWarning('ERROR', JText::_('You cannot delete a system field!') . ' ("' . $field->title . '")');
        return false;
      }

      // Delete the field
      if (!$field->delete($cid))
      {
        JError::raiseWarning('ERROR', $field->getErrorMsg());
        return false;
      }
    }

    return true;
  }

  function change()
  {
    $database =& JFactory::getDBO();
    $field = JRequest::getVar('field', '', 'GET', 'string');
    $value = JRequest::getVar('value',  0, 'GET', 'integer');
    $id    = JRequest::getVar('id',     0, 'GET', 'integer');

    if (!in_array($field, array('published', 'required')))
    {
      $this->setError(JText::_('Field not found!'));
      return false;
    }

    $query = ' UPDATE #__lovefactory_fields'
           . ' SET ' . $field . ' = ' . $value
           . ' WHERE id = ' . $id;
    $database->setQuery($query);

    return $database->query();
  }

  function publish()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');
    JRequest::setVar('field', 'published', 'GET', true);
    JRequest::setVar('value', 1, 'GET', true);

    foreach ($cids as $cid)
    {
      JRequest::setVar('id', $cid, 'GET', true);

      if (!$this->change())
      {
        $this->setError($field->getErrorMsg());
        return false;
      }
    }

    return true;
  }

  function unpublish()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');
    JRequest::setVar('field', 'published', 'GET', true);
    JRequest::setVar('value', 0, 'GET', true);

    foreach ($cids as $cid)
    {
      JRequest::setVar('id', $cid, 'GET', true);

      if (!$this->change())
      {
        $this->setError($field->getErrorMsg());
        return false;
      }
    }

    return true;
  }

  function getNotAllowedFieldTypes()
  {
    $query = ' SELECT f.type_id'
           . ' FROM #__lovefactory_fields f'
           . ' WHERE f.type_id IN(10, 11)';
    $this->_db->setQuery($query);

    return $this->_db->loadAssocList('type_id');
  }
}