<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelGroup extends JModel
{
  var $id;

  function __construct()
  {
    parent::__construct();

    $cids = JRequest::getVar('cid', 0, '', 'array');
    $this->setId((int)$cids[0]);
  }

  function setId($id)
  {
    $this->_id   = $id;
    $this->_data = null;
  }

  function &getData()
  {
    if (empty($this->_data))
    {
      $query = ' SELECT g.*, u.username'
             . ' FROM #__lovefactory_groups g'
             . ' LEFT JOIN #__users u ON u.id = g.user_id'
             . ' WHERE g.id = ' . $this->_id;
      $this->_db->setQuery($query);
      $group = $this->_db->loadObject();

      $this->_data = $this->getTable();

      if ($group)
      {
        $this->_data->bind($group);
        $this->_data->username = $group->username;
      }
    }

    if (!$this->_data)
    {
      $this->_data = $this->getTable();
    }

    return $this->_data;
  }

  function store()
  {
    $group =& $this->getTable();
    $data  =  JRequest::get('post');
    $user  =& JFactory::getUser();
    $id    =& JRequest::getVar('id', 0, 'POST', 'integer');

    $isNew = false;

    $group->load($id);

    if (!$group->bind($data))
    {
      JError::raiseError(500, $this->_db->getErrorMsg());
      return false;
    }

    if (!$group->user_id)
    {
      $group->user_id = $user->id;
      $isNew = true;
    }

    if (!$group->check())
    {
      JError::raiseError(500, $this->_db->getErrorMsg());
      return false;
    }

    // Check for thumbnail delete
    $delete_thumb =& JRequest::getVar('delete_thumb', 0, 'POST', 'integer');

    if ($delete_thumb)
    {
      @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$group->user_id.DS.'group_'.$group->thumbnail);
      @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$group->user_id.DS.'group_thumb_'.$group->thumbnail);

      $group->thumbnail = '';
    }

    // Upload thumbnail
    $thumbnail =& JRequest::getVar('thumbnail', array(), 'FILES', 'array');

    if (count($thumbnail) && !$thumbnail['error'])
    {
      jimport('joomla.filesystem.file');
      $settings = new LovefactorySettings();
      require_once(JPATH_COMPONENT_SITE.DS.'resizeIMG.php');

      // Delete old thumbnail
      @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$group->user_id.DS.'group_'.$group->thumbnail);
      @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$group->user_id.DS.'group_thumb_'.$group->thumbnail);

      // Upload new thumbnail
      $user_folder = JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$group->user_id;
      $extension   = strtolower(JFile::getExt($thumbnail['name']));
      $filename    = md5($group->user_id . time() . rand(0, 1000000)) . '.' . $extension;

      $filepath = JPath::clean($user_folder.DS.'group_'.$filename);
      $resize = new RESIZEIMAGE($thumbnail['tmp_name']);
      $resize->resize_scale($settings->groups_photo_max_width, $settings->groups_photo_max_height, $filepath, false);
      $resize->close();

      $filepath = JPath::clean($user_folder.DS.'group_thumb_'.$filename);
      $resize = new RESIZEIMAGE($thumbnail['tmp_name']);
      $resize->resize_scale(100, 63, $filepath);
      $resize->close();

      $group->thumbnail = $filename;
    }

    if (!$group->store())
    {
      JError::raiseError(500, $this->_db->getErrorMsg());
      return false;
    }

    $this->id = $group->id;

    if ($isNew)
    {
      // Create owner group member
      $member =& $this->getTable('GroupMember');

      $member->group_id = $group->id;
      $member->user_id  = $group->user_id;

      $member->store();
    }

    return true;
  }

  function delete()
  {
    $cid =& JRequest::getVar('cid', array(), 'POST', 'array');
    JArrayHelper::toInteger($cid);

    foreach ($cid as $id)
    {
      $group =& $this->getTable('Group');
      $group->load($id);

      if (!$group->delete())
      {
        JError::raiseWarning(0, $this->_db->getErrorMsg());
        return false;
      }
    }

    return true;
  }
}