<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelGroupMembers extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;

  function __construct()
  {
    parent::__construct();

    global $mainframe, $option;
    $limit      = $mainframe->getUserStateFromRequest('global.list.limit',                'limit',      $mainframe->getCfg('list_limit'), 'int');
    $limitstart = $mainframe->getUserStateFromRequest($option.'.groupmembers.limitstart', 'limitstart', 0,                                'int');

    $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

    $this->setState('limit',      $limit);
    $this->setState('limitstart', $limitstart);
  }

  // List
  function getData()
  {
    if (empty($this->_data))
    {
      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
    }

    return $this->_data;
  }

  function _buildQuery()
  {
    $orderby = $this->_buildContentOrderBy();
    $where   = $this->_buildContentWhere();

    $query = ' SELECT m.*, u.username,'
           . '   COUNT(DISTINCT p.id) AS posts'
           . ' FROM #__lovefactory_group_members m'
           . ' LEFT JOIN #__users u ON m.user_id = u.id'
           . ' LEFT JOIN #__lovefactory_group_posts p ON p.group_id = m.group_id AND p.user_id = m.user_id'
           . $where
           . ' GROUP BY m.user_id'
           . $orderby
           ;

    return $query;
  }

  function _buildContentOrderBy()
  {
    global $mainframe, $option;

    $filter_order     = $mainframe->getUserStateFromRequest($option.'.groups.filter_order',     'filter_order',     'title', 'cmd');
    $filter_order_Dir = $mainframe->getUserStateFromRequest($option.'.groups.filter_order_Dir', 'filter_order_Dir', 'asc',   'word');

    $orderby = '';

    if (in_array($filter_order, array('posts', 'u.username',
                                      'm.created_at')))
    {
      $orderby = ' ORDER BY ' . $filter_order . ' ' . $filter_order_Dir;
    }

    return $orderby;
  }

  function _buildContentWhere()
  {
    $group_id = $this->getGroupId();

    $where = ' WHERE m.group_id = ' . $group_id;

    return $where;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit'));
    }

    return $this->_pagination;
  }

  function getGroupId()
  {
    static $group_id = null;

    if (is_null($group_id))
    {
      $group_id =& JRequest::getVar('id', 0, 'REQUEST', 'integer');
    }

    return $group_id;
  }

  function getGroup()
  {
    $group_id =  $this->getGroupId();
    $group    =& $this->getTable('Group');

    $group->load($group_id);

    return $group;
  }
}