<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelMembership extends JModel
{
  var $id;

  function __construct()
  {
    parent::__construct();

    $cids = JRequest::getVar('cid', 0, '', 'array');
    $this->setId((int)$cids[0]);
  }

  function setId($id)
  {
    $this->_id   = $id;
    $this->_data = null;
  }

  function &getData()
  {
    if (empty($this->_data))
    {
       $this->_data = $this->getTable();
       $this->_data->load($this->_id);
    }

    if (!$this->_data)
    {
      $this->_data = $this->getTable();
    }

    return $this->_data;
  }

  function publish()
  {
    $cids       =& JRequest::getVar('cid', array(0), 'REQUEST', 'array');
    $membership =& $this->getTable('membership');

    foreach ($cids as $cid)
    {
      $membership->load($cid);

      $membership->published = 1;
      $membership->store();
    }

    return true;
  }

  function unpublish()
  {
    $cids       =& JRequest::getVar('cid', array(0), 'REQUEST', 'array');
    $membership =& $this->getTable('membership');

    foreach ($cids as $cid)
    {
      $membership->load($cid);

      if ($membership->default)
      {
        JError::raiseWarning(1, JText::_('You cannot unpublish the default membership'));
        return false;
      }

      $membership->published = 0;
      $membership->store();
    }

    return true;
  }

  function store()
  {
    $membership =& $this->getTable();
    $data = JRequest::get('post');

    if (!$membership->bind($data))
    {
      JError::raiseError(500, $this->_db->getErrorMsg());
      return false;
    }

    if (!$membership->check())
    {
      JError::raiseError(500, $this->_db->getErrorMsg());
      return false;
    }

    if (!$membership->id)
    {
      $membership->ordering = $membership->getNextOrder();
    }

    if (!$membership->store())
    {
      JError::raiseError(500, $this->_db->getErrorMsg());
      return false;
    }

    // Check if saved membership is default
    $membership->load($membership->id);
    if ($membership->default)
    {
      $this->updateDefaultSoldMembership($membership);
    }

    // Check if we apply the changes to all sold memberships
    $apply_to_sold =& JRequest::getVar('apply_to_sold', array(), 'POST', 'array');
    JArrayHelper::toInteger($apply_to_sold);

    if (count($apply_to_sold))
    {
      $this->updateSoldMemberships($membership, $apply_to_sold);
    }

    $this->id = $membership->id;

    return true;
  }

  function delete()
  {
    $cids       =& JRequest::getVar('cid', array(0), 'post', 'array');
    $membership =& $this->getTable();

    foreach ($cids as $cid)
    {
      $membership->load($cid);

      if ($membership->default)
      {
        JError::raiseWarning(1, JText::_('You cannot delete the default membership!'));
        return false;
      }

      if (!$membership->delete())
      {
        $this->setError($membership->getError());
        return false;
      }
    }
    return true;
  }

  function saveorder()
  {
    global $mainframe;

		$cid		    =& JRequest::getVar('cid',        array(0), 'post', 'array');
		$order		  =& JRequest::getVar('order',      array(0), 'post', 'array');
		$redirect	  =& JRequest::getVar('redirect',   0,        'post', 'int');
		$rettask	  =& JRequest::getVar('returntask', '',       'post', 'cmd');
		$total		  = count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid,   array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate an article table object
		$row =& JTable::getInstance('membership', 'Table');

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load(intval($cid[$i]));

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];

				if (!$row->store())
				{
					JError::raiseError(500, $db->getErrorMsg());
					return false;
				}
			}
		}

		return true;
  }

  function orderContent($direction)
  {
		$cid =& JRequest::getVar('cid', array(), 'post', 'array');

		if (isset($cid[0]))
		{
			$row =& JTable::getInstance('membership', 'Table');
			$row->load(intval($cid[0]));
			$row->move($direction);
		}
  }

  function setDefault()
  {
    $cid =& JRequest::getVar('cid', array(), 'POST', 'array');
		JArrayHelper::toInteger($cid);

		if (isset($cid[0]) && $cid[0])
		{
			$id = $cid[0];
		}
		else
		{
			JError::raiseWarning('ERROR', JText::_('No Item Selected!'));
			return false;
		}

		$membership =& $this->getTable();
		$membership->load($id);

		if (!$membership->published)
		{
		  JError::raiseWarning('ERROR', JText::_('The Default Membership Must Be Published!'));
			return false;
		}

		$query = ' UPDATE #__lovefactory_memberships'
		       . ' SET `default` = 0';
		$this->_db->setQuery($query);
		$this->_db->query();

		$membership->default = 1;
		$membership->store();

		$this->updateDefaultSoldMembership($membership);

		return true;
  }

  function updateDefaultSoldMembership($membership)
  {
    // Update the sold memberships
		$sold =& $this->getTable('membershipsold', 'Table');
		$sold->load(1);

		$sold->updateDefaultFromMembership($membership);

		$sold->store(false, true);
  }

  function updateSoldMemberships($membership, $apply_to_sold)
  {
    $query = ' SELECT m.*'
           . ' FROM #__lovefactory_memberships_sold m'
           . ' WHERE m.membership_id = ' . $membership->id
           . ' AND m.expired = 0'
           . ' AND m.user_id <> 0';
    $this->_db->setQuery($query);
    $memberships = $this->_db->loadObjectList();

    foreach ($memberships as $sold)
    {
      $table =& $this->getTable('membershipsold', 'Table');
      $table->bind($sold);

      foreach ($apply_to_sold as $option => $value)
      {
        if (in_array($option, array('shoutbox', 'chatfactory', 'top_friends', 'groups_join', 'groups_create')))
        {
          $table->$option = $membership->$option;
        }
      }

      $table->store();
    }
  }
}