<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelPage extends JModel
{
  function __construct()
  {
    parent::__construct();

    $cids = JRequest::getVar('cid', 0, '', 'array');
    $this->setId((int)$cids[0]);
  }

  function setId($id)
  {
    $this->_id   = $id;
    $this->_data = null;
  }

  function getData()
  {
    $page =& $this->getTable('page', 'Table');
    $page->load($this->_id);

    // Get the titles
    $titles   = array();
    $exploded = explode('#', $page->titles);
    foreach ($exploded as $title)
    {
      $title = explode('___', $title);
      $titles[$title[0]] = @$title[1];
    }

    // Get the zones
    $zones    = array();
    $used     = array();
    $exploded = explode('#', $page->fields);

    foreach ($exploded as $field)
    {
      $field = explode('_', $field);

      if (!isset($zones[$field[0]]))
      {
        $zones[$field[0]] = array();
      }

      if (!isset($zones[$field[0]][$field[1]]))
      {
        $zones[$field[0]][$field[1]] = array();
      }

      $zones[$field[0]][$field[1]][] = $field[2];
      $used[] = $field[2];
    }

    // Get the fields
    $fields = $this->getFieldsForPage();

    // Get available fields
    $available = array_diff(array_keys($fields), $used);

    $page->_titles = $titles;
    $page->_zones = $zones;
    $page->_fields = $fields;
    $page->_available = $available;

    return $page;
  }

  function getAvailableFields()
  {
    $query = ' SELECT *'
           . ' FROM #__lovefactory_fields';
    $this->_db->setQuery($query);

    $array = array();
    $fields = $this->_db->loadObjectList();
    foreach ($fields as $field)
    {
      $array[$field->id] = $field;
    }

    return $array;
  }

  function getSpacer()
  {
    $array = array();

    $query = ' SELECT f.id'
           . ' FROM #__lovefactory_fields f'
           . ' WHERE f.type_id =  27';
    $this->_db->setQuery($query);
    $id = $this->_db->loadResult();

    $array['id']   = $id;
    $array['link'] = 'index.php?option=com_lovefactory&controller=field&task=edit&cid[]=' . $id;

    return (object)$array;
  }

  function store()
  {
    $page =& $this->getTable();

    $data = JRequest::get('post');

    if (!$page->bind($data))
    {
      JError::raiseWarning('ERROR', $this->_db->getErrorMsg());
      return false;
    }

    if (!$page->check())
    {
      $this->saved_id = $page->id;
      JError::raiseWarning('ERROR', $page->getError());
      return false;
    }

    if (!$page->store())
    {
      JError::raiseWarning('ERROR', $this->_db->getErrorMsg());
      return false;
    }

    $this->saved_id = $page->id;

    return true;
  }

  function getFieldsForPage()
  {
    $field_types = array(
      // Registration
      1 => array(1, 2, 3, 4, 5, 6, 7, 10, 11, 12, 18, 19, 20, 21, 23, 26, 27, 28),

      // Profile edit
      2 => array(1, 2, 3, 4, 5, 6, 7, 10, 11, 23, 27),

      // Quick search
      3 => array(1, 2, 3, 4, 5, 6, 7, 10, 11, 12, 13, 14, 24, 25, 27),

      // Advanced search
      4 => array(1, 2, 3, 4, 5, 6, 7, 10, 11, 12, 13, 14, 24, 25, 27),

      // Profile search
      5 => array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 15, 16, 17, 22, 24, 25, 27, 29),

      // Profile view
      6 => array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 15, 16, 17, 22, 23, 24, 25, 27, 29),

      // Friends list view
      7 => array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 15, 16, 17, 22, 24, 25, 27, 29),

      // Profile fillin
      8 => array(1, 2, 3, 4, 5, 6, 7, 10, 11, 21, 23, 26, 27, 28),

      // Map member info
      9 => array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 15, 16, 17, 22, 24, 25, 27, 29),
    );

    $query = ' SELECT f.id, f.title, f.system'
           . ' FROM #__lovefactory_fields f'
           . ' WHERE f.type_id IN (' . implode(',', $field_types[$this->_id]) . ')';
    $this->_db->setQuery($query);
    return $this->_db->loadObjectList('id');
  }
}