<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelPayment extends JModel
{
  function __construct()
  {
    parent::__construct();
  }

  function getData()
  {
    $cid = JRequest::getVar('cid', array(), 'REQUEST', 'array');
    $id = $cid[0];

    $query = ' SELECT p.*, u.username, m.title AS membership_title, o.months, o.id AS order_id,'
           . '   p.amount AS payment_amount, o.amount AS order_amount,'
           . '   p.currency AS payment_currency, o.currency AS order_currency'
           . ' FROM #__lovefactory_payments p'
           . ' LEFT JOIN #__users u ON u.id = p.user_id'
           . ' LEFT JOIN #__lovefactory_orders o ON o.id = p.order_id'
           . ' LEFT JOIN #__lovefactory_memberships m ON m.id = o.membership_id'
           . ' WHERE p.id = ' . $id;
    $this->_db->setQuery($query);

    return $this->_db->loadObject();
  }

  function delete()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');
    $payment =& $this->getTable();

    foreach ($cids as $cid)
    {
      if (!$payment->delete($cid))
      {
        JError::raiseError('ERROR', $payment->getErrorMsg());
        return false;
      }
    }
    return true;
  }

  function validate()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');
    $payment =& $this->getTable('payment');

    foreach ($cids as $cid)
    {
      $payment->loadAndOrder($cid);

      if ($payment->status != 'manual-check')
      {
        JError::raiseWarning('ERROR', JText::_('Only payments with status "manual-check" can be validated!'));
        return false;
      }

      if (count($payment->order->_errors))
      {
        JError::raiseWarning('ERROR', JText::_('Order not found for payment:') . ' ' . $payment->id);
        return false;
      }

      //$payment->status = 'ok';
      $payment->store();

      $this->adjustMembershipPeriod($payment);
    }

    return true;
  }

  function invalidate()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');
    $payment =& $this->getTable('payment');

    foreach ($cids as $cid)
    {
      $payment->load($cid);

      if ($payment->status != 'manual-check')
      {
        JError::raiseWarning('ERROR', JText::_('Only payments with status "manual-check" can be invalidated!'));
        return false;
      }

      $user =& JFactory::getUser();

      $payment->status = 'error';
      $payment->log .= "\n\n" . '<b>' . JText::_('Status changed') . ':</b>' . "\n";
      $payment->log .= JText::_('to') . ' ' . $payment->status. ' ' . JText::_('by') . ' ' . $user->username;

      $payment->store();
    }

    return true;
  }

  function adjustMembershipPeriod($payment)
  {
    JModel::addIncludePath(JPATH_COMPONENT_SITE.DS.'models');
    $model =& JModel::getInstance('payment', 'FrontendModel');

    $model->adjustMembershipPeriod($payment);
  }

  function store()
  {
    $id      =  JRequest::getVar('id', 0, 'POST', 'integer');
    $payment =& $this->getTable('payment');

    $payment->load($id);

    if ($payment->status != 'manual-check')
    {
      return false;
    }

    $status = JRequest::getVar('status', '', 'POST', 'string');
    if (!in_array($status, array('ok', 'error', 'manual-check')))
    {
      return false;
    }

    $payment->status = $status;
    $payment->store();

    if ($status == 'ok')
    {
      $this->adjustMembershipPeriod($payment);
    }

    return true;
  }
}