<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelPrice extends JModel
{
  function __construct()
  {
    parent::__construct();

    $cids = JRequest::getVar('cid', 0, '', 'array');
    $this->setId((int)$cids[0]);
  }

  function setId($id)
  {
    $this->_id   = $id;
    $this->_data = null;
  }

  function &getData()
  {
    if (empty($this->_data))
    {
      $query = ' SELECT * FROM #__lovefactory_pricing'
             . ' WHERE id = '.$this->_id;
      $this->_db->setQuery($query);
      $this->_data = $this->_db->loadObject();

      if ($this->_data)
      {
        $this->_data->_gender_prices = $this->_prepareGenderPrices($this->_data->gender_prices);
      }
    }

    if (!$this->_data)
    {
      $this->_data = $this->getTable();
    }

    return $this->_data;
  }

  function getGenders()
  {
    $query = ' SELECT f.*'
           . ' FROM #__lovefactory_fields f'
           . ' WHERE f.type_id = 10';
    $this->_db->setQuery($query);
    $result = $this->_db->loadObject();

    $field =& $this->getTable('field', 'Table');
    $field->bind($result);

    $genders = $field->getParam('values');
    $genders = explode('*|*', $genders);

    return $genders;
  }

  function getMemberships($only_published = 1)
  {
    $where = ($only_published) ? ' WHERE m.published = 1' : '';

    $query = ' SELECT m.*'
           . ' FROM #__lovefactory_memberships m'
           . $where
           . ' ORDER BY m.ordering ASC';
    $this->_db->setQuery($query);
    return $this->_db->loadObjectList();
  }

  function store()
  {
    $price =& $this->getTable();
    $data  =  $this->_prepareData();

    if (!$price->bind($data))
    {
      $this->setError($this->_db->getErrorMsg());
      return false;
    }

    if (!$price->check())
    {
      $this->setError($this->_db->getErrorMsg());
      return false;
    }

    if (!$price->store())
    {
      $this->setError($this->_db->getErrorMsg());
      return false;
    }

    $this->_id = $price->id;

    return true;
  }

  function delete()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');
    $price =& $this->getTable();

    foreach ($cids as $cid)
    {
      if (!$price->delete($cid))
      {
        $this->setError($price->getErrorMsg());
        return false;
      }
    }
    return true;
  }

  function change()
  {
    $database =& JFactory::getDBO();
    $field = JRequest::getVar('field', '', 'GET', 'string');
    $value = JRequest::getVar('value',  0, 'GET', 'integer');
    $id    = JRequest::getVar('id',     0, 'GET', 'integer');

    if (!in_array($field, array('published', 'required')))
    {
      return false;
    }

    $query = ' UPDATE #__lovefactory_fields'
           . ' SET ' . $field . ' = ' . $value
           . ' WHERE id = ' . $id;
    $database->setQuery($query);

    return $database->query();
  }

  function publish()
  {
    $cids = JRequest::getVar('cid', array(0), 'REQUEST', 'array');
    $price =& $this->getTable('price');

    foreach ($cids as $cid)
    {
      $price->load($cid);

      $price->published = 1;
      $price->store();
    }

    return true;
  }

  function unpublish()
  {
    $cids = JRequest::getVar('cid', array(0), 'REQUEST', 'array');
    $price =& $this->getTable('price');

    foreach ($cids as $cid)
    {
      JRequest::setVar('id', $cid, 'GET', true);
      $price->load($cid);

      $price->published = 0;
      $price->store();
    }

    return true;
  }

  function _prepareData()
  {
    $data     =& JRequest::get('post');
    $settings =  new LovefactorySettings();

    if ($settings->gender_pricing)
    {
      $genders = $this->getGenders();
      $array   = array();

      foreach ($genders as $i => $gender)
      {
        $array[] = $gender . '=' . number_format($data['price_' . $i], 2);
      }

      $data['gender_prices'] = implode("\n", $array);
    }

    return $data;
  }

  function _prepareGenderPrices($gender_prices)
  {
    $array = array();
    $prices = explode("\n", $gender_prices);

    if ('' != $gender_prices && count($prices))
    {
      foreach ($prices as $price)
      {
        $price = explode('=', $price);
        $array[$price[0]] = $price[1];
      }
    }

    return $array;
  }
}