<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class BackendModelUser extends JModel
{
  var $_user;
  var $_zones;

  function __construct()
  {
    parent::__construct();
  }

  function getUser()
  {
    if (!isset($this->_user))
    {
      $id = JRequest::getVar('id', 0, 'GET', 'integer');

      $query = ' SELECT p.*, u.username, s.membership_id, s.end_membership,'
             . '   s.title AS membership_title, s.payment_id'
             . ' FROM #__lovefactory_profiles p'
             . ' LEFT JOIN #__users u ON u.id = p.user_id'
             . ' LEFT JOIN #__lovefactory_memberships_sold s ON s.id = p.membership_sold_id'
             . ' WHERE p.user_id = ' . $id;
      $this->_db->setQuery($query);
      $this->_user = $this->_db->loadObject();
    }

    return ($this->_user->validated == null) ? false : $this->_user;
  }

  function getReports()
  {
    $user = $this->getUser();

    $query = ' SELECT *'
           . ' FROM #__lovefactory_reports'
           . ' WHERE user_id = ' . $user->user_id
           . ' ORDER BY date DESC';
    $this->_db->setQuery($query);

    return $this->_db->loadObjectList();
  }

  function getPayments()
  {
    $user = $this->getUser();

    $query = ' SELECT p.*, m.title, o.months'
           . ' FROM #__lovefactory_payments p'
           . ' LEFT JOIN #__lovefactory_orders o ON o.id = p.order_id'
           . ' LEFT JOIN #__lovefactory_memberships m ON m.id = o.membership_id'
           . ' WHERE p.user_id = ' . $user->user_id
           . ' ORDER BY p.received_at DESC';
    $this->_db->setQuery($query);

    return $this->_db->loadObjectList();
  }

  function getIps()
  {
    $user = $this->getUser();

    $query = ' SELECT i.*, COUNT(i.ip) AS shares'
           . ' FROM #__lovefactory_ips i'
           . ' LEFT JOIN #__lovefactory_ips c ON c.ip = i.ip AND c.user_id <> i.user_id'
           . ' WHERE i.user_id = ' . $user->user_id
           . ' GROUP BY i.ip'
           . ' ORDER BY i.visits DESC';
    $this->_db->setQuery($query);

    return $this->_db->loadObjectList();
  }

  function getEditZones()
  {
    $zones = $this->getZones(2);
    $fields = $this->getFieldsFromZones($zones);

    return $this->parseZones($zones, $fields);
  }

  function getEditFields()
  {
    $zones = $this->getZones(2);

    return $this->getFieldsFromZones($zones);
  }

  function getZones($type_id)
  {
    if (empty($this->_zones))
    {
      $page  =& $this->getTable('page');
      $zones = $page->getZones($type_id);

      $this->_zones = explode('#', $zones);
    }

    return $this->_zones;
  }

  function getFieldsFromZones($zones)
  {
    if ($zones[0] == '')
    {
      return array();
    }

    if (empty($this->_fields))
    {
      $fields = array();

      foreach ($zones as $zone)
      {
        $zone = explode('_', $zone);
        $fields[] = $zone[2];
      }

      $field =& $this->getTable('field');
      $this->_fields = $field->loadArray($fields);
    }

    return $this->_fields;
  }

  function parseZones($zones, $fields)
  {
    $result = array();

    if ($zones[0] == '')
    {
      return $result;
    }

    foreach ($zones as $zone)
    {
      $zone = explode('_', $zone);

      $row      = $zone[0];
      $col      = $zone[1];
      $field_id = $zone[2];

      if (!isset($result[$row]))
      {
        $result[$row] = array();
      }

      if (!isset($result[$row][$col]))
      {
        $result[$row][$col] = array();
      }

      $result[$row][$col][] = $fields[$field_id];
    }

    return $result;
  }

  function getPhotos()
  {
    $id = JRequest::getVar('id', 0, 'GET', 'integer');

    $query = ' SELECT *'
           . ' FROM #__lovefactory_photos'
           . ' WHERE user_id = ' . $id;
    $this->_db->setQuery($query);

    return $this->_db->loadObjectList();
  }

  function ban()
  {
    $id = JRequest::getVar('id', 0, 'get', 'integer');
    $profile =& $this->getTable('profile');

    $profile->load($id);

    if ($profile->banned != null)
    {
      $profile->banned = 1;
      $profile->store();

      return true;
    }

    return false;
  }

  function banList()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');

    $query = ' UPDATE #__lovefactory_profiles'
           . ' SET banned = 1'
           . ' WHERE user_id IN (' . implode(', ', $cids) . ')';
    $this->_db->setQuery($query);

    return $this->_db->query();
  }

  function unban()
  {
    $id = JRequest::getVar('id', 0, 'get', 'integer');
    $profile =& $this->getTable('profile');

    $profile->load($id);

    if ($profile->banned != null)
    {
      $profile->banned = 0;
      $profile->store();

      return true;
    }

    return false;
  }

  function unbanList()
  {
    $cids = JRequest::getVar('cid', array(0), 'post', 'array');

    $query = ' UPDATE #__lovefactory_profiles'
           . ' SET banned = 0'
           . ' WHERE user_id IN (' . implode(', ', $cids) . ')';
    $this->_db->setQuery($query);

    return $this->_db->query();
  }

  function delete()
  {
    $cids    =  JRequest::getVar('cid', array(0), 'post', 'array');
    $profile =& $this->getTable('profile', 'Table');

    foreach ($cids as $cid)
    {
      $profile->load($cid);
      $profile->delete();
    }

    return true;
  }

  function store()
  {
    $id      =& JRequest::getVar('id', 0, 'POST', 'integer');
    $profile =& $this->getTable('profile');

    $profile->loadAndMembership($id);

    // Get the user
    if (count($profile->_errors))
    {
      JError::raiseWarning('ERROR', JText::_('User not found!'));
      return false;
    }

    $banned =& JRequest::getVar('banned', 0, 'POST', 'integer');

    $change_membership =& JRequest::getVar('change_membership', false, 'POST', 'bool');
    $unlimited         =& JRequest::getVar('unlimited',         false, 'POST', 'bool');

    if (!$unlimited)
    {
      $end_membership =& JRequest::getVar('end_membership', array(), 'POST', 'array');
      $end_membership =  $end_membership['year'] . '-' . str_pad($end_membership['month'], 2, 0, STR_PAD_LEFT) . '-' . str_pad($end_membership['day'], 2, 0, STR_PAD_LEFT)
                      .  ' ' . str_pad($end_membership['hour'], 2, 0, STR_PAD_LEFT) . ':' . str_pad($end_membership['min'], 2, 0, STR_PAD_LEFT) . ':00';
    }
    else
    {
      $end_membership = '0000-00-00 00:00:00';
    }

    // If change membership
    if ($change_membership)
    {
      $membership_id =& JRequest::getVar('membership_id',   0,     'POST', 'integer');
      $set_expired   =  true;
      $membership    =& $this->getTable('membership');
      $membership->load($membership_id);

      $membership_sold =& $this->getTable('membershipsold');

      if ($membership->default)
      {
        $membership_sold->load(1);
      }
      else
      {
        $membership_sold->addFromMembership($membership);

        $membership_sold->user_id        = $profile->user_id;
        $membership_sold->end_membership = $end_membership;

        $membership_sold->store();
      }

      $profile->changeMembershipTo($membership_sold, $set_expired);
    }
    else
    {
      if ($profile->membership_sold->default)
      {
        $profile->membership_sold->end_membership = '0000-00-00 00:00:00';
      }
      else
      {
        $profile->membership_sold->end_membership = $end_membership;
      }
    }

    $profile->banned = $banned;

    // Store the profile
    $profile->store();

    // Photo management
    $delete_all = JRequest::getVar('delete_all', '', 'POST', 'string');
    if ($delete_all == 'on')
    {
      $query = ' DELETE'
             . ' FROM #__lovefactory_photos'
             . ' WHERE user_id = ' . $id;
      $this->_db->setQuery($query);
      $this->_db->query();

      $profile->photos = 0;
      $profile->main_photo = '';
      $profile->store();
    }
    else
    {
      $delete_photo = JRequest::getVar('delete_photo', array(), 'POST', 'array');
      $delete_photo = array_keys($delete_photo);

      foreach ($delete_photo as $id)
      {
        $photo =& $this->getTable('photo', 'Table');
        $photo->load($id);
        $photo->delete();
      }
    }

    return true;
  }

  function updateProfile($fields)
  {
    $user_id =& JRequest::getVar('id', 0, 'POST', 'integer');

    JModel::addIncludePath(JPATH_COMPONENT_SITE.DS.'models');
    $profile =& JModel::getInstance('profile', 'FrontendModel');

    return $profile->updateProfile($fields, $user_id);
  }

  function getMemberships()
  {
    JModel::addIncludePath(JPATH_COMPONENT_SITE.DS.'models');
    $model =& JModel::getInstance('mymembership', 'FrontendModel');
    $id    =& JRequest::getVar('id', 0, 'GET', 'integer');

    return $model->getMemberships($id);
  }

  function verifyUsers($showErrors = true)
  {
    $output = array();

    $query = ' SELECT p.user_id, p.photos, p.friends, p.looking, u.id AS joomla_id'
           . ' FROM #__lovefactory_profiles p'
           . ' LEFT JOIN #__users u ON u.id = p.user_id';
    $this->_db->setQuery($query);
    $users = $this->_db->loadObjectList();

    $query = ' SELECT p.user_id, COUNT(1) AS count'
           . ' FROM #__lovefactory_photos p'
           . ' GROUP BY p.user_id';
    $this->_db->setQuery($query);
    $photos = $this->_db->loadObjectList('user_id');

    foreach ($users as $user)
    {
      // Check if Joomla user still exists
      if (is_null($user->joomla_id))
      {
        $output[] = 'Removed Love Factory profile of user id: ' . $user->user_id . ' (Joomla profile doesn\' exists!)';

        $profile =& $this->getTable('profile');

        $profile->load($user->user_id);
        $profile->delete();

        continue;
      }

      $no_photos = isset($photos[$user->user_id]->count) ? $photos[$user->user_id]->count : 0;

      // Update friends
      $query = ' SELECT COUNT(1)'
             . ' FROM  #__lovefactory_friends f'
             . ' WHERE (f.sender_id = ' . $user->user_id
             . ' OR f.receiver_id = ' . $user->user_id . ')'
             . ' AND f.pending = 0';
      $this->_db->setQuery($query);
      $friends = $this->_db->loadResult();

      // Looking for check
      $exploded = explode('*|*', $user->looking);
      if (1 >= count($exploded))
      {
        $user->looking = '*|*' . $user->looking . '*|*';
      }

      // Checks
      $photos_check  = $user->photos != $no_photos;
      $users_check   = $user->friends != $friends;
      $looking_check = 1 >= count($exploded);

      if ($photos_check || $users_check || $looking_check)
      {
        if ($photos_check)
        {
          $output[] = 'Updated no. of photos for profile: ' . $user->user_id;
        }

        if ($users_check)
        {
          $output[] = 'Updated no. of friends for profile: ' . $user->user_id;
        }

        $query = ' UPDATE #__lovefactory_profiles'
               . ' SET photos = ' . $no_photos . ','
               . ' friends = ' . $friends . ','
               . ' looking = "' . $user->looking . '"'
               . ' WHERE user_id = ' . $user->user_id;
        $this->_db->setQuery($query);
        $this->_db->query();
      }
    }

    if ($showErrors)
    {
      JError::raiseNotice(0, count($output) ? implode('<br/>', $output) : JText::_('No changes made!'));
    }
  }
}