jQueryFactory(document).ready(function ($) {
  var queue    = new Array();
  var started  = false;
  var shoutbox = $("#lovefactory-shoutbox");
  var request  = false;

  // Send message
  $("#lovefactory-shoutbox-submit").keypress(function (event) {
    var code    = (event.keyCode ? event.keyCode : event.which);
    var message = $(this).val().trim();

    if (code == 13 && !request && '' != message)
    {
      $(this).val('');

      request = true;
      $("#lovefactory-shoutbox-loader span").show();

      $.ajax({
        url: 'index.php?option=com_lovefactory&controller=shoutbox&task=postmessage',
        type: 'POST',
        data: 'message=' + message,
        dataType: 'json',
        success: function (response) {
          request = false;
          $("#lovefactory-shoutbox-loader span").hide();

          if (0 == response.status)
          {
            $("#lovefactory-shoutbox-response")
              .hide()
              .html(response.message)
              .fadeIn(function () {
                var info = $(this);
                setTimeout(function () {
                  info.fadeOut();
                }, 3000);
              });
          }
        }
      });
    }
  });

  // Update shotubox
  if (lovefactory_shoutbox_interval)
  {
    setInterval(function () {
      $.ajax({
        url: 'index.php?option=com_lovefactory&controller=shoutbox&task=getmessages&format=raw',
        type: 'POST',
        data: 'lovefactory_shoutbox_last=' + lovefactory_shoutbox_last + '&lovefactory_shoutbox_limit=' + lovefactory_shoutbox_limit,
        dataType: "json",
        success: function (response)
        {
          if (1 == response.status)
          {
            var messages = response.messages;

            if (response.last)
            {
              lovefactory_shoutbox_last = response.last;
            }

            for (var i = 0, count = messages.length; i < count; i++)
            {
              var message = messages[i];
              queue.push(message);

              showQueue();
            }
          }
        }
      });
    }, lovefactory_shoutbox_interval * 1000);
  }

  // Show queue
  function showQueue()
  {
    if (started)
    {
      return false;
    }

    if (0 == queue.length)
    {
      started = false;
      return false;
    }

    started = true;

    if (lovefactory_shoutbox_limit == shoutbox.find(".lovefactory-shoutbox-message").length)
    {
      shoutbox.find(".lovefactory-shoutbox-message:last").remove();
    }

    message = queue[0];
    var even = shoutbox.find(".lovefactory-shoutbox-message:first").hasClass("even") ? "" : "even";
    shoutbox.attr({ scrollTop: 0 });

    shoutbox
      .prepend("<div class='lovefactory-shoutbox-message " + even + "' style='display: none;'><a href='" + message.l + "'>" + message.u + "</a>" + message.m + "<div class='date'>" + message.d + "</div></div>")
      .find(".lovefactory-shoutbox-message:first")
      .effect("highlight", {}, 1000, function () {
        queue.splice(0,1);
        started = false;
        showQueue();
    });
  }
});