<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemFactoryTokenAuth extends JPlugin
{
  function plgSystemFactoryTokenAuth(&$subject, $config)
	{
	  parent::__construct($subject, $config);

	  $this->_checkTable();
	  $this->_deleteExpiredTokens();
	}


	function onAfterRoute()
	{
	  $db         =& JFactory::getDBO();
	  $date       =& JFactory::getDate();
	  $app        =& JFactory::getApplication();
	  $user       =& JFactory::getUser();
	  $dispatcher =& JDispatcher::getInstance();

	  // Get the token
    $token =& JRequest::getVar($this->params->get('name', 'token'), '', 'GET', 'string');
    $token =  $db->getEscaped($token);

    // Check if token is empty
    if (empty($token))
    {
      return false;
    }

    // Find the token in database
    $query = ' SELECT t.*'
           . ' FROM #__factory_tokens_auth t'
           . ' WHERE t.token = "' . $token . '"'
           . ' AND t.expires_at > "' . $date->toMySql() . '"';
    $db->setQuery($query);
    $record = $db->loadObject();

    // Was the token found in database
    if (!$record)
    {
      return false;
    }

    JPluginHelper::importPlugin('user');

    // First logout currently logged in user,
    // only if it's not the user we want to authentificate
    if ($user->id && $user->id != $record->user_id)
    {
      $parameters['username'] = $user->get('username');
      $parameters['id']       = $user->get('id');
      $clientid               = $app->getClientId();

      // Log out user
      $results = $dispatcher->trigger('onLogoutUser', array($parameters, array('clientid' => array($clientid))));

      // Delete all session records for user
      $table = & JTable::getInstance('session');
      $table->destroy($user->id, array($clientid));

      // Delete cookies
      foreach($_COOKIE as $key => $value)
      {
        setcookie($key, $value, time() - 10000, '/');
      }

      // Reload page
      $app->redirect($_SERVER['REQUEST_URI']);
    }

    $query = ' SELECT *'
           . ' FROM #__users u'
           . ' WHERE u.id = ' . $record->user_id;
    $db->setQuery($query);
    $user_found = $db->loadAssoc();

    $options = array('autoregister' => false);
    $results = $dispatcher->trigger('onLoginUser', array($user_found, $options));

    // If login was successfull, delete token
    if ($results[0] === true)
    {
      $query = ' DELETE'
             . ' FROM #__factory_tokens_auth'
             . ' WHERE id = ' . $record->id;
      $db->setQuery($query);
      $db->query();
    }

    return true;
	}

	function FactoryTokenAuthCreateToken($parameters)
	{
	  // Check if user_id is provided
	  if (!isset($parameters['user_id']))
	  {
	    return JError::raiseWarning(100, JText::_('NO_USER_ID_PROVIDED'));
	  }

	  $date =& JFactory::getDate();
	  $db   =& JFactory::getDBO();

	  $user_id =  $db->getEscaped($parameters['user_id']);
	  $user    =& JFactory::getUser($user_id);

	  // Check if user exists
	  if (is_null($user->id))
	  {
	    return JError::raiseWarning(101, JText::_('USER_WAS_NOT_FOUND'));
	  }

	  // Find if user has already a token
	  $query = ' SELECT t.*'
	         . ' FROM #__factory_tokens_auth t'
	         . ' WHERE t.user_id = ' . $user_id;
	  $db->setQuery($query);
	  $record = $db->loadObject();

	  $expires_at = date('Y-m-d H:i:s', strtotime('+' . $this->params->get('valability', 30) . ' days', $date->toUnix()));
	  $created_at = $date->toMySql();

	  if (!$record)
	  {
	    // User doesn't have a token, create a new one
	    $dirname = dirname(__FILE__);
		  $stat    = implode('', stat(__FILE__));
	    $token   = $user_id.time().rand(0, 99999999);

	    $token = md5($dirname.$token) . md5($token.$stat);

	    $query = ' INSERT'
	           . ' INTO #__factory_tokens_auth'
	           . ' VALUES("", "' . $user_id . '", "' . $token . '", "' . $created_at . '", "' . $expires_at . '")';
	  }
	  else
	  {
	    // User has a token, use it
	    $query = ' UPDATE #__factory_tokens_auth'
	           . ' SET expires_at = "' . $expires_at . '"'
	           . ' WHERE user_id = ' . $user_id;
	    $token = $record->token;
	  }

	  $db->setQuery($query);
	  if (!$db->query())
	  {
	    return JError::raiseWarning(102, JText::_('ERROR_UPDATING_DATABASE'));
	  }

	  return $this->params->get('name', 'token') . '='.$token;
	}


	function _checkTable()
	{
	  $db =& JFactory::getDBO();

	  // Get the table
	  $query = ' SHOW TABLES'
	         . ' LIKE "' . $db->getPrefix() . 'factory_tokens_auth"';
	  $db->setQuery($query);
	  $result = $db->loadObject();

	  // Table was found, whew...
	  if ($result)
	  {
	    return true;
	  }

	  // Table was not found, create the table
	  $query = ' CREATE TABLE #__factory_tokens_auth ('
           . '   `id` int(11) NOT NULL AUTO_INCREMENT,'
           . '   `user_id` int(11) NOT NULL,'
           . '   `token` varchar(255) NOT NULL,'
           . '   `created_at` datetime NOT NULL,'
           . '   `expires_at` datetime NOT NULL,'
           . '   PRIMARY KEY (`id`)'
           . ' ) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8';
    $db->setQuery($query);
    $db->query();
	}

	function _deleteExpiredTokens()
	{
	  $date =& JFactory::getDate();
	  $db   =& JFactory::getDBO();

	  $query = ' DELETE'
	         . ' FROM #__factory_tokens_auth'
	         . ' WHERE expires_at <= "' . $date->toMySql() . '"';
	  $db->setQuery($query);
	  $db->query();
	}
}
