<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemLoveFactory extends JPlugin
{
  var $_lovefactory_settings;
  var $_is_valid = true;

  function plgSystemLoveFactory(&$subject, $config)
	{
	  parent::__construct($subject, $config);

		global $mainframe;
		$filepath = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_lovefactory'.DS.'settings.php';

	  if (!$mainframe->isSite() || $this->isAjaxRequest() || !file_exists($filepath))
	  {
	    $this->_is_valid = false;
	    return false;
	  }

	  require_once($filepath);
	  $this->_lovefactory_settings = new LovefactorySettings();
	}

	function onAfterRoute()
	{
	  if (!$this->_is_valid)
	  {
	    return false;
	  }

	  $view   =& JRequest::getVar('view',   '', 'REQUEST', 'string');
	  $task   =& JRequest::getVar('task',   '', 'REQUEST', 'string');
	  $option =& JRequest::getVar('option', '', 'REQUEST', 'string');

	  if (1 == $this->_lovefactory_settings->registration_mode &&
	      'com_user' == $option &&
	      ('register' == $view || 'register' == $task))
	  {
	    global $mainframe;
	    $mainframe->redirect(JRoute::_('index.php?option=com_lovefactory&view=signup&Itemid=' . $this->params->get('itemid', 0), false));
	  }
	}

	function onAfterDispatch()
	{
	  $user =& JFactory::getUser();

	  if (!$this->_is_valid || $user->guest || !$this->_lovefactory_settings->enable_infobar)
	  {
	    return false;
	  }

	  global $mainframe, $Itemid;

	  jimport('joomla.application.component.model');
	  JModel::addIncludePath(JPATH_BASE.DS.'components'.DS.'com_lovefactory'.DS.'models');

	  $profile =& JModel::getInstance('profile', 'FrontendModel');
	  $infobar =  $profile->getInfobar();

    if ($infobar)
    {
      require_once(JPATH_SITE.DS.'components'.DS.'com_lovefactory'.DS.'lib'.DS.'vendor'.DS.'html.php');

      JHtmlFactory::jQueryScript('effects', 'effects-pulsate');
      JHTML::script('plugin.js', 'components/com_lovefactory/assets/js/');

      JHTML::stylesheet('plugin.css',  'components/com_lovefactory/assets/css/');
      JHTML::stylesheet('main.css',    'components/com_lovefactory/assets/css/');
      JHTML::stylesheet('buttons.css', 'components/com_lovefactory/assets/css/');

      $document =& JFactory::getDocument();

      // Infobar location
      $document->addStyleDeclaration('#lovefactory-bottom-wrapper { ' . (2 == $infobar ? 'top' : 'bottom') . ': 0px; }');

      // Infobar rounded corners
      $location1 = 2 == $infobar ? 'top'    : 'bottom';
      $location2 = 2 == $infobar ? 'bottom' : 'top';
      $shadow    = 2 == $infobar ? -4       : 4;

      $document->addStyleDeclaration(
          '#lovefactory-bottom-bar { border-' . $location1 . '-width: 0px;'
        . '  -moz-border-radius-' . $location2 . 'left: 5px;'
        . '  -moz-border-radius-' . $location2 . 'right: 5px;'
        . '  -webkit-border-' . $location2 . '-left-radius: 5px;'
        . '  -webkit-border-' . $location2 . '-right-radius: 5px;'
        . '  -moz-box-shadow:0 ' . $shadow . 'px 18px #666666; }');

      $lang = JFactory::getLanguage();
      $lang->load('com_lovefactory');

      // Friendship requests
      $friends =& JModel::getInstance('friends', 'FrontendModel');
      $requests = $friends->getRequests();

      $view_profile_link   = $this->_lovefactory_settings->enable_infobar_view_profile   ? '<span><a href="'.JRoute::_('index.php?option=com_lovefactory&view=profile&id='.$user->id.'&Itemid='.$this->_lovefactory_settings->infobar_view_profile_itemid).'" class="lovefactory-button lovefactory-user">' . $lang->_('PLUGIN_VIEW_MY_PROFILE') . '</a></span>' : '';
      $update_profile_link = $this->_lovefactory_settings->enable_infobar_update_profile ? '<span><a href="'.JRoute::_('index.php?option=com_lovefactory&view=edit&Itemid='.$this->_lovefactory_settings->infobar_update_profile_itemid).'" class="lovefactory-button lovefactory-user-edit">' . $lang->_('PLUGIN_EDIT_MY_PROFILE') . '</a></span>' : '';
      $gallery_link        = $this->_lovefactory_settings->enable_infobar_gallery        ? '<span><a href="'.JRoute::_('index.php?option=com_lovefactory&view=mygallery&Itemid='.$this->_lovefactory_settings->infobar_gallery_itemid).'" class="lovefactory-button lovefactory-images">' . $lang->_('PLUGIN_MY_GALLERY') . '</a></span>' : '';
      $friends_link        = $this->_lovefactory_settings->enable_infobar_friends        ? '<span><a href="'.JRoute::_('index.php?option=com_lovefactory&view=myfriends&Itemid='.$this->_lovefactory_settings->infobar_friends_itemid).'" class="lovefactory-button lovefactory-user-star">' . $lang->_('PLUGIN_MY_FRIENDS') . '</a></span>' : '';
      $close_link          = $this->_lovefactory_settings->enable_infobar_close          ? '<span><a href="#" class="lovefactory-button lovefactory-cross" id="lovefactory-infobar-close">' . $lang->_('PLUGIN_CLOSE') . '</a></span>' : '';

	    $content = '<div id="lovefactory-bottom-wrapper">'
	             . '  <div id="lovefactory-bottom-bar">'
	             . '    <div style="float: right">' . $view_profile_link . $update_profile_link . $gallery_link . $friends_link . $close_link . '</div>';

	    // Interactions
	    if ($this->_lovefactory_settings->enable_interactions && $this->_lovefactory_settings->enable_infobar_interactions)
	    {
	      $interactions =& JModel::getInstance('interactions', 'FrontendModel');
        $interactions =  $interactions->getUnseen();
	      $content .= '<span id="lovefactory-bottom-interactions"><a href="' . JRoute::_('index.php?option=com_lovefactory&view=interactions&Itemid=' . $this->_lovefactory_settings->infobar_interactions_itemid) . '" class="lovefactory-button lovefactory-emoticon-smile-go"><span class="' . ($interactions ? 'bold' : '') . '">' . $interactions . '</span> ' . $lang->_('PLUGIN_INTERACTIONS') . '</a></span>';
	    }

	    // Messages
	    if ($this->_lovefactory_settings->enable_messages && $this->_lovefactory_settings->enable_infobar_messages)
      {
        $inbox    =& JModel::getInstance('inbox', 'FrontendModel');
        $messages =  $inbox->getUnreadCount();

        $content .= '<span id="lovefactory-bottom-messages"><a href="' . JRoute::_('index.php?option=com_lovefactory&view=inbox&Itemid=' . $this->_lovefactory_settings->infobar_messages_itemid) . '" class="lovefactory-button lovefactory-email-go"><span class="' . ($messages ? 'bold' : '') . '">' . $messages . '</span> ' . $lang->_('PLUGIN_MESSAGES') . '</a></span>';
      }

      // Requests
      if ($this->_lovefactory_settings->enable_infobar_requests)
      {
        $content .= '<span id="lovefactory-bottom-users"><a href="' . JRoute::_('index.php?option=com_lovefactory&view=requests&Itemid=' . $this->_lovefactory_settings->infobar_requests_itemid) . '" class="lovefactory-button lovefactory-user-go"><span class="' . ($requests ? 'bold' : '') . '">' . $requests . '</span> ' . $lang->_('PLUGIN_REQUESTS') . '</a></span>';
      }

      $content .= '  </div>'
	             .  '</div>';

	    $document->setBuffer($document->getBuffer('component') . $content, 'component');
	    $document->addScriptDeclaration('var route_infobar_update     = "' . 'index.php?option=com_lovefactory&amp;controller=infobar&amp;task=update' . '";');
	    $document->addScriptDeclaration('var route_infobar_close      = "' . 'index.php?option=com_lovefactory&amp;controller=infobar&amp;task=close' . '";');
	    $document->addScriptDeclaration('var infobar_refresh_interval = "' . $this->_lovefactory_settings->infobar_refresh_interval . '";');
    }
	}

	function isAjaxRequest()
	{
	  return (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && ($_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest'));
	}
}
