<?php

defined('_JEXEC') or die('Restricted access');

class factoryPaymentPlugin
{
  var $enabled     = false;
  var $params      = null;
  var $title       = null;
  var $description = null;
  var $_db         = null;
  var $_params     = null;

  function factoryPaymentPlugin()
  {
    $this->__construct();
  }

  function __construct()
  {
    $this->_db   =& JFactory::getDBO();
    $this->user  =& JFactory::getUser();
    $this->title =  strtolower(get_class($this));

    $this->getParams();
    $this->configure();
  }

  function configure()
  {
    $this->return_url    = JRoute::_('index.php?option=com_lovefactory&view=payment&type=complete', false, -1);
    $this->cancel_return = JRoute::_('index.php?option=com_lovefactory&view=payment&type=cancel', false, -1);
    $this->notify_url    = JRoute::_('index.php?option=com_lovefactory&controller=payment&task=notify&gateway=' . $this->title . '&lang=en', false, -1);
    //$this->notify_url    = 'http://clasamente.sokker.ro/ipn.php';
  }

  function getParams()
  {
    $query = ' SELECT g.*'
           . ' FROM #__lovefactory_gateways g'
           . ' WHERE g.title = "' . strtolower($this->title) . '"';
    $this->_db->setQuery($query);
    $result = $this->_db->loadObject();

    $this->_params = new JParameter(isset($result->params) ? $result->params : null);

    $this->enabled = isset($result->enabled) ? $result->enabled : false;
    $this->id      = isset($result->id)      ? $result->id      : false;
  }

  function saveAdminConfig()
  {
    // Get params
    $params =  array();
    $enable =& JRequest::getVar('enable', 0, 'POST', 'integer');

    foreach ($this->params as $param)
    {
      $value =& JRequest::getVar($param, '', 'POST', 'string');
      $value = str_replace("\n", '', $value);

      $params[] = $param . '=' . $this->_db->getEscaped($value);
    }

    $params = implode("\n", $params);

    // Get table record
    $query = ' SELECT g.title'
           . ' FROM #__lovefactory_gateways g'
           . ' WHERE g.title = "' . strtolower($this->title) . '"';
    $this->_db->setQuery($query);
    $title = $this->_db->loadResult();

    if ($title)
    {
      $query = ' UPDATE #__lovefactory_gateways'
             . ' SET enabled = ' . $enable . ', params = "' . $params . '"'
             . ' WHERE title = "' . strtolower($this->title) . '"';
    }
    else
    {
      $query = ' INSERT'
             . ' INTO #__lovefactory_gateways'
             . ' VALUES ("", "' . strtolower($this->title) . '", "' . strtolower($this->title) . '", ' . $enable . ', "' . $params . '", 0, 0)';
    }

    $this->_db->setQuery($query);
    $this->_db->query();

    return true;
  }

  function getLogo()
  {
    if (isset($this->logo))
    {
      return $this->logo;
    }

    $logos = JFolder::files(JPATH_COMPONENT_ADMINISTRATOR.DS.'plugins'.DS.'payment'.DS.'logos', '^' . strtolower($this->title) . '.(jpg|png|gif)');

    if (count($logos))
    {
      $logo = $logos[0];

      return JURI::root() . 'administrator/components/com_lovefactory/plugins/payment/logos/' . $logo;
    }

    return '';
  }

  function getNewPayment()
  {
    $payment = JTable::getInstance('payment', 'Table');

    $payment->received_at = date('Y-m-d H:i:s');
    $payment->gateway     = $this->title;
    $payment->log         = '<b>Request From Gateway:</b>' . "\n";

    foreach ($_POST as $variable => $value)
    {
      $payment->log .= $this->_db->getEscaped($variable) . ': ' . $this->_db->getEscaped($value) . "\n";
    }

    return $payment;
  }

  function validateUser()
  {
    $profile =& JTable::getInstance('profile', 'Table');
	  $profile->load($this->user_id);

	  return $profile->validated == 1;
  }

  function savePayment($payment)
  {
    $payment->errors  = implode("\n", $this->errors);
    $payment->log    .= "\n" . '<b>Love Factory Response:</b>' . "\n" . $payment->status;

    $payment->store();

    if ($payment->status == 'ok')
    {
      $payment->loadAndOrder($payment->id);
      $model =& JModel::getInstance('payment', 'FrontendModel');

      /* @var $model FrontendModelPayment */
      $model->adjustMembershipPeriod($payment);
    }

    $this->_order->status = 'processed';
    $this->_order->store();
  }

  function showAdminConfig()
  {
    echo JText::_('Configuration form not set up!');
  }

  function showPaymentForm()
  {
    echo JText::_('Payment form not set up!');
  }

  function executeStep($step)
  {
    if (method_exists($this, 'step' . $step))
    {
      $this->{'step'.$step}();
    }
    else
    {
      JError::raiseWarning('ERROR', $this->title .  ' ' . JText::_('does not have step') . ' ' . $step);
    }
  }

  function createOrder()
  {
    $order =& JModel::getInstance('order', 'FrontendModel');
    return $order->create($this->title, $this->price);
  }

  function showError($error)
  {
    JError::raiseWarning('ERROR', $error);
  }

  function redirectToStep($step)
  {
    global $mainframe, $Itemid;

    $mainframe->redirect(JRoute::_('index.php?option=com_lovefactory&controller=gateway&task=process&step=' . $step . '&method=' . $this->title . '&price=' . $this->price . '&Itemid=' . $Itemid, false));
  }

  function getOrder($id)
  {
    $order =& JTable::getInstance('order', 'Table');
	  $order->load($id);

	  if (count($order->_errors))
	  {
	    return false;
	  }

	  $this->_order = $order;

	  return $order;
  }
}