<?php

defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'plugins'.DS.'factoryPaymentPlugin.class.php');

class Moneybookers extends factoryPaymentPlugin
{
  function configure()
  {
    parent::configure();

    $this->description = 'Moneybookers Payment';
    $this->params      = array('email');
    $this->action      = 'https://www.moneybookers.com/app/payment.pl';
    $this->button_src  = 'http://www.moneybookers.com/images/logos/checkout_logos/checkout_120x40px.gif';
    $this->logo        = 'http://www.moneybookers.com/images/logos/checkout_logos/checkout_120x40px.gif';
  }

  function showAdminConfig()
  {
    ?>

    <table width="100%" class="admintable">
      <tr>
        <td class="key" align="right"><label for="email"><?php echo JText::_('Email'); ?>:</label></td>
        <td><input size="40" name="email" id="email" class="inputbox" value="<?php echo $this->_params->get('email', 'test@moneybookers.com'); ?>"></td>
      </tr>

      <tr>
        <td class="key" align="right"><label for="enable"><?php echo JText::_('Enable'); ?>:</label></td>
        <td><?php echo JHTML::_('select.booleanlist', 'enable', 'class="inputbox"', $this->enabled); ?></td>
      </tr>
    </table>

    <?php
  }

  function step1()
  {
    // Create a new order
    $order = $this->createOrder();

    // Show the confirmation form
    ?>

    <h1><?php echo JText::_('Confirm'); ?></h1>
    <p><?php echo JText::_('Are you sure you want to buy'); ?> <b><?php echo $order->title; ?></b> <?php echo JText::_('using Moneybookers?'); ?></p>

    <br />

    <form action="<?php echo $this->action; ?>" method="post">
      <input type="hidden" name="pay_to_email"    value="<?php echo $this->_params->get('email', ''); ?>" />
      <input type="hidden" name="hide_login"      value="0" />
      <input type="hidden" name="merchant_fields" value="m_userid,m_itemnr" />
      <input type="hidden" name="m_userid"        value="<?php echo $this->user->id; ?>" />
      <input type="hidden" name="m_itemnr"        value="<?php echo $order->id; ?>" />
      <input type="hidden" name="language"        value="EN" />

      <input type="hidden" name="return_url" value="<?php echo $this->return_url; ?>" />
      <input type="hidden" name="cancel_url" value="<?php echo $this->cancel_return; ?>" />
      <input type="hidden" name="status_url" value="<?php echo $this->notify_url; ?>" />

      <input type="hidden" name="amount"              value="<?php echo $order->amount; ?>" />
      <input type="hidden" name="currency"            value="<?php echo $order->currency;?>" />
      <input type="hidden" name="detail1_description" value="<?php echo JText::_('Membership'); ?>" />
      <input type="hidden" name="detail1_text"        value="<?php echo $order->title; ?>" />

      <input type="image" src="<?php echo $this->button_src; ?>" name="submit" alt="<?php echo JText::_('Buy');?>" style="margin-left: 30px;">

    </form>

    <?php
  }

  function processIpn()
  {
    // Get values from request
    $this->refnumber      = trim(stripslashes($_POST['mb_transaction_id']));
    $this->order_id       = trim(stripslashes($_POST['m_itemnr']));
    $this->status         = trim(stripslashes($_POST['status']));
    $this->amount         = trim(stripslashes($_POST['mb_amount']));
    $this->currency       = trim(stripslashes($_POST['mb_currency']));
    $this->receiver_email = trim(stripslashes($_POST['pay_to_email']));
    $this->payer_email    = trim(stripslashes($_POST['pay_from_email']));
    $this->user_id        = trim(stripslashes($_POST['m_userid']));
    $this->md5sig         = trim(stripslashes($_POST['md5sig']));
    $this->userid         = trim(stripslashes($_POST['m_userid']));

    $payment = $this->getNewPayment();

	  $payment->payment_date = date('Y-m-d H:i:s');
	  $payment->user_id      = $this->user_id;
	  $payment->amount       = $this->amount;
	  $payment->currency     = $this->currency;
	  $payment->order_id     = $this->order_id;
	  $payment->refnumber    = $this->refnumber;

    // Check for errors
    $this->errors = $this->validatePayment();

    switch ($this->status)
    {
      case '2':
        $payment->status = count($errors) ? 'manual-check' : 'ok';
      break;

      case '-1':
      case '-2':
      case '-3':
        $payment->status = 'error';
      break;

      case '0':
      default:
        $payment->status = 'manual-check';
      break;
    }

    $this->savePayment($payment);
  }

  function validatePayment()
  {
    $errors = array();

    // Validate IPN
    if (true !== $this->validateIpn())
	  {
	    $errors[] = JText::_('IPN not verified');
	  }

	  // Validate paypal email
	  if ($this->receiver_email != $this->_params->get('email', ''))
	  {
	    $errors[] = JText::_('Receiver email is different from expected');
	  }

	  // Validate user
	  if (!$this->validateUser())
	  {
	    $errors[] = JText::_('User doesn\'t exist or is not validated!');
	  }

    // Validate Order
	  $order = $this->getOrder($this->order_id);

	  if ($order)
	  {
	    if ('pending' == $order->status)
	    {
	      // Validate amount
	      if ($order->amount != $this->amount)
	      {
	        $errors[] = JText::_('Payment amount received is different from expected');
	      }

	      // Validate currency
	      if ($order->currency != $this->currency)
	      {
	        $errors[] = JText::_('Payment currency is different from expected');
	      }
	    }
	    else
	    {
	      $errors[] = JText::_('Order already processed');
	    }
	  }
	  else
	  {
	    $errors[] = JText::_('Order not found');
	  }

    return $errors;
  }

  function validateIpn()
  {
    $pay_to_email    = trim(stripslashes($_POST['pay_to_email']));
    $md5sig          = trim(stripslashes($_POST['md5sig']));
    $mbooker_address = trim($this->_params->get('email',''));
    $payment_status  = trim(stripslashes($_POST['status']));

    //to do MD5 check

    $verified_ok = (strtolower($mbooker_address) == strtolower($pay_to_email) && $payment_status == '2');

    return $verified_ok;

  }
}