<?php

defined('_JEXEC') or die('Restricted access');

class TableMembershipSold extends JTable
{
	var $id                       = null;
	var $user_id                  = null;
	var $membership_id            = null;
	var $payment_id               = null;
	var $start_membership         = '0000-00-00 00:00:00';
	var $end_membership           = '0000-00-00 00:00:00';
	var $expired                  = 0;
	var $months                   = null;
	var $title                    = null;
	var $default                  = null;
	var $trial                    = null;
	var $max_friends              = null;
	var $max_photos               = null;
	var $max_videos               = null;
	var $max_messages_per_day     = null;
	var $max_interactions_per_day = null;
	var $shoutbox                 = null;
	var $chatfactory              = null;
	var $top_friends              = null;
	var $groups_create            = null;
	var $groups_join              = null;

	function TableMembershipSold(&$db)
	{
		parent::__construct('#__lovefactory_memberships_sold', 'id', $db);
	}

	function addFromOrder($order)
	{
	  $this->user_id                  = $order->user_id;
	  $this->membership_id            = $order->membership_id;
	  $this->months                   = $order->months;
	  $this->title                    = $order->getParam('title');
	  $this->max_friends              = $order->getParam('max_friends');
	  $this->max_photos               = $order->getParam('max_photos');
	  $this->max_videos               = $order->getParam('max_videos');
	  $this->max_messages_per_day     = $order->getParam('max_messages_per_day');
	  $this->max_interactions_per_day = $order->getParam('max_messages_per_day');
	  $this->shoutbox                 = $order->getParam('shoutbox');
	  $this->chatfactory              = $order->getParam('chatfactory');
	  $this->top_friends              = $order->getParam('top_friends');
	  $this->groups_create            = $order->getParam('groups_create');
	  $this->groups_join              = $order->getParam('groups_join');
	}

	function addFromMembership($membership)
	{
	  $date =& JFactory::getDate();

	  $this->membership_id            = $membership->id;
	  $this->start_membership         = $date->toMySql();
	  $this->months                   = -1;
	  $this->title                    = $membership->title;
	  $this->max_friends              = $membership->max_friends;
	  $this->max_photos               = $membership->max_photos;
	  $this->max_videos               = $membership->max_videos;
	  $this->max_messages_per_day     = $membership->max_messages_per_day;
	  $this->max_interactions_per_day = $membership->max_messages_per_day;
	  $this->shoutbox                 = $membership->shoutbox;
	  $this->chatfactory              = $membership->chatfactory;
	  $this->top_friends              = $membership->top_friends;
	  $this->groups_create            = $membership->groups_create;
	  $this->groups_join              = $membership->groups_join;
	}

	function updateDefaultFromMembership($membership)
	{
	  $this->membership_id            = $membership->id;
	  $this->title                    = $membership->title;
	  $this->max_friends              = $membership->max_friends;
	  $this->max_photos               = $membership->max_photos;
	  $this->max_videos               = $membership->max_videos;
	  $this->max_messages_per_day     = $membership->max_messages_per_day;
	  $this->max_interactions_per_day = $membership->max_interactions_per_day;
	  $this->shoutbox                 = $membership->shoutbox;
	  $this->chatfactory              = $membership->chatfactory;
	  $this->top_friends              = $membership->top_friends;
	  $this->groups_create            = $membership->groups_create;
	  $this->groups_join              = $membership->groups_join;
	}

	function store($updateNulls = false, $force = false)
	{
	  if (!$this->user_id && !$force)
	  {
	    return false;
	  }

	  parent::store($updateNulls);
	}
}
