<?php

defined('_JEXEC') or die('Restricted access');

class TableOrder extends JTable
{
	var $id            = null;
	var $title         = null;
	var $user_id       = null;
	var $membership_id = null;
	var $params        = null;
	var $starting_type = 0;
	var $amount        = null;
	var $currency      = null;
	var $months        = null;
	var $gateway       = null;
	var $status        = 'pending';
	var $created_at    = null;
	var $updated_at    = null;

	function TableOrder(&$db)
	{
		parent::__construct('#__lovefactory_orders', 'id', $db);
	}

	function store($updateNulls = false)
	{
	  // Set title
	  if (is_null($this->title))
	  {
	    $settings = new LovefactorySettings();
	    $gender_string = '';

	    if ($settings->gender_pricing)
	    {
	      $profile = JTable::getInstance('profile', 'Table');
	      $profile->load($this->user_id);

	      $gender_string = $settings->gender_pricing ? $profile->sex . ' ' : '';
	    }

	    $this->title = $this->months . ' ' . JText::_('months') . ' ' . $this->getParam('title') . ' ' . $gender_string . '@ ' . $this->amount . ' ' . $this->currency;
	  }

	  // Set created_at
	  if (is_null($this->created_at))
	  {
	    $date =& JFactory::getDate();
	    $this->created_at = $date->toMySql();
      $this->updated_at = $date->toMySql();
	  }

	  // Set updated_at
	  if ($this->id)
	  {
	    $date =& JFactory::getDate();
	    $this->updated_at = $date->toMySql();
	  }

	  parent::store($updateNulls);
	}

	function getParam($param, $default = null)
	{
	  $params = $this->getParams();

	  return isset($params[$param]) ? $params[$param] : $default;
	}

	function getParams()
	{
	  $params = explode("\n", $this->params);
	  $array  = array();

	  foreach ($params as $param)
	  {
	    $param = explode('=', $param);
	    $array[$param[0]] = $param[1];
	  }

	  return $array;
	}
}
