<?php

defined('_JEXEC') or die('Restricted access');

class TablePhotoComment extends JTable
{
	var $id         = null;
	var $photo_id   = null;
	var $user_id    = null;
	var $text       = null;
	var $reported   = null;
	var $created_at = null;

	function TablePhotoComment(&$db)
	{
		parent::__construct('#__lovefactory_photo_comments', 'id', $db);
	}

	function loadAndOwner($id)
	{
	  $query = ' SELECT c.*, p.user_id'
	         . ' FROM #__lovefactory_photo_comments c'
	         . ' LEFT JOIN #__lovefactory_photos p ON p.id = c.photo_id'
	         . ' WHERE c.id = ' . $id;
	  $this->_db->setQuery($query);
	  $photo = $this->_db->loadObject();

	  if ($photo)
	  {
	    $this->bind($photo);
	    $this->_user_id = $photo->user_id;
	  }
	}

	function isMyComment()
	{
	  $user =& JFactory::getUser();

	  return isset($this->_user_id) ? $user->id == $this->_user_id : false;
	}

	function report()
	{
	  // Mark the comment as reported
	  $this->reported = 1;
	  $this->store();

	  // Create new report
    $report =& JTable::getInstance('report', 'Table');
    $report->createNew('photocomment', $this);
	}

	function store($updateNulls = false)
	{
	  $is_new = $this->id ? false : true;

	  if ($is_new)
	  {
	    $date =& JFactory::getDate();
	    $this->created_at = $date->toMySql();
	  }

	  parent::store($updateNulls);

	  if ($is_new)
	  {
      $mailer =& JModel::getInstance('mailer', 'FrontendModel');
      $mailer->sendNotification($this->_user_id, 'photo_comment', array('photo_id' => $this->photo_id));

      $action =& JTable::getInstance('action', 'Table');
      $action->addPhotoComment($this);
	  }
	}
}
