<?php

defined('_JEXEC') or die('Restricted access');

class TableProfile extends JTable
{
	var $user_id            = null;
	var $online             = 0;
	var $validated          = 0;
	var $banned             = 0;
	var $membership_sold_id = null;
	var $date               = null;
	var $alerts             = 1;
	var $rating             = 0;
	var $votes              = 0;
	var $infobar            = 3;
	var $photos             = 0;
	var $friends            = 0;
	var $main_photo         = null;
	var $relationship       = 0;
	var $trials             = 0;
	var $status             = null;
	var $sex                = null;
	var $looking            = null;
	var $_is_new            = true;

	function TableProfile(&$db)
	{
		parent::__construct('#__lovefactory_profiles', 'user_id', $db);
	}

	function load($oid = null)
	{
	  parent::load($oid);

	  $this->_is_new = count($this->_errors) ? true : false;

	  if (is_null($this->user_id))
	  {
	    $this->_is_new = true;
	  }
	}

	function loadUsername($username)
	{
	  $query = ' SELECT id'
	         . ' FROM #__users'
	         . ' WHERE username = "' . $username . '"';
	  $this->_db->setQuery($query);
	  $id = $this->_db->loadResult();

	  return $this->load($id);
	}

	function loadAndMembership($user_id)
	{
	  $this->load($user_id);

	  $membership =& JTable::getInstance('membershipsold', 'Table');
	  $membership->load($this->membership_sold_id);

	  $this->membership_sold = $membership;
	}

	function changeMembershipTo($membership_sold, $force_set_expired = false, $trial = false)
	{
	  $date =& JFactory::getDate();

	  // Set the new membership for the user
	  $this->membership_sold_id = $membership_sold->id;
	  $this->save($this);

	  // If the current membership is not default
	  if (!$this->membership_sold->default)
	  {
	    if (!($this->membership_sold->payment_id && !$this->membership_sold->months) ||
	        $force_set_expired)
	    {
	      $this->membership_sold->expired = 1;
	      $this->membership_sold->store();
	    }
	  }

	  // Set the new membership start and end date
	  if (!$membership_sold->default)
	  {
	    $membership_sold->start_membership = date('Y-m-d H:i:s');
	    if (!$trial)
	    {
	      if ($membership_sold->months > 0)
	      {
	        $membership_sold->end_membership = date('Y-m-d H:i:s', strtotime('+ ' . $membership_sold->months . ' months', strtotime($membership_sold->start_membership)));
	      }
	    }
	    else
	    {
	      $membership_sold->end_membership = date('Y-m-d H:i:s', strtotime('+ ' . $membership_sold->months . ' hours', strtotime($membership_sold->start_membership)));
	    }

	    $membership_sold->store();
	  }

	  // Send notification to the admins
	  JModel::addIncludePath(JPATH_COMPONENT_SITE.DS.'models');
	  $mailer =& JModel::getInstance('mailer', 'FrontendModel');
    $mailer->sendMultipleNotifications('change_membership', array(
      'member_id'      => $this->user_id,
      'membership'     => $membership_sold->title,
      'end_membership' => '0000-00-00 00:00:00' == $membership_sold->end_membership ? JText::_('unlimited') : $membership_sold->end_membership));
	}

	function store($updateNulls = false)
	{
	  if (isset($this->membership_sold) && is_object($this->membership_sold))
	  {
	    $this->membership_sold->store();
	  }

	  return parent::store($updateNulls);
	}

	function updateFromFields($fields, $errors = true)
	{
    $settings = new LoveFactorySettings();

	  if ($this->_is_new)
	  {
	    $date =& JFactory::getDate();

	    $this->membership_sold_id = 1;
      $this->date               = $date->toMySql();
      $this->validated          = 1;
	  }

	  $this->_has_errors = false;

    // Field location
    $old_location_field = array();
    $new_location_field = array();

	  foreach ($fields as $field)
	  {
	    /* @var $field TableField */
	    if (false !== $request = $field->parseValueFromRequest($this, $errors))
	    {
        // Field location
        if ($settings->fields_location && $field->getParam('location_field', 0))
        {
          $old_location_field[] = $this->{'field_' . $field->id};
          $new_location_field[] = $request;
        }

	      switch ($field->type_id)
	      {
	        case 10: // Sex
	          $this->sex = $request;
	          break;

	        case 11: // Looking for
	          $this->looking = $request;
	          break;

	        case 21: // Main photo upload
	          $this->main_photo = $request;
	          break;

	        case 1:
	        case 2:
	        case 3:
	        case 4:
	        case 5:
	        case 6:
	        case 7:
	          $this->{'field_' . $field->id} = $request;

	          // Set visibility
	          if (7 != $field->type_id)
	          {
	            $visibility =& JRequest::getVar('field_visibility_' . $field->id, -1, 'POST', 'integer');
	            if (-1 != $visibility)
	            {
	              $this->{'field_' . $field->id . '_visibility'} = $visibility;
	            }
	          }
	          break;
	      }
	    }
	    else
	    {
	      $this->_has_errors = true;
	    }
	  }

    if ($settings->fields_location && (!$settings->update_fields_location || ($old_location_field != $new_location_field)))
    {
      $this->updateGeoLocation($settings->gmaps_api_key, urlencode(implode(', ', $new_location_field)));
    }
	}

  function updateGeoLocation($key, $address)
  {
    $url = "http://maps.google.com/maps/geo?q=" . $address . "&output=csv&key=" . $key;
    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER["HTTP_USER_AGENT"]);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

    $data = curl_exec($ch);
    curl_close($ch);

    $data = explode(',', $data);

    $geo = & JTable::getInstance('geo', 'Table');
    $geo->load($this->user_id);
    $geo->lat = $data[2];
    $geo->lng = $data[3];

    if (count($geo->_errors))
    {
      $user = & JFactory::getUser($this->user_id);
      $geo->username = $user->username;

      $this->_db->insertObject($geo->getTableName(), $geo, 'user_id');
    }
    else
    {
      $this->_db->updateObject($geo->getTableName(), $geo, 'user_id');
    }
  }

	function loadForView($id)
	{
	  $user =& JFactory::getUser();
	  $date =& JFactory::getDate();
    $diff = $date->_date - time();

	  $query = ' SELECT p.*, u.username, m.title, u.lastvisitDate, COUNT(s.userid) AS loggedin,'
	         . '   IF (MAX(s.time) IS NULL, UNIX_TIMESTAMP(u.lastvisitDate), MAX(s.time) + ' . $diff . ') AS last_seen_on,'
	         . '   (SELECT COUNT(f.id) FROM #__lovefactory_friends f WHERE ((f.sender_id = ' . $user->id . ' AND f.receiver_id = ' . $id . ') OR (f.sender_id = ' . $id . ' AND f.receiver_id = ' . $user->id . ')) AND f.pending = 0) AS is_friend'
	         . ' FROM #__lovefactory_profiles p'
	         . ' LEFT JOIN #__users u ON u.id = p.user_id'
	         . ' LEFT JOIN #__lovefactory_memberships_sold m ON m.id = p.membership_sold_id'
	         . ' LEFT JOIN #__session s ON s.userid = p.user_id'
	         . ' LEFT JOIN #__lovefactory_photos ph ON ph.user_id = p.user_id'
	         . ' WHERE p.user_id = ' . $id;
	  $this->_db->setQuery($query);
	  $profile = $this->_db->loadObject();

    $profile->_my_profile = $user->id == $id;

    return $profile;
	}

	function getMainPhotoSource($thumbnail = false)
	{
	  require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_lovefactory'.DS.'settings.php');
	  $settings = new LovefactorySettings();

	  $path = JURI::root().'components/com_lovefactory/';
	  $base = JPATH_ROOT.DS.'components'.DS.'com_lovefactory'.DS.'storage';

	  // Check main photo
	  $filepath = $base.DS.'photos'.DS.$this->user_id.DS.($thumbnail ? 'thumb_' : '').$this->main_photo;

	  if (!empty($this->main_photo))
	  {
	    if (file_exists($filepath))
	    {
	      $src = $path.'storage/photos/'.$this->user_id.'/'.($thumbnail ? 'thumb_' : '').$this->main_photo;
	    }
	    elseif ('gravatar' == $this->main_photo)
	    {
	      if ($settings->enable_gravatar_integration)
	      {
	        if (!isset($this->_email))
	        {
	          $user =& JFactory::getUser($this->user_id);
	          $email = md5(strtolower(trim($user->email)));
	        }
	        else
	        {
	          $email = md5(strtolower(trim($this->_email)));
	        }

	        $size = $thumbnail ? max(array($settings->thumbnail_max_width, $settings->thumbnail_max_height)) : 512;

	        $src = 'http://www.gravatar.com/avatar/'.$email.'?s='.$size.'.jpg';
	      }
	    }
	    else
	    {
	      $src = $path.'assets/images/love.png';
	    }
	  }
	  else
	  {
	    $filepath = $base.DS.'defaults'.DS.$this->sex.'.'.$settings->default_photo_extension;

	    if (file_exists($filepath) && '' != $this->sex && '' != $settings->default_photo_extension)
	    {
	      $src = $path.'storage/defaults/'.$this->sex.'.'.$settings->default_photo_extension;
	    }
	    else
	    {
	      $src = $path.'assets/images/love.png';
	    }
	  }

	  return $src;
	}

	function renderThumbnail($link = false, $size = 'large')
	{
	  static $main_photo_visibility = null;

	  if (is_null($main_photo_visibility))
	  {
	    $field =& JTable::getInstance('field', 'Table');
      $field->getMainPhoto();

      $main_photo_visibility = $field->visibility;
	  }

	  $this->_main_photo_visibility = $main_photo_visibility;

    $settings = new LovefactorySettings();
	  $default  = JURI::root().'components/com_lovefactory/assets/images/love.png';

	  // Check if it's my photo
	  $user =& JFactory::getUser();
	  if ($user->id == $this->user_id)
	  {
	    $this->_main_photo_visibility = 1;
	  }

	  // Check the field visibility
	  switch ($this->_main_photo_visibility)
	  {
	    case 0: // Hidden
	      $src = $default;
	    break;

	    case 1: // For all
	      $src = $this->getMainPhotoSource(true);
	    break;

	    case 2: // For friends
	      $src = $this->_is_friend ? $this->getMainPhotoSource(true) : $default;
	    break;
	  }

	  $href = '';
	  if ($link)
	  {
	    global $Itemid;
	    $href = '<a href="'.JRoute::_('index.php?option=com_lovefactory&view=profile&id='.$this->user_id.'&Itemid='.$Itemid).'"></a>';
	  }

	  $size = 'large' == $size ? 1 : 2;

	  // Create output
	  $output = '<div style="background-image: url(\'' . $src . '\'); height: ' . ($settings->thumbnail_max_height / $size) .'px; width: ' . ($settings->thumbnail_max_width / $size) . 'px;" class="lovefactory-thumbnail">'.$href.'</div>';

	  return $output;
	}

	function addPhoto()
	{
	  $this->modifyPhotos(1);
	}

	function removePhoto($filename)
	{
	  $this->modifyPhotos(-1, $filename);
	}

	function modifyPhotos($count, $filename = null)
	{
	  $this->photos += $count;

	  if (-1 == $count && $this->main_photo == $filename)
	  {
	    $this->main_photo = '';
	  }

	  $this->store();
	}

	function createUserFolder()
	{
	  if (!file_exists(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id))
    {
      mkdir(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id, 0755);
    }
	}

	function addDefaultInTable()
	{
	  $query = ' SELECT p.user_id'
	         . ' FROM #__lovefactory_profiles p'
	         . ' WHERE p.user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  if (!$this->_db->loadResult())
	  {
	    $date =& JFactory::getDate();
	    $query = ' INSERT'
             . ' INTO #__lovefactory_profiles(`user_id`, `date`) VALUES(' . $this->user_id . ', "' . $date->toMySql() . '")';
      $this->_db->setQuery($query);
      $this->_db->query();
	  }
	}

	function storeMainPhotoUpload()
	{
	  if ('' == $this->main_photo)
	  {
	    return false;
	  }

	  $this->photos = 1;

	  jimport('joomla.filesystem.file');
	  JFile::move(JPATH_COMPONENT_SITE.DS.'storage'.DS.'registration_photos'.DS.$this->main_photo,          JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id.DS.$this->main_photo);
	  JFile::move(JPATH_COMPONENT_SITE.DS.'storage'.DS.'registration_photos'.DS.'thumb_'.$this->main_photo, JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id.DS.'thumb_'.$this->main_photo);

	  // Insert into photos table
	  $photo =& JTable::getInstance('photo', 'Table');
	  $date  =& JFactory::getDate();

	  $photo->user_id    = $this->user_id;
	  $photo->filename   = $this->main_photo;
	  $photo->is_main    = 1;
	  $photo->date_added = $date->toMySql();

	  $photo->store();
	}

	function isMyProfile()
	{
	  $user =& JFactory::getUser();

	  return $user->id == $this->user_id;
	}

	function initializeFields($fields)
	{
	  foreach ($fields as $field)
    {
      $this->{'field_' . $field->id} = null;
    }
	}

	function delete()
	{
	  $settings = new LoveFactorySettings();

	  $this->_deleteActions($settings->user_delete_actions);
	  $this->_deleteBlacklist();
	  $this->_deleteComments($settings->user_delete_comments);
	  $this->_deleteFriends();
	  $this->_deleteGeoLocation();
	  $this->_deleteInteractions($settings->user_delete_interactions);
	  $this->_deleteIps();
	  $this->_deleteSoldMemberships();
	  $this->_deleteMessages();
	  $this->_deletePhotoComments($settings->user_delete_photo_comments);
	  $this->_deletePhotos();
	  $this->_deleteProfileVisitors($settings->user_delete_profile_visits);
	  $this->_deletePayments($settings->user_delete_payments);
	  $this->_deleteRatings($settings->user_delete_ratings);
	  $this->_deleteReports();
	  $this->_deleteStatisticsPerDay();
	  $this->_deleteShoutbox($settings->user_delete_shoutbox);
	  $this->_deleteVideoComments($settings->user_delete_video_comments);
	  $this->_deleteVideos();
	  $this->_deleteUserFolder();
	  $this->_deleteCreatedGroups($settings->user_delete_created_groups);
	  $this->_deleteGroupPosts($settings->user_delete_posts_in_groups);
	  $this->_deleteGroupMemberships();
	  $this->_deleteGroupBans();

	  // delete the profile
	  parent::delete();
	}


	function membershipGroupsLimitReached($type = 'join')
	{
	  $var = 'groups_' . $type;

	  // Check if membership has unlimited groups
	  if (-1 == $this->membership_sold->$var)
	  {
	    return false;
	  }

	  // Get user's group count
	  if ('join' == $type)
	  {
	    $query = ' SELECT COUNT(1)'
	           . ' FROM #__lovefactory_group_members m'
	           . ' WHERE m.user_id = ' . $this->user_id;
	  }
	  else
	  {
	    $query = ' SELECT COUNT(1)'
	           . ' FROM #__lovefactory_groups g'
	           . ' WHERE g.user_id = ' . $this->user_id;
	  }
	  $this->_db->setQuery($query);
	  $count = $this->_db->loadResult();

	  if ($count < $this->membership_sold->$var)
	  {
	    return false;
	  }

	  return true;
	}


	// Delete helpers
	function _deleteActions($deleteOther = false)
	{
	  $where = ' WHERE user_id = ' . $this->user_id;

	  if ($deleteOther)
	  {
	    $where .= ' OR sender_id = ' . $this->user_id;
	  }

	  $query = ' DELETE'
	         . ' FROM #__lovefactory_actions'
	         . $where;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteProfileVisitors($deleteOther = false)
	{
	  $where = ' WHERE user_id = ' . $this->user_id;

	  if ($deleteOther)
	  {
	    $where .= ' OR visitor_id =' . $this->user_id;
	  }

	  $query = ' DELETE'
	         . ' FROM #__lovefactory_profile_visitors'
	         . $where;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteBlacklist()
	{
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_blacklist'
	         . ' WHERE sender_id = ' . $this->user_id
	         . ' OR receiver_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteComments($deleteOther = false)
	{
	  $where = ' WHERE receiver_id = ' . $this->user_id;

	  if ($deleteOther)
	  {
	    $where .= ' OR sender_id = ' . $this->user_id;
	  }

	  $query = ' DELETE'
       	   . ' FROM #__lovefactory_comments'
       	   . $where;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteFriends()
	{
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_friends'
	         . ' WHERE sender_id = ' . $this->user_id
	         . ' OR receiver_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteInteractions($delete = true)
	{
	  if (!$delete)
	  {
	    return true;
	  }

	  $query = ' DELETE'
	         . ' FROM #__lovefactory_interactions'
	         . ' WHERE sender_id = ' . $this->user_id
	         . ' OR receiver_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteIps()
	{
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_ips'
	         . ' WHERE user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);
	  return $this->_db->query();
	}

	function _deleteMessages()
	{
	  // delete messages
	  $query = ' SELECT m.*'
	         . ' FROM #__lovefactory_messages m'
	         . ' WHERE m.sender_id = ' . $this->user_id
	         . ' OR m.receiver_id = ' . $this->user_id;
	  $this->_db->setQuery($query);
	  $messages = $this->_db->loadObjectList();

	  foreach ($messages as $message)
	  {
	    if (($message->sender_id == $this->user_id && $message->deleted_by_receiver == 1) ||
	        ($message->receiver_id == $this->user_id && $message->deleted_by_sender == 1))
	    {
	      $query = ' DELETE'
	             . ' FROM #__lovefactory_messages'
	             . ' WHERE id = ' . $message->id;
	    }
	    elseif ($message->sender_id == $this->user_id)
	    {
	      $query = ' UPDATE #__lovefactory_messages'
	             . ' SET deleted_by_sender = 1'
	             . ' WHERE id = ' . $message->id;
	    }
	    else
	    {
	      $query = ' UPDATE #__lovefactory_messages'
	             . ' SET deleted_by_receiver = 1'
	             . ' WHERE id = ' . $message->id;
	    }

	    $this->_db->setQuery($query);
	    $this->_db->query();
	  }
	}

	function _deletePayments()
	{
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_payments'
	         . ' WHERE user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deletePhotos()
	{
	  // Get all photos
	  $query = ' SELECT id, filename'
	         . ' FROM #__lovefactory_photos'
	         . ' WHERE user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);
	  $photos = $this->_db->loadObjectList('id');

	  // If any photos were found
	  if (count($photos))
	  {
	    // Delete comments
	    $query = ' DELETE'
     	       . ' FROM #__lovefactory_photo_comments'
	           . ' WHERE photo_id IN (' . implode(',', array_keys($photos)) . ')';
	    $this->_db->setQuery($query);
	    $this->_db->query();

	    // Delete photo files
	    $ids = array();
	    foreach ($photos as $photo)
	    {
	      @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id.DS.$photo->filename);
	      @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id.DS.'thumb_'.$photo->filename);

	      $ids[] = $photo->id;
	    }

	    $query = ' DELETE'
	           . ' FROM #__lovefactory_photos'
	           . ' WHERE id IN (' . implode(', ', $ids) . ')';
	    $this->_db->setQuery($query);
	    $this->_db->query();
	  }
	}

	function _deletePhotoComments($delete = true)
	{
	  if (!$delete)
	  {
	    return true;
	  }

	  $query = ' DELETE'
     	     . ' FROM #__lovefactory_photo_comments'
	         . ' WHERE user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteRatings($deleteOther = false)
	{
	  $where = ' WHERE receiver_id = ' . $this->user_id;

	  if ($deleteOther)
	  {
	    $where .= ' OR sender_id = ' . $this->user_id;
	  }

	  $query = ' DELETE'
	         . ' FROM #__lovefactory_ratings'
	         . $where;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteReports()
	{
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_reports'
	         . ' WHERE user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteStatisticsPerDay()
	{
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_statistics_per_day'
	         . ' WHERE user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteSoldMemberships()
	{
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_memberships_sold'
	         . ' WHERE user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteGeoLocation()
	{
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_geo'
	         . ' WHERE user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteShoutbox($delete = true)
	{
	  if (!$delete)
	  {
	    return true;
	  }

	  $query = ' DELETE'
	         . ' FROM #__lovefactory_shoutbox'
	         . ' WHERE sender_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteVideoComments($delete = true)
	{
	  if (!$delete)
	  {
	    return true;
	  }

	  $query = ' DELETE'
	         . ' FROM #__lovefactory_video_comments'
	         . ' WHERE user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);

	  return $this->_db->query();
	}

	function _deleteVideos()
	{
	  // Get all videos
	  $query = ' SELECT v.id, v.thumbnail'
	         . ' FROM #__lovefactory_videos v'
	         . ' WHERE v.user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);
	  $videos = $this->_db->loadObjectList('id');

	  // If videos were found
	  if (count($videos))
	  {
	    // Delete video comments
	    $query = ' DELETE'
	           . ' FROM #__lovefactory_video_comments'
	           . ' WHERE video_id IN (' . implode(',', array_keys($videos)) . ')';
	    $this->_db->setQuery($query);
	    $this->_db->query();

	    // Delete thumbnails
	    foreach ($videos as $video)
	    {
	      @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id.DS.$video->thumbnail);
	    }

	    // Delete videos
	    $query = ' DELETE'
	           . ' FROM #__lovefactory_videos'
	           . ' WHERE user_id = ' . $this->user_id;
	    $this->_db->setQuery($query);
	    $this->_db->query();
	  }
	}

	function _deleteUserFolder()
	{
	  // Delete user folder
	  return @unlink(JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id);
	}

	function _deleteCreatedGroups($delete = true)
	{
	  if (!$delete)
	  {
	    return true;
	  }

	  $query = ' SELECT g.*'
	         . ' FROM #__lovefactory_groups g'
	         . ' WHERE g.user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);
	  $groups = $this->_db->loadObjectList();

	  foreach ($groups as $group)
	  {
	    $table =& JTable::getInstance('Group', 'Table');

	    $table->bind($group);

	    $table->delete();
	  }

	}

	function _deleteGroupPosts($delete = true)
	{
	  if (!$delete)
	  {
	    return true;
	  }

	  $query = ' SELECT p.id'
	         . ' FROM #__lovefactory_group_posts p'
	         . ' WHERE p.user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);
	  $posts = $this->_db->loadObjectList('id');
	  $posts = array_keys($posts);

	  if ($posts)
	  {
	    $query = ' DELETE'
	           . ' FROM #__lovefactory_group_posts'
	           . ' WHERE id IN ('.implode(',', $posts).')'
	           . ' OR parent_id IN ('.implode(',', $posts).')';
	    $this->_db->setQuery($query);
	    $this->_db->query();
	  }
	}

	function _deleteGroupMemberships()
	{
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_group_members'
	         . ' WHERE user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);
	  $this->_db->query();
	}

	function _deleteGroupBans()
	{
	  $query = ' DELETE'
	         . ' FROM #__lovefactory_group_bans'
	         . ' WHERE user_id = ' . $this->user_id;
	  $this->_db->setQuery($query);
	  $this->_db->query();
	}
}
