<?php

defined('_JEXEC') or die('Restricted access');

class TableVideo extends JTable
{
	var $id          = null;
	var $user_id     = null;
	var $code        = null;
	var $thumbnail   = null;
	var $title       = null;
	var $description = null;
	var $status      = null;
	var $ordering    = null;
	var $date_added  = null;

	function __construct(&$db)
	{
		parent::__construct('#__lovefactory_videos', 'id', $db);
	}

	function isMyVideo()
	{
	  $user =& JFactory::getUser();

	  return $this->user_id == $user->id;
	}

	function getThumbnailStyle()
	{
	  $source = $this->getThumbnailSource();

	  if (!$source)
	  {
	    return '';
	  }

	  return 'style="background-image: url(\'' . $source . '\');"';
	}

	function getThumbnailSource()
	{
	  if (empty($this->thumbnail))
	  {
	    return false;
	  }

	  return JURI::root().'components/com_lovefactory/storage/photos/'.$this->user_id.'/'.$this->thumbnail;
	}

	function getShortTitle($maxLength = 30)
	{
	  if (strlen($this->title) <= $maxLength)
	  {
	    return $this->title;
	  }

	  return substr($this->title, 0, $maxLength) . '...';
	}

	function check()
	{
	  if (empty($this->title))
	  {
	    $this->setError(JText::_('VIDEO_TASK_ADDVIDEO_TITLE_REQUIRED'));
	    return false;
	  }

	  if (empty($this->code))
	  {
	    $this->setError(JText::_('VIDEO_TASK_ADDVIDEO_CODE_REQUIRED'));
	    return false;
	  }

	  return parent::check();
	}

	function store($updateNulls = false)
	{
	  if (is_null($this->id))
	  {
	    $date =& JFactory::getDate();

	    $this->date_added = $date->toMySql();
	    $this->ordering   = $this->getNextOrder('user_id = ' . $this->user_id . ' AND status = ' . $this->status);

	    $this->_moveThumbnail();
	    $this->_resizeVideo();
	  }

	  return parent::store($updateNulls);
	}

	function bindAll($from, $ignore = array())
	{
		$fromArray	= is_array($from);
		$fromObject	= is_object($from);

		if (!$fromArray && !$fromObject)
		{
			$this->setError(get_class($this).'::bind failed. Invalid from argument');
			return false;
		}

		if (!is_array($ignore))
		{
			$ignore = explode(' ', $ignore);
		}

		foreach ($from as $k => $v)
		{
			// internal attributes of an object are ignored
			if (!in_array( $k, $ignore ))
			{
				if ($fromArray && isset( $from[$k] ))
				{
					$this->$k = $from[$k];
				}
				else if ($fromObject && isset( $from->$k ))
				{
					$this->$k = $from->$k;
				}
			}
		}

		return true;
	}

	function _moveThumbnail()
	{
	  jimport('joomla.filesystem.file');

	  $src  = JPATH_COMPONENT_SITE.DS.'storage'.DS.'registration_photos'.DS.$this->thumbnail;
	  $dest = JPATH_COMPONENT_SITE.DS.'storage'.DS.'photos'.DS.$this->user_id.DS.'video_'.$this->thumbnail;

	  if (JFile::move($src, $dest))
	  {
	    $this->thumbnail = 'video_' . $this->thumbnail;
	  }
	}

	function _resizeVideo()
	{
	  preg_match('/width=(\"|\')([0-9]+)(\"|\')/', $this->code, $matches);

	  if (!$matches)
    {
      return false;
    }

	  $width         = $matches[2];
    $width_pattern = $matches[0];

    preg_match('/height=(\"|\')([0-9]+)(\"|\')/', $this->code, $matches);

    if (!$matches)
    {
      return false;
    }

    $height         = $matches[2];
    $height_pattern = $matches[0];

    // Is resize needed?
    if ($width <= 500)
    {
      return true;
    }

    $new_width  = 500;
    $new_height = intval($new_width * $height / $width);

    $search  = array($width_pattern,           $height_pattern);
    $replace = array('width="'.$new_width.'"', 'height="'.$new_height.'"');

    $this->code = str_replace($search, $replace, $this->code);
	}
}
