<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class BackendViewProfile extends JView
{
  function display($tpl = null)
  {
    $user =& JModel::getInstance('user', 'BackendModel');
    $user = $user->getUser();

    if (!$user)
    {
      $this->_layout = 'error';
    }
    else
    {
      JToolBarHelper::title(JText::_('Edit user profile').': <small><small>[ ' . $user->username .' ]</small></small>');

      JToolBarHelper::save('saveprofile',     JText::_('Save'));
      JToolBarHelper::apply('applyprofile',   JText::_('Apply'));
      JToolBarHelper::cancel('cancelprofile', JText::_('Close'));

      JModel::addIncludePath(JPATH_COMPONENT_SITE.DS.'models');

      $document =& JFactory::getDocument();
      $edit     =& JModel::getInstance('edit',     'FrontendModel');
      $renderer =& JModel::getInstance('renderer', 'FrontendModel');
      $fields   =& JModel::getInstance('fields',   'FrontendModel');

      $profile       =& $edit->getProfile($user->user_id);
      $zones         =& $edit->getZones($user->user_id);
      $settings_zone =& $edit->getSettingsZone();

      $fields->addRequiredConditionsFor($zones['required']);

      $this->assignRef('zones',         $zones);
      $this->assignRef('profile',       $profile);
      $this->assignRef('renderer',      $renderer);
      $this->assignRef('settings_zone', $settings_zone);

      $this->assign('has_required_fields', count($zones['required']));

      $document->addScriptDeclaration('txt_hidden       = "' . JText::_('Hidden') . '";');
      $document->addScriptDeclaration('txt_for_all      = "' . JText::_('For all') . '";');
      $document->addScriptDeclaration('txt_for_friends  = "' . JText::_('Only for friends') . '";');
      $document->addScriptDeclaration('txt_apply        = "' . JText::_('apply') . '";');
      $document->addScriptDeclaration('txt_visibilities = new Array("' . JText::_('Hidden') . '", "' . JText::_('For all') . '", "' . JText::_('Only for friends') . '");');

      JHtmlFactory::jQueryScript();
      JHTML::script('form-validation.js',   'components/com_lovefactory/assets/js/');
      JHTML::script('edit.js',              'components/com_lovefactory/assets/js/views/backend/');

      JHTML::stylesheet('main.css',         'components/com_lovefactory/assets/css/');
      JHTML::stylesheet('buttons.css',      'components/com_lovefactory/assets/css/');
      JHTML::stylesheet('edit.css',         'components/com_lovefactory/assets/css/views/');

      JHTML::_('behavior.tooltip');
    }

    parent::display($tpl);
  }
}