<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');
jimport('joomla.html.pane');

class BackendViewUser extends JView
{
  function display($tpl = null)
  {
    $user = $this->get('User');

    if (!$user)
    {
      $this->_layout = 'error';
    }
    else
    {
      require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');

      JToolBarHelper::save();
      JToolBarHelper::apply();

      $settings         =  new LovefactorySettings();
      $reports          =& $this->get('Reports');
      $payments         =& $this->get('Payments');
      $user_memberships =& $this->get('Memberships');
      $photos           =& $this->get('Photos');
      $ips              =& $this->get('Ips');

      $price             =& JModel::getInstance('Price', 'BackendModel');
      $memberships       =& $price->getMemberships();
      $membership_select =  JHTML::_('select.genericlist', $memberships, 'membership_id', 'class="inputbox" size="1"', 'id', 'title');

      $this->assignRef('user',              $user);
      $this->assignRef('settings',          $settings);
      $this->assignRef('reports',           $reports);
      $this->assignRef('payments',          $payments);
      $this->assignRef('memberships',       $user_memberships);
      $this->assignRef('photos',            $photos);
      $this->assignRef('ips',               $ips);
      $this->assignRef('settings',          $settings);
      $this->assignRef('membership_select', $membership_select);

      $pane = &JPane::getInstance('tabs');
		  $this->assignRef('pane', $pane);

		  $types = array(1 => JText::_('Message'),
		                 2 => JText::_('Comment'),
		                 3 => JText::_('Gallery'),
		                 4 => JText::_('Photo Comment'));
		  $this->assignRef('types', $types);
    }

    JToolBarHelper::title(JText::_('User').': <small><small>[ ' . JText::_('View') .' ]</small></small>');
    JToolBarHelper::cancel('cancel', JText::_('Close'));

    JHTML::_('behavior.tooltip');

    JHtmlFactory::jQueryScript('cookie');
    JHTML::script('gmaps.unload.js', 'components/com_lovefactory/assets/js/');

    $this->_prepareUserProfile($user->user_id);

    parent::display($tpl);
  }

  function _prepareUserProfile($user_id)
  {
    JModel::addIncludePath(JPATH_COMPONENT_SITE.DS.'models');
    $model    =& JModel::getInstance('profile',  'FrontendModel');
    $renderer =& JModel::getInstance('renderer', 'FrontendModel');
    $fields   =& JModel::getInstance('fields',   'FrontendModel');

    $profile =& $model->getProfile();
    $zones   =& $model->getZones();

    $this->assignRef('zones',    $zones);
    $this->assignRef('profile',  $profile);
    $this->assignRef('renderer', $renderer);

    JHTML::stylesheet('main.css',    'components/com_lovefactory/assets/css/');
    JHTML::stylesheet('buttons.css', 'components/com_lovefactory/assets/css/');
  }
}