<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class BackendViewUsers extends JView
{
  function display($tpl = null)
  {
    require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');

    JToolBarHelper::title(JText::_('Users'), 'generic.png');

    JToolBarHelper::custom('verifyusers', 'database', '', 'Verify users', false);
    JToolBarHelper::divider();
    JToolBarHelper::unpublishList('unbanList', JText::_('Unban'));
    JToolBarHelper::publishList('banList', JText::_('Ban'));
    JToolBarHelper::custom('options', 'config', 'config', 'Options', false);
    JToolBarHelper::deleteList(JText::_('Are you sure you want to delete these users?'));

    $users      =& $this->get('Data');
    $pagination =& $this->get('Pagination');
    $lists		  =& $this->_getViewLists();
    $settings   =  new LovefactorySettings();

    $this->assignRef('users',      $users);
    $this->assignRef('pagination', $pagination);
    $this->assignRef('lists',      $lists);
    $this->assignRef('settings',   $settings);

    JHTML::_('behavior.modal');

    parent::display($tpl);
  }

  function &_getViewLists()
	{
		global $mainframe, $option;

		$filter_order     = $mainframe->getUserStateFromRequest($option . '.users.filter_order',     'filter_order',     'title', 'cmd');
    $filter_order_Dir = $mainframe->getUserStateFromRequest($option . '.users.filter_order_Dir', 'filter_order_Dir', 'asc',   'word');
    $filter_state		  = $mainframe->getUserStateFromRequest($option . '.users.filter_state',		 'filter_state',		 '',			'word');
    $membership		    = $mainframe->getUserStateFromRequest($option . '.users.membership',		   'membership',		   '',			'int');
    $banned		        = $mainframe->getUserStateFromRequest($option . '.users.banned',		       'banned',		       '',			'int');
    $search				    = $mainframe->getUserStateFromRequest($option . '.users.search',			     'search',			     '',			'string');
		$search				    = JString::strtolower($search);

		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		  = $filter_order;

		// search
		$lists['search'] = $search;

		// state
		$lists['state'] = $filter_state;

		// membership
		$lists['membership'] = $membership;

		// banned
		$lists['banned'] = $banned;

		$lists['bans']   = array();
    $lists['bans'][] = JHTML::_('select.option', '-1', JText::_('- Select Banned -'));
    $lists['bans'][] = JHTML::_('select.option', '0', JText::_('Not banned'));
    $lists['bans'][] = JHTML::_('select.option', '1', JText::_('Banned'));

		// memberships
		$settings = new LovefactorySettings();

		$lists['memberships'] = array();
		$lists['memberships'][] = JHTML::_('select.option', '-1', JText::_('- Select Membership -'));

		$model       =& JModel::getInstance('Price', 'BackendModel');
		$memberships =  $model->getMemberships(0);

		foreach ($memberships as $membership)
		{
		  $lists['memberships'][] = JHTML::_('select.option',  $membership->id, $membership->title);
		}

		return $lists;
	}
}