var request;
var extra_info = [];

function Member(latlng, options)
{
  this.latlng = latlng;

  this.username_ = options.username;
  this.user_id_  = options.user_id;
  this.link_     = options.link;
  this.center_   = options.center || false;
}

Member.prototype = new GOverlay();

// Creates the DIV representing this rectangle.
Member.prototype.initialize = function(map)
{
  var me = this;

  var div = document.createElement("div");
  div.className = "lovefactory-member-map";
  div.innerHTML = me.username_;

  var info = document.createElement("div");
  info.innerHTML = '<div class="lf-map-loading">loading...</div>';
  info.className = "lovefactory-info-map";
  info.style.display = "none";
  div.appendChild(info);

  map.getPane(G_MAP_FLOAT_PANE).appendChild(div);

  GEvent.addDomListener(div, "click", function () {
    document.location.href = me.link_;
  });

  this.map_ = map;
  this.div_ = div;

  var info = jQueryFactory(div).find(".lovefactory-info-map");

  jQueryFactory(div).hover(function () {
    div.style.zIndex = 1000;
    info.show();

    if (info.find(".lf-map-loading").length)
    {
      if (undefined == extra_info[me.user_id_])
      {
        var data = {};
        data.user_id = me.user_id_;
        data.Itemid = Itemid;

        if (false !== me.center_)
        {
          data.lat = me.center_.y;
          data.lng = me.center_.x;
        }

        request = jQueryFactory.ajax({
          url: "index.php?option=com_lovefactory&controller=membersmap&task=getmoreinfo",
          type: "POST",
          data: data,
          success: function (response) {
            info.find(".lf-map-loading").remove();
            info.html(response);

            extra_info[me.user_id_] = response;
          }
        });
      }
      else
      {
        info.find(".lf-map-loading").remove();
        info.html(extra_info[me.user_id_]);
      }
    }
  }, function () {
    div.style.zIndex = "";
    info.hide();

    //request.abort();
  });
}

// Remove the main DIV from the map pane
Member.prototype.remove = function()
{
  this.div_.parentNode.removeChild(this.div_);
}

// Copy our data to a new Rectangle
Member.prototype.copy = function()
{
  return new Member(this.latlng, { username: this.username_, user_id: this.user_id_, link: this.link_ });
}

Member.prototype.redraw = function(force)
{
  if (!force)
  {
    return;
  }

  var divPixel = this.map_.fromLatLngToDivPixel(this.latlng);

  this.div_.style.left = (divPixel.x - this.div_.offsetWidth / 2) + "px"
  this.div_.style.top  = (divPixel.y - this.div_.offsetHeight / 2) + "px";
}

Member.prototype.getLatLng = function ()
{
  return this.latlng;
}

Member.prototype.isHidden = function ()
{
  return false;
}