jQueryFactory(document).ready(function ($) {
  var newPostHtml = '<div>'
                  + ' <textarea class="lf-input" style="width: 75%;" rows="1"></textarea>'
                  + ' <br />'
                  + ' <a href="#" class="lovefactory-button lovefactory-bullet-add">' + txt_group_post + '</a>'
                  + ' <a href="#" class="lovefactory-button lovefactory-bullet-delete">' + txt_group_cancel + '</a>'
                  + ' <span class="lf-post-response"></span>'
                  + ' <small class="lf-post-info">' + txt_allowed_html + '</small>'
                  + '</div>';

  // Pagination
  $('.lf-pagination a').live('click', function (event) {
    event.preventDefault();

    var link   = this.href;
    var posts  = $('.lf-posts');
    var height = posts.outerHeight() - $('div.lf-pagination').outerHeight();

    posts.find('div:first').html('<div class="loading"></div>').height(height);

    $.get(link, function (response) {
      posts.height('').html($(response).html());
    })
  });

  // Report buttons
  $('.lf-report').live('click', function (event) {
    event.preventDefault();

    var $this = $(this);
    var id    = $this.attr('rel');
    var link  = root + 'index.php?option=com_lovefactory&controller=report&task=add';
    var data  = { type: 6, id: id };

    $this.addClass('lovefactory-button lovefactory-loader-button');

    $.post(link, data, function (response) {
      // Report was successfull
      if (response.status) {
        $this.replaceWith(txt_group_reported);
      }

      $this.removeClass('lovefactory-button lovefactory-loader-button');
    });
  });

  // Exclude buttons
  $('.lf-user-exclude').live('click', function (event) {
    event.preventDefault();

    var $this = $(this);
    var link  = this.href;

    $this.addClass('lovefactory-button lovefactory-loader-button');

    $.post(link, function (response) {
      if (!response.success) {
        alert(response.message + "\n" + response.error);
      }
      else {
        $this.replaceWith(txt_group_excluded);
      }

      $this.removeClass('lovefactory-button lovefactory-loader-button');
    }, 'json');
  });

  // Text expandable
  $('.expandable').expander({
    expandPrefix: '…<div class="lf-expandable-spacer"></div>',
    expandText: '<small>' + txt_group_read_more + '</small>',
    userCollapse: false,
    slicePoint: 220,
  });

  // Reply button
  $('.lf-reply-button').live('click', function (event) {
    event.preventDefault();

    var $this   = $(this);
    var parent  = $this.parents('.lf-group-post:first');

    if ('' == $('.lf-reply-textarea', parent).html())
    {
      var textarea = $('.lf-reply-textarea', parent);
      $('.lf-reply-textarea').html('').hide();

      textarea
        .html(newPostHtml)

        // Resize
        .find('textarea')
          .autoResize({ animateDuration : 300, extraSpace : 20 })
        .end()

        // Cancel button
        .find('.lovefactory-bullet-delete')
          .click(function (event) {
            event.preventDefault();

            textarea.html('').hide();
          })
        .end()

        // Post button
        .find('.lovefactory-bullet-add')
          .click(function (event) {
            event.preventDefault();

            var $this    = $(this);
            var post_id  = parent.attr('id').replace('lf-group-post-', '');
            var url      = 'index.php?option=com_lovefactory&controller=group&task=post';
            var data     = { post_id: post_id, group_id: group_id, message: textarea.find('textarea:last').val() };
            var responseSpan = $this.parents('div:first').find('span:first');

            responseSpan.html('');

            $this.addClass('lovefactory-loader-button');

            $.post(url, data, function (response) {
              $this.removeClass('lovefactory-loader-button');

              if (response.status) {
                $this.parents('.lf-group-post:first').find('.lf-replies').prepend(response.text).end().find('.lf-post-reply:first').effect('highlight', {}, 1000);

                textarea.find('.lovefactory-bullet-delete').click();
              }
              else {
                responseSpan.html(response.message + ' ' + response.error);
              }
            }, 'json');
          })
        .end()

        .fadeIn('normal', function () {
          textarea.find('textarea').focus();
        });
    }
  });

  // Post & Reply delete button
  $('.lf-reply-delete, .lf-post-delete').live('click', function (event) {
    event.preventDefault();

    var $this  = $(this);
    var link   = $this.attr('href');
    var parent = $this.hasClass('lf-post-delete') ? 'lf-group-post' : 'lf-post-reply';

    $this.addClass('lovefactory-button lovefactory-loader-button');

    $.post(link, function (response) {
      $this.removeClass('lovefactory-button lovefactory-loader-button');

      if (response.status) {
        $this.parents('.' + parent + ':first').fadeOut();
      }
    });
  });

  // Add new post button
  $('#lf-new-post').click(function (event) {
    event.preventDefault();

    textarea = $('.lf-post-textarea');
    textarea
      .html('<fieldset><legend>' + txt_group_new_post_title + '</legend>' + newPostHtml + '</fieldset><br />').show()

      // Resize
      .find('textarea')
        .autoResize({ animateDuration : 300, extraSpace : 20 })
        .focus()
      .end()

      // Cancel button
      .find('.lovefactory-bullet-delete')
        .click(function (event) {
          event.preventDefault();

          textarea.html('').hide();
        })
      .end()

      // Post button
      .find('.lovefactory-bullet-add')
        .click(function (event) {
          event.preventDefault();

          var $this    = $(this);
          var url      = 'index.php?option=com_lovefactory&controller=group&task=post';
          var data     = { group_id: group_id, message: textarea.find('textarea:last').val() };
          var responseSpan = $this.parents('div:first').find('span:first');

          responseSpan.html('');

          $this.addClass('lovefactory-loader-button');

          $.post(url, data, function (response) {
            $this.removeClass('lovefactory-loader-button');

            if (response.status) {
              $this.parents('#lf-group-container:first').find('.lf-posts').prepend(response.text).end().find('.lf-group-post:first').effect('highlight', {}, 1000);

              textarea.find('.lovefactory-bullet-delete').click();

              // Remove No posts found
              $('#lf-group-no-posts').remove();
            }
            else {
              responseSpan.html(response.message + ' ' + response.error);
            }
          }, 'json');
        })
      .end()
  });

  // Group description button
  $('#lf-description-button').click(function (event) {
    event.preventDefault();

    var description = $('#lf-group-description');
    description.slideDown();
  });

  $('#lf-group-description-hide').click(function (event) {
    event.preventDefault();

    var description = $('#lf-group-description');
    description.slideUp();
  });
});