(function ($) {
  // Get checked media
  $.fn.getChecked = function () {
    var array = [];

    var checked = $(this).parents('.lf-media-container').find('.sortable input[type=checkbox]:checked');

    for (var i = 0, count = checked.length; i < count; i++) {
      array.push($(checked[i]).val());
    }

    return array.length ? array : false;
  };
})(jQueryFactory);

// Document ready
jQueryFactory(document).ready(function ($) {
  // Delete batch buttons
  $('.lf-batch-delete').click(function (event) {
    event.preventDefault();

    var media_ids = $(this).getChecked();

    if (false == media_ids) {
      alert(txt_select_photo);
      return false;
    }

    var link       = $(this);
    var media_type = link.parents('ul:first').attr('id').replace('lf-media-', '');
    link.addClass('lovefactory-bullet-load');

    $.post(
      root + 'index.php?option=com_lovefactory&controller=mygallery&task=deleteBatch',
      { media_ids: media_ids, media_type: media_type },
      function (response) {
        link.removeClass('lovefactory-bullet-load');

        // Remove deleted media
        var media = response.deleted;

        for (var i = 0, count = media.length; i < count; i++) {
          var media_id = media[i];

          $('#lf-media-' + media_id).fadeOut(function () { $(this).remove(); });
        }
    }, 'json');
  });

  // Delete buttons
  $(".lf-list li li .lovefactory-bullet-delete").live("click", function (event) {
    event.preventDefault();

    var link       = $(this);
    var media_type = link.parents('ul.lf-list:first').attr('id').replace('lf-media-', '');
    var id         = link.parents("li:first").attr("id").replace("lf-media-", "");

    link.addClass("lovefactory-bullet-load");

    $.post(
      root + "index.php?option=com_lovefactory&controller=mygallery&task=delete",
      { media_id: id, media_type: media_type },
      function (response) {
        link.removeClass("lovefactory-bullet-load");

        if (1 == response.status)
        {
          $("#lf-media-" + id).fadeOut(function () { $(this).remove(); });
        }
    }, "json");
  });

  // Collapse
  $(".lf-title").click(function (event) {
    event.preventDefault();

    $(this).parent().find("div:first").slideToggle();
    $(this).toggleClass("lovefactory-toggle-plus");
  });

  // Hover container
  if (1 == hover_action_links) {
    $('.lf-media-container').live('mouseover', function () {
      $(this).find('.lf-batch-actions').css('visibility', 'visible');
    });
    $('.lf-media-container').live('mouseout', function () {
      $(this).find('.lf-batch-actions').css('visibility', 'hidden');
    });

    // Hover media
    $('.lf-media').live('mouseover', function () {
      $(this).find('a').css('visibility', 'visible');
    });
    $('.lf-media').live('mouseout', function () {
      $(this).find('a').css('visibility', 'hidden');
    });
  }

  // Check all
  $(".lf-check-all").click(function () {
    var id      = $(this).attr("id").replace("lf-all-", "");
    var checked = $(this).attr("checked");

    $("#lf-media-" + id + " .sortable input[type=checkbox]").attr("checked", checked);
  });

  // Expand all
  $("#lf-expand-all").click(function (event) {
    event.preventDefault();

    $(".lf-title").each(function () {
      if ($(this).hasClass("lovefactory-toggle-plus"))
      {
        $(this).click();
      }
    });
  });

  // Collapse all
  $("#lf-collapse-all").click(function (event) {
    event.preventDefault();

    $(".lf-title").each(function () {
      if (!$(this).hasClass("lovefactory-toggle-plus"))
      {
        $(this).click();
      }
    });
  });
});