jQueryFactory(document).ready(function ($) {

  ajaxPaginationLinks();

  // Comments pagination
  function ajaxPaginationLinks()
  {
    // Pagination
    $(".lovefactory-pagination a").unbind().click(function () {
      var href     = $(this).attr("href");
      var comments = $("#lovefactory-comments");
      var height   = comments.css("height");

      $(".lovefactory-pagination").addClass("lovefactory-button lovefactory-loader-button");

      $.post(href, { format: "raw"}, function (response) {
        $("#lovefactory-comments").html(response);
        comments.removeClass('lovefactory-loader')
        ajaxPaginationLinks();

        var targetOffset = $("a[name='comments']").offset().top;
        jQueryFactory("html,body").animate({scrollTop: targetOffset}, "normal");
      });

      return false;
    });

    // Add comment button
    $("#lovefactory-add-comment").unbind().click(function () {
      var link   = $(this);
      var parent = link.parent();
      var output = '<div style="position:relative; display: none;">'
                 + '  <div id="lovefactory-quick-error" class="lovefactory-error-field" style="display: none;"><span class="lovefactory-button lovefactory-bullet-error">' + txt_enter_message + '</span></div>'
                 + '  <textarea></textarea>'
                 + '  <div class="lovefactory-actions">'
                 + '    <a href="#" class="lovefactory-button lovefactory-bullet-add">' + txt_send + '</a>'
                 + '    <a href="#" class="lovefactory-button lovefactory-bullet-delete">' + txt_cancel + '</a>'
                 + '  </div>'
                 + '</div>';

      parent.append(output);

      link.fadeOut("fast", function () {
        parent.find("div:first").fadeIn("fast", function () {
          parent.find("textarea:first").focus();
        });
      });

      // Cancel button
      parent.find(".lovefactory-bullet-delete").click(function () {
        parent.find("div:first").fadeOut("fast", function () {
          $(this).remove();
          link.fadeIn("fast");
        });

        return false;
      });

      // Send button
      parent.find(".lovefactory-bullet-add").click(function () {
        var message = parent.find("textarea:first").val();
        var error = parent.find(".lovefactory-error-field:first");

        error.fadeOut("fast");

        if ('' == message)
        {
          error.fadeIn("fast");
          return false;
        }

        parent.find("div:first").append('<div class="lovefactory-loading-cover" style="display: "></div>');
        parent.find(".lovefactory-loading-cover").fadeIn("fast");

        $.post(route_add_comment, { format: "raw", photo_id: photo_id, text: message }, function (response) {
          $.showMessage({id: "lovefactory-comment-response", response: response });

          parent.find("div:first").fadeOut("fast", function () {

            if (1 == response.status)
            {
              $.post(document.location.href, { format: "raw"}, function (response) {
                $("#lovefactory-comments").html(response);
                ajaxPaginationLinks();

                link.fadeIn("fast");
                parent.find("div:first").remove();
              });
            }
            else
            {
              link.fadeIn("fast");
              parent.find("div:first").remove();
            }
          });
        }, "json");

        return false;
      });

      return false;
    });

    // Delete comment button
    $(".lovefactory-comment-actions .lovefactory-bullet-delete").click(function () {
      var link   = $(this);
      var parent = $(this).parent().parent().parent();
      var id     = parent.attr("id");

      id = id.split("-");
      id = id[2];

      link.addClass("lovefactory-loader-button");
      $.post(route_delete_comment, { format: "raw", comment_id: id}, function (response) {
        if (1 == response.status)
        {
          link.fadeOut("fast", function () {
            parent.find(".lovefactory-comment-actions").fadeOut("fast", function () {
              parent.css("text-decoration", "line-through");
            })

            link.remove();
          });
        }
      }, "json");

      return false;
    });

    // Report comment button
    $(".lovefactory-comment-actions .lovefactory-bullet-blue").click(function () {
      var link = $(this);
      var id   = $(this).parent().parent().parent().attr("id");

      id = id.split("-");
      id = id[2];

      var div = link.parent().find("div:first");
      div.fadeOut("fast");

      link.addClass("lovefactory-loader-button");
      $.post(route_report_comment, { format: "raw", comment_id: id}, function (response) {
        if (1 == response.status)
        {
          link.fadeOut("fast", function () {
            link.parent().append('<span class="lovefactory-button">' + response.text + '</span>');
            link.parent().find("span:last").fadeIn("fast");
            link.remove();
          });
        }
        else
        {
          link.removeClass("lovefactory-loader-button");

          link.parent().append('<div class="lovefactory-comment-action-error" style="display:none;">' + response.error + '</div>');
          div = link.parent().find("div:first");
          div.fadeIn("fast");
        }
      }, "json");

      return false;
    });

    // Show comment action buttons
    $(".lovefactory-comment").hover(function () {
      $(this).find(".lovefactory-comment-actions").css("visibility", "visible");
    }, function () {
      $(this).find(".lovefactory-comment-actions").css("visibility", "hidden");
    });
  }
});