jQueryFactory(document).ready(function ($) {
  var map    = new GMap2(document.getElementById("google-map"));
  var start  = new GLatLng(start_x, start_y);
  var zoom   = start_z;
  var bounds = new GLatLngBounds();
  var poly   = null;
  var users  = [];
  var markerCluster = null;

  map.setCenter(start, zoom);
  map.setUIToDefault();

  function drawCircle(center, radius, nodes, liColor, liWidth, liOpa, fillColor, fillOpa)
  {
    // Esa 2006
    //calculating km/degree
    var latConv = center.distanceFrom(new GLatLng(center.lat()+0.1, center.lng()))/unit;
    var lngConv = center.distanceFrom(new GLatLng(center.lat(), center.lng()+0.1))/unit;

    //Loop
    var points = [];
    var step = parseInt(360/nodes)||10;
    for (var i=0; i<=360; i+=step)
    {
      var pint = new GLatLng(center.lat() + (radius/latConv * Math.cos(i * Math.PI/180)), center.lng() +
      (radius/lngConv * Math.sin(i * Math.PI/180)));
      points.push(pint);
      bounds.extend(pint); //this is for fit function
    }
    points.push(points[0]); // Closes the circle, thanks Martin
    fillColor = fillColor||liColor||"#0055ff";
    liWidth = liWidth||2;
    poly = new GPolygon(points,liColor,liWidth,liOpa,fillColor,fillOpa);
    map.addOverlay(poly);
  }

  var newIcon = new GIcon(G_DEFAULT_ICON);

  newIcon.image      = root + "components/com_lovefactory/assets/images/pin.png";
  newIcon.iconSize   = new GSize(32, 32);
  newIcon.shadow     = root + "components/com_lovefactory/assets/images/pin_shadow.png";
  newIcon.shadowSize = new GSize(40, 32);
  newIcon.iconAnchor = new GPoint(2, 30);

  var marker = new GMarker(start, { draggable: true, icon: newIcon });
  map.addOverlay(marker);

  // Search
  $("#lf-radius-search").submit(function () {
    extra_info = [];
    if ("none" != $(".lovefactory-loader-button").css("display"))
    {
      return false;
    }

    if (null != poly)
    {
      map.removeOverlay(poly);
    }

    for (var i = 0, count = users.length; i < count; i++)
    {
      map.removeOverlay(users[i]);
    }

    if (null != markerCluster)
    {
      markerCluster.clearMarkers();
    }

    var radius = parseInt($("#radius").val());
    if (isNaN(radius))
    {
      radius = 10;
      $("#radius").val(radius);
    }

    if (max_search_radius < radius)
    {
      radius = max_search_radius;
      $("#radius").val(radius);
    }

    drawCircle(marker.getPoint(), radius, 360);
    var sex = $("#sex").val();

    $(".lovefactory-loader-button").show();

    $.ajax({
      url: root + "index.php?option=com_lovefactory&controller=radiussearch&task=search",
      type: "POST",
      data: { lat: marker.getLatLng().y, lng: marker.getLatLng().x, radius: radius, sex: sex, Itemid: Itemid },
      dataType: "json",
      success: function (response) {
        $(".lovefactory-loader-button").hide();

        var members = [];

        for (var i = 0, count = response.results.length; i < count; i++)
        {
          var member = response.results[i];
          var latlng = new GLatLng(member.lat, member.lng);

          member = new Member(latlng, { username: member.username, user_id: member.user_id, center: marker.getPoint(), link: member.link });
          if (lf_group_members)
          {
            members.push(member);
          }
          else
          {
            map.addOverlay(member);
          }
        }

        if (lf_group_members)
        {
          markerCluster = new MarkerClusterer(map, members, { maxZoom: lf_group_members_zoom } );
        }
      }
    });

    return false;
  });
});