var lf_current_video;

jQueryFactory(document).ready(function ($) {
  // List video click
  $('#lf-videos-list ul a').live('click', function (event) {
    event.preventDefault();

    var id        = $(this).attr('id').replace('lf-video-', '');
    var url       = 'index.php?option=com_lovefactory&controller=video&task=loadvideo&format=raw';
    var data      = { video_id: id }
    var container = $('#lf-video-container');

    lf_current_video = id;

    container.html('<div class="loading" style="margin-top: 40px;"></div>');

    $.get(url, data, function (response) {
      container.html(response);
    });
  });

  // Videos list Pagination
  $('#lf-videos-list .pagination a').live('click', function (event) {
    event.preventDefault();

    var href = $(this).attr('href');
    var height = $('#lf-videos-list ul').outerHeight();

    $('#lf-videos-list ul').html('<div class="loading" style="margin-top: 40px;"></div>').css('height', height);

    $.get(href, function (response) {
      $('#lf-videos-list').html(response);
    });
  });

  // Comments list Pagination
  $('#lf-other-comments .pagination a').live('click', function (event) {
    event.preventDefault();

    var href = $(this).attr('href');
    var height = $('#lf-other-comments ul').outerHeight();

    var targetOffset = $("#lf-other-comments").offset().top;
    if (window.pageYOffset > targetOffset) {
      $('html, body').animate({scrollTop: targetOffset}, 'slow');
    }

    $('#lf-other-comments ul').html('<div class="loading"></div>').css('height', height);

    $.get(href, function (response) {
      $('#lf-other-comments').html(response);
    });
  });

  // Textarea
  $('#lf-video-comments textarea')
    .live('focus', function () {
      $(this).height(100);
      $('#lf-comment-submit').show();
    });

  // Comment cancel
  $('#lf-comment-submit .lovefactory-cancel').live('click', function (event) {
    event.preventDefault();

    $('#lf-video-comments textarea').val('').height(10);
    $('#lf-comment-submit .response').html('');
    $('#lf-comment-submit').hide();
  });

  // Comment actions
  $('#lf-other-comments li')
    .live('mouseover', function () {
      $(this).find('.lf-comment-actions').css('visibility', 'visible');
    })
    .live('mouseout', function () {
      $(this).find('.lf-comment-actions').css('visibility', 'hidden');
    });

  // Post comment
  var comment_posting = false;
  $('#lf-comment-submit .lovefactory-add-comment').live('click', function (event) {
    event.preventDefault();

    if (comment_posting) {
      return false;
    }

    var message = $('#lf-your-comment textarea').val();
    var data    = { text: message, video_id: lf_current_video }
    var url     = 'index.php?option=com_lovefactory&controller=video&task=submitcomment';
    var button  = $(this);

    if ('' == message) {
      return false;
    }

    button.addClass('lovefactory-loader-button');
    $('#lf-comment-submit .response').html('');

    comment_posting = true;

    $.post(url, data, function (response) {
      button.removeClass('lovefactory-loader-button');
      $('#lf-comment-submit .response').html(response.message);

      comment_posting = false;

      if (1 == response.status) {
        var url     = 'index.php?option=com_lovefactory&controller=video&task=commentslist&format=raw&video_id=' + lf_current_video;
        var height = $('#lf-other-comments ul').outerHeight();

        $('#lf-other-comments ul').html('<div class="loading"></div>').css('height', height);

        $.get(url, function (response) {
          $('#lf-other-comments').html(response);
          $('#lf-your-comment textarea').val('');
        });
      }
    });
  });

  // Comment delete
  $('.lf-video-comment-delete').live('click', function (event) {
    event.preventDefault();

    var id     = $(this).parents('li:first').attr('id').replace('lf-video-comment-', '');
    var data   = { id: id }
    var url    = 'index.php?option=com_lovefactory&controller=video&task=removecomment';
    var button = $(this);

    button.addClass('lovefactory-loader-button');

    $.post(url, data, function (response) {
      button.removeClass('lovefactory-loader-button');

      if (response.status) {
        button.parents('.lf-comment-actions').hide();
        button.parents('li:first').css('text-decoration', 'line-through');
      }
    });
  });

  // Comment report
  $('.lf-video-comment-report').live('click', function (event) {
    event.preventDefault();

    var button = $(this);
    var id     = button.parents('li:first').attr('id').replace('lf-video-comment-', '');
    var data   = { id: id }
    var url    = 'index.php?option=com_lovefactory&controller=video&task=reportcomment';

    button.addClass('lovefactory-loader-button');

    $.post(url, data, function (response) {
      button.removeClass('lovefactory-loader-button');
      button.replaceWith(response.message);
    });
  });
});