<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class FrontendController extends JController
{
  function __construct()
  {
    parent::__construct();

    require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');
    require_once(JPATH_COMPONENT_SITE.DS.'lib'.DS.'vendor'.DS.'JFactoryView.class.php');
    require_once(JPATH_COMPONENT_SITE.DS.'lib'.DS.'vendor'.DS.'html.php');

    JLoader::register('TheFactoryHelper', JPATH_COMPONENT_SITE.DS.'lib'.DS.'vendor'.DS.'TheFactoryHelper.class.php');

    $this->trackIp();
    $this->doMaintenance();
    $this->checkPermissions();
  }

  function display()
  {
    parent::display();
  }


  // Helpers
  function doMaintenance()
  {
    $model =& $this->getModel('maintenance');
    $model->doMaintenance();
  }

  function trackIp()
  {
    $user =& JFactory::getUser();

    if (!$user->guest)
    {
      JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');
      $ip =& JTable::getInstance('ip', 'Table');
      $ip->update();
    }
  }

  function checkPermissions()
  {
    global $mainframe, $Itemid;

    $view       =& JRequest::getVar('view',       '', 'REQUEST', 'string');
    $controller =& JRequest::getVar('controller', '', 'REQUEST', 'string');

    $type = '' == $controller ? $view : $controller;

    // Banned users are not allowed
    $user    =& JFactory::getUser();
    $profile =& JTable::getInstance('profile', 'Table');
    $profile->loadAndMembership($user->id);

    if ($profile->banned && 'banned' != $type)
    {
      $this->redirectTo(
        'index.php?option=com_lovefactory&view=banned&Itemid=' . $Itemid,
        'PERMISSIONS_BANNED'
      );
    }

    $settings = new LovefactorySettings();

    $permissions = array(
      'advancedsearch' => array(),
      'banned'         => array(),
      'blacklist'      => array('loggedin', 'registered'),
      'comment'        => array('loggedin', 'registered', 'enable_comments'),
      'edit'           => array('loggedin', 'registered'),
      'fillin'         => array('loggedin', 'notregistered'),
      'friend'         => array('loggedin', 'registered'),
      'friends'        => array('loggedin', 'registered'),
      'friendspending' => array('loggedin', 'registered'),
      'gallery'        => array(),
      'gateway'        => array('loggedin', 'registered'),
      'inbox'          => array('loggedin', 'registered', 'enable_messages'),
      'interaction'    => array('loggedin', 'registered', 'enable_interactions'),
      'interactions'   => array('loggedin', 'registered', 'enable_interactions'),
      'mailbox'        => array('loggedin', 'registered', 'enable_messages'),
      'membershipbuy'  => array('loggedin', 'registered'),
      'memberships'    => array(),
      'membersmap'     => array(($settings->allow_guest_members_map ? '' : 'loggedin'), 'enable_gmaps', 'enable_members_map'),
      'message'        => array('loggedin', 'registered', 'enable_messages'),
      'messageread'    => array('loggedin', 'registered', 'enable_messages'),
      'messagewrite'   => array('loggedin', 'registered', 'enable_messages'),
      'myfriends'      => array('loggedin', 'registered'),
      'mygallery'      => array('loggedin', 'registered'),
      'mymembership'   => array('loggedin', 'registered'),
      'mymemberships'  => array('loggedin', 'registered'),

      // Relationship
      'myrelationship'       => array('enable_relationships', 'loggedin', 'registered'),
      'relationshipspending' => array('enable_relationships', 'loggedin', 'registered'),
      'relationship'         => array('enable_relationships', 'loggedin', 'registered'),

      'groups'       => array('enable_groups'),
      'groupmember'  => array('enable_groups', 'loggedin', 'registered'),
      'groupmembers' => array('enable_groups', 'loggedin', 'registered'),
      'groupexclude' => array('enable_groups', 'loggedin', 'registered'),
      'group'        => array('enable_groups', 'loggedin', 'registered'),
      'groupedit'    => array('enable_groups', 'loggedin', 'registered'),

      'notavailable'   => array(),
      'online'         => array('loggedin'),
      'outbox'         => array('loggedin', 'registered', 'enable_messages'),
      'payment'        => array(),
      'profile'        => array(),
      'radiussearch'   => array(($settings->allow_guest_search_radius ? '' : 'loggedin'), 'enable_gmaps', 'enable_search_radius'),
      'rating'         => array('loggedin', 'registered', 'enable_ratings'),
      'report'         => array('loggedin', 'registered'),
      'quicksearch'    => array(),
      'signup'         => array('notloggedin', 'enable_signup'),
      'status'         => array('loggedin', 'registered', 'enable_status'),
      'terms'          => array(),
      'wallpage'       => array('loggedin', 'registered'),
    );

    if (!isset($permissions[$type]))
    {
      return false;
    }
    $membership  = $settings->default_membership_access;
    $permissions = $permissions[$type];

    if (in_array($type, $membership))
    {
      $permissions[] = 'membership';
    }

    // Profile view
    if ('profile' == $type)
    {
      $settings =  new LovefactorySettings();
      $id       =& JRequest::getVar('id', 0, 'REQUEST', 'integer');

      $my_profile = ($id == 0 || $user->id == $id);

      $permissions = array(
        ($settings->allow_guests_view_profile) ? '' : 'loggedin',
        (!$my_profile)                         ? '' : 'loggedin',
        (!$my_profile)                         ? '' : 'registered',
      );

      if (in_array('otherprofiles', $membership) && !$my_profile)
      {
        $permissions[] = 'membership';
      }
    }

    foreach ($permissions as $permission)
    {
      switch ($permission)
      {
        case 'loggedin':
          if ($user->guest)
          {
            $uri     =& JFactory::getURI();
            $referer =  base64_encode($uri->_uri);

            $this->redirectTo(
              'index.php?option=com_user&view=login&Itemid=' . $Itemid . '&return=' . $referer,
              'PERMISSIONS_LOGIN'
            );
          }
          break;

        case 'notloggedin':
          if (!$user->guest)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid
            );
          }
          break;

        case 'registered':
          if (!$profile->validated)
          {
            switch ($settings->registration_mode)
            {
              case 2: // Fillin required
                $this->redirectTo(
                  'index.php?option=com_lovefactory&view=fillin&Itemid=' . $Itemid,
                  'PERMISSIONS_FILLIN_PROFILE'
                );
              break;

              case 3: // No fillin required
              default:
                if (!$user->guest)
                {
                  /* @var $profile TableProfile */
                  $profile->addDefaultInTable();
                  $profile->createUserFolder();

                  $profile->validated          = 1;
                  $profile->membership_sold_id = 1;

                  $profile->store();
                }
              break;
            }
          }
          break;

        case 'notregistered':
          if ($profile->validated)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid
            );
          }
          break;

        case 'enable_signup':
          if ($settings->registration_mode != 1)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid
            );
          }
          break;

        case 'enable_messages':
          if (!$settings->enable_messages)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid,
              'PERMISSIONS_MESSAGES_NOT_ENABLED'
            );
          }
          break;

        case 'enable_interactions':
          if (!$settings->enable_interactions)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid,
              'PERMISSIONS_INTERACTIONS_NOT_ENABLED'
            );
          }
          break;

        case 'enable_ratings':
          if (!$settings->enable_rating)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid,
              'PERMISSIONS_RATINGS_NOT_ENABLED'
            );
          }
          break;

        case 'enable_relationships':
          if (!$settings->enable_relationships)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid,
              'PERMISSIONS_RELATIONSHIPS_NOT_ENABLED'
            );
          }
          break;

        case 'enable_status':
          if (!$settings->enable_status)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid,
              'PERMISSIONS_STATUS_NOT_ENABLED'
            );
          }
          break;

        case 'enable_comments':
          if (!$settings->enable_comments)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid,
              'PERMISSIONS_COMMENTS_NOT_ENABLED'
            );
          }
          break;

        case 'membership':
          if ($profile->membership_sold->default)
          {
            if ($settings->invalid_membership_action)
            {
              JError::raiseWarning(0, JText::_('MEMBERSHIP_ERROR_UPGRADE_MEMBERSHIP'));
              $this->redirectTo('index.php?option=com_lovefactory&view=memberships&Itemid=' . $Itemid, 'PERMISSIONS_NOT_AVAILABLE_FOR_DEFAULT_MEMBERSHIP');
            }
            else
            {
              $this->redirectTo(
                'index.php?option=com_lovefactory&view=notavailable&layout=membership&Itemid=' . $Itemid,
                'PERMISSIONS_NOT_AVAILABLE_FOR_DEFAULT_MEMBERSHIP'
              );
            }
          }
        break;

        case 'enable_gmaps':
          if (!$settings->enable_gmaps)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid,
              'PERMISSIONS_GOOGLE_MAPS_NOT_ENABLED'
            );
          }
        break;

        case 'enable_search_radius':
          if (!$settings->enable_search_radius)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid,
              'PERMISSIONS_RADIUS_SEARCH_NOT_ENABLED'
            );
          }
        break;

        case 'enable_members_map':
          if (!$settings->enable_members_map)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid,
              'PERMISSIONS_MEMBERSMAP_NOT_ENABLED'
            );
          }
        break;

        case 'enable_groups':
          if (!$settings->enable_groups)
          {
            $this->redirectTo(
              'index.php?option=com_lovefactory&view=notavailable&layout=notenabled&Itemid=' . $Itemid,
              'PERMISSIONS_GROUPS_NOT_ENABLED'
            );
          }
        break;
      }
    }
  }

  function redirectTo($link, $warning = null, $message = null)
  {
    if ($this->isAjaxRequest())
    {
      die('{"status":"0","message":"' . JText::_('PERMISSIONS_NOT_AVAILABLE') . '","error":"' . JText::_($warning) . '"}');
    }

    if (null != $warning)
    {
      JError::raiseWarning('ERROR', JText::_($warning));
    }

    global $mainframe;
    $link = JRoute::_($link, false);

    if (null != $message)
    {
      $mainframe->redirect($link, JText::_($message));
    }

    $mainframe->redirect($link);
  }


  // Ajax helpers
  function isAjaxRequest()
  {
    return (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && ($_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest'));
  }

  function renderJson($data)
  {
    // PHP 4 json_encode
    if (!function_exists('json_encode'))
    {
      function json_encode($a=false)
      {
        if (is_null($a)) return 'null';
        if ($a === false) return 'false';
        if ($a === true) return 'true';
        if (is_scalar($a))
        {
          if (is_float($a))
          {
            // Always use "." for floats.
            return floatval(str_replace(",", ".", strval($a)));
          }

          if (is_string($a))
          {
            static $jsonReplaces = array(array("\\", "/", "\n", "\t", "\r", "\b", "\f", '"'), array('\\\\', '\\/', '\\n', '\\t', '\\r', '\\b', '\\f', '\"'));
            return '"' . str_replace($jsonReplaces[0], $jsonReplaces[1], $a) . '"';
          }
          else
          return $a;
        }
        $isList = true;
        for ($i = 0, reset($a); $i < count($a); $i++, next($a))
        {
          if (key($a) !== $i)
          {
            $isList = false;
            break;
          }
        }
        $result = array();
        if ($isList)
        {
          foreach ($a as $v) $result[] = json_encode($v);
          return '[' . join(',', $result) . ']';
        }
        else
        {
          foreach ($a as $k => $v) $result[] = json_encode($k).':'.json_encode($v);
          return '{' . join(',', $result) . '}';
        }
      }
    }

    // Clear the buffer
    //ob_end_clean();

    // Set headers
    header('Cache-Control: no-cache, must-revalidate');
    header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
    header('Content-type: application/json');

    // Output data
    echo json_encode($data);

    // Exit
    jexit();
  }
}
