<?php

defined('_JEXEC') or die('Restricted access');

class FrontendControllerGallery extends FrontendController
{
  function report()
  {
    $model    =& $this->getModel('gallery');
    $response = array();

    if ($model->report())
    {
      $response['status']  = 1;
      $response['message'] = JText::_('GALLERY_TASK_REPORT_SUCCESS');
      $response['error']   = '';
    }
    else
    {
      $response['status']  = 0;
      $response['message'] = JText::_('GALLERY_TASK_REPORT_FAILURE');
      $response['error']   = $model->getError();

    }

    $this->renderJson($response);
  }

  function registrationUpload()
  {
    require_once(JPATH_COMPONENT_SITE.DS.'resizeIMG.php');
	  jimport('joomla.filesystem.file');

	  $file_name = md5($_POST['PHPSESSID'] . mt_rand(0, 100000));

	  $settings  =  new LovefactorySettings();
	  $photo     =& JRequest::getVar('photo', array(), 'FILES', 'array');
	  $extension =  strtolower(JFile::getExt($photo['name']));

	  $filepath  = JPATH_COMPONENT_SITE.DS.'storage'.DS.'registration_photos'.DS.$file_name.'.'.$extension;
	  $resize = new RESIZEIMAGE($photo['tmp_name']);
    $resize->resize_scale($settings->photo_max_width, $settings->photo_max_height, $filepath);
    $main = $resize->close() ? true : false;

    $filepath  = JPATH_COMPONENT_SITE.DS.'storage'.DS.'registration_photos'.DS.'thumb_'.$file_name.'.'.$extension;
	  $resize = new RESIZEIMAGE($photo['tmp_name']);
    $resize->resize_scale($settings->thumbnail_max_width, $settings->thumbnail_max_height, $filepath);
    $thumb = $resize->close() ? true : false;

    $status   = $main && $thumb;
    $message  = $status ? '' : JText::_('GALLERY_REGISTRATION_UPLOAD_FAILURE');
    $thumb    = addslashes(JURI::root().'components/com_lovefactory/storage/registration_photos/thumb_'.$file_name.'.'.$extension.'?'.rand(0,100000));
    $filename = $file_name.'.'.$extension;

    $response = array();

    $response['status']   = $status;
    $response['filename'] = $filename;
    $response['thumb']    = $thumb;
    $response['message']  = $message;

    $this->renderJson($response);
  }

  function upload()
  {
    $model    =& $this->getModel('mygallery');
    $response =  array();

    if ($model->upload())
    {
      $response['status']    = 1;
      $response['message']   = JText::_('GALLERY_TASK_UPLOAD_SUCCESS');
      $response['thumbnail'] = $model->_thumbnail_path;
      $response['photo_id']  = $model->_photo_id;
      $response['type']      = $model->_type;
      $response['code']      = 0;
    }
    else
    {
      $response['status']  = 0;
      $response['message'] = JText::_('GALLERY_TASK_UPLOAD_FAILURE') . "\n\n" . $model->getError();
      $response['code']    = $model->_error_code;
    }

    $settings = new LovefactorySettings();
	  if (2 == $response['code'] && !$settings->invalid_membership_action)
	  {
	    $response['code'] = 0;
	  }

    $this->renderJson($response);
  }

  function uploadVideoThumbnail()
  {
    $model    =& $this->getModel('mygallery');
    $response =  array();

    if ($model->uploadVideoThumbnail())
    {
      $response['status']   = 1;
      $response['message']  = '';
      $response['filename'] = $model->_filename;
      $response['source']   = $model->_source;
    }
    else
    {
      $response['status']  = 0;
      $response['message'] = JText::_('MY_GALLERY_VIDEO_THUMBNAIL_UPLOAD_FAILURE') . '&nbsp;' . $model->getError();
    }

    $this->renderJson($response);
  }
}