<?php

defined('_JEXEC') or die('Restricted access');

class FrontendControllerGroup extends FrontendController
{
	function save()
	{
	  global $Itemid;

	  $group =& $this->getModel('Group', 'FrontendModel');

	  if ($group->save())
	  {
	    $message = JText::_('GROUP_TASK_SAVE_SUCCESS');
	  }
	  else
	  {
	    $message = JText::_('GROUP_TASK_SAVE_FAILURE');
	  }

	  setcookie('lf-groups-filter-groups', 1, null);

	  $this->setRedirect(JRoute::_('index.php?option=com_lovefactory&view=groups', false), $message);
	}

	function join()
	{
	  $model    =& $this->getModel('Group', 'FrontendModel');
	  $response =  array();

	  if ($model->join())
	  {
	    $response['success'] = true;
	    $response['message'] = JText::_('GROUP_TASK_JOIN_SUCCESS');
	    $response['link']    = JRoute::_('index.php?option=com_lovefactory&controller=group&task=leave&group_id=' . $model->_group_id, false);
	    $response['text']    = JText::_('GROUP_LIST_LEAVE_GROUP');
	    $response['ajax']    = true;
	  }
	  else
	  {
	    $response['success'] = false;
	    $response['message'] = '<b>'.JText::_('GROUP_TASK_JOIN_FAILURE').'</b>';
	    $response['error']   = $model->getError();

	    $settings = new LovefactorySettings();
	    if (isset($model->_code) && $settings->invalid_membership_action)
	    {
	     $response['redirect'] = JURI::root().'index.php?option=com_lovefactory&controller=membership&task=redirectnomembership&code=' . $model->_code;
	    }
	  }

	  $this->renderJson($response);
	}

	function leave()
	{
	  $model    =& $this->getModel('Group', 'FrontendModel');
	  $response =  array();

	  if ($model->leave())
	  {
	    $response['success'] = true;
	    $response['message'] = JText::_('GROUP_TASK_LEAVE_SUCCESS');
	    $response['link']    = JRoute::_('index.php?option=com_lovefactory&controller=group&task=join&group_id=' . $model->_group_id, false);
	    $response['text']    = JText::_('GROUP_LIST_JOIN_GROUP');
	    $response['ajax']    = true;
	  }
	  else
	  {
	    $response['success'] = false;
	    $response['message'] = '<b>'.JText::_('GROUP_TASK_LEAVE_FAILURE').'</b>';
	    $response['error']   = $model->getError();
	  }

	  $this->renderJson($response);
	}

	function post()
	{
	  $model    =& $this->getModel('Group', 'FrontendModel');
	  $response =  array();

	  if ($model->post())
	  {
	    global $Itemid;

	    $view =& $this->getView('Group', 'html', 'FrontendView');
	    $view->assignRef('reply', $model->_reply);
	    $view->assignRef('post',  $model->_reply);
	    $view->assignRef('group', $model->_group);
	    $view->assignRef('Itemid', $Itemid);

	    $response['status'] = 1;
	    $response['text']   = $view->loadTemplate($model->_reply->parent_id ? 'reply' : 'post');
	  }
	  else
	  {
	    $response['status']  = 0;
	    $response['message'] = JText::_('GROUP_TASK_POST_FAILURE');
	    $response['error']   = $model->getError();
	  }

	  $this->renderJson($response);
	}

	function deletePost()
	{
	  $model    =& $this->getModel('Group', 'FrontendModel');
	  $response =  array();

	  if ($model->deletePost())
	  {
	    $response['status'] = 1;
	  }
	  else
	  {
	    $response['status'] = 0;
	    $response['error']  = $model->getError();
	  }

	  $this->renderJson($response);
	}
}