<?php

/* cron script */
define('_JEXEC', 1);

define('DS', DIRECTORY_SEPARATOR);
define('JPATH_BASE', str_replace('components'.DS.'com_lovefactory', '', dirname(__FILE__)));

require_once(JPATH_BASE.DS.'includes/defines.php');
require_once(JPATH_BASE.DS.'includes/framework.php');

$mosConfig_live_site = JPATH_SITE;
$mainframe =& JFactory::getApplication('site');

$mainframe->initialise();

JPluginHelper::importPlugin('system');

JDEBUG ? $_PROFILER->mark('afterInitialise') : null;
$mainframe->triggerEvent('onAfterInitialise');

$database = & JFactory::getDBO();

define('LOVEFACTORY_COMPONENT_PATH', dirname(__FILE__));
require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_lovefactory'.DS.'settings.php');

if (!isset($_SESSION))
{
	session_name(md5($mosConfig_live_site));
	session_start();
}
@set_time_limit(0);
@ignore_user_abort(true);

if (php_sapi_name() == 'cli')
{
  $argv = $_SERVER['argv'];
  $argc = $_SERVER['argc'];

  if ($argc > 0)
  {
    for ($i=1; $i < $argc; $i++)
    {
      parse_str($argv[$i], $tmp);
      $_REQUEST = array_merge($_REQUEST, $tmp);
    }
  }
}

$pass = JRequest::getVar('pass', '', 'REQUEST', 'string');
$settings = new LovefactorySettings();

if ($pass !== $settings->cron_password)
{
  die ("AUTH ERROR");
}

$database =& JFactory::getDBO();

// Send End membership notification
if ($settings->end_membership_notification)
{
  $interval =  $settings->end_membership_notify_interval;
  $limit    =  time() + $interval * 60 * 60 * 24;

  $query = ' SELECT p.user_id, u.username, UNIX_TIMESTAMP(m.end_membership) AS end_membership_unix_timestamp,'
         . '   m.id AS membership_id'
         . ' FROM #__lovefactory_profiles p'
         . ' LEFT JOIN #__users u ON u.id = p.user_id'
         . ' LEFT JOIN #__lovefactory_memberships_sold m ON m.id = p.membership_sold_id'
         . ' WHERE m.user_id <> 0'
         . ' AND m.end_notification = 0'
         . ' AND p.user_id = 62'
         . ' AND m.end_membership <> "0000-00-00 00:00:00"'
         . ' AND UNIX_TIMESTAMP(m.end_membership) < ' . $limit;
  $database->setQuery($query);
  $users = $database->loadObjectList();

  jimport('joomla.application.component.model');
  JModel::addIncludePath(JPATH_BASE.DS.'components'.DS.'com_lovefactory'.DS.'models');
  $mailer =& JModel::getInstance('mailer', 'FrontendModel');

  foreach ($users as $user)
  {
    $days_left = floor(($users[0]->end_membership_unix_timestamp - time()) / 60 / 60 / 24);

    $mailer->sendNotification($user->user_id, 'end_membership', array('days_left' => $days_left));

    $query = ' UPDATE #__lovefactory_memberships_sold'
           . ' SET end_notification = 1'
           . ' WHERE id = ' . $user->membership_id;
    $database->setQuery($query);
    $database->query();
  }
}

// Delete wallpage entires
if ($settings->cron_job_wallpage_entries_interval)
{
  $limit =  time() - $settings->cron_job_wallpage_entries_interval * 60 * 60 * 24 * 30;

  $query = ' DELETE'
         . ' FROM #__lovefactory_actions'
         . ' WHERE UNIX_TIMESTAMP(created_at) < ' . $limit;
  $database->setQuery($query);
  $database->query();
}

// Delete shoutbox messages
if ($settings->cron_job_shoutbox_messages)
{
  $limit =  time() - $settings->cron_job_shoutbox_messages * 60 * 60 * 24;

  $query = ' DELETE'
         . ' FROM #__lovefactory_shoutbox'
         . ' WHERE UNIX_TIMESTAMP(created_at) < ' . $limit;
  $database->setQuery($query);
  $database->query();
}

// Delete registration_photos
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
$path  = JPATH_BASE.DS.'components'.DS.'com_lovefactory'.DS.'storage'.DS.'registration_photos';
$files = JFolder::files($path);
foreach ($files as $file)
{
  JFile::delete($path.DS.$file);
}