<?php

jimport('joomla.application.component.view');

class JFactoryView extends JView
{
  var $_enable_smarty;
  var $_smarty;
  var $_template_path;
  var $_debug = false;

  function __construct()
  {
    parent::__construct();

    $this->getSmarty();
  }

  function getSmarty()
  {
    $settings = new LovefactorySettings();
    $this->_enable_smarty = $settings->enable_smarty;

    if ($this->_enable_smarty)
    {
      $base_path = JPATH_COMPONENT_SITE.DS.'views';
      $view_path = $base_path.DS.$this->getName().DS.'smarty';

      require(JPATH_COMPONENT_SITE.DS.'lib'.DS.'Smarty'.DS.'Smarty.class.php');
      $this->_smarty = new Smarty();

      $this->_smarty->template_dir = JPATH_COMPONENT_SITE.DS.'lib'.DS.'Smarty'.DS.'user'.DS.'templates';
      $this->_smarty->compile_dir  = JPATH_COMPONENT_SITE.DS.'lib'.DS.'Smarty'.DS.'user'.DS.'templates_c';
      $this->_smarty->cache_dir    = JPATH_COMPONENT_SITE.DS.'lib'.DS.'Smarty'.DS.'user'.DS.'cache';
      $this->_smarty->config_dir   = JPATH_COMPONENT_SITE.DS.'lib'.DS.'Smarty'.DS.'user'.DS.'configs';

      $this->_smarty->_base_path = $base_path;
      $this->_smarty->_view_path = $view_path;
    }
  }


  // Display
  function display($tpl = null)
  {
    JHTML::stylesheet('main.css',    'components/com_lovefactory/assets/css/');
    JHTML::stylesheet('buttons.css', 'components/com_lovefactory/assets/css/');

    if ($this->_enable_smarty)
    {
      echo $this->loadTemplate($tpl);
    }
    else
    {
      parent::display($tpl);
    }
  }

  function loadTemplate($tpl = null)
  {
    // If Smarty templates are enabled
    if ($this->_enable_smarty)
    {
      // Create template filepath
      $template = $this->_smarty->_view_path . DS . $this->getLayout() . (!is_null($tpl) ? '_' . $tpl : '') . '.tpl';

      // Check if template exists
      if (file_exists($template))
      {
        $this->_smarty->fetch($template);
      }
      else
      {
        JError::raiseError(500, JText::sprintf('SMARTY_ERROR_TEMPLATE_NOT_FOUND', $this->getLayout()));
      }

      $debug = $this->_debug ? '<span style="font-weight: bold; color: #ff0000;">Smarty Template!</span>' : '';

      return $debug . $this->_smarty->fetch($template);
    }

    // Smarty templates are not enabled
    return parent::loadTemplate($tpl);
  }


  // Assign
  function assignRef($key, &$val)
  {
    if ($this->_enable_smarty)
    {
      $this->_smarty->assign($key, $val);
    }
    else
    {
      parent::assignRef($key, $val);
    }
  }

  function assign()
  {
    $arg0 = @func_get_arg(0);
    $arg1 = @func_get_arg(1);

    if ($this->_enable_smarty)
    {
      $this->_smarty->assign($arg0, $arg1);
    }
    else
    {
      parent::assign($arg0, $arg1);
    }
  }

  function assignJavascript($key, $value)
  {
    if (!isset($this->document))
    {
      $this->document =& JFactory::getDocument();
    }

    if (!is_array($value))
    {
      $this->document->addScriptDeclaration('var ' . $key . ' = "' . addslashes($value) . '";');
    }
    else
    {
      foreach ($value as $i => $val)
      {
        $value[$i] = addslashes($val);
      }

      $value = 'new Array("' . implode('", "', $value) . '")';
      $this->document->addScriptDeclaration('var ' . $key . ' = ' . $value . ';');
    }
  }
}