<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelBlacklist extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;
  var $_limit;
  var $_limitstart;

  // List & pagination
  function __construct()
  {
    parent::__construct();

    global $mainframe;
    $this->_limit      = JRequest::getVar('limit',      $mainframe->getCfg('list_limit'), 'REQUEST', 'integer');
    $this->_limitstart = JRequest::getVar('limitstart', 0,                                'REQUEST', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
  }

  function getData()
  {
    if (empty($this->_data))
    {
      $query       = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);
    }

    return $this->_data;
  }

  function _buildQuery()
  {
    $user =& JFactory::getUser();

    $query = ' SELECT b.*, u.username'
           . ' FROM #__lovefactory_blacklist b'
           . ' LEFT JOIN #__users u ON u.id = b.receiver_id'
           . ' WHERE b.sender_id = ' . $user->id
           . ' ORDER BY b.date DESC';

    return $query;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }

  // Tasks
  function add()
  {
    $user =& JFactory::getUser();
    $id   =& JRequest::getVar('user_id', 0, 'POST', 'integer');

    $is_blacklisted = $this->isBlacklisted($id);

    if ($is_blacklisted)
    {
      $this->setError(JText::_('BLACKLIST_USER_ALREADY_ON_BLACKLIST'));
      return false;
    }

    $date      =& JFactory::getDate();
    $blacklist =& $this->getTable('blacklist');

    $blacklist->sender_id   = $user->id;
    $blacklist->receiver_id = $id;
    $blacklist->date        = date('Y-m-d H:i:s');

    $blacklist->store();

    // Send user message
    require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');
    $settings = new LovefactorySettings();
    if ($settings->enable_messages)
    {
      $message =& $this->getTable('message');

      $message->sendSystemMessage(
        $blacklist->receiver_id,
        JText::_('BLACKLIST_ADDED_MESSAGE_TITLE'),
        JText::sprintf('BLACKLIST_ADDED_MESSAGE_TEXT', '<a href="'.JRoute::_('index.php?option=com_lovefactory&view=profile&id='.$user->id).'" class="lovefactory-button lovefactory-user">'.$user->username.'</a>')
      );
    }

    $this->_blacklist_id = $blacklist->id;

    return true;
  }

  function remove()
  {
    $user =& JFactory::getUser();
    $id   =& JRequest::getVar('id', 0, 'REQUEST', 'integer');

    $blacklist =& $this->getTable('blacklist');
    $blacklist->load($id);

    if ($blacklist->sender_id != $user->id)
    {
      $this->setError(JText::_('BLACKLIST_USER_NOT_FOUND'));
      return false;
    }

    $blacklist->delete();

    require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'settings.php');
    $settings = new LovefactorySettings();

    if ($settings->enable_messages)
    {
      $message =& $this->getTable('message');
      $message->sendSystemMessage(
        $blacklist->receiver_id,
        JText::_('BLACKLIST_REMOVED_MESSAGE_TITLE'),
        JText::sprintf('BLACKLIST_REMOVED_MESSAGE_TEXT', '<a href="'.JRoute::_('index.php?option=com_lovefactory&view=profile&id='.$user->id).'" class="lovefactory-button lovefactory-user">'.$user->username.'</a>')
      );
    }

    return true;
  }

  function isBlacklisted($receiver_id, $sender_id = null)
  {
    $user      =& JFactory::getUser();
    $sender_id =  ($sender_id == null) ? $user->id : $sender_id;

    $query = ' SELECT b.id'
           . ' FROM #__lovefactory_blacklist b'
           . ' WHERE b.sender_id = ' . $sender_id
           . ' AND b.receiver_id = ' . $receiver_id;
    $this->_db->setQuery($query);

    return $this->_db->loadResult();
  }
}