<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelComment extends JModel
{
  function store()
  {
    $user        =& JFactory::getUser();
    $receiver_id =& JRequest::getVar('user_id', 0,  'POST', 'integer');
    $text        =& JRequest::getVar('text',    '', 'POST', 'string');

    $profile =& $this->getTable('profile', 'Table');
    $profile->load($receiver_id);

    // Check if user exists
    if ($profile->_is_new)
    {
      $this->setError(JText::_('COMMENT_TASK_STORE_ERROR_USER_NOT_FOUND'));
      return false;
    }

    // Check if comment is empty
    if ('' == $text)
    {
      $this->setError(JText::_('COMMENT_TASK_STORE_ERROR_MESSAGE_EMPTY'));
      return false;
    }

    // Check if the user is blacklisted
    $blacklist =& JModel::getInstance('blacklist', 'FrontendModel');
    $blacklisted = $blacklist->isBlacklisted($user->id, $receiver_id);

    if ($blacklisted)
    {
      $this->setError(JText::_('COMMENT_TASK_STORE_ERROR_BLACKLISTED'));
      return false;
    }

    $date    =& JFactory::getDate();
    $comment =& $this->getTable('comment');

    $comment->receiver_id = $receiver_id;
    $comment->sender_id   = $user->id;
    $comment->date        = $date->toMySql();
    $comment->text        = $text;

    $comment->store();

    $mailer =& JModel::getInstance('mailer', 'FrontendModel');
    $mailer->sendNotification($profile->user_id, 'comment');

    $action =& $this->getTable('action', 'Table');
    $action->addComment($comment->text, $comment->receiver_id, $comment->sender_id);

    return true;
  }

  function delete()
  {
    $id      =& JRequest::getVar('comment_id', 0, 'REQUEST', 'integer');
    $user    =& JFactory::getUser();
    $comment =& $this->getTable('comment');

    $comment->load($id);
    if ($comment->receiver_id == $user->id)
    {
      $comment->delete();

      return true;
    }

    $this->setError(JText::_('COMMENT_TASK_DELETE_ERROR_NOT_FOUND'));
    return false;
  }

  function report()
  {
    $id      =& JRequest::getVar('comment_id', 0, 'REQUEST', 'integer');
    $user    =& JFactory::getUser();
    $comment =& $this->getTable('comment');

    $comment->load($id);
    if ($comment->receiver_id == $user->id)
    {
      $comment->report();
      return true;
    }

    $this->setError(JText::_('COMMENT_TASK_REPORT_ERROR_NOT_FOUND'));
    return false;
  }
}