<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelEdit extends JModel
{
  var $_profile;

  function getProfile($user_id = null)
  {
    $user    =& JFactory::getUser();
    $profile =& JModel::getInstance('profile', 'FrontendModel');

    $id = null == $user_id ? $user->id : $user_id;

    $zones = $this->getZones();
    $extra = $profile->getExtraFields($zones['types']);

	  $query = $profile->getMainSelectQuery($extra)
	         . ' FROM #__lovefactory_profiles p'
	         . $profile->getLeftJoinsQuery($extra)
	         . ' WHERE p.user_id = ' . $id
	         . ' GROUP BY p.user_id';
	  $this->_db->setQuery($query);
	  $this->_profile = $this->_db->loadObject();

    $this->_profile->_my_profile = 1;

    return $this->_profile;
  }

  function getZones($user_id = null)
  {
    static $zones = null;

    if (!is_null($zones))
    {
      return $zones;
    }

    $zones =& JModel::getInstance('zones', 'FrontendModel');
    $zones = $zones->getZonesForDisplayForPage('edit', $user_id);

    return $zones;
  }

  function getMisc()
  {
    $array    = array();
    $settings = new LovefactorySettings();

    if ($settings->profile_status_change)
    {
      $table =& $this->getTable('field', 'Table');
      $table->id               = 'online';
      $table->type_id          = 3;
      $table->title            = JText::_('PROFILE_STATUS');
      $table->published        = 1;
      $table->params           = 'values='.JText::_('PROFILE_EDIT_STATUS_ONLINE').'*|*'.JText::_('PROFILE_EDIT_STATUS_ONLY_FRIENDS').'*|*'.JText::_('PROFILE_EDIT_STATUS_OFFLINE').'
no_blank=true';
      $table->required         = 0;
      $table->user_visibility  = 0;
      $table->_value           = $this->_profile->online;

      $array[] = $table;
    }

    if ($settings->enable_user_email_notify)
    {
      $table =& $this->getTable('field', 'Table');
      $table->id               = 'alerts';
      $table->type_id          = 3;
      $table->title            = JText::_('EMAIL_ALERTS');
      $table->published        = 1;
      $table->params           = 'values='.JText::_('PROFILE_EDIT_ALERTS_DISABLE').'*|*'.JText::_('PROFILE_EDIT_ALERTS_ENABLE').'
no_blank=true';
      $table->required         = 0;
      $table->user_visibility  = 0;
      $table->_value           = $this->_profile->alerts;

      $array[] = $table;
    }

    if ($settings->enable_infobar)
    {
      if (1 == $settings->infobar_location)
      {
        $values = JText::_('PROFILE_EDIT_INFOBAR_DISABLE').'*|**|*'.JText::_('PROFILE_EDIT_INFOBAR_SHOW_TOP').'*|*'.JText::_('PROFILE_EDIT_INFOBAR_SHOW_BOTTOM');
      }
      else
      {
        $values = JText::_('PROFILE_EDIT_INFOBAR_DISABLE').'*|*' . (2 == $settings->infobar_location ? JText::_('PROFILE_EDIT_INFOBAR_ENABLE') : '*|*'.JText::_('PROFILE_EDIT_INFOBAR_ENABLE'));
      }

      $table =& $this->getTable('field', 'Table');
      $table->id               = 'infobar';
      $table->type_id          = 3;
      $table->title            = JText::_('INFOBAR');
      $table->published        = 1;
      $table->params           = 'values=' . $values . '
no_blank=true';
      $table->required         = 0;
      $table->user_visibility  = 0;
      $table->_value           = $this->_profile->infobar;

      $array[] = $table;
    }

    return $array;
  }

  function getSettingsZone()
  {
    return (object)array('title' => JText::_('SETTINGS'), 'fields' => array($this->getMisc()));
  }
}