<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelFriends extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;
  var $_limit;
  var $_limitstart;
  var $_pending;

  function __construct()
  {
    parent::__construct();

    global $mainframe;
    $this->_limit      = JRequest::getVar('limit',      10, 'REQUEST', 'integer');
    $this->_limitstart = JRequest::getVar('limitstart', 0,  'GET', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
    $this->_pending = 0;
  }


  function getFriends()
  {
    $this->_relationship = 0;
    $this->_pending      = 0;

    return $this->getData();
  }

  function getPending()
  {
    $this->_relationship = null;
    $this->_pending      = 1;

    return $this->getData();
  }

  function getRelationship()
  {
    $this->_relationship = 1;
    $this->_pending      = 0;

    return $this->getData();
  }

  function getTopFriends()
  {
    JRequest::setVar('top_friends', 1, 'GET');

    $this->_relationship = 0;
    $this->_pending      = 0;

    return $this->getData();
  }


  function getData()
  {
    if (empty($this->_data))
    {
      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);
    }

    return $this->_data;
  }

  function _buildQuery()
  {
    $user    =& JFactory::getUser();
    $id      =  JRequest::getVar('id', 0, 'GET', 'integer');
    $fields  =& JModel::getInstance('fields',  'FrontendModel');
    $profile =& JModel::getInstance('profile', 'FrontendModel');
    $user_id =  ($id != 0) ? $id : $user->id;

    $order = $this->_buildContentOrder();

    $zones   = $this->getZones();
    $extra   = $profile->getExtraFields($zones['types']);
    $friends = $this->getFriendsList();

	  $query = $profile->getMainSelectQuery($extra) . ','
	         . '   IF (fr.sender_id = ' . $user_id . ', 1, 0) AS my_request,'
	         . '   IF (fr.sender_id = ' . $user_id . ', fr.receiver_id, fr.sender_id) AS friend_id,'
	         . '   fr.id AS friendship_id, fr.message, fr.type,'
	         . '   IF (fr.sender_id = ' . $user_id . ', fr.sender_status, fr.receiver_status) AS friendship_status'
	         . ' FROM #__lovefactory_profiles p'
	         . $profile->getLeftJoinsQuery($extra)
	         . ' LEFT JOIN #__lovefactory_friends fr ON ((fr.sender_id = p.user_id AND fr.receiver_id = ' . $user_id . ') OR (fr.receiver_id = p.user_id AND fr.sender_id = ' . $user_id . '))'
	         . ' WHERE p.user_id IN (' . implode(',', $friends) . ')'
	         . ' GROUP BY p.user_id'
	         . $order;
    return $query;
  }

  function _buildContentWhere($user_id)
  {
    $search      =& JRequest::getVar('search',      '', 'GET', 'string');
    $top_friends =& JRequest::getVar('top_friends', 0,  'GET', 'integer');

    $where = ' WHERE (f.sender_id = ' . $user_id . ' OR f.receiver_id = ' . $user_id . ')';

    // Search
    if ('' != $search)
    {
      $where .= ' AND u.username LIKE "%' . $this->_db->getEscaped($search) . '%"';
    }

    // Top friends
    if ($top_friends)
    {
      $where .= ' AND IF (f.sender_id = ' . $user_id . ', f.sender_status, f.receiver_status) = 1';
    }

    // Pending
    $where .= ' AND f.pending = ' . $this->_pending;

    if ($this->_pending)
    {
      $session =& JFactory::getSession();
      if ($session->get('lovefactory.requests.filter.my_requests', 0))
      {
        $user =& JFactory::getUser();
        $where .= ' AND f.sender_id <> ' . $user_id;
      }
    }

    // Relationship
    if (!is_null($this->_relationship))
    {
      $where .= ' AND f.type = ' . ($this->_relationship ? 2 : 1);
    }


    return $where;
  }

  function _buildContentOrder()
  {
    $order = '';

    if (!$this->_relationship)
    {
      $order .= ' ORDER BY friendship_status DESC';
    }

    return $order;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery();
      $this->_total = $this->_getListCount($query);
    }
    return $this->_total;
  }

  function getPagination($ajax = false)
  {
    if (empty($this->_pagination))
    {
      if ($ajax)
      {
        $app    =& JFactory::getApplication();
        $router =& $app->getRouter();
        $router->setVar('format', 'raw');
      }

      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }

  function getFriendsList()
  {
    $user    =& JFactory::getUser();
    $id      =& JRequest::getVar('id', 0, 'GET', 'integer');
    $user_id =  ($id != 0) ? $id : $user->id;

    $where = $this->_buildContentWhere($user_id);

    $query = ' SELECT'
           . '   IF (f.sender_id = ' . $user_id . ', f.receiver_id, f.sender_id) AS user_id'
           . ' FROM #__lovefactory_friends f'
           . ' LEFT JOIN #__users u ON u.id = IF (f.sender_id = ' . $user_id . ', f.receiver_id, f.sender_id)'
           . $where
           . ' ORDER BY f.date DESC';
    $this->_db->setQuery($query);
    $friends = $this->_db->loadResultArray();

    return count($friends) ? $friends : array(-1);
  }


  function getUser()
  {
    $user    =& JFactory::getUser();
    $id      =  JRequest::getVar('id', 0, 'GET', 'integer');
    $user_id =  ($id != 0) ? $id : $user->id;

    $query = ' SELECT u.username'
           . ' FROM #__lovefactory_profiles p'
           . ' LEFT JOIN #__users u ON u.id = p.user_id'
           . ' WHERE p.user_id = ' . $user_id;
    $this->_db->setQuery($query);

    return $this->_db->loadObject();
  }

  function getRequests()
  {
    $user =& JFactory::getUser();

    if ($user->guest)
    {
      return false;
    }

    $query = ' SELECT COUNT(1) AS requests'
           . ' FROM #__lovefactory_friends f'
           //. ' WHERE (f.sender_id = ' . $user->id . ' OR f.receiver_id = ' . $user->id . ')'
           . ' WHERE f.receiver_id = ' . $user->id
           . ' AND f.pending = 1';
    $this->_db->setQuery($query);

    return $this->_db->loadResult();
  }


  function friendsLimitReached($status = null)
  {
    $user    =& JFactory::getUser();
    $friends =  $this->getTotalFriends($status);

    $query = ' SELECT p.user_id, m.*'
           . ' FROM #__lovefactory_profiles p'
           . ' LEFT JOIN #__lovefactory_memberships_sold m ON m.id = p.membership_sold_id'
           . ' WHERE p.user_id = ' . $user->id;
    $this->_db->setQuery($query);
    $profile = $this->_db->loadObject();

    $max_friends = is_null($status) ? $profile->max_friends : $profile->top_friends;

    if ($max_friends == -1)
    {
      return false;
    }

    return $friends >= $max_friends;
  }

  function getTotalFriends($status = null)
  {
    $user =& JFactory::getUser();

    $query = ' SELECT COUNT(f.id)'
           . ' FROM #__lovefactory_friends f'
           . ' WHERE (f.sender_id = ' . $user->id . ' OR f.receiver_id = ' . $user->id . ')'
           . ' AND f.pending = 0'
           . ' AND f.type = 1';

    if (!is_null($status))
    {
      $query .= ' AND IF (f.sender_id = ' . $user->id . ', f.sender_status, f.receiver_status) = ' . $status;
    }

    $this->_db->setQuery($query);

    return $this->_db->loadResult();
  }


  function getMaxFriends()
  {
    $settings =  new LovefactorySettings();
    $user     =& JFactory::getUser();

    $query = ' SELECT p.*, m.max_friends, m.top_friends'
           . ' FROM #__lovefactory_profiles p'
           . ' LEFT JOIN #__lovefactory_memberships_sold m ON m.id = p.membership_sold_id'
           . ' WHERE p.user_id = ' . $user->id;
    $this->_db->setQuery($query);
    $profile = $this->_db->loadObject();

    $top_friends =& JRequest::getVar('top_friends', 0, 'GET', 'integer');
    $max_friends = $top_friends ? $profile->top_friends : $profile->max_friends;

    return ($max_friends == -1) ? JText::_('MEMBERSHIP_UNLIMITED') : $max_friends;
  }

  function getZones()
  {
    static $zones = null;

    if (!is_null($zones))
    {
      return $zones;
    }

    $model =& JModel::getInstance('zones', 'FrontendModel');
    $zones =  $model->getZonesForDisplayForPage('friends');

    return $zones;
  }
}