<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelMembership extends JModel
{
  function trial()
  {
    $id   =& JRequest::getVar('id', 0, 'GET', 'integer');
    $user =& JFactory::getUser();

    // Check if user is logged in
    if ($user->guest)
    {
      JError::raiseWarning(0, JText::_('MEMBERSHIP_TRIAL_TASK_TRIAL_ERROR_LOGIN'));
      return false;
    }

    // Check if user has a default membership
    $profile =& $this->getTable('profile', 'Table');
    $profile->loadAndMembership($user->id);

    if (!$profile->membership_sold->default)
    {
      JError::raiseWarning(0, JText::_('MEMBERSHIP_TRIAL_TASK_TRIAL_ERROR_ONLY_DEFAULT_MEMBRESHIP'));
      return false;
    }

    // Check if required membership is trial
    $date  =& JFactory::getDate();
    $price =& $this->getTable('price', 'Table');
    $price->load($id);

    if (1 != $price->is_trial ||
        !$price->published ||
        ($price->available_interval && (strtotime($price->available_from) > $date->toUnix() || strtotime($price->available_until) < $date->toUnix())))
    {
      JError::raiseWarning(0, JText::_('MEMBERSHIP_TRIAL_TASK_TRIAL_ERROR_NOT_FOUND'));
      return false;
    }

    // Check if user hasn't used a trial membership before
    if (!$price->new_trial && 0 < $profile->trials)
    {
      JError::raiseWarning(0, JText::_('MEMBERSHIP_TRIAL_TASK_TRIAL_ERROR_ALREADY_TRIAL'));
      return false;
    }

    // Check if user has used this trial before
    $query = ' SELECT COUNT(1)'
           . ' FROM #__lovefactory_memberships_sold m'
           . ' WHERE m.user_id = ' . $user->id
           . ' AND m.trial = ' . $id;
    $this->_db->setQuery($query);
    $result = $this->_db->loadResult();

    if ($this->_db->loadResult())
    {
      JError::raiseWarning(0, JText::_('MEMBERSHIP_TRIAL_TASK_TRIAL_ERROR_ALREADY_USED_THIS_TRIAL'));
      return false;
    }

    // Set the new trial membership
    $membership_sold =& $this->getTable('membershipsold', 'Table');
    $membership      =& $this->getTable('membership',     'Table');

    $membership->load($price->membership_id);

    $membership_sold->user_id                  = $user->id;
    $membership_sold->membership_id            = $price->membership_id;
    $membership_sold->months                   = $price->months;
	  $membership_sold->title                    = JText::sprintf('MEMBERSHIP_TRIAL_TITLE', $membership->title);
	  $membership_sold->trial                    = $price->id;
	  $membership_sold->max_photos               = $membership->max_photos;
	  $membership_sold->max_friends              = $membership->max_friends;
	  $membership_sold->max_messages_per_day     = $membership->max_messages_per_day;
	  $membership_sold->max_interactions_per_day = $membership->max_interactions_per_day;
	  $membership_sold->shoutbox                 = $membership->shoutbox;
	  $membership_sold->chatfactory              = $membership->chatfactory;
	  $membership_sold->top_friends              = $membership->top_friends;
	  $membership_sold->groups_create            = $membership->groups_create;
	  $membership_sold->groups_join              = $membership->groups_join;
    $membership_sold->payment_id               = 0;

    $membership_sold->store();

    $profile =& $this->getTable('profile', 'Table');
    $profile->loadAndMembership($user->id);

    $profile->changeMembershipTo($membership_sold, false, true);

    $profile->trials = 1;
    $profile->store();

    return true;
  }

  function free()
  {
    $id       =& JRequest::getVar('id', 0, 'GET', 'integer');
    $user     =& JFactory::getUser();
    $settings =  new LovefactorySettings();

    // Check if user is logged in
    if ($user->guest)
    {
      JError::raiseWarning(0, JText::_('MEMBERSHIP_FREE_TASK_FREE_ERROR_LOGIN'));
      return false;
    }

    // Check if gender prices are enabled
    if (!$settings->gender_pricing)
    {
      JError::raiseWarning(0, JText::_('MEMBERSHIP_FREE_TASK_FREE_GENDER_PRICING_NOT_ENABLED'));
      return false;
    }

    // Check if price exists
    $price =& $this->getTable('Price');

    $price->load($id);

    if (count($price->_errors))
    {
      JError::raiseWarning(0, JText::_('MEMBERSHIP_FREE_TASK_FREE_SELECTED_PRICE_WAS_NOT_FOUND'));
      return false;
    }

    // Check if price is available for user's gender
    $profile =& $this->getTable('Profile');
    $profile->loadAndMembership($user->id);

    if (!$price->hasGender($profile->sex) || '0.00' != $price->getGenderPrice($profile->sex))
    {
      JError::raiseWarning(0, JText::_('MEMBERSHIP_FREE_TASK_FREE_SELECTED_PRICE_NOT_AVAILABLE_FOR_GENDER'));
      return false;
    }

    // Change user membership
    $membership_sold =& $this->getTable('MembershipSold', 'Table');
    $membership      =& $this->getTable('Membership',     'Table');

    $membership->load($price->membership_id);

    $membership_sold->user_id                  = $user->id;
    $membership_sold->membership_id            = $price->membership_id;
    $membership_sold->months                   = $price->months;
	  $membership_sold->title                    = JText::sprintf('MEMBERSHIP_FREE_TITLE', $membership->title);
	  $membership_sold->trial                    = 0;
	  $membership_sold->max_photos               = $membership->max_photos;
	  $membership_sold->max_friends              = $membership->max_friends;
	  $membership_sold->max_messages_per_day     = $membership->max_messages_per_day;
	  $membership_sold->max_interactions_per_day = $membership->max_interactions_per_day;
	  $membership_sold->shoutbox                 = $membership->shoutbox;
	  $membership_sold->chatfactory              = $membership->chatfactory;
	  $membership_sold->top_friends              = $membership->top_friends;
	  $membership_sold->groups_create            = $membership->groups_create;
	  $membership_sold->groups_join              = $membership->groups_join;
	  $membership_sold->payment_id               = 0;

    $membership_sold->store();

    $profile->changeMembershipTo($membership_sold, false);

    $profile->store();

    return true;
  }
}