<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelMyMembership extends JModel
{
  var $_data;
  var $_total;
  var $_pagination;
  var $_limit;
  var $_limitstart;

  function __construct()
  {
    parent::__construct();

    global $mainframe;
    $this->_limit      = JRequest::getVar('limit',      $mainframe->getCfg('list_limit'), 'REQUEST', 'integer');
    $this->_limitstart = JRequest::getVar('limitstart', 0,                                'REQUEST', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
  }

  function getMembership()
  {
    $user    =& JFactory::getUser();
    $options =  $this->_buildOptionsQuery();

    $query = ' SELECT m.*, pay.amount, pay.currency, pay.payment_date,'
           . $options
           . ' FROM #__lovefactory_profiles p'
           . ' LEFT JOIN #__lovefactory_memberships_sold m ON m.id = p.membership_sold_id'
           . ' LEFT JOIN #__lovefactory_payments pay ON pay.id = m.payment_id'
           . ' WHERE p.user_id = ' . $user->id;
    $this->_db->setQuery($query);

    $result =  $this->_db->loadObject();
    $table  =& $this->getTable('membership');

    $values = $table->getShoutboxValues();
    $result->shoutbox = $values[$result->shoutbox];

    return $result;
  }

  function getMemberships($user_id = null)
  {
    $user =& JFactory::getUser();
    $user_id = null == $user_id ? $user->id : $user_id;

    $table  =& $this->getTable('membership');
    $values =  $table->getShoutboxValues();

    if (empty($this->_data))
    {
      $query       = $this->_buildQuery($user_id);
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);

      foreach ($this->_data as $i => $membership)
      {
        $this->_data[$i]->shoutbox = $values[$membership->shoutbox];
      }
    }

    return $this->_data;
  }

  function _buildQuery($user_id)
  {
    $options = $this->_buildOptionsQuery();

    $query = ' SELECT m.*, p.amount, p.currency, p.payment_date,'
           . '   IF (pf.membership_sold_id = m.id, 1, 0) AS is_active,'
           . $options
           . ' FROM #__lovefactory_memberships_sold m'
           . ' LEFT JOIN #__lovefactory_payments p ON p.id = m.payment_id'
           . ' LEFT JOIN #__lovefactory_profiles pf ON pf.user_id = m.user_id'
           . ' WHERE m.user_id = ' . $user_id
           . ' AND m.id <> 1'
           . ' ORDER BY m.id DESC';

    return $query;
  }

  function _buildOptionsQuery()
  {
    $query = '   IF(m.end_membership = "0000-00-00 00:00:00", "' . JText::_('MEMBERSHIP_UNLIMITED') . '", m.end_membership) AS end_membership,'
           . '   IF(m.max_photos = -1, "' . JText::_('MEMBERSHIP_UNLIMITED') . '", m.max_photos) AS max_photos,'
           . '   IF(m.max_videos = -1, "' . JText::_('MEMBERSHIP_UNLIMITED') . '", m.max_videos) AS max_videos,'
           . '   IF(m.max_friends = -1, "' . JText::_('MEMBERSHIP_UNLIMITED') . '", m.max_friends) AS max_friends,'
           . '   IF(m.max_interactions_per_day = -1, "' . JText::_('MEMBERSHIP_UNLIMITED') . '", m.max_interactions_per_day) AS max_interactions_per_day,'
           . '   IF(m.top_friends = -1, "' . JText::_('MEMBERSHIP_UNLIMITED') . '", m.top_friends) AS top_friends,'
           . '   IF(m.max_messages_per_day = -1, "' . JText::_('MEMBERSHIP_UNLIMITED') . '", m.max_messages_per_day) AS max_messages_per_day,'
           . '   IF(m.groups_create = -1, "' . JText::_('MEMBERSHIP_UNLIMITED') . '", m.groups_create) AS groups_create,'
           . '   IF(m.groups_join = -1, "' . JText::_('MEMBERSHIP_UNLIMITED') . '", m.groups_join) AS groups_join';

    return $query;
  }

  function getTotal($user_id = null)
  {
    $user =& JFactory::getUser();
    $user_id = null == $user_id ? $user->id : $user_id;

    if (empty($this->_total))
    {
      $query = $this->_buildQuery($user_id);
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }
}