<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelRating extends JModel
{
  function add()
  {
    $user =& JFactory::getUser();
    $id   =& JRequest::getVar('user_id', 0, 'POST', 'integer');
    $vote =& JRequest::getVar('rating',  0, 'POST', 'integer');

    // Check if it's my profile
    if ($user->id == $id)
    {
      $this->setError(JText::_('RATING_TASK_ADD_ERROR_CANNOT_VOTE_FOR_SELF'));
      return false;
    }

    // Check if user exists
    $profile =& $this->getTable('profile', 'Table');
    $profile->load($id);

    if ($profile->_is_new)
    {
      $this->setError(JText::_('RATING_TASK_ADD_ERROR_USER_NOT_EXIST'));
      return false;
    }

    // Check if the vote is valid
    if (1 > $vote || 10 < $vote)
    {
      $this->setError(JText::_('RATING_TASK_ADD_ERROR_RATING_INVALID'));
      return false;
    }

    // Already rated this profile?
    $my_rating = $this->getMyRatingForUser($id);
    $my_rating = isset($my_rating->rating) ? $my_rating->rating : false;
    if (false !== $my_rating)
    {
      $this->setError(JText::_('RATING_TASK_ADD_ERROR_ALREADY_RATED'));
      return false;
    }

    // Add new rating
    $date   =& JFactory::getDate();
    $rating =& $this->getTable('rating');

    $rating->receiver_id = $id;
    $rating->sender_id   = $user->id;
    $rating->date        = $date->toMySql();
    $rating->rating      = $vote;

    $rating->store();

    // Send email alert
    $mailer =& JModel::getInstance('mailer', 'FrontendModel');
    $mailer->sendNotification($profile->user_id, 'rating');

    // Calculate the new total rating
    $profile->rating = ($profile->rating * $profile->votes + $vote) / ($profile->votes + 1);
    $profile->votes++;

    $profile->store();

    $this->_new_rating = $profile->rating;
    $this->_votes      = $profile->votes;
    $this->_rating     = $vote;

    // Register action
    $action =& $this->getTable('action', 'Table');
    $action->addRating($rating->rating, $rating->receiver_id, $rating->sender_id);

    return true;
  }

  function getMyRatingForUser($user_id = null)
  {
    $id   =& JRequest::getVar('id', 0, 'REQUEST', 'integer');
    $user =& JFactory::getUser();

    $id = is_null($user_id) ? $id : $user_id;

    if (!$id || $user->id == $id)
    {
      return false;
    }

    $query = ' SELECT r.*'
           . ' FROM #__lovefactory_ratings r'
           . ' WHERE r.sender_id = ' . $user->id
           . ' AND r.receiver_id = ' . $id;
    $this->_db->setQuery($query);

    return $this->_db->loadObject();
  }
}