<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelSignup extends JModel
{
  // View
	function getZones()
  {
    $zones =& JModel::getInstance('zones', 'FrontendModel');
    $zones = $zones->getZonesForDisplayForPage('signup');

    return $zones;
  }


  // Tasks
  function signUp()
  {
    global $mainframe;

    // Check required Lovefactory fields
    $profile =& $this->getTable('profile', 'Table');

    $fields =& JModel::getInstance('fields', 'FrontendModel');
    $fields->getFieldsForPage('signup');

    /* @var $profile TableProfile */
    $profile->updateFromFields($fields->_fields);

    if ($profile->_has_errors)
    {
      $mainframe->redirect(JRoute::_('index.php?option=com_lovefactory&view=signup&Itemid=' . $Itemid, false));
    }

    // Is photo required on registration?
    $photo_required    =  $fields->getPhotoRequiredOnRegistration();
    $main_photo_upload =& JRequest::getVar('main_photo_upload', '', 'POST', 'string');
    $valid_photo       =  file_exists(JPATH_COMPONENT_SITE.DS.'storage'.DS.'registration_photos'.DS.$main_photo_upload);

    if ($photo_required && !$valid_photo)
    {
      JError::raiseWarning(0, JText::_('SIGNUP_TASK_SIGNUP_ERROR_UPLOAD_PHOTO'));
      $mainframe->redirect(JRoute::_('index.php?option=com_lovefactory&view=signup&Itemid=' . $Itemid, false));
    }

    // Joomla Registration: START

    // Get required system objects
    $user 		 =  clone(JFactory::getUser());
    $pathway 	 =& $mainframe->getPathway();
    $config		 =& JFactory::getConfig();
    $authorize =& JFactory::getACL();
    $document  =& JFactory::getDocument();

    // If user registration is not allowed, show 403 not authorized.
    $usersConfig = &JComponentHelper::getParams('com_users');
    if ('0' == $usersConfig->get('allowUserRegistration'))
    {
      JError::raiseError(403, JText::_('Access Forbidden'));
      return;
    }

    // Initialize new usertype setting
    $newUsertype = $usersConfig->get('new_usertype');
    if (!$newUsertype)
    {
      $newUsertype = 'Registered';
    }

    // Prepare the post for bind
    $fields      =& JModel::getInstance('fields', 'FrontendModel');
    $jreg_fields =  $fields->getFieldsIdsForJoomlaRegistration();

    JRequest::setVar('username',  JRequest::getVar('field_' . $jreg_fields[12]->id, '', 'POST', 'string'), 'POST');
    JRequest::setVar('name',      JRequest::getVar('field_' . $jreg_fields[12]->id, '', 'POST', 'string'), 'POST');
    JRequest::setVar('email',     JRequest::getVar('field_' . $jreg_fields[18]->id, '', 'POST', 'string'), 'POST');
    JRequest::setVar('password',  JRequest::getVar('field_' . $jreg_fields[19]->id, '', 'POST', 'string'), 'POST');
    JRequest::setVar('password2', JRequest::getVar('field_' . $jreg_fields[20]->id, '', 'POST', 'string'), 'POST');

    // Bind the post array to the user object
    if (!$user->bind(JRequest::get('post'), 'usertype'))
    {
      JError::raiseError(500, $user->getError());
    }

    // Set some initial user values
    $date =& JFactory::getDate();

    $user->set('id',           0);
    $user->set('usertype',     $newUsertype);
    $user->set('gid',          $authorize->get_group_id('', $newUsertype, 'ARO'));
    $user->set('registerDate', $date->toMySQL());

    // If user activation is turned on, we need to set the activation information
    $useractivation = $usersConfig->get('useractivation');
    if ('1' == $useractivation)
    {
      jimport('joomla.user.helper');
      $user->set('activation', JUtility::getHash(JUserHelper::genRandomPassword()));
      $user->set('block', '1');
    }

    // If there was an error with registration, set the message and display form
    if (!$user->save())
    {
      $mainframe->redirect(JRoute::_('index.php?option=com_lovefactory&view=signup&Itemid=' . $Itemid, false), $user->getError());
    }

    // Send registration confirmation mail
    $password = JRequest::getString('password', '', 'post', JREQUEST_ALLOWRAW);
    $password = preg_replace('/[\x00-\x1F\x7F]/', '', $password); //Disallow control chars in the email
    require_once(JPATH_BASE.DS.'components'.DS.'com_user'.DS.'controller.php');

    $this->_sendMail($user, $password);

    $lang = JFactory::getLanguage();
    $lang->load('com_user');

    // Everything went fine, set relevant message depending upon user activation state and display message
    if (1 == $useractivation)
    {
      $message = $lang->_('REG_COMPLETE_ACTIVATE');
    }
    else
    {
      $message = $lang->_('REG_COMPLETE');
    }

    // Joomla Registration: STOP

    // All went fine, register the Love Factory Profile
    $profile->user_id = $user->id;

    $profile->addDefaultInTable();
    $profile->createUserFolder();
    $profile->storeMainPhotoUpload();

    // Update the location field, now we have an user id
    $fields =& JModel::getInstance('fields', 'FrontendModel');
    $fields->getFieldsForPage('signup');

    foreach ($fields->_fields as $i => $field)
    {
      if (23 != $field->type_id)
      {
        unset($fields->_fields[$i]);
      }
    }

    if (count($fields->_fields))
    {
      $profile->updateFromFields($fields->_fields);
    }

    $profile->store();

    // Update fields location
    if ($settings->fields_location)
    {
      $this->_updateFieldsLocation($user->id, 'signup');
    }

    global $mainframe;
    $mainframe->redirect('index.php', $message);
  }

  function checkAvailability()
	{
	  $type  =& JRequest::getVar('type',  '', 'POST', 'string');
	  $value =& JRequest::getVar('value', '', 'POST', 'string');

	  switch ($type)
	  {
	    case 'email':
	      if (!preg_match('/^[^\W][a-zA-Z0-9_]+(\.[a-zA-Z0-9_]+)*\@[a-zA-Z0-9_]+(\.[a-zA-Z0-9_]+)*\.[a-zA-Z]{2,4}$/', $this->_db->getEscaped($value)))
	      {
	        return false;
	      }

	      $query = ' SELECT u.id'
	             . ' FROM #__users u'
	             . ' WHERE u.email = "' . $this->_db->getEscaped($value) . '"';
	    break;

	    default:
	      $query = ' SELECT u.id'
	             . ' FROM #__users u'
	             . ' WHERE u.username = "' . $this->_db->getEscaped($value) . '"';
	    break;
	  }

	  $this->_db->setQuery($query);

	  return $this->_db->loadResult() ? false : true;
	}


  // Helpers
  function _sendMail(&$user, $password)
	{
		global $mainframe;

		$lang = JFactory::getLanguage();
    $lang->load('com_user');

		$db		=& JFactory::getDBO();

		$name 		= $user->get('name');
		$email 		= $user->get('email');
		$username 	= $user->get('username');

		$usersConfig 	= &JComponentHelper::getParams( 'com_users' );
		$sitename 		= $mainframe->getCfg( 'sitename' );
		$useractivation = $usersConfig->get( 'useractivation' );
		$mailfrom 		= $mainframe->getCfg( 'mailfrom' );
		$fromname 		= $mainframe->getCfg( 'fromname' );
		$siteURL		= JURI::base();

		$subject 	= sprintf ( $lang->_('Account details for' ), $name, $sitename);
		$subject 	= html_entity_decode($subject, ENT_QUOTES);

		if ( $useractivation == 1 ){
			$message = sprintf ( $lang->_('SEND_MSG_ACTIVATE' ), $name, $sitename, $siteURL."index.php?option=com_user&task=activate&activation=".$user->get('activation'), $siteURL, $username, $password);
		} else {
			$message = sprintf ( $lang->_('SEND_MSG' ), $name, $sitename, $siteURL);
		}

		$message = html_entity_decode($message, ENT_QUOTES);

		//get all super administrator
		$query = 'SELECT name, email, sendEmail' .
				' FROM #__users' .
				' WHERE LOWER( usertype ) = "super administrator"';
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// Send email to user
		if ( ! $mailfrom  || ! $fromname ) {
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}

		JUtility::sendMail($mailfrom, $fromname, $email, $subject, $message);

		// Send notification to all administrators
		$subject2 = sprintf ( $lang->_('Account details for' ), $name, $sitename);
		$subject2 = html_entity_decode($subject2, ENT_QUOTES);

		// get superadministrators id
		foreach ( $rows as $row )
		{
			if ($row->sendEmail)
			{
				$message2 = sprintf ( $lang->_('SEND_MSG_ADMIN' ), $row->name, $sitename, $name, $email, $username);
				$message2 = html_entity_decode($message2, ENT_QUOTES);
				JUtility::sendMail($mailfrom, $fromname, $row->email, $subject2, $message2);
			}
		}
	}

	function _updateFieldsLocation($user_id, $page)
	{
    $profile =& $this->getTable('profile', 'Table');
    $profile->user_id = $user_id;

    $fields =& JModel::getInstance('fields', 'FrontendModel');
    $fields->getFieldsForPage($page);

    /* @var $profile TableProfile */
    $profile->updateFromFields($fields->_fields, false);

    $profile->store();
	}
}