<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelVideo extends JModel
{
  function __construct()
  {
    parent::__construct();

    global $mainframe;

    $settings = new LovefactorySettings();

    $this->_limit      =& JRequest::getVar('limit',      $settings->videos_list_pagination_limit, 'REQUEST', 'integer');
    $this->_limitstart =& JRequest::getVar('limitstart', 0,  'GET', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
  }

  function getData()
  {
    if (empty($this->_data))
    {
      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);

      foreach ($this->_data as $i => $video)
      {
        $table =& $this->getTable('Video');
        $table->bind($video);

        $this->_data[$i] = $table;
      }
    }

    return $this->_data;
  }

  function _buildQuery($total = false)
  {
    $id        =& JRequest::getVar('user_id', 0, 'GET', 'integer');
    $gallery   =& JModel::getInstance('Gallery', 'FrontendModel');
    $is_friend =  $gallery->getIsFriend($id);

    $array = array(0);
    if ($is_friend)
    {
      $array[] = 1;
    }

    if ($gallery->getIsMyGallery())
    {
      $array[] = 2;
    }

    $query = ($total ? 'SELECT COUNT(1)' : ' SELECT v.*')
           . ' FROM #__lovefactory_videos v'
           . ' LEFT JOIN #__lovefactory_video_comments c ON c.video_id = v.id'
           . ' WHERE v.user_id = ' . $id
           . ' AND v.status IN (' . implode(',', $array) . ')'
           . ' GROUP BY v.id'
           . ' ORDER BY v.status ASC, ordering ASC';

    return $query;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery(true);
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      global $mainframe;
      $router = $mainframe->getRouter();
      $router->setVar('format',     'raw');
      $router->setVar('view',       '');
      $router->setVar('controller', 'video');
      $router->setVar('task',       'videoslist');

      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }

  function getPhotosForUser($user_id)
  {
    $query = ' SELECT p.*, u.email AS _email'
           . ' FROM #__lovefactory_photos p'
           . ' LEFT JOIN #__users u ON u.id = p.user_id'
           . ' WHERE p.user_id = ' . $user_id
           . ' ORDER BY p.status ASC, ordering ASC';
    $this->_db->setQuery($query);

    $photos = $this->_db->loadObjectList();
    $array  = array(0 => array(), 1 => array(), 2 => array());

    foreach ($photos as $photo)
    {
      $table =& $this->getTable('Photo', 'Table');
      $table->bind($photo);
      $table->_email = $photo->_email;

      $array[$table->status][] = $table;
    }

    return $array;
  }

  function getVideo()
  {
    $video_id =& JRequest::getVar('video_id', 0, 'GET', 'integer');
    $video    =& $this->getTable('Video');

    $video->load($video_id);

    return $video;
  }

  // Tasks
  function report()
  {
    $text       =& JRequest::getVar('text',       '', 'POST', 'string');
    $gallery_id =& JRequest::getVar('gallery_id', 0,  'POST', 'integer');

    $profile =& $this->getTable('profile', 'Table');
    $profile->load($gallery_id);

    if ($profile->_is_new)
    {
      $this->setError(JText::_('GALLERY_TASK_REPORT_ERROR_NOT_FOUND'));
      return false;
    }

    $user   =& JFactory::getUser();
    $date   =& JFactory::getDate();
    $report =& $this->getTable('report');

    $report->reporting_id = $user->id;
    $report->reported_id  = $gallery_id;
    $report->user_id      = $gallery_id;
    $report->type_id      = 3;
    $report->comment      = $text;
    $report->date         = $date->toMySql();

    $report->store();

    return true;
  }
}