<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class FrontendModelVideoComments extends JModel
{
  function __construct()
  {
    parent::__construct();

    global $mainframe;

    $settings = new LovefactorySettings();

    $this->_limit      =& JRequest::getVar('limit',      $settings->videos_comments_pagination_limit, 'REQUEST', 'integer');
    $this->_limitstart =& JRequest::getVar('limitstart', 0,  'GET', 'integer');

    $this->_limitstart = ($this->_limit != 0 ? (floor($this->_limitstart / $this->_limit) * $this->_limit) : 0);
  }

  function getData()
  {
    if (empty($this->_data))
    {
      $total = $this->getTotal();

      if ($this->_limitstart >= $total)
      {
        $this->_limitstart = 0;
      }

      $query = $this->_buildQuery();
      $this->_data = $this->_getList($query, $this->_limitstart, $this->_limit);

      foreach ($this->_data as $i => $comment)
      {
        $this->_data[$i]->username = is_null($comment->username) ? JText::_('USER_DELETED') : $comment->username;
      }
    }

    return $this->_data;
  }

  function _buildQuery($total = false)
  {
    $video_id =& JRequest::getVar('video_id', 0, 'GET', 'integer');

    $query = ($total ? ' SELECT COUNT(1)' : ' SELECT c.*, u.username')
           . ' FROM #__lovefactory_video_comments c'
           . ' LEFT JOIN #__users u ON u.id = c.user_id'
           . ' WHERE c.video_id = ' . $video_id
           . ' GROUP BY c.id'
           . ' ORDER BY c.created_at DESC';

    return $query;
  }

  function getTotal()
  {
    if (empty($this->_total))
    {
      $query = $this->_buildQuery(true);
      $this->_total = $this->_getListCount($query);
    }

    return $this->_total;
  }

  function getPagination()
  {
    if (empty($this->_pagination))
    {
      global $mainframe;
      $router = $mainframe->getRouter();
      $router->setVar('format',     'raw');
      $router->setVar('view',       '');
      $router->setVar('controller', 'video');
      $router->setVar('task',       'commentslist');

      jimport('joomla.html.pagination');
      $this->_pagination = new JPagination($this->getTotal(), $this->_limitstart, $this->_limit);
    }

    return $this->_pagination;
  }

  function getIsMyVideo()
  {
    $id    =& JRequest::getVar('video_id', 0, 'GET', 'integer');
    $video =& $this->getTable('Video');

    $video->load($id);

    return $video->isMyVideo();
  }


  function add()
  {
    $comment =& $this->getTable('VideoComment');

    return $comment->save(JRequest::get('post'));
  }

  function remove()
  {
    $id      =& JRequest::getVar('id', 0, 'POST', 'integer');
    $comment =& $this->getTable('VideoComment');

    $comment->load($id);

    // Comment not found?
    if (count($comment->_errors))
    {
      $this->setError(JText::_('VIDEOS_COMMENTS_REMOVE_ERROR_NOT_FOUND'));
      return false;
    }

    // Is my video?
    $video =& $this->getTable('Video');
    $video->load($comment->video_id);

    if (!$video->isMyVideo())
    {
      $this->setError(JText::_('VIDEOS_COMMENTS_REMOVE_ERROR_NOT_MY_VIDEO'));
      return false;
    }

    // Remove the comment
    return $comment->delete();
  }

  function report()
  {
    $id      =& JRequest::getVar('id', 0, 'POST', 'integer');
    $comment =& $this->getTable('VideoComment');

    $comment->load($id);

    // Comment not found?
    if (count($comment->_errors))
    {
      $this->setError(JText::_('VIDEOS_COMMENTS_REMOVE_ERROR_NOT_FOUND'));
      return false;
    }

    // Report the comment
    return $comment->report();
  }
}