<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

class FrontendViewMyGalleryVideo extends JFactoryView
{
  function display($tpl = null)
  {
    global $Itemid;

    $document =& JFactory::getDocument();
    $session  =& JFactory::getSession();
    $user     =& JFactory::getUser();
    $gallery  =& JModel::getInstance('gallery', 'FrontendModel');

    $photos   = $gallery->getPhotosForUser($user->id);
    $videos = $gallery->getVideos();
    $settings = new LovefactorySettings();

    $this->assignRef('user',     $user);
    $this->assignRef('videos',   $videos);
    $this->assignRef('Itemid',   $Itemid);
    $this->assignRef('settings', $settings);

    $this->assignRef('public_videos',  $videos[0]);
    $this->assignRef('friends_videos', $videos[1]);
    $this->assignRef('private_videos', $videos[2]);

    $this->assign('gallery', 'videos');

    $this->assignJavascript('route_upload',        JRoute::_('index.php?option=com_lovefactory&controller=mygallery&task=upload&format=raw'));
    $this->assignJavascript('route_delete',        JRoute::_('index.php?option=com_lovefactory&controller=mygallery&task=delete'));
    $this->assignJavascript('route_save',          JRoute::_('index.php?option=com_lovefactory&controller=mygallery&task=save'));
    $this->assignJavascript('txt_delete',          JText::_('MY_GALLERY_DELETE'));
    $this->assignJavascript('txt_error_uploading', JText::_('MY_GALLERY_ERROR_UPLOADING'));
    $this->assignJavascript('txt_select_photo',    JText::_('MY_GALLERY_SELECT_AT_LEAST_ONE_PHOTO'));
    $this->assignJavascript('txt_upload',          JText::_('MY_GALLERY_UPLOAD'));
    $this->assignJavascript('root',                JURI::root());
    $this->assignJavascript('session_id',          $session->getId());
    $this->assignJavascript('session_name',        $session->getName());
    $this->assignJavascript('hover_action_links',  $settings->my_gallery_action_links);
    $this->assignJavascript('txt_select_just_one_image', JText::_('MY_GALLERY_SELECT_JUST_ONE_IMAGE'));

    $document->addStyleDeclaration('.ui-state-highlight { height: ' . $settings->thumbnail_max_height . 'px; width: ' . $settings->thumbnail_max_width . 'px; border-style: dotted; }');
    $document->addStyleDeclaration('.lovefactory-gallery-thumbnail { height: ' . $settings->thumbnail_max_height . 'px; width: ' . $settings->thumbnail_max_width . 'px; }');

    JHtmlFactory::jQueryScript('ui', 'ui-widget', 'ui-mouse', 'ui-sortable', 'ui-progressbar', 'swfupload');

    JHTML::script('mygallery.js',      'components/com_lovefactory/assets/js/views/');
    JHTML::script('mygalleryvideo.js', 'components/com_lovefactory/assets/js/views/');
    JHTML::script('swfupload.js',      'components/com_lovefactory/assets/js/');

    JHTML::stylesheet('main.css',            'components/com_lovefactory/assets/css/');
    JHTML::stylesheet('buttons.css',         'components/com_lovefactory/assets/css/');
    JHTML::stylesheet('mygallery.css',       'components/com_lovefactory/assets/css/views/');
    JHTML::stylesheet('mygalleryvideo.css',  'components/com_lovefactory/assets/css/views/');
    JHTML::stylesheet('ui.all.css',          'components/com_lovefactory/assets/css/');

    parent::display($tpl);
  }
}