<?php

defined('_JEXEC') or die('Restricted access');

class FrontendViewProfile extends JFactoryView
{
  function __construct()
  {
    parent::__construct();

    $profile =& JModel::getInstance('profile', 'FrontendModel');
    $profile->checkOnlineStatus();
  }

  function display($tpl = null)
  {
    global $Itemid;

    $profile  =& $this->get('Profile');
    $document =& JFactory::getDocument();
    $zones    =& $this->get('Zones');
    $renderer =& JModel::getInstance('renderer', 'FrontendModel');

    $settings      =  new LovefactorySettings();
    $total_friends =& $this->get('TotalFriends');
    $visitor       =& $this->get('Visitor');

    require_once(JPATH_COMPONENT_SITE.DS.'lib'.DS.'vendor'.DS.'TheFactoryHelper.class.php');

    $comments =& JModel::getInstance('comments', 'FrontendModel');
    $comments->getData();

    // If profile friends preview
    if ($settings->enable_profile_friends)
    {
      $friends =& $this->get('Friends');
      $remaining_friends = $total_friends - count($friends);

      $this->assignRef('friends',           $friends);
      $this->assignRef('remaining_friends', $remaining_friends);
    }

    if ($settings->enable_rating)
    {
      $rating    =& JModel::getInstance('rating', 'FrontendModel');
      $my_rating =  $rating->getMyRatingForUser();

      $ratings =& JModel::getInstance('ratings', 'FrontendModel');
      $ratings->getLatestRatingsForUser($profile->user_id);

      $this->assignRef('ratings',  $ratings);
      $this->assign('rating_size', $profile->rating + 10);
    }

    if ($settings->enable_wallpage)
    {
      $wallpage =& $this->get('Wallpage');
      $this->assignRef('wallpage', $wallpage);
      JHTML::stylesheet('wallpage.css', 'components/com_lovefactory/assets/css/views/');
    }

    if (!$profile->_my_profile)
    {
      $friendship =& $this->get('Friendship');
      $blacklist  =& $this->get('Blacklist');

      $this->assignRef('friendship', $friendship);
      $this->assignRef('blacklist',  $blacklist);
    }

    $this->assignRef('zones',             $zones);
    $this->assignRef('profile',           $profile);
    $this->assignRef('renderer',          $renderer);
    $this->assignRef('comments',          $comments);
    $this->assignRef('my_rating',         $my_rating);
    $this->assignRef('visitor',           $visitor);
    $this->assignRef('settings',          $settings);

    $this->assignJavascript('route_ask_friendship',   JRoute::_('index.php?option=com_lovefactory&controller=friend&task=request', true));
    $this->assignJavascript('route_ask_relationship', JRoute::_('index.php?option=com_lovefactory&controller=relationship&task=request', true));
    $this->assignJavascript('route_cancel_pending',   JRoute::_('index.php?option=com_lovefactory&controller=friend&task=cancel', true));
    $this->assignJavascript('route_cancel_pending_relationship', JRoute::_('index.php?option=com_lovefactory&controller=relationship&task=cancel', true));
    $this->assignJavascript('route_break_friendship', JRoute::_('index.php?option=com_lovefactory&controller=friend&task=remove', true));
    $this->assignJavascript('route_break_relationship', JRoute::_('index.php?option=com_lovefactory&controller=relationship&task=remove', true));
    $this->assignJavascript('route_pending_friends',  JRoute::_('index.php?option=com_lovefactory&view=friendspending&Itemid=' . $Itemid, true));
    $this->assignJavascript('route_pending_relationships', JRoute::_('index.php?option=com_lovefactory&view=relationshipspending&Itemid=' . $Itemid, true));
    $this->assignJavascript('route_add_comment',      JRoute::_('index.php?option=com_lovefactory&controller=comment&task=add', true));
    $this->assignJavascript('route_profile_vote',     JRoute::_('index.php?option=com_lovefactory&controller=rating&task=add', true));
    $this->assignJavascript('route_delete_comment',   JRoute::_('index.php?option=com_lovefactory&controller=comment&task=delete', true));
    $this->assignJavascript('route_report_comment',   JRoute::_('index.php?option=com_lovefactory&controller=comment&task=report', true));
    $this->assignJavascript('route_send_message',     JRoute::_('index.php?option=com_lovefactory&controller=message&task=send', true));
    $this->assignJavascript('route_send_interaction', JRoute::_('index.php?option=com_lovefactory&controller=interaction&task=send', true));
    $this->assignJavascript('route_add_blacklist',    JRoute::_('index.php?option=com_lovefactory&controller=blacklist&task=add', true));
    $this->assignJavascript('route_remove_blacklist', JRoute::_('index.php?option=com_lovefactory&controller=blacklist&task=remove', true));
    $this->assignJavascript('root',                   JURI::root());
    $this->assignJavascript('user_id',                $profile->user_id);
    $this->assignJavascript('txt_are_you_sure',       JText::_('PROFILE_CONFIRM'));
    $this->assignJavascript('txt_send',               JText::_('PROFILE_SEND'));
    $this->assignJavascript('txt_cancel',             JText::_('PROFILE_CANCEL'));
    $this->assignJavascript('txt_save',               JText::_('PROFILE_SAVE'));
    $this->assignJavascript('txt_edit',               JText::_('PROFILE_EDIT'));
    $this->assignJavascript('txt_enter_message',      JText::_('PROFILE_ENTER_MESSAGE'));
    $this->assignJavascript('txt_send_quick_message', JText::_('PROFILE_SEND_QUICK_MESSAGE'));
    $this->assignJavascript('txt_ask_for_friendship', JText::_('PROFILE_ASK_FOR_FRIENDSHIP'));
    $this->assignJavascript('txt_ask_for_relationship', JText::_('PROFILE_ASK_FOR_RELATIONSHIP'));
    $this->assignJavascript('txt_chars_remaining',    JText::_('PROFILE_CHARACTERS_REMAINING'));
    $this->assignJavascript('status_max_length',      $settings->status_max_length);
    $this->assignJavascript('friendship_id',          (isset($friendship->friendship) ? $friendship->friendship->id : 0 ));
    $this->assignJavascript('relationship_id',        (isset($friendship->relationship) ? @$friendship->relationship->id : 0 ));
    $this->assignJavascript('blacklist_id',           (isset($blacklist->id) ? $blacklist->id : 0 ));

    $document->addStyleDeclaration('.lovefactory-thumbnail { height: ' . $settings->thumbnail_max_height . 'px; width: ' . $settings->thumbnail_max_width . 'px; }');

    JHtmlFactory::jQueryScript('cookie', 'wmodefix');
    JHTML::script('profile.js',           'components/com_lovefactory/assets/js/views/');
    JHTML::script('main.js',              'components/com_lovefactory/assets/js/');
    JHTML::script('gmaps.unload.js',      'components/com_lovefactory/assets/js/');

    JHTML::stylesheet('main.css',    'components/com_lovefactory/assets/css/');
    JHTML::stylesheet('profile.css', 'components/com_lovefactory/assets/css/views/');
    JHTML::stylesheet('buttons.css', 'components/com_lovefactory/assets/css/');

    JHtmlFactory::IEStylesheet('ie.css');

    $this->assignRef('Itemid', $Itemid);

    parent::display($tpl);
  }
}